function Challenges()
{
	this.area = "";
	this.challenge = null;
	
	this.mainmenu = {
		preset: {
			title: "Preset Challenges"
		},
		daily: {
			title: "Daily Challenges"
		},
		weekly: {
			title: "Weekly Challenges"
		}
	};
	this.preset = [{
		map: "ss001",
		title: "$10k Challenge!",
		description: "Reach level 20 with only $10k starting money. No other money will be awarded during play.",
		rules: [{
			money: {
				start: 10000,
				award: "n",
				newLevelAward: "n",
				loan: "n"
			}
		}],
		goal: [{
			level: 20
		}]
	}];
	
	this.page = 0;
	this.pageSliding = false;
	this.maxPages = 0;
	this.mapmenuOffsetX = 0;
	this.mapmenuOffsetX2 = 0;
	
	this.onIndex = 0;
	this.options = [{
		value: "Start!",
		action: function()
		{
			MainMenu.loadMap(MainMenu.map, "Hard");
		}
	}/*, {
		value: "Highscores",
		action: function()
		{
			Leaderboard.init({
				type: "mainmenu_map",
				map: Challenges.map,
				area: "local",
				mode: "hard"
			});
		}
	}*/, {
		value: "Back",
		action: function()
		{
			Challenges.switchArea("preset");
		}
	}];
	
	//Init
	this.init = function(area)
	{
		if (area == undefined) area = "";
		
		nwf.system.WiiUSystem.getInstance().homeButtonEnabled = true;
		nwf.system.Memory.requestGC();
		ClickBank.clearAll();
		InputBank.clearAll();
		Render.soundsStopAll();
		
		if (Game && Game.map)
			__Maps[Game.map].scriptUnset();
		
		this.area = area;
		this.area = "preset";
		this.recentChanges = {};
		
		Render.renderControl = function(){ Challenges.render(); };
		
		if (Render.sounds["mainmenu"].readyState > 0)
			Render.sounds["mainmenu"].currentTime = 0;
		Render.sounds["mainmenu"].play();

		//Buttons
		InputBank.add({
			id: "button",
			type: ["b", "a", "up", "down", "left", "right", "start", "r", "r2", "l", "l2"],
			action: function(clickID, vaultEntry, type)
			{
				switch(type)
				{
				case "up":
					if (Challenges.area == "challenge")
					{
						Challenges.onIndex--;
						if (Challenges.onIndex < 0) Challenges.onIndex = 0;
					}
				break;
				
				case "down":
					if (Challenges.area == "challenge")
					{
						Challenges.onIndex++;
						if (Challenges.onIndex >= Challenges.options.length) Challenges.onIndex = Challenges.options.length-1;
					}
				break;
				
				case "b":
					switch(Challenges.area)
					{
					default:
						MainMenu.init();
					break;
					
					case "preset":
						Challenges.switchArea("");
					break;
					}
				break;
				
				case "a":
					if (Challenges.area == "challenge")
					{
						Challenges.options[Challenges.onIndex].action();
					}
				break;
				
				case "l":
				case "l2":
					if (Challenges.area == "preset")
						Challenges.loadPrevPage();
				break;
				
				case "r":
				case "r2":
					if (Challenges.area == "preset")
						Challenges.loadNextPage();
				break;
				}
			}
		});
	};
	
	//Render Function
	this.recentChanges = {};
	this.render = function()
	{
		var cxt = Render.renderContext;
		
		//Clear
		Render.renderClear("all");
		var cxt = Render.tvContext, gxt = Render.gp0Context;
		
		//Background
		cxt.fillStyle = "#000"; gxt.fillStyle = "#000";
		cxt.drawImage(Render.images["space1"], 0, 0, Render.tvWidth, Render.tvHeight);
		gxt.drawImage(Render.images["space1"], 0, 0, Render.gp0Width, Render.gp0Height);
		cxt.globalAlpha = 0.7; gxt.globalAlpha = 0.7;
		cxt.fillRect(0, 0, Render.tvWidth, Render.tvHeight);
		gxt.fillRect(0, 0, Render.gp0Width, Render.gp0Height);
		cxt.globalAlpha = 1; gxt.globalAlpha = 1;
		
		switch(this.area)
		{
		default:
			//Challenges Title
			/*cxt.strokeStyle = "#000";
			cxt.font = "110px Verdana";
			cxt.textAlign = "center";
			cxt.strokeText("Challenges", Render.tvWidth/2, -5);
			cxt.textAlign = "left";
			
			gxt.fillStyle = "#FFF";
			gxt.font = "32px Verdana";
			gxt.textAlign = "center";
			gxt.fillText("Challenges", Render.gp0Width/2, 5);
			gxt.textAlign = "left";*/
			var w = 800*Render.renderTVRatio, h = w*(437/2087);
			cxt.drawImage(Render.images["challenges_title"], Render.tvWidth/2-w/2, 25*Render.renderTVRatio, w, h);
			
			var w = 325, h = w*(437/2087);
			gxt.drawImage(Render.images["challenges_title"], Render.gp0Width/2-w/2, 10, w, h);
			
			
			//Loop through the areas and display
			var x=Render.tvWidth/3,y=-50*Render.renderTVRatio,map,imgW=492*Render.renderTVRatio,imgH=328*Render.renderTVRatio,
				x2=Render.gp0Width/3,y2=-40,imgW2=492*0.45,imgH2=328*0.45,
				pg=0;
			cxt.textAlign = "center"; gxt.textAlign = "center";
			cxt.font = "32px Verdana"; gxt.font = "20px Verdana";
			cxt.lineWidth = 1; gxt.lineWidth = 1;
			var challengeType;
			for(var _challengeType in this.mainmenu)
			{
				continue;
				challengeType = this.mainmenu[_challengeType];

				cxt.save();
				cxt.translate(x+Render.tvWidth*pg, y);
				gxt.save();
				gxt.translate(x2+Render.gp0Width*pg, y2);
				
				//Draw image
				/*
				if (map.previewGenerate != undefined)
				{
					if (-250 <= x+Render.tvWidth*pg+this.mapmenuOffsetX && x+Render.tvWidth*pg+this.mapmenuOffsetX <= Render.tvWidth*1.2)
					{
						//if (Challenges.disbaleMe == undefined || !Challenges.disbaleMe )
						map.previewGenerate(492, 328);
						cxt.drawImage(map.previewCanvas, -imgW/2, -imgH/2, imgW, imgH);
						gxt.drawImage(map.previewCanvas, -imgW2/2, -imgH2/2, imgW2, imgH2);
					}
				} else {
					//cxt.drawImage(Render.images["map_"+_mapID], -imgW/2, -imgH/2, imgW, imgH);
					//gxt.drawImage(Render.images["map_"+_mapID], -imgW2/2, -imgH2/2, imgW2, imgH2);
				}*/
				
				//Draw border
				cxt.strokeStyle = "#666";
				cxt.strokeRect(-imgW/2, -imgH/2, imgW, imgH);
				gxt.strokeStyle = "#666";
				gxt.strokeRect(-imgW2/2, -imgH2/2, imgW2, imgH2);
				
				//Disabled?
				if (challengeType.disabled)
				{
					cxt.globalAlpha = 0.7; gxt.globalAlpha = 0.7;
					cxt.fillStyle = "#000"; gxt.fillStyle = "#000";
					cxt.fillRect(-imgW/2, -imgH/2, imgW, imgH);
					gxt.fillRect(-imgW2/2, -imgH2/2, imgW2, imgH2);
					cxt.globalAlpha = 1; gxt.globalAlpha = 1;
				}
				
				//Title
				if (challengeType.disabled)
				{
					cxt.fillStyle = "#666"; gxt.fillStyle = "#666";
				} else {
					cxt.fillStyle = "#FFF"; gxt.fillStyle = "#FFF";
				}
				cxt.fillText(challengeType.title, 0, imgH/2+5);
				gxt.fillText(challengeType.title, 0, imgH2/2+5);
				
				cxt.restore();
				gxt.restore();
				
				//Add click
				if (this.recentChanges["challengeclick_"+_mapID] == undefined || this.recentChanges["challengeclick_"+_mapID] == "n")
				{
					ClickBank.add({
						id: "map_"+_mapID,
						x: x2-imgW2/2+Render.gp0Width*pg+this.mapmenuOffsetX2,
						y: y2-imgH2/2,
						w: imgW2,
						h: imgH2,
						click: function(clickID, vaultEntry)
						{
							ClickBank.clearAll();
							Challenges.area = vaultEntry.data.challengeType;
							Challenges.recentChanges = {};
						},
						data: {
							challengeType: _challengeType
						}
					});
					
					this.recentChanges["challengeclick_"+_mapID] = "y";
				}
				
				x += Render.tvWidth/3;
				x2 += Render.gp0Width/3;
			}
			

			//Options on Gamepad
			gxt.font = "24px Verdana";
			gxt.fillStyle = "#FFF";
			gxt.textAlign = "center";
			gxt.strokeStyle = "#666";

			//Main Menu
			var x = (Render.gp0Width-15)-155, y = Render.gp0Height-50, w = 155, h = 35;
			var str = "Main Menu";
			gxt.drawImage(Render.images["button1"], x, y, w, h);
			gxt.strokeRect(x, y, w, h);
			gxt.fillText(str, x+w/2, y);
			if (this.recentChanges["mainmenu"] == undefined || this.recentChanges["mainmenu"] == "n")
			{
				ClickBank.add({
					id: "mainmenu",
					x: x, y: y, w: w, h: h,
					click: function(clickID, vaultEntry)
					{
						MainMenu.init();
					}
				});
				this.recentChanges["mainmenu"] = "y";
			}
			
			
			gxt.textAlign = "left";
		break;
		
		case "preset":
			//Game Title
			var w = 800*Render.renderTVRatio, h = w*(437/2087);
			cxt.drawImage(Render.images["challenges_title"], Render.tvWidth/2-w/2, 35*Render.renderTVRatio, w, h);
			
			var w = 325, h = w*(437/2087);
			gxt.drawImage(Render.images["challenges_title"], Render.gp0Width/2-w/2, 10, w, h);
			
			
			//Loop through the maps and display
			var x=Render.tvWidth/3,y=-50*Render.renderTVRatio,map,imgW=492*Render.renderTVRatio,imgH=328*Render.renderTVRatio,
				x2=Render.gp0Width/3,y2=-40,imgW2=492*0.45,imgH2=328*0.45,
				pg=0;
			cxt.textAlign = "center"; gxt.textAlign = "center";
			cxt.font = "32px Verdana"; gxt.font = "20px Verdana";
			cxt.lineWidth = 1; gxt.lineWidth = 1;
			var count = 0,map,preset,_mapID;
			for(var __key in this.preset)
			{
				preset = this.preset[__key];
				_mapID = preset.map;
				map = __Maps[_mapID];
				if (map.isHidden) continue
				if (x == Render.tvWidth/3)
				{
					y += 430*Render.renderTVRatio;
					y2 += 195;
					
					if (y == (-50+430+430+430)*Render.renderTVRatio)
					{
						pg++;
						y = (-50+430)*Render.renderTVRatio;
						y2 = -40+195;
					}
				}
				
				count++;

				cxt.save();
				cxt.translate(x+Render.tvWidth*pg+this.mapmenuOffsetX, y);
				gxt.save();
				gxt.translate(x2+Render.gp0Width*pg+this.mapmenuOffsetX2, y2);
				
				//Draw image
				if (map.previewGenerate != undefined)
				{
					if (-250 <= x+Render.tvWidth*pg+this.mapmenuOffsetX && x+Render.tvWidth*pg+this.mapmenuOffsetX <= Render.tvWidth*1.2)
					{
						//if (Challenges.disbaleMe == undefined || !Challenges.disbaleMe )
						map.previewGenerate(492, 328);
						cxt.drawImage(map.previewCanvas, -imgW/2, -imgH/2, imgW, imgH);
						gxt.drawImage(map.previewCanvas, -imgW2/2, -imgH2/2, imgW2, imgH2);
					}
				} else {
					//cxt.drawImage(Render.images["map_"+_mapID], -imgW/2, -imgH/2, imgW, imgH);
					//gxt.drawImage(Render.images["map_"+_mapID], -imgW2/2, -imgH2/2, imgW2, imgH2);
				}
				
				//Draw border
				cxt.strokeStyle = "#666";
				cxt.strokeRect(-imgW/2, -imgH/2, imgW, imgH);
				gxt.strokeStyle = "#666";
				gxt.strokeRect(-imgW2/2, -imgH2/2, imgW2, imgH2);
				
				//Disabled?
				if (map.disabled)
				{
					cxt.globalAlpha = 0.7; gxt.globalAlpha = 0.7;
					cxt.fillStyle = "#000"; gxt.fillStyle = "#000";
					cxt.fillRect(-imgW/2, -imgH/2, imgW, imgH);
					gxt.fillRect(-imgW2/2, -imgH2/2, imgW2, imgH2);
					cxt.globalAlpha = 1; gxt.globalAlpha = 1;
				}
				
				//Title
				if (map.disabled)
				{
					cxt.fillStyle = "#666"; gxt.fillStyle = "#666";
				} else {
					cxt.fillStyle = "#FFF"; gxt.fillStyle = "#FFF";
				}
				cxt.fillText(preset.title, 0, imgH/2+5);
				gxt.fillText(preset.title, 0, imgH2/2+5);
				
				cxt.restore();
				gxt.restore();
				
				//Add click
				if (!this.pageSliding)
				{
					if (this.recentChanges["mapclick_"+__key] == undefined || this.recentChanges["mapclick_"+__key] == "n")
					{
						if (!map.disabled)
						{
							ClickBank.add({
								id: "map_"+__key,
								x: x2-imgW2/2+Render.gp0Width*pg+this.mapmenuOffsetX2,
								y: y2-imgH2/2,
								w: imgW2,
								h: imgH2,
								click: function(clickID, vaultEntry)
								{
									//Challenges.loadMap(vaultEntry.data.mapID, "Hard");
									ClickBank.clearAll();
									Challenges.area = "challenge";
									Challenges.challenge = Challenges.preset[vaultEntry.data.presetID];
									Challenges.onIndex = 0;
									Challenges.recentChanges = {};
								},
								data: {
									mapID: _mapID,
									presetID: __key
								}
							});
						}
						
						this.recentChanges["mapclick_"+__key] = "y";
					}
				} else {
					if (this.recentChanges["mapclick_"+__key] == "y")
					{
						ClickBank.clear("map_"+__key);
						this.recentChanges["mapclick_"+__key] = "n";
					}
				}
				
				x += Render.tvWidth/3;
				if (Math.abs(Render.tvWidth - x) <= 10) x = Render.tvWidth/3;
				x2 += Render.gp0Width/3;
				if (Math.abs(Render.gp0Width - x2) <= 10) x2 = Render.gp0Width/3;
			}
			//cxt.textAlign = "left"; gxt.textAlign = "left";
			
			this.maxPages = Math.floor(count/4);
			
			
			//Page Options
			if (this.page > (!this.pageShowHidden ? 0 : 0-Math.ceil(mapsCountHidden/4)) && !this.pageSliding)
			{
				gxt.drawImage(Render.images["arrow2"], 25, Render.gp0Height/2-150/2, 40, 150);
				if (this.recentChanges["pageleft"] == undefined || this.recentChanges["pageleft"] == "n")
				{
					ClickBank.add({
						id: "page_left",
						x: 25, y: Render.gp0Height/2-150/2, w: 40, h: 150,
						click: function()
						{
							Challenges.loadPrevPage();
						}
					});
					
					this.recentChanges["pageleft"] = "y";
				}
			} else {
				if (this.recentChanges["pageleft"] == "y")
				{
					ClickBank.clear("page_left");
					this.recentChanges["pageleft"] = "n";
				}
			}

			if (this.page < pg && !this.pageSliding)
			{
				gxt.drawImage(Render.images["arrow1"], Render.gp0Width-25-40, Render.gp0Height/2-150/2, 40, 150);
				if (this.recentChanges["pageright"] == undefined || this.recentChanges["pageright"] == "n")
				{
					ClickBank.add({
						id: "page_right",
						x: Render.gp0Width-25-40, y: Render.gp0Height/2-150/2, w: 40, h: 150,
						click: function()
						{
							Challenges.loadNextPage();
						}
					});
					
					this.recentChanges["pageright"] = "y";
				}
			} else {
				if (this.recentChanges["pageright"] == "y")
				{
					ClickBank.clear("page_right");
					this.recentChanges["pageright"] = "n";
				}
			}
			
			//Options on Gamepad
			gxt.font = "24px Verdana";
			gxt.fillStyle = "#FFF";
			gxt.textAlign = "center";
			gxt.strokeStyle = "#666";
			
			//Options
			var x = 15, y = Render.gp0Height-50, w = 135, h = 35;
			var str = "Back";
			gxt.drawImage(Render.images["button1"], x, y, w, h);
			gxt.strokeRect(x, y, w, h);
			gxt.fillText(str, x+w/2, y);
			if (this.recentChanges["back"] == undefined || this.recentChanges["back"] == "n")
			{
				ClickBank.add({
					id: "back",
					x: x, y: y, w: w, h: h,
					click: function(clickID, vaultEntry)
					{
						Challenges.switchArea("");
					}
				});
				this.recentChanges["back"] = "y";
			}
			
			//Main Menu
			var x = (Render.gp0Width-15)-155, y = Render.gp0Height-50, w = 155, h = 35;
			var str = "Main Menu";
			gxt.drawImage(Render.images["button1"], x, y, w, h);
			gxt.strokeRect(x, y, w, h);
			gxt.fillText(str, x+w/2, y);
			if (this.recentChanges["mainmenu"] == undefined || this.recentChanges["mainmenu"] == "n")
			{
				ClickBank.add({
					id: "mainmenu",
					x: x, y: y, w: w, h: h,
					click: function(clickID, vaultEntry)
					{
						MainMenu.init();
					}
				});
				this.recentChanges["mainmenu"] = "y";
			}
			
			
			gxt.textAlign = "left";
		break;
		
		case "challenge":
			var challenge = this.challenge;
			var map = challenge.map, mapObj = __Maps[map];
			
			//Map Title
			cxt.fillStyle = "#FFF";
			cxt.font = "60px Verdana";
			cxt.textAlign = "center";
			cxt.fillText(challenge.title, Render.tvWidth/2, 10*Render.renderTVRatio);
			cxt.fillText(mapObj.title, Render.tvWidth/2, 100*Render.renderTVRatio);
			cxt.fillStyle = "#F8F8F8";
			cxt.font = "40px Verdana";
			var lines = Render.splitText(cxt, challenge.description, 1000);
			for(var key in lines)
				cxt.fillText(lines[key], Render.tvWidth/2, (250+65*parseInt(key))*Render.renderTVRatio);
			
			gxt.fillStyle = "#FFF";
			gxt.font = "32px Verdana";
			gxt.textAlign = "center";
			gxt.fillText(challenge.title, Render.gp0Width/2, 10);
			gxt.fillText(mapObj.title, Render.gp0Width/2, 50);
			gxt.fillStyle = "#F8F8F8";
			gxt.font = "24px Verdana";
			var lines = Render.splitText(gxt, challenge.description, 700);
			for(var key in lines)
				gxt.fillText(lines[key], Render.gp0Width/2, (125+32*parseInt(key)));

			cxt.textBaseline = "middle"; gxt.textBaseline = "middle";
			
			var option;
			cxt.lineWidth = 1; gxt.lineWidth = 1;
			cxt.font = "55px Verdana"; gxt.font = "40px Verdana";
			cxt.textBaseline = "middle"; gxt.textBaseline = "middle";
			var x = Render.tvWidth/3, y = 980*Render.renderTVRatio, w = 600*Render.renderTVRatio, h = 125*Render.renderTVRatio,
				x2 = Render.gp0Width/3, y2 = 425, w2 = 265, h2 = 60,
				_h = 100*Render.renderTVRatio, _h2 = 50,
				bcDefault = "#AAA", bcOn = "#FFF", bc,
				bgDefault = "#000", bgOn = "#333", bg;
			for(var i=0,n=2; i<n; i++)
			{
				option = this.options[i];
				
				bc = this.onIndex == i ? bcOn : bcDefault;
				bg = this.onIndex == i ? bgOn : bgDefault;
				cxt.strokeStyle = bc; gxt.strokeStyle = bc;
				cxt.fillStyle = bg; gxt.fillStyle = bg;
				cxt.drawImage(Render.images["button"+(this.onIndex == i ? "2" : "1")], x-w/2, y-h/2, w, h);
				gxt.drawImage(Render.images["button"+(this.onIndex == i ? "2" : "1")], x2-w2/2, y2-h2/2, w2, h2);
				cxt.strokeStyle = "#666"; gxt.strokeStyle = "#666";
				cxt.strokeRect(x-w/2, y-h/2, w, h);
				gxt.strokeRect(x2-w2/2, y2-h2/2, w2, h2);
				
				cxt.fillStyle = "#FFF"; gxt.fillStyle = "#FFF";
				cxt.fillText(option.value, x, y);
				gxt.fillText(option.value, x2, y2);
				
				if (this.recentChanges["clickbutton_"+i] == undefined || this.recentChanges["clickbutton_"+i] == "n")
				{
					ClickBank.add({
						id: "button_"+i,
						group: "options",
						x: x2-w2/2, y: y2-h2/2, w: w2, h: h2,
						click: option.action,
						data: {
							index: i
						}
					});
					
					this.recentChanges["clickbutton_"+i] = "y";
				}
				
				//x += w*1.15; x2 += w2*1.15;
				x *= 2; x2 *= 2;
			}
			
			/*
			cxt.lineWidth = 1; gxt.lineWidth = 1;
			cxt.font = "55px Verdana"; gxt.font = "40px Verdana";
			cxt.textBaseline = "middle"; gxt.textBaseline = "middle";
			var x = Render.tvWidth/2, y = 300*Render.renderTVRatio, w = 900*Render.renderTVRatio, h = 125*Render.renderTVRatio,
				x2 = Render.gp0Width/2, y2 = 150, w2 = 550, h2 = 60,
				_h = 100*Render.renderTVRatio, _h2 = 50,
				bcDefault = "#AAA", bcOn = "#FFF", bc,
				bgDefault = "#000", bgOn = "#333", bg;
			y += h*1.5; y2 += h2*1.5;
			for(var i=2,n=this.options.length; i<n; i++)
			{
				option = this.options[i];
				
				bc = this.onIndex == i ? bcOn : bcDefault;
				bg = this.onIndex == i ? bgOn : bgDefault;
				cxt.strokeStyle = bc; gxt.strokeStyle = bc;
				cxt.fillStyle = bg; gxt.fillStyle = bg;
				cxt.drawImage(Render.images["button"+(this.onIndex == i ? "2" : "1")], x-w/2, y-h/2, w, h);
				gxt.drawImage(Render.images["button"+(this.onIndex == i ? "2" : "1")], x2-w2/2, y2-h2/2, w2, h2);
				cxt.strokeStyle = "#666"; gxt.strokeStyle = "#666";
				cxt.strokeRect(x-w/2, y-h/2, w, h);
				gxt.strokeRect(x2-w2/2, y2-h2/2, w2, h2);
				
				cxt.fillStyle = "#FFF"; gxt.fillStyle = "#FFF";
				cxt.fillText(option.value, x, y);
				gxt.fillText(option.value, x2, y2);
				
				if (this.recentChanges["clickbutton_"+i] == undefined || this.recentChanges["clickbutton_"+i] == "n")
				{
					ClickBank.add({
						id: "button_"+i,
						group: "options",
						x: x2-w2/2, y: y2-h2/2, w: w2, h: h2,
						click: option.action,
						data: {
							index: i
						}
					});
					
					this.recentChanges["clickbutton_"+i] = "y";
				}
				
				y += h*1.5; y2 += h2*1.5;
			}*/

			cxt.textBaseline = "top"; gxt.textBaseline = "top";
			cxt.textAlign = "left"; gxt.textAlign = "left";
		break;
		}
	};
	
	//Switch Area
	this.switchArea = function(area)
	{
		ClickBank.clearAll();
		this.recentChanges = {};
		this.area = area;
	};
	
	//Slides the page to the left
	this.loadingNewPage = null;
	this.loadNextPage = function()
	{
		if (this.pageSliding) return false;
		if (Challenges.page >= Math.ceil(this.maxPages-1)) return false;
		this.pageSliding = true;
		
		Challenges.mapmenuOffsetX0 = Render.tvWidth;
		
		clearInterval(this.loadingNewPage);
		this.loadingNewPage = setInterval(function()
		{
			Challenges.mapmenuOffsetX -= Render.tvWidth/50;
			Challenges.mapmenuOffsetX2 -= Render.gp0Width/50;
			Challenges.mapmenuOffsetX0 -= Render.tvWidth/50;
			
			if (Math.abs(Challenges.mapmenuOffsetX0) < 5)
			{
				clearInterval(Challenges.loadingNewPage);
				Challenges.page++;
				Challenges.pageSliding = false;
				Challenges.mapmenuOffsetX = -Render.tvWidth*Challenges.page;
				Challenges.mapmenuOffsetX2 = -Render.gp0Width*Challenges.page;
			}
		}, 15);
	};
	
	//Slides the page to the right
	this.loadPrevPage = function()
	{
		if (this.pageSliding) return false;
		if ((!this.pageShowHidden && Challenges.page <= 0) || (this.pageShowHidden && Challenges.page <= 0-Math.ceil(mapsCountHidden/4))) return false;
		this.pageSliding = true;
		
		Challenges.mapmenuOffsetX0 = Render.tvWidth;
		
		clearInterval(this.loadingNewPage);
		this.loadingNewPage = setInterval(function()
		{
			Challenges.mapmenuOffsetX += Render.tvWidth/50;
			Challenges.mapmenuOffsetX2 += Render.gp0Width/50;
			Challenges.mapmenuOffsetX0 -= Render.tvWidth/50;
			
			if (Math.abs(Challenges.mapmenuOffsetX0) < 5)
			{
				clearInterval(Challenges.loadingNewPage);
				Challenges.page--;
				Challenges.pageSliding = false;
				Challenges.mapmenuOffsetX = -Render.tvWidth*Challenges.page;
				Challenges.mapmenuOffsetX2 = -Render.gp0Width*Challenges.page;
			}
		}, 15);
	};
	
	
	//Will load the map
	this.loadMap = function(mapID, mode)
	{
		//Clear all Image cache
		for(var tempMap in __Maps)
		{
			if (__Maps[tempMap].previewCanvas)
				$(__Maps[tempMap].previewCanvas).remove();
			__Maps[tempMap].previewCanvas = null;
			__Maps[tempMap].previewContext = null;
			if (__Maps[tempMap].previewImages)
				for(var key in __Maps[tempMap].previewImages)
					delete __Maps[tempMap].previewImages[key];
			__Maps[tempMap].previewImages = {};
			if (__Maps[tempMap].previewData)
			{
				if (__Maps[tempMap].previewData.bgs)
				{
					for(var key in __Maps[tempMap].previewData.bgs)
						delete __Maps[tempMap].previewData.bgs[key];
					__Maps[tempMap].previewData.bgs = [];
				}
				__Maps[tempMap].previewData.enemies = [];
				if (__Maps[tempMap].previewData.paths)
					for(var key in __Maps[tempMap].previewData.paths)
						for(var key2 in __Maps[tempMap].previewData.paths[key].path)
						{
							__Maps[tempMap].previewData.paths[key].path[key2].x = __Maps[tempMap].previewData.paths[key].path[key2].x0;
							__Maps[tempMap].previewData.paths[key].path[key2].y = __Maps[tempMap].previewData.paths[key].path[key2].y0;
						}
			}
		}
		
		LoadingScreen.init(function()
		{
			nwf.system.WiiUSystem.getInstance().homeButtonEnabled = false;
			
			this.data.mapID = mapID;
			this.data.mode = mode;
			var map = __Maps[mapID];
			
			if (!map.scriptLoaded)
			{
				/*var _script = $(document.createElement("script"));
				_script.attr({
					src: "js/maps/"+mapID+".js",
					type: "text/javascript"
				});
				$("head").append(_script);*/
				
				return true;
			} else {
				map.scriptLoaded = false;
				//map.initCall(mode);
				
				return true;
			}
		}, function()
		{
			var map = __Maps[mapID];
			if (map.scriptLoadCall != undefined)
				map.scriptLoadCall();
		}, function()
		{
			var mapID = this.data.mapID;
			var map = __Maps[mapID];
			
			map.scriptIsLoaded();
			
			return map.scriptLoaded;
		}, function()
		{
			var mapID = this.data.mapID;
			var map = __Maps[mapID];
			
			map.scriptLoaded = true;
			map.initCall(this.data.mode);
			//nwf.system.WiiUSystem.getInstance().homeButtonEnabled = true;
		});
	};
};
var Challenges = new Challenges();