function GameGP0Display()
{
	this.container; this.tabDivs = {}; this.spotbotClicks = null; this.spotbotClicksObjs = {};
	this.baseX = 0; this.baseY = 34;
	this.mapOffset = {x: 0, y: 0};
	this.mapOffsetLimit = {x:0,y:0,w:Render.trueWidth,h:Render.trueHeight};
	this.mapWidth = Render.gp0Width-150; this.mapHeight = Render.gp0Height-34;
	
	this.tab = "overview";
	this.tabs = {
		overview: {
			title: "Overview"
		},
		resources: {
			title: "Resources"
		},
		bots: {
			title: "Active Bots"
		}
	};
	this.tabData = {};
	
	this.scrollbarActive = false;
	this.scrollbarOffsetY = 0;
	
	this.messageDisplayed = null;
	this.spotSelected = null;
	this.botSelected = null;
	this.botsSelected = null;
	this.resourceSelected = null;
	
	this.popupDiv = null;
	this.popupEnabled = false;
	this.popupCloseFunc = null;
	this.popupArea = "";
	
	this.gameSpeeds = {
		"0x": {
			title: "0x",
			allow: function()
			{
				return true;
			},
			enabled: function()
			{
				return Game.isPaused;
			},
			action: function()
			{
				if (Game.gameOver) return false;
				Game.isPaused = true;
				Game.fastEnabled = false;
				Game.gamePause = false;
			}
		},
		"1x": {
			title: "1x",
			allow: function()
			{
				return true;
			},
			enabled: function()
			{
				return !Game.isPaused && !Game.fastEnabled;
			},
			action: function()
			{
				if (Game.gameOver) return false;
				Game.isPaused = false;
				Game.fastEnabled = false;
				Game.fastRate = 1;
				Game.gamePause = false;
			}
		},
		"3x": {
			title: "3x",
			allow: function()
			{
				return true;
			},
			enabled: function()
			{
				return Game.fastEnabled && Game.fastRate == 3;
			},
			action: function()
			{
				if (Game.gameOver) return false;
				Game.isPaused = false;
				Game.fastEnabled = true;
				Game.fastRate = 3;
				Game.gamePause = false;
			}
		},
		"5x": {
			title: "5x",
			allow: function()
			{
				return Game.mode != "Insanity";
			},
			enabled: function()
			{
				return Game.fastEnabled && Game.fastRate == 5;
			},
			action: function()
			{
				if (Game.gameOver) return false;
				Game.isPaused = false;
				Game.fastEnabled = true;
				Game.fastRate = 5;
				Game.gamePause = false;
			}
		}
	};
	this.specials = {
		money: {
			title: "Money Multiplier",
			titleShort: "$",
			description: "special_money_desc"
		},
		score: {
			title: "Score Multiplier",
			titleShort: "#",
			description: "special_score_desc"
		},
		atomic: {
			title: "Atomic Bomb",
			titleShort: "A",
			description: "special_atomic_desc"
		},
		health: {
			title: "Health Pack",
			titleShort: "H",
			description: "special_health_desc"
		}
	};
	
	//Init
	this.init = function()
	{
		this.tab = "overview";
		this.popupEnabled = false;
		this.recentChanges = {};
		this.resourceSelected = null;
		
		Render.gp0RenderRatio = 0.6;
		
		var gpCord = Game.calculateTVCords(this.mapWidth, this.mapHeight, true);
		this.mapOffset = {
			x: (this.mapOffsetLimit.w/2)-(gpCord.x/2),
			y: (this.mapOffsetLimit.h-gpCord.y)/2
		};
		if (Game.mapClass.gp0ScreenOffset != undefined)
		{
			this.mapOffset.x += Game.mapClass.gp0ScreenOffset.x;
			this.mapOffset.y += Game.mapClass.gp0ScreenOffset.y;
		}
		Game.mapOffsetX = this.mapOffset.x;
		Game.mapOffsetY = this.mapOffset.y;
		
		
		//Game Speed Switch
		InputBank.add({
			id: "gamespeed_switch",
			type: ["l2", "r2"],
			action: function(clickID, vaultEntry, type, controller)
			{
				if (Game.gameOver) return true;
				switch(type)
				{
				case "l2":
					if (Game.isPaused && !Game.fastEnabled)
					{
						if (Game.mode != "Insanity")
						{
							Game.isPaused = false;
							Game.fastEnabled = true;
							Game.fastRate = 5;
						} else {
							Game.isPaused = false;
							Game.fastEnabled = true;
							Game.fastRate = 3;
						}
					} else if (!Game.isPaused && !Game.fastEnabled) {
						Game.isPaused = true;
						Game.fastEnabled = false;
					} else if (!Game.isPaused && Game.fastEnabled && Game.fastRate == 3) {
						Game.isPaused = false;
						Game.fastEnabled = false;
					} else if (!Game.isPaused && Game.fastEnabled) {
						Game.isPaused = false;
						Game.fastEnabled = true;
						Game.fastRate = 3;
					}
				break;
				
				case "r2":
					if (Game.isPaused && !Game.fastEnabled)
					{
						Game.isPaused = false;
						Game.fastEnabled = false;
					} else if (!Game.isPaused && !Game.fastEnabled) {
						Game.isPaused = false;
						Game.fastEnabled = true;
						Game.fastRate = 3;
					} else if (!Game.isPaused && Game.fastEnabled && Game.fastRate == 3 && Game.mode != "Insanity") {
						Game.isPaused = false;
						Game.fastEnabled = true;
						Game.fastRate = 5;
					} else if (!Game.isPaused && Game.fastEnabled) {
						Game.isPaused = true;
						Game.fastEnabled = false;
					}
				break;
				}
			}
		});
		
		//Tab Switch
		InputBank.add({
			id: "tab_switch",
			type: ["l", "r", "b"],
			action: function(clickID, vaultEntry, type, controller)
			{
				switch(type)
				{
				case "l":
					if (GameGP0Display.tab == "overview")
					{
						if (GameGP0Display.container.find(".tab[tab='extra']").length) GameGP0Display.switchTab("extra");
						else GameGP0Display.switchTab("bots");
					} else if (GameGP0Display.tab == "resources") GameGP0Display.switchTab("overview");
					else if (GameGP0Display.tab == "bots") GameGP0Display.switchTab("resources");
					else if (GameGP0Display.tab == "extra") GameGP0Display.switchTab("bots");
				break;
				
				case "r":
					if (GameGP0Display.tab == "overview") GameGP0Display.switchTab("resources");
					else if (GameGP0Display.tab == "resources") GameGP0Display.switchTab("bots");
					else if (GameGP0Display.tab == "bots") {
						if (GameGP0Display.container.find(".tab[tab='extra']").length) GameGP0Display.switchTab("extra");
						else GameGP0Display.switchTab("overview");
					} else if (GameGP0Display.tab == "extra") GameGP0Display.switchTab("overview");
				break;
				
				case "b":
					//Game.atomicVisuals = 0;
					/*
					if (GameGP0Display.atomic == undefined)
					{
						GameGP0Display.atomic = {
							a: 5,
							b: 1000,
							c: 500,
							d: 25
						};
					}
					
					Particles.addEmitter(Render.tvWidth/2, Render.tvHeight/2, GameGP0Display.atomic.a, Math.PI,
						GameGP0Display.atomic.b, GameGP0Display.atomic.c,
						{
							image: "particle_grey",
							w: 5, h: 5,
							emissionRate: GameGP0Display.atomic.d,
							global: true
						});*/
				break;
				}
			}
		});
		
		//Map Move
		InputBank.add({
			id: "move_map",
			type: ["down", "up", "left", "right"],
			controller: "gp0",
			held: function(clickID, vaultEntry, type, controller)
			{
				var gpCord = Game.calculateTVCords(GameGP0Display.mapWidth, GameGP0Display.mapHeight, true);
				
				switch(type)
				{
				case "down":
					if (GameGP0Display.tab == "overview")
					{
						GameGP0Display.mapOffset.y += 10;
						if (GameGP0Display.mapOffset.y > GameGP0Display.mapOffsetLimit.h-gpCord.y)
							GameGP0Display.mapOffset.y = GameGP0Display.mapOffsetLimit.h-gpCord.y;
						
						Game.mapOffsetX = GameGP0Display.mapOffset.x;
						Game.mapOffsetY = GameGP0Display.mapOffset.y;
					} else {
						GameGP0Display.scrollbarScrollDown();
					}
				break;
				
				case "up":
					if (GameGP0Display.tab == "overview")
					{
						GameGP0Display.mapOffset.y -= 10;
						if (GameGP0Display.mapOffset.y < GameGP0Display.mapOffsetLimit.y)
							GameGP0Display.mapOffset.y = GameGP0Display.mapOffsetLimit.y;
						
						Game.mapOffsetX = GameGP0Display.mapOffset.x;
						Game.mapOffsetY = GameGP0Display.mapOffset.y;
					} else {
						GameGP0Display.scrollbarScrollUp();
					}
				break;
				
				case "right":
					if (GameGP0Display.tab == "overview")
					{
						GameGP0Display.mapOffset.x += 10;
						if (GameGP0Display.mapOffset.x > GameGP0Display.mapOffsetLimit.w-gpCord.x)
							GameGP0Display.mapOffset.x = GameGP0Display.mapOffsetLimit.w-gpCord.x;
						
						Game.mapOffsetX = GameGP0Display.mapOffset.x;
						Game.mapOffsetY = GameGP0Display.mapOffset.y;
					}
				break;
				
				case "left":
					if (GameGP0Display.tab == "overview")
					{
						GameGP0Display.mapOffset.x -= 10;
						if (GameGP0Display.mapOffset.x < GameGP0Display.mapOffsetLimit.x)
							GameGP0Display.mapOffset.x = GameGP0Display.mapOffsetLimit.x;
						
						Game.mapOffsetX = GameGP0Display.mapOffset.x;
						Game.mapOffsetY = GameGP0Display.mapOffset.y;
					}
				break;
				}
			}
		});
		InputBank.add({
			id: "move_map2",
			type: ["left", "right"],
			stick: function(clickID, vaultEntry, type, controller, x, y)
			{
				if (GameGP0Display.tab == "overview")
				{
					var gpCord = Game.calculateTVCords(GameGP0Display.mapWidth, GameGP0Display.mapHeight, true);
					
					var xMove = Math.round(x*10), yMove = Math.round(y*10);
					GameGP0Display.mapOffset.x += xMove;
					GameGP0Display.mapOffset.y += yMove;
	
					if (GameGP0Display.mapOffset.y > GameGP0Display.mapOffsetLimit.h-gpCord.y)
						GameGP0Display.mapOffset.y = GameGP0Display.mapOffsetLimit.h-gpCord.y;
					else if (GameGP0Display.mapOffset.y < GameGP0Display.mapOffsetLimit.y)
						GameGP0Display.mapOffset.y = GameGP0Display.mapOffsetLimit.y;
					if (GameGP0Display.mapOffset.x > GameGP0Display.mapOffsetLimit.w-gpCord.x)
						GameGP0Display.mapOffset.x = GameGP0Display.mapOffsetLimit.w-gpCord.x;
					else if (GameGP0Display.mapOffset.x < GameGP0Display.mapOffsetLimit.x)
						GameGP0Display.mapOffset.x = GameGP0Display.mapOffsetLimit.x;
					
					Game.mapOffsetX = GameGP0Display.mapOffset.x;
					Game.mapOffsetY = GameGP0Display.mapOffset.y;
					
				} else {
					if (y > 0) GameGP0Display.scrollbarScrollDown();
					else if (y < 0) GameGP0Display.scrollbarScrollUp();
				}
			}
		});
		
		//Open up the div
		this.open();
	};
	
	//Open the main div and set things up
	this.open = function()
	{
		GameGP0DisplayClicks.init();
		
		this.tabDivs = {}; this.spotbotClicks = null; this.popupDiv = null; this.spotbotClicksObjs = {};
		this.overviewStatsObjs = {};
		this.container = $(document.createElement("div"));
		this.container.attr({
			id: "gp0display"
		}).css({
			position: "absolute",
			top: "0px",
			left: "0px",
			width: Render.gp0Width+"px",
			height: Render.gp0Height+"px",
			//"font-family": "Verdana",
			color: "#FFF",
			"z-index": 10
		});
		
		var div = $(document.createElement("div"));
		div.attr({
			id: "gp0displayClicks"
		}).css({
			position: "absolute",
			top: "0px",
			left: "0px",
			width: Render.gp0Width+"px",
			height: Render.gp0Height+"px",
			"z-index": 1000
		}).click(function(e)
		{
			GameGP0DisplayClicks.click(e);
		}).mousedown(function(e)
		{
			GameGP0DisplayClicks.mouseDown(e);
		}).mousemove(function(e)
		{
			GameGP0DisplayClicks.mouseMove(e);
		}).mouseup(function(e)
		{
			GameGP0DisplayClicks.mouseUp(e);
		});
		this.container.append(div);
		
		
		/* Top Area */
		var minbasey = 34;
		
		//Background
		var spaceBGWidth = Render.images["space1"].width, spaceBGHeight = Render.images["space1"].height;
		var background = $(document.createElement("div"));
		background.css({
			position: "absolute",
			top: "0px",
			left: "0px",
			width: Render.gp0Width+"px",
			height: "34px",
			background: "#000"
			//background: "URL('"+Render.images["space1"].src+"')",
			//"background-size": Render.gp0Width+"px 32px"
		});
		this.container.append(background);
		background = $(document.createElement("div"));
		background.css({
			position: "absolute",
			top: "0px",
			left: "0px",
			width: Render.gp0Width+"px",
			height: "34px",
			background: "#000",
			opacity: "0.85"
		});
		this.container.append(background);
		
		var div = $(document.createElement("div"));
		div.css({
			position: "absolute",
			top: minbasey+"px",
			left: "0px",
			width: Render.gp0Width+"px",
			height: "1px",
			background: "#EEE"
		});
		this.container.append(div);
		
		//Tabs at top
		var x=15,y=5,w,h=minbasey-y-1,tab;
		for(var type in this.tabs)
		{
			tab = this.tabs[type];
			w = 100;
			
			var div = $(document.createElement("div"));
			div.attr({
				tab: type
			}).addClass("tab_buttons clickevents").css({
				position: "absolute",
				left: x+"px",
				top: y+"px",
				width: w+"px",
				height: h+"px",
				border: "1px solid #AAA",
				//"font-family": "Verdana",
				"font-size": "14px",
				color: "#FFF"
			}).html("<img class='img_off' src='media/etc/tab_off.jpg' style='width:"+w+"px;height:"+h+"px;"+(this.tab != type ? "" : "display:none;")+"' />" +
					"<img class='img_on' src='media/etc/tab_on.jpg' style='width:"+w+"px;height:"+h+"px;"+(this.tab != type ? "display:none;" : "")+"' />" +
					"<div class='dark' style='position:absolute;left:0px;top:0px;width:"+w+"px;height:"+h+"px;background:#000;opacity:0.3;display:"+(this.tab != type ? "none" : "block")+";'>&nbsp;</div>" +
					"<div class='text' style='position:absolute;left:0px;top:4px;width:"+w+"px;text-align:center;'>"+_t(tab.title)+"</div>").click(function()
			{
				GameGP0Display.switchTab($(this).attr("tab"));
			});
			this.container.append(div);
			
			x += w;
		}
		setTimeout(function()
		{
			GameGP0Display.container.find(".tab_buttons > .text").each(function()
			{
				if ($(this).height() < 30) return true;
				
				var font = 14;
				while($(this).height() > 30 && font >= 10)
				{
					$(this).css("font-size", font+"px");
					font--;
				}
			});
		}, 25);
		
		//755 - 783
		//8   - 32
		//Game Speed
		x=Render.gp0Width-15,y=8,w=28,h=24;
		
		if (Game.mode != "Endless")
		{
			w = 100;
			div = $(document.createElement("div"));
			div.attr({
				id: "autopausebutton"
			}).addClass("clickevents").css({
				position: "absolute",
				left: (x-w)+"px",
				top: (y+1)+"px",
				width: w+"px",
				height: (h-1)+"px",
				border: "1px solid #999",
				"border-bottom": "0px",
				//"font-family": "Verdana",
				"padding-top": "1px",
				"font-size": "14px",
				color: "#FFF",
				"text-align": "center"
			}).html(_t("Auto Pause")).click(function()
			{
				Game.autoPauseOnNewLevels = !Game.autoPauseOnNewLevels;
			});
			this.container.append(div);
			x -= w;
		}
		w=28;
		
		var gameSpeeds = ["5x", "3x", "1x", "0x"], gameSpeed, gameSpeedObj, innerW=20;
		for(var key in gameSpeeds)
		{
			gameSpeed = gameSpeeds[key];
			gameSpeedObj = this.gameSpeeds[gameSpeed];
			if (!gameSpeedObj.allow()) continue;
			
			div = $(document.createElement("div"));
			div.attr({
				speed: gameSpeed
			}).addClass("gamespeeds clickevents").css({
				position: "absolute",
				left: (x-w)+"px",
				top: (y+1)+"px",
				width: w+"px",
				height: (h-1)+"px",
				border: "1px solid #999",
				"border-bottom": "0px",
				//"font-family": "Verdana",
				"padding-top": "1px",
				"font-size": "14px",
				color: "#FFF",
				"text-align": "center"
			}).html(gameSpeedObj.title).click(function()
			{
				GameGP0Display.gameSpeeds[$(this).attr("speed")].action();
			});
			this.container.append(div);
			
			x -= w;
		}
		
		var div = $(document.createElement("div"));
		div.css({
			position: "absolute",
			left: (x-110-25)+"px",
			top: (y+2-20)+"px",
			width: "125px",
			height: "40px",
			//"font-family": "Verdana",
			"font-size": "14px",
			"line-height": "14px",
			color: "#DDD",
			"text-align": "right",
			"word-break": "break-all",
			"vertical-align": "text-bottom"
		}).html("<div style='position:absolute;bottom:0px;left:0px;width:100%;'>"+_t("Game Speed")+":</div>");
		this.container.append(div);
		

		/* Tabs */
		/* Overview */
		
		var tab = $(document.createElement("div"));
		this.container.append(tab);
		tab.addClass("tab").attr({tab: "overview"}).css({
			position: "absolute",
			left: "0px",
			top: (minbasey+1)+"px",
			width: Render.gp0Width+"px",
			height: (Render.gp0Height-minbasey)+"px"
		});
		x = 15; y = 0;
		
		//Stats/etc
		x = Render.gp0Width - 150;
		
		background = $(document.createElement("div"));
		background.css({
			position: "absolute",
			left: x+"px",
			top: y+"px",
			width: "150px",
			height: (Render.gp0Height-minbasey)+"px",
			background: "#000"
		});
		tab.append(background);
		background = $(document.createElement("div"));
		background.css({
			position: "absolute",
			left: x+"px",
			top: y+"px",
			width: "150px",
			height: (Render.gp0Height-minbasey)+"px",
			background: "#000",
			opacity: "0.85"
		});
		tab.append(background);
		/*gxt.drawImage(Render.images["space1"],
			spaceBGWidth*(x/Render.gp0Width), spaceBGHeight*(y/Render.gp0Height),
			spaceBGWidth*((Render.gp0Width-x)/Render.gp0Width), spaceBGHeight*((Render.gp0Height-y)/Render.gp0Height),
			x, y, Render.gp0Width-x, Render.gp0Height-y);*/

		div = $(document.createElement("div"));
		div.css({
			position: "absolute",
			left: x+"px",
			top: y+"px",
			width: "1px",
			height: (Render.gp0Height-minbasey)+"px",
			background: "#DDD"
		});
		tab.append(div);

		//var stats = this.overviewStats;
		var stats = [{
			name0: "Level",
			title: _t("Level"),
			value: Game.level
		}, {
			name0: Game.mode != "Endless" ? "Enemies Left" : "Enemies Destroyed",
			title: _t(Game.mode != "Endless" ? "Enemies Left" : "Enemies Destroyed"),
			value: Leaderboard.numberFormat(Game.mode != "Endless" ? Game.enemies.total_left : Game.enemies.dead)
		}, {
			name0: "Bank",
			title: _t("Bank"),
			value: "$"+Leaderboard.numberFormat(Game.money, "short"),
			statschangeshow: "money"
		}, {
			name0: "Score",
			title: _t("Score"),
			value: Leaderboard.numberFormat(Game.score, "short"),
			statschangeshow: "score"
		}];
		if (Game.mode == "Endless")
			stats.shift();
		var base,health=Game.basesLife,healthMax=Game.basesMaxLife,shield=Game.basesShield;
		for(var key in Game.mapClass.base)
		{
			base = Game.mapClass.base[key];
			
			health += base.life;
			healthMax += base.maxLife;
			shield += base.shield;
		}
		if (health < 0) health = 0;
		stats.push({
			name0: "Health",
			title: _t("Health"),
			value: Math.round((health/healthMax)*100)+"%",
			statschangeshow: "life"
		});
		if (shield > 0 || 1)
		{
			stats.push({
				name0: "Shield",
				title: _t("Shield"),
				value: 0,
				statschangeshow: "shield"
			});
		}
		stats.push({
			name0: "Loan Balance",
			title: _t("Loan Balance"),
			value: 0,
			//valueColor: "#FF0000",
			donotallowempty: true,
			statschangeshow: "loanbalance"
		});
		
		var stat;
		x += 5; y += 5;
		for(var key in stats)
		{
			y = 0;
			stat = stats[key];
			
			var div0 = $(document.createElement("div"));
			div0.attr({
				type: stat.name0
			}).addClass("statshowmaster").css({
				position: "relative",
				height: "42px",
				marginTop: "5px"
			});
			tab.append(div0);
			
			div = $(document.createElement("div"));
			div.attr({
				type: stat.name0
			}).addClass("statshow").css({
				position: "absolute",
				left: x+"px",
				top: y+"px",
				//"font-family": "Verdana",
				"font-size": "14px",
				"font-weight": "bold",
				color: "#FFF",
				overflow: "hidden"
			}).html("<div style='width:300px;'>"+stat.title+"</div>");
			div0.append(div);
			
			if (stat.statschangeshow)
			{
				div2 = $(document.createElement("div"));
				div2.attr({
					type: stat.name0,
					left: (x+5)
				}).addClass("specialsinuse").css({
					position: "absolute",
					left: (x+5)+"px",
					top: (y)+"px",
					//"font-family": "Verdana",
					"font-size": "14px",
					"font-weight": "bold",
					color: "green",
					display: "none"
				}).html("x");
				div0.append(div2);
				
				div2 = $(document.createElement("div"));
				div2.attr({
					type: stat.name0
				}).addClass("statschangeshow").css({
					position: "absolute",
					right: (5)+"px",
					top: (y+20)+"px",
					width: "150px",
					//"font-family": "Verdana",
					"font-size": "12px",
					color: "green",
					"text-align": "right",
					display: "none"
				}).html("");
				div0.append(div2);
			}
			y += 20;
			
			div = $(document.createElement("div"));
			div.css({
				position: "absolute",
				left: x+"px",
				top: y+"px",
				//"font-family": "Verdana",
				"font-size": "12px",
				color: "#FFF"
			}).html("> <span class='stats_amt' type='"+stat.name0+"' style='color:#FFFFFF;'>"+stat.value+"</span>");
			div0.append(div);
			
			y += 30;
		}
		
		//Specials
		y = Render.gp0Height - minbasey - 65;
		div = $(document.createElement("div"));
		div.css({
			position: "absolute",
			left: x+"px",
			top: y+"px",
			//"font-family": "Verdana",
			"font-size": "16px",
			color: "#FFF"
		}).html(_t("Specials"));
		tab.append(div);
		
		x += 10;
		y += 35;
		var specials = this.specials;
		var special, numLeft;
		for(var type in specials)
		{
			special = specials[type];
			numLeft = Game.specials[type];
			
			div = $(document.createElement("div"));
			div.attr({
				type: type
			}).addClass("specialsquickbtn clickevents").css({
				position: "absolute",
				left: x+"px",
				top: y+"px",
				width: "20px",
				height: "22px",
				//"font-family": "Verdana",
				"font-size": "14px",
				color: "#999",
				border: "1px solid #999",
				"text-align": "center"
			}).html(special.titleShort).click(function()
			{
				var type = $(this).attr("type");
				numLeft = Game.specials[type];
				
				if (numLeft > 0)
					Game.activateSpecial(type);
				
				GameGP0Display.recentChanges.specialsMessage = 0;
			});
			tab.append(div);
			
			x += 35;
		}
		

		//Render Map
		var baseX = 0, baseY = 0;
		div = $(document.createElement("div"));
		div.attr({
			id: "spotbot_clicks"
		}).css({
			position: "absolute",
			left: "0px",
			top: "0px",
			width: (this.mapWidth)+"px",
			height: (this.mapHeight)+"px",
			overflow: "hidden"
		});
		tab.append(div);
		this.spotbotClicks = div;
			
		//Game Paused?
		div = $(document.createElement("div"));
		div.attr({
			id: "gameispaused_msg"
		}).css({
			position: "absolute",
			left: "0px",
			top: "0px",
			width: (this.mapWidth-1)+"px",
			height: "29px",
			//"font-family": "Verdana",
			"font-size": "14px",
			color: "#FFF",
			background: "#000",
			"border-bottom": "1px solid #FFF",
			display: "none"
		}).html("<div style='position:absolute;left:0px;top:0px;width:"+(this.mapWidth-1)+"px;height:29px;background:#000;opacity:0.85;'></div>" +
				"<div style='position:absolute;left:0px;top:0px;width:"+(this.mapWidth-1)+"px;height:29px;padding:5px 0 0 7px;'>"+_t("gamepad_topmessage1")+"</div>" +
				"<div class='button clickevents' style='position:absolute;right:0px;top:0px;width:75px;height:29px;border-left:1px solid #FFF;text-align:center;'>" +
					"<img src='"+Render.images["button1"].src+"' style='width:75px;height:29px;' />" +
					"<div style='position:absolute;left:0px;top:5px;width:75px;text-align:center;'>"+_t("Resume")+"</div>" +
				"</div>");
		div.find(".button").click(function()
		{
			Game.isPaused = false;
		});
		tab.append(div);
		
		//Resource Selected?
		div = $(document.createElement("div"));
		div.attr({
			id: "resourceselected_msg"
		}).css({
			position: "absolute",
			left: "0px",
			top: "0px",
			width: (this.mapWidth-1)+"px",
			minHeight: "29px",
			//"font-family": "Verdana",
			"font-size": "14px",
			color: "#FFF",
			background: "#000",
			"border-bottom": "1px solid #FFF",
			display: "none"
		}).html(/*"<div style='position:absolute;left:0px;top:0px;width:"+(this.mapWidth-1)+"px;height:100%;background:#000;opacity:0.85;'></div>" +*/
				"<div style='width:"+(this.mapWidth-1-80-7)+"px;padding:5px 0 5px 7px;color:#FFF;'>"+_t("gamepad_topmessage2")+"</div>" +
				"<div class='button clickevents' style='position:absolute;right:0px;top:0px;width:80px;height:100%;border-left:1px solid #FFF;text-align:center;vertical-align:middle;'>" +
					"<img src='"+Render.images["button1"].src+"' style='width:80px;height:100%;' />" +
					"<div style='position:absolute;left:0px;top:50%;width:80px;height:100%;margin-top:-25%;text-align:center;vertical-align:middle;'>"+_t("Cancel")+"</div>" +
				"</div>");
		div.find(".button").click(function()
		{
			GameGP0Display.resourceSelected = null;
		});
		tab.append(div);
		
		//Message Displayed?
		div = $(document.createElement("div"));
		div.attr({
			id: "messagetodisplay_msg"
		}).css({
			position: "absolute",
			left: "0px",
			top: "0px",
			width: (this.mapWidth-1)+"px",
			height: "29px",
			//"font-family": "Verdana",
			"font-size": "14px",
			color: "#FFF",
			background: "#000",
			"border-bottom": "1px solid #FFF",
			display: "none"
		}).html("<div style='position:absolute;left:0px;top:0px;width:"+(this.mapWidth-1)+"px;height:29px;background:#000;opacity:0.85;'></div>" +
				"<div class='msg' style='position:absolute;left:0px;top:0px;width:"+(this.mapWidth-1)+"px;height:29px;padding:5px 0 0 7px;'></div>" +
				"<div class='button clickevents' style='position:absolute;right:0px;top:0px;width:75px;height:29px;border-left:1px solid #FFF;text-align:center;'>" +
					"<img src='"+Render.images["button1"].src+"' style='width:75px;height:29px;' />" +
					"<div style='position:absolute;left:0px;top:5px;width:75px;text-align:center;'>"+_t("Hide")+"</div>" +
				"</div>");
		div.find(".button").click(function()
		{
			GameGP0Display.messageDisplayed = null;
		});
		tab.append(div);
		
		
		//Map Zoom
		w = 25; h = 20;
		x = 0; y = Render.gp0Height-h-minbasey;
		div = $(document.createElement("div"));
		div.attr({
			id: "zoom_minus"
		}).addClass("clickevents").css({
			position: "absolute",
			left: x+"px",
			bottom: "1px",
			width: w+"px",
			height: h+"px",
			//"font-family": "Verdana",
			"font-size": "18px",
			color: "#FFF",
			border: "1px solid #666",
			"text-align": "center"
		}).html("<img class='img_off' src='"+Render.images["button_grey"].src+"' style='width:"+w+"px;height:"+h+"px;display:none;' />" +
				"<img class='img_on' src='"+Render.images["button2"].src+"' style='width:"+w+"px;height:"+h+"px;display:block;' />" +
				"<div style='position:absolute;left:0px;top:-5px;width:"+w+"px;'>-</div>").click(function()
		{
			if (Render.gp0RenderRatio < Render.gp0RenderRatioMin) return false;
			if (Render.gp0RenderRatio > Render.gp0RenderRatioMin)
				Render.gp0RenderRatio -= 0.1;
			if (Render.gp0RenderRatio < Render.gp0RenderRatioMin)
				Render.gp0RenderRatio = Render.gp0RenderRatioMin;
			
			var gpCord = Game.calculateTVCords(GameGP0Display.mapWidth, GameGP0Display.mapHeight, true);
			//GameGP0Display.mapOffset.x += gpCord.x/8;
			//GameGP0Display.mapOffset.y += gpCord.y/8;
			if (GameGP0Display.mapOffset.y > GameGP0Display.mapOffsetLimit.h-gpCord.y)
				GameGP0Display.mapOffset.y = GameGP0Display.mapOffsetLimit.h-gpCord.y;
			if (GameGP0Display.mapOffset.x > GameGP0Display.mapOffsetLimit.w-gpCord.x)
				GameGP0Display.mapOffset.x = GameGP0Display.mapOffsetLimit.w-gpCord.x;
			
			Game.mapOffsetX = GameGP0Display.mapOffset.x;
			Game.mapOffsetY = GameGP0Display.mapOffset.y;
			
			if (Render.gp0RenderRatio <= Render.gp0RenderRatioMin)
			{
				$("#zoom_minus").find(".img_off").show();
				$("#zoom_minus").find(".img_on").hide();
			}
			$("#zoom_plus").find(".img_on").show();
			$("#zoom_plus").find(".img_off").hide();
		});
		tab.append(div);
		x += w;
		if (Render.gp0RenderRatio <= Render.gp0RenderRatioMin)
		{
			tab.find("#zoom_minus").find(".img_off").show();
			tab.find("#zoom_minus").find(".img_on").hide();
		}
		
		div = $(document.createElement("div"));
		div.attr({
			id: "zoom_plus"
		}).addClass("clickevents").css({
			position: "absolute",
			left: x+"px",
			bottom: "1px",
			width: w+"px",
			height: h+"px",
			//"font-family": "Verdana",
			"font-size": "18px",
			color: "#FFF",
			border: "1px solid #666",
			"text-align": "center"
		}).html("<img class='img_off' src='"+Render.images["button_grey"].src+"' style='width:"+w+"px;height:"+h+"px;display:none;' />" +
				"<img class='img_on' src='"+Render.images["button2"].src+"' style='width:"+w+"px;height:"+h+"px;display:block;' />" +
				"<div style='position:absolute;left:0px;top:-5px;width:"+w+"px;'>+</div>").click(function()
		{
			if (Render.gp0RenderRatio >= Render.gp0RenderRatioMax) return false;
			if (Render.gp0RenderRatio < Render.gp0RenderRatioMax)
			{
				Render.gp0RenderRatio += 0.1;
				Render.gp0RenderRatio = Math.floor(Render.gp0RenderRatio*10.0)/10;
			}
			if (Render.gp0RenderRatio >= Render.gp0RenderRatioMax)
				Render.gp0RenderRatio = Render.gp0RenderRatioMax;
			
			var gpCord = Game.calculateTVCords(GameGP0Display.mapWidth, GameGP0Display.mapHeight, true);
			//GameGP0Display.mapOffset.x += gpCord.x/8;
			//GameGP0Display.mapOffset.y += gpCord.y/8;
			
			Game.mapOffsetX = GameGP0Display.mapOffset.x;
			Game.mapOffsetY = GameGP0Display.mapOffset.y;
			
			if (Render.gp0RenderRatio >= Render.gp0RenderRatioMax)
			{
				$("#zoom_plus").find(".img_off").show();
				$("#zoom_plus").find(".img_on").hide();
			}
			$("#zoom_minus").find(".img_on").show();
			$("#zoom_minus").find(".img_off").hide();
		});
		tab.append(div);
		if (Render.gp0RenderRatio >= Render.gp0RenderRatioMax)
		{
			tab.find("#zoom_plus").find(".img_off").show();
			tab.find("#zoom_plus").find(".img_on").hide();
		}
		
		
		
		/* Resources */
		var tab = $(document.createElement("div"));
		this.container.append(tab);
		tab.addClass("tab").attr({tab: "resources"}).css({
			position: "absolute",
			left: "0px",
			top: (minbasey+1)+"px",
			width: Render.gp0Width+"px",
			height: (Render.gp0Height-minbasey)+"px",
			display: "none"
		});
		x = 15; y = 0;
		
		background = $(document.createElement("div"));
		background.css({
			position: "absolute",
			left: "0px",
			top: "0px",
			width: tab.width()+"px",
			height: tab.height()+"px",
			background: "#000"
		});
		tab.append(background);
		background = $(document.createElement("div"));
		background.css({
			position: "absolute",
			left: "0px",
			top: "0px",
			width: tab.width()+"px",
			height: tab.height()+"px",
			background: "#000",
			opacity: "0.85"
		});
		tab.append(background);
		/*gxt.drawImage(Render.images["space1"],
			0, spaceBGHeight*(minbasey/Render.gp0Height),
			spaceBGWidth, spaceBGHeight*((Render.gp0Height-minbasey)/Render.gp0Height),
			0, minbasey, Render.gp0Width, Render.gp0Height);*/

		div = $(document.createElement("div"));
		div.css({
			position: "absolute",
			left: "15px",
			top: "10px",
			color: "#FFF",
			"font-size": "14px"
		}).html("<div class='fl' style='min-width:50px;margin-right:5px;'>"+_t("Bank")+":</div>" +
				"<div class='bankamt fl' style='color:#FFFFFF;'>$"+Leaderboard.numberFormat(Game.money)+"</div>" +
				"<div class='clear'></div>");
		tab.append(div);
		
		var overflow = $(document.createElement("div"));
		overflow.addClass("overflow").css({
			position: "absolute",
			left: "0px",
			top: "44px",
			width: (tab.width()-30)+"px",
			height: (tab.height()-44)+"px",
			padding: "0 15px",
			"overflow-x": "hidden",
			"overflow-y": "overflow"
		});
		tab.append(overflow);
		
		//Resource Items
		var x = 15, y = 45, _h;
		
		div = $(document.createElement("div"));
		div.css({
			height: "35px",
			"font-size": "24px"
		}).html(_t("Resource Items"));
		overflow.append(div);
		
		div = $(document.createElement("div"));
		div.css({
			width: overflow.width()+"px",
			height: "1px",
			"margin": "6px 0",
			background: "#1A1A1A"
		}).html("&nbsp;");
		overflow.append(div);
		
		var item, cost, lines, line;
		for(var type in __Store)
		{
			item = __Store[type];
			if (item.displayForPurchase != undefined && !item.displayForPurchase) continue;
			if (Game.mapClass.storeRules[type] && Game.mapClass.storeRules[type].enabled != undefined
				&& !Game.mapClass.storeRules[type].enabled) continue;
			
			cost = item.cost;
			if (item.costupgrade != undefined) cost = item.costupgrade();
			
			var itemDiv = $(document.createElement("div"));
			itemDiv.addClass("items").attr({
				type: type
			});
			overflow.append(itemDiv);
			
			div = $(document.createElement("div"));
			div.css({
				"font-size": "16px"
			}).html("<div class='fl' style='width:150px;'>"+_t(item.name)+"</div>" +
					"<div class='fl cost' style='color:#FFFFFF;'>$"+Leaderboard.numberFormat(cost, "short")+"</div>" +
					"<div class='clear'></div>");
			itemDiv.append(div);
			
			div = $(document.createElement("div"));
			div.attr({
				type: type
			}).addClass("fr buybtn clickevents").css({
				position: "relative",
				width: "70px",
				height: "26px",
				"margin-top": "-12px",
				border: "1px solid #666",
				"font-size": "16px"
			}).html("<img class='img_on' src='"+Render.images["button2"].src+"' style='width:70px;height:26px;' />" +
					"<img class='img_off' src='"+Render.images["button_grey"].src+"' style='width:70px;height:26px;display:none;' />" +
					"<div class='text' style='position:absolute;left:0px;top:2px;width:70px;text-align:center;'>"+_t("Add")+"</div>")
				.click(function()
				{
					var ID = GameGP0Display.spotSelected,
						spot = Game.spots[ID],
						type = $(this).attr("type"),
						item = __Store[type];
					var cost = item.cost;
					if (item.costupgrade != undefined) cost = item.costupgrade();
					if (cost > Game.money) return false;
					
					if (item.type == "bot")
					{
						GameGP0Display.resourceSelected = type;
						GameGP0Display.switchTab("overview");
					} else {
						if (Game.defenseAdd(type))
						{
							GameGP0Display.resourceExtraAdded = {
								message: _t((type == "drone" ? "gamepad_topmessage3" : "gamepad_topmessage4")),
								timer: Date.now()+5000
							};
						} else {
							GameGP0Display.resourceExtraAdded = {
								message: (type == "drone" ? _t("gamepad_topmessage5") : ""),
								timer: Date.now()+5000,
								color: "red"
							};
						}
					}
				});
			itemDiv.append(div);
			
			div = $(document.createElement("div"));
			div.addClass("fl").css({
				width: (overflow.width()-110)+"px",
				"margin-top": "7px",
				"margin-left": "15px",
				"font-size": "14px"
			}).html("<div>"+_t(item.description)+"</div>");
			itemDiv.append(div);
			itemDiv.append("<div class='clear'></div>");
			
			div = $(document.createElement("div"));
			div.css({
				width: overflow.width()+"px",
				height: "1px",
				"margin": "6px 0",
				background: "#1A1A1A"
			}).html("&nbsp;");
			overflow.append(div);
		}
		div = $(document.createElement("div"));
		div.css({
			height: "30px",
		}).html("&nbsp;");
		overflow.append(div);
		
		
		//Bank of GulAtiCa
		div = $(document.createElement("div"));
		div.css({
			height: "35px",
			"font-size": "24px"
		}).html(_t("bank_title"));
		overflow.append(div);
		
		div = $(document.createElement("div"));
		div.css({
			width: overflow.width()+"px",
			height: "1px",
			"margin": "6px 0",
			background: "#1A1A1A"
		}).html("&nbsp;");
		overflow.append(div);
		
		var loaninactive = $("<div id='bankloaninactive' />");
		overflow.append(loaninactive);
		
		div = $(document.createElement("div"));
		div.css({
			"font-size": "16px",
			"margin-bottom": "5px"
		}).html(_t("bank_message"));
		loaninactive.append(div);
		div = $(document.createElement("div"));
		div.css({
			width: overflow.width()+"px",
			height: "1px",
			"margin": "6px 0",
			background: "#1A1A1A"
		}).html("&nbsp;");
		loaninactive.append(div);
		
		var loanOption, loanOptionDiv;
		for(var type in Game.bankLoanOptions)
		{
			loanOption = Game.bankLoanOptions[type];
			
			var loanOptionDiv = $(document.createElement("div"));
			loanOptionDiv.addClass("loanoptions").attr({
				type: type
			});
			loaninactive.append(loanOptionDiv);
			
			div = $(document.createElement("div"));
			div.css({
				"font-size": "16px"
			}).html("<div class='fl' style='width:75px;'>"+_t(loanOption.title)+"</div>" +
					"<div class='fl amount' style='color:#FFFFFF;'>$0</div>" +
					"<div class='clear'></div>");
			loanOptionDiv.append(div);

			div = $(document.createElement("div"));
			div.attr({
				type: type,
				isclicked: "n"
			}).addClass("fr clickevents").css({
				position: "relative",
				width: "80px",
				height: "26px",
				"margin-top": "-12px",
				border: "1px solid #666",
				"font-size": "16px"
			}).html("<img class='img_on' src='"+Render.images["button2"].src+"' style='width:80px;height:26px;' />" +
					"<img class='img_off' src='"+Render.images["button_grey"].src+"' style='width:80px;height:26px;display:none;' />" +
					"<div style='position:absolute;left:0px;top:2px;width:80px;text-align:center;'>"+_t("Activate")+"</div>")
				.click(function()
				{
					if ($(this).attr("isclicked") == "y") return true;
					$(this).attr("isclicked", "y");
					
					var type = $(this).attr("type"),
						loanOption = Game.bankLoanOptions[type];
					var amount = loanOption.amount();
					
					Game.bankLoanActivate(type);
					GameGP0Display.recentChanges.amountowed = 0;
					Render.sounds["build"].play();
					
					$("#bankloaninactive").hide();
					$("#bankloanactive").show();
					
					$(this).attr("isclicked", "n");
				});
			loanOptionDiv.append(div);
			
			div = $(document.createElement("div"));
			div.addClass("fl").css({
				width: (overflow.width()-130)+"px",
				"margin-top": "7px",
				"margin-left": "15px",
				"font-size": "14px"
			}).html("<div class='fl' style='width:150px;'>"+_t("Cut")+": "+((Game.mode != "Endless" ? loanOption.percent : loanOption.percentEndless)*100)+"%</div>" +
					"<div class='fl'>"+_t("Interest")+": "+((Game.mode != "Endless" ? loanOption.interest : loanOption.interestEndless)*100)+"%</div>" +
					"<div class='clear'></div>");
			loanOptionDiv.append(div);
			loanOptionDiv.append("<div class='clear'></div>");
			
			div = $(document.createElement("div"));
			div.css({
				width: overflow.width()+"px",
				height: "1px",
				"margin": "6px 0",
				background: "#1A1A1A"
			}).html("&nbsp;");
			loaninactive.append(div);
		}
		
		var loanactive = $("<div id='bankloanactive' style='display:none;' />");
		overflow.append(loanactive);
		
		div = $(document.createElement("div"));
		div.attr({
			id: "bankpayoffloan"
		}).addClass("fr clickevents").css({
			position: "relative",
			width: "120px",
			minHeight: "26px",
			"margin-top": "2px",
			border: "1px solid #666",
			"font-size": "16px"
		}).html("<img class='img_on' src='"+Render.images["button2"].src+"' style='position:absolute;width:120px;height:100%;' />" +
				"<img class='img_off' src='"+Render.images["button_grey"].src+"' style='position:absolute;width:120px;height:100%;display:none;' />" +
				"<div style='position:relative;width:120px;padding:2px 0;text-align:center;'>"+_t("Pay Off Loan")+"</div>")
			.click(function()
			{
				Game.bankLoanPayoffLoan();
				Render.sounds["build"].play();
			});
		loanactive.append(div);
		div = $(document.createElement("div"));
		div.css({
			"font-size": "16px",
			"margin-top": "8px"
		}).html(_t("Loan Balance")+": <span class='amountowed' style='color:#FFFFFF;'>$0</span>");
		loanactive.append(div);

		div = $(document.createElement("div"));
		div.css({
			height: "30px",
		}).html("&nbsp;");
		overflow.append(div);
		
		
		//Specials
		div = $(document.createElement("div"));
		div.css({
			height: "35px",
			"font-size": "24px"
		}).html(_t("Specials"));
		overflow.append(div);
		
		div = $(document.createElement("div"));
		div.css({
			width: overflow.width()+"px",
			height: "1px",
			"margin": "6px 0",
			background: "#1A1A1A"
		}).html("&nbsp;");
		overflow.append(div);
		
		var specials = this.specials;
		var special, numLeft;
		for(var type in specials)
		{
			special = specials[type];
			numLeft = Game.specials[type];
			
			var specialDiv = $(document.createElement("div"));
			specialDiv.addClass("specials").attr({
				type: type
			});
			overflow.append(specialDiv);

			div = $(document.createElement("div"));
			div.attr({
				type: type
			}).addClass("fr usebtn clickevents").css({
				position: "relative",
				width: "80px",
				height: "24px",
				"margin-top": "10px",
				border: "1px solid #666",
				"font-size": "16px"
			}).html("<img class='img_on' src='"+Render.images["button2"].src+"' style='width:80px;height:24px;' />" +
					"<img class='img_off' src='"+Render.images["button_grey"].src+"' style='width:80px;height:24px;display:none;' />" +
					"<div style='position:absolute;left:0px;top:2px;width:80px;text-align:center;'>"+_t("Use")+"</div>").click(function()
				{
					var type = $(this).attr("type");
					if (Game.specials[type] > 0)
						Game.activateSpecial(type);
				});
			specialDiv.append(div);
			
			div = $(document.createElement("div"));
			div.addClass("fl title").css({
				color: "#FFF"
			}).html("<span style='font-size:18px;'>"+_t(special.title)+"</span> " +
					"<span class='howmany' style='padding-top:2px;font-size:16px;'>("+_t("none available")+")</span>");
			specialDiv.append(div);
			specialDiv.append("<div class='clear'></div>");
			
			div = $(document.createElement("div"));
			div.css({
				"margin-top": "-5px",
				"margin-left": "15px",
				"font-size": "14px"
			}).html(_t(special.description));
			specialDiv.append(div);
			
			div = $(document.createElement("div"));
			div.css({
				width: overflow.width()+"px",
				height: "1px",
				"margin": "6px 0",
				background: "#1A1A1A"
			}).html("&nbsp;");
			overflow.append(div);
		}
		
		//Scrollbars
		var scrollbar = $(document.createElement("div"));
		scrollbar.addClass("scrollbarDisplay").css({
			position: "absolute",
			top: "44px",
			right: "0px",
			width: "30px",
			height: (Render.gp0Height-minbasey-44)+"px",
			background: "#000"
		});
		tab.append(scrollbar);

		var arrow = $(document.createElement("img"));
		arrow.addClass("clickevents heldevents").attr({
			src: "media/etc/scrollbar_arrow.jpg"
		}).css({
			position: "absolute",
			top: "0px",
			right: "0px",
			width: "30px",
			height: "30px"
		}).click(function()
		{
			GameGP0Display.container.children(".tab[tab='resources']").find(".overflow").get(0).scrollTop -= 5;
		});
		scrollbar.append(arrow);
		
		arrow = $(document.createElement("img"));
		arrow.addClass("clickevents heldevents").attr({
			src: "media/etc/scrollbar_arrow2.jpg"
		}).css({
			position: "absolute",
			bottom: "0px",
			right: "0px",
			width: "30px",
			height: "30px"
		}).click(function()
		{
			GameGP0Display.container.children(".tab[tab='resources']").find(".overflow").get(0).scrollTop += 5;
		});
		scrollbar.append(arrow);
		
		
		
		/* Bots */
		var tab = $(document.createElement("div"));
		this.container.append(tab);
		tab.addClass("tab").attr({tab: "bots"}).css({
			position: "absolute",
			left: "0px",
			top: (minbasey+1)+"px",
			width: Render.gp0Width+"px",
			height: (Render.gp0Height-minbasey)+"px",
			display: "none"
		});
		
		background = $(document.createElement("div"));
		background.css({
			position: "absolute",
			left: "0px",
			top: "0px",
			width: tab.width()+"px",
			height: tab.height()+"px",
			background: "#000"
		});
		tab.append(background);
		background = $(document.createElement("div"));
		background.css({
			position: "absolute",
			left: "0px",
			top: "0px",
			width: tab.width()+"px",
			height: tab.height()+"px",
			background: "#000",
			opacity: "0.85"
		});
		tab.append(background);
		/*gxt.drawImage(Render.images["space1"],
			0, spaceBGHeight*(minbasey/Render.gp0Height),
			spaceBGWidth, spaceBGHeight*((Render.gp0Height-minbasey)/Render.gp0Height),
			0, minbasey, Render.gp0Width, Render.gp0Height);*/

		div = $(document.createElement("div"));
		div.css({
			position: "absolute",
			left: "15px",
			top: "10px",
			color: "#FFF",
			"font-size": "14px"
		}).html("<div class='fl' style='min-width:50px;margin-right:5px;'>"+_t("Bank")+":</div>" +
				"<div class='bankamt fl' style='color:#FFFFFF;'>$"+Leaderboard.numberFormat(Game.money)+"</div>" +
				"<div class='clear'></div>");
		tab.append(div);
		
		x = 15; y = 45;
		
		var div = $(document.createElement("div"));
		div.addClass("none").css({
			position: "absolute",
			left: "0px",
			top: "55px",//10
			width: (tab.width()-30)+"px",
			padding: "15px",
			"font-size": "16px"
		}).html(_t("activebots_none"));
		tab.append(div);
		
		var overflow = $(document.createElement("div"));
		overflow.addClass("overflow").css({
			position: "absolute",
			left: "0px",
			top: "55px", //10
			width: (tab.width()-30)+"px",
			height: (tab.height()-55)+"px",
			padding: "0 15px",
			"overflow-x": "hidden",
			"overflow-y": "overflow",
			display: "none"
		});
		tab.append(overflow);

		var types = {}, botsCount = 0, botCounts = {};
		for(var type in __Store)
		{
			types[type] = {};
			botCounts[type] = 0;
		}
		for(var ID in Game.bots)
		{
			types[Game.bots[ID].type][ID] = Game.bots[ID];
			botCounts[Game.bots[ID].type]++;
			botsCount++;
		}
		var item;
		for(type in types)
		{
			var itemDiv = $(document.createElement("div"));
			itemDiv.attr({
				type: type
			}).addClass("items").css({
				"margin-bottom": "15px"
			});
			overflow.append(itemDiv);
			
			div = $(document.createElement("div"));
			div.attr({
				type: type
			}).addClass("fr clickevents").css({
				position: "relative",
				width: "120px",
				height: "26px",
				border: "1px solid #666",
				"font-size": "16px",
				marginLeft: "15px",
				marginTop: "7px"
			}).html("<img class='img_on' src='"+Render.images["button2"].src+"' style='width:120px;height:26px;' />" +
					"<div style='position:absolute;left:0px;top:2px;width:120px;text-align:center;'>"+_t("Manage All")+"</div>")
				.click(function()
				{
					var type = $(this).attr("type");
					
					var bot, botIDs = [];
					for(var ID in Game.bots)
					{
						bot = Game.bots[ID];
						if (bot.type != type) continue;
						
						botIDs.push(ID);
					}
					
					GameGP0Display.botsSelected = botIDs;
					GameGP0Display.popupOpen("bots_upgrade", function()
					{
						GameGP0Display.botsSelected = null;
					});
				});
			itemDiv.append(div);
			
			div = $(document.createElement("div"));
			div.attr({
				type: type
			}).addClass("fr clickevents").css({
				position: "relative",
				width: "125px",
				height: "26px",
				border: "1px solid #666",
				"font-size": "16px",
				marginTop: "7px"
			}).html("<img class='img_on' src='"+Render.images["button2"].src+"' style='width:125px;height:26px;' />" +
					"<div class='sellalltext' style='position:absolute;left:0px;top:2px;width:125px;text-align:center;'>"+_t("Sell All")+"</div>")
				.click(function()
				{
					var type = $(this).attr("type");
					
					var sellAmt = 0;
					var bot;
					for(var ID in Game.bots)
					{
						bot = Game.bots[ID];
						if (bot.type != type) continue;
						
						sellAmt += whatIsResellAmount(bot);
					}
					
					GameGP0Display.sellBotConfirmation(function(data)
					{
						var bot;
						for(var ID in Game.bots)
						{
							bot = Game.bots[ID];
							if (bot.type != data.type) continue;
							
							Game.botsSell(ID);
						}
						
						GameGP0Display.spotbotClicksObjs = {};
					}, {
						type: type,
						value: sellAmt,
						me: $(this),
						multi: true
					});
				});
			itemDiv.append(div);
			
			div = $(document.createElement("div"));
			div.addClass("fl").css({
				height: "35px",
				"font-size": "22px"
			}).html(_t(__Store[type].name));
			itemDiv.append(div);
			itemDiv.append("<div class='clear'></div>");
			
			div = $(document.createElement("div"));
			div.css({
				width: overflow.width()+"px",
				height: "1px",
				"margin": "6px 0",
				background: "#1A1A1A"
			}).html("&nbsp;");
			itemDiv.append(div);
		}
		
		//Scrollbars
		var scrollbar = $(document.createElement("div"));
		scrollbar.addClass("scrollbarDisplay").css({
			position: "absolute",
			top: "0px",
			right: "0px",
			width: "30px",
			height: (Render.gp0Height-minbasey)+"px",
			background: "#000"
		});
		tab.append(scrollbar);

		var arrow = $(document.createElement("img"));
		arrow.addClass("clickevents heldevents").attr({
			src: "media/etc/scrollbar_arrow.jpg"
		}).css({
			position: "absolute",
			top: "0px",
			right: "0px",
			width: "30px",
			height: "30px"
		}).click(function()
		{
			GameGP0Display.container.children(".tab[tab='bots']").find(".overflow").get(0).scrollTop -= 5;
		});
		scrollbar.append(arrow);
		
		arrow = $(document.createElement("img"));
		arrow.addClass("clickevents heldevents").attr({
			src: "media/etc/scrollbar_arrow2.jpg"
		}).css({
			position: "absolute",
			bottom: "0px",
			right: "0px",
			width: "30px",
			height: "30px"
		}).click(function()
		{
			GameGP0Display.container.children(".tab[tab='bots']").find(".overflow").get(0).scrollTop += 5;
		});
		scrollbar.append(arrow);
		
		
		
		$("body").append(this.container);
	};
	
	//Close this div/etc
	this.close = function()
	{
		if (this.container) this.container.remove(); this.container = null;
		if (this.popupDiv) this.popupDiv.remove(); this.popupDiv = null;
		this.tabDivs = {}; this.spotbotClicks = null; this.popupDiv = null; this.spotbotClicksObjs = {};
		this.overviewStatsObjs = {};
		GameGP0DisplayClicks.exit();
	};
	
	//Show the Container
	this.show = function()
	{
		if (this.container) this.container.show();
	};
	
	//Hide the Container
	this.hide = function()
	{
		if (this.container) this.container.hide();
	};
	
	
	
	//Render the content for bottom screen
	this.recentChanges = {};
	this.overviewStats = {
		level: {
			title: "Level",
			value: 0
		},
		enemiesleft: {
			title: "Enemies Left",
			value: 0
		},
		enemiesdestroyed: {
			title: "Enemies Destroyed",
			value: 0
		},
		money: {
			title: "Bank",
			value: "$0",
			statschangeshow: "money"
		},
		score: {
			title: "Score",
			value: 0,
			statschangeshow: "score"
		},
		health: {
			title: "Health",
			value: "0%",
			statschangeshow: "life"
		},
		shield: {
			title: "Shield",
			value: 0,
			statschangeshow: "shield"
		},
		loanamountowed: {
			title: "Loan Balance",
			value: 0,
			valueColor: "red",
			donotallowempty: true,
			statschangeshow: "loanbalance"
		}
	}; this.overviewStatsObjs = {};
	this.render = function()
	{
		//try{
		//ClickBank.clearAll();
		var gxt = Render.gp0Context, minbasey = 34;
		
		var gamespeed = "0x";
		if (!Game.isPaused && !Game.fastEnabled) gamespeed = "1x";
		else if (Game.fastEnabled && Game.fastRate == 3) gamespeed = "3x";
		else if (Game.fastEnabled && Game.fastRate == 5) gamespeed = "5x";
		if (this.recentChanges.gamespeed == undefined || this.recentChanges.gamespeed != gamespeed)
		{
			$(".gamespeeds").css({
				color: "#999",
				"border-color": "#999",
				"z-index": 2
			});
			var cssApply = {
				color: "#FFF",
				"border-color": "#FFF",
				"z-index": 3
			};
			if (Game.isPaused) $(".gamespeeds[speed='0x']").css(cssApply);
			else if (!Game.isPaused && !Game.fastEnabled) $(".gamespeeds[speed='1x']").css(cssApply);
			else if (Game.fastEnabled && Game.fastRate == 3) $(".gamespeeds[speed='3x']").css(cssApply);
			else $(".gamespeeds[speed='5x']").css(cssApply);
			
			this.recentChanges.gamespeed = gamespeed;
		}
		if (this.recentChanges.autopausebutton == undefined || this.recentChanges.autopausebutton != Game.autoPauseOnNewLevels)
		{
			if (!Game.autoPauseOnNewLevels)
				$("#autopausebutton").css({
					color: "#999",
					"border-color": "#999",
					"z-index": 2
				});
			else
				$("#autopausebutton").css({
					color: "#FFF",
					"border-color": "#FFF",
					"z-index": 3
				});
			
			this.recentChanges.autopausebutton = Game.autoPauseOnNewLevels;
		}
		
		//Specific tab content
		if (this.tabDivs[this.tab] == undefined)
			this.tabDivs[this.tab] = $(".tab[tab='"+this.tab+"']");
		var tab = this.tabDivs[this.tab];
		switch(this.tab)
		{
		//default:
		case "overview":
			if (this.recentChanges.stats == undefined)
				this.recentChanges.stats = {};
			var stats = this.overviewStats;
			
			var base,health=Game.basesLife,healthMax=Game.basesMaxLife,shield=Game.basesShield;
			if (health < 0) health = 0;
			
			stats.level.value = Game.level;
			stats.enemiesleft.value = Leaderboard.numberFormat(Game.enemies.total_left);
			stats.enemiesdestroyed.value = Leaderboard.numberFormat(Game.enemies.dead);
			stats.money.value = "$"+Leaderboard.numberFormat(Game.money, "short");
			stats.score.value = Leaderboard.numberFormat(Game.score, "short");
			stats.health.value = Math.round((health/healthMax)*100)+"%";
			stats.shield.value = shield;
			stats.loanamountowed.value = "$"+Leaderboard.numberFormat(Game.bankLoanAmountOwed, "short");
			
			var stat, statObj, specialdiv, str, statschangeshowdiv;
			for(var key in stats)
			{
				stat = stats[key];
				
				if (this.recentChanges.stats[stat.title] == undefined || this.recentChanges.stats[stat.title] != stat.value)
				{
					statObj = this.overviewStatsObjs["stats_amt_"+stat.title];
					if (statObj == undefined)
					{
						statObj = $(".stats_amt[type='"+stat.title+"']");
						this.overviewStatsObjs["stats_amt_"+stat.title] = statObj;
					}
					statObj.html(stat.value);
					this.recentChanges.stats[stat.title] = stat.value;
					
					if (stat.title == "Shield" || stat.donotallowempty)
					{
						statObj = this.overviewStatsObjs["statshowmaster_"+stat.title];
						if (statObj == undefined)
						{
							statObj = $(".statshowmaster[type='"+stat.title+"']");
							this.overviewStatsObjs["statshowmaster_"+stat.title] = statObj;
						}
						
						if (this.recentChanges.stats[stat.title] <= 0 || this.recentChanges.stats[stat.title] == "$0") statObj.hide();
						else statObj.show();
					}
				}
				
				if (stat.statschangeshow)
				{
					if (Game.specialsInUse[stat.statschangeshow] != undefined
						&& (this.recentChanges.stats[stat.title+"_special"] == undefined
						|| this.recentChanges.stats[stat.title+"_special"] != Game.specialsInUse[stat.statschangeshow]))
					{
						specialdiv = this.overviewStatsObjs["specialsinuse_"+stat.title];
						if (specialdiv == undefined)
						{
							specialdiv = $(".specialsinuse[type='"+stat.title+"']");
							this.overviewStatsObjs["specialsinuse_"+stat.title] = specialdiv;
						}
						if (Game.specialsInUse[stat.statschangeshow])
						{
							statObj = this.overviewStatsObjs["statshow_Idiv_"+stat.title];
							if (statObj == undefined)
							{
								statObj = $(".statshow[type='"+stat.title+"'] > div");
								this.overviewStatsObjs["statshow_Idiv_"+stat.title] = statObj;
							}
							
							str = "x"+(Game.specialsInUse[stat.statschangeshow]+1);
							specialdiv.css({
								"left": (parseInt(specialdiv.attr("left"))+statObj.textWidth())+"px"
							}).html(str).show();
						} else {
							specialdiv.hide();
						}
						
						this.recentChanges.stats[stat.title+"_special"] = Game.specialsInUse[stat.statschangeshow];
					}
					
					var statschangeshow = Game.statsChangeShow(gxt, stat.statschangeshow, Render.gp0Width-5, 0, 16, "short2");
					if (this.recentChanges.stats[stat.title+"_statschangeshow"] == undefined
						|| this.recentChanges.stats[stat.title+"_statschangeshow"] != statschangeshow.text)
					{
						statschangeshowdiv = this.overviewStatsObjs["statschangeshow_"+stat.title];
						if (statschangeshowdiv == undefined)
						{
							statschangeshowdiv = $(".statschangeshow[type='"+stat.title+"']");
							this.overviewStatsObjs["statschangeshow_"+stat.title] = statschangeshowdiv;
						}
						if (statschangeshowdiv.text != "")
						{
							statschangeshowdiv.css({
								color: statschangeshow.color
							}).html(statschangeshow.text).show();
						} else {
							statschangeshowdiv.hide();
						}
						
						this.recentChanges.stats[stat.title+"_statschangeshow"] = statschangeshow.text;
					}
				}
				
				stat = null;
			}
			
			
			//Specials Used/Acquired
			if (this.recentChanges.specialsMessage == undefined) this.recentChanges.specialsMessage = 0;
			if (Game.specialAcquired)
			{
				if (Game.specialUsed)
				{
					Game.specialUsed = null;
					$("#specialUsedMessage").remove();
				}

				if (this.recentChanges.specialsMessage != 1)
				{
					if (!$("#specialAcquiredMessage").length)
					{
						var str = "";
						switch(Game.specialAcquired.type)
						{
						case "money": str = "Money Mult."; break;
						case "score": str = "Score Mult."; break;
						case "atomic": str = "Atomic Bomb"; break;
						case "health": str = "Health Pack"; break;
						}
						str = _t(str);
						
						var div = $(document.createElement("div"));
						div.attr({
							id: "specialAcquiredMessage"
						}).css({
							position: "absolute",
							left: (Render.gp0Width - 150 + 5)+"px",
							top: (Render.gp0Height - minbasey - 90)+"px",
							"font-size": "14px",
							color: "green"
						}).html("+ "+str);
						tab.append(div);
						
						this.recentChanges.specialsMessage = 1;
					} else {
						var str = "";
						switch(Game.specialAcquired.type)
						{
						case "money": str = "Money Mult."; break;
						case "score": str = "Score Mult."; break;
						case "atomic": str = "Atomic Bomb"; break;
						case "health": str = "Health Pack"; break;
						}
						str = _t(str);
						
						$("#specialAcquiredMessage").html("+ "+str);
					
						this.recentChanges.specialsMessage = 1;
					}
				}
				
				if (Game.specialAcquired.time+2500 < Date.now())
				{
					Game.specialAcquired = null;
					$("#specialAcquiredMessage").remove();
					this.recentChanges.specialsMessage = 0;
				}
			} else if (Game.specialUsed) {
				if (this.recentChanges.specialsMessage != 2)
				{
					if (!$("#specialUsedMessage").length)
					{
						var str = "";
						switch(Game.specialUsed.type)
						{
						case "money": str = "Money Mult."; break;
						case "score": str = "Score Mult."; break;
						case "atomic": str = "Atomic Bomb"; break;
						case "health": str = "Health Pack"; break;
						}
						str = _t(str);
						str = "- "+str;
						
						if (typeof Game.specialUsed.error != "undefined")
						{
							switch(Game.specialUsed.error)
							{
							case "maxlimit":
								str = _t("Max limit reached");
							break;
							}
						}
						
						var div = $(document.createElement("div"));
						div.attr({
							id: "specialUsedMessage"
						}).css({
							position: "absolute",
							left: (Render.gp0Width - 150 + 5)+"px",
							top: (Render.gp0Height - minbasey - 90)+"px",
							"font-size": "14px",
							color: "red"
						}).html(str);
						tab.append(div);
						
						this.recentChanges.specialsMessage = 2;
					} else {
						var str = "";
						switch(Game.specialUsed.type)
						{
						case "money": str = "Money Mult."; break;
						case "score": str = "Score Mult."; break;
						case "atomic": str = "Atomic Bomb"; break;
						case "health": str = "Health Pack"; break;
						}
						str = _t(str);
						str = "- "+str;
						
						if (typeof Game.specialUsed.error != "undefined")
						{
							switch(Game.specialUsed.error)
							{
							case "maxlimit":
								str = _t("Max limit reached");
							break;
							}
						}
						
						$("#specialUsedMessage").html(str);
						
						this.recentChanges.specialsMessage = 2;
					}
				}
				
				if (Game.specialUsed.time+2500 < Date.now())
				{
					Game.specialUsed = null;
					$("#specialUsedMessage").remove();
					this.recentChanges.specialsMessage = 0;
				}
			}
			
			//Specials
			if (this.recentChanges.specials == undefined)
				this.recentChanges.specials = {};
			var specials = this.specials;
			var special, numLeft;
			for(var type in specials)
			{
				special = specials[type];
				numLeft = Game.specials[type];
				
				if (this.recentChanges.specials[type] == undefined || this.recentChanges.specials[type] != numLeft)
				{
					$(".specialsquickbtn[type='"+type+"']").css({
						color: (numLeft ? "#FFF" : "#999"),
						"border-color": (numLeft ? "#FFF" : "#999")
					});
					this.recentChanges.specials[type] = numLeft;
				}
				
				special = null;
			}
			
			
			
			//Render Map
			var baseX = this.baseX, baseY = this.baseY;
			//gxt.drawImage(gxt2Canvas, 0, 0, this.mapWidth, this.mapHeight, 0, minbasey, this.mapWidth, this.mapHeight);

			if (this.recentChanges.messageDisplayed == undefined) this.recentChanges.messageDisplayed = false;
			if (this.recentChanges.resourceselected_msg == undefined) this.recentChanges.resourceselected_msg = false;
			if (this.recentChanges.gameispaused_msg == undefined) this.recentChanges.gameispaused_msg = false;
			
			//Message Displayed?
			if (this.messageDisplayed)
			{
				$("#messagetodisplay_msg").show();
				$("#messagetodisplay_msg .msg").html(this.messageDisplayed.msg);
				this.recentChanges.messageDisplayed = true;
				
				if (this.messageDisplayed.date + 5000 < Date.now())
				{
					this.messageDisplayed = null;
				}
			} else {
				if (this.recentChanges.messageDisplayed)
				{
					$("#messagetodisplay_msg").hide();
					this.recentChanges.messageDisplayed = false;
				}
			}
			
			//Resource Selected?
			if (this.resourceSelected)
			{
				if (!(this.recentChanges.resourceselected_msg && !this.recentChanges.gameispaused_msg))
				{
					$("#resourceselected_msg").show();
					$("#gameispaused_msg").hide();
				}
				
				baseY += 30;
				this.recentChanges.resourceselected_msg = true;
				this.recentChanges.gameispaused_msg = false;
				
			//Game Paused?
			} else if (Game.isPaused) {
				if (!(!this.recentChanges.resourceselected_msg && this.recentChanges.gameispaused_msg))
				{
					$("#resourceselected_msg").hide();
					$("#gameispaused_msg").show();
				}
				
				baseY += 30;
				this.recentChanges.resourceselected_msg = false;
				this.recentChanges.gameispaused_msg = true;
			} else {
				if (!(!this.recentChanges.resourceselected_msg && !this.recentChanges.gameispaused_msg))
				{
					$("#resourceselected_msg").hide();
					$("#gameispaused_msg").hide();
				}

				this.recentChanges.resourceselected_msg = false;
				this.recentChanges.gameispaused_msg = false;
			}
			if (this.recentChanges.gameispaused_msg2 == undefined || this.recentChanges.gameispaused_msg2 != Game.isPaused)
			{
				if (!Game.isPaused)
					$("#gameispaused_msg").hide();
				
				this.recentChanges.gameispaused_msg2 = Game.isPaused;
			}
			
			//Add click events to bots
			if (this.recentChanges.botClicks == undefined)
				this.recentChanges.botClicks = {};
			var obj, spot, bot, gp0Cord, r, rx, ry, _x=0,_y=0;
			for(var ID in Game.bots)
			{
				bot = Game.bots[ID];
				if (typeof __Store[bot.type].displayOnActiveBotsTab != "undefined" && !__Store[bot.type].displayOnActiveBotsTab) continue;
				r = bot.bottype == "spotbot" ? 20 : 15;
				r = r*Render.gp0RenderRatio*Game.gp0RClick;
				rx = r*2; ry = r*2;
				
				if (!Game.isPaused && bot.type == "drone")
				{
					if (this.recentChanges.botClicks[ID+"dronekill"] == undefined)
					{
						//obj = this.spotbotClicks.find(".botclick[objID='"+ID+"']");
						obj = this.spotbotClicksObjs[ID];
						if (obj)
						{
							obj.remove();
							this.spotbotClicksObjs[ID] = null;
						}
						this.recentChanges.botClicks[ID+"dronekill"] = true;
						delete this.recentChanges.botClicks[ID];
					}
					continue;
				} else if (Game.isPaused && bot.type == "drone") {
					delete this.recentChanges.botClicks[ID+"dronekill"];
				}
				
				gp0Cord = Game.calculateGPCords(bot.x, bot.y);
				gp0Cord.x2 -= rx/2; gp0Cord.y2 -= ry/2;
				_x = gp0Cord.x2+this.baseX; _y = gp0Cord.y2+this.baseY-34;

				if (this.recentChanges.botClicks[ID] == undefined || this.recentChanges.botClicks[ID] != _x+"|"+_y)
				{
					//obj = this.spotbotClicks.find(".botclick[objID='"+ID+"']");
					obj = this.spotbotClicksObjs[ID];
					if (!obj || !obj.length)
					{
						obj = $(document.createElement("div")).attr({
							objID: ID
						}).addClass("botclick clickevents").css({
							position: "absolute",
							left: _x+"px",
							top: _y+"px",
							width: rx+"px",
							height: ry+"px"
							//background: "green", opacity: 0.5
						}).click(function()
						{
							var ID = $(this).attr("objID");
							
							GameGP0Display.botSelected = ID;
							GameGP0Display.popupOpen("bot_upgrade", function()
							{
								GameGP0Display.botSelected = null;
								$(".botclick").remove();
								GameGP0Display.spotbotClicksObjs = {};
								GameGP0Display.recentChanges = {};
							});
						});
						this.spotbotClicks.append(obj);
						this.spotbotClicksObjs[ID] = obj;
					} else {
						obj.css({
							left: _x+"px",
							top: _y+"px",
							width: rx+"px",
							height: ry+"px"
						});
					}
					this.recentChanges.botClicks[ID] = _x+"|"+_y;
				}
			}
			
			//Add click events to spots
			if (this.recentChanges.spotClicks == undefined)
				this.recentChanges.spotClicks = {};
			for(var ID in Game.spots)
			{
				spot = Game.spots[ID];
				r = spot.r*Render.gp0RenderRatio*Game.gp0RClick;
				rx = r*2; ry = r*2;
				
				gp0Cord = Game.calculateGPCords(spot.x, spot.y);
				gp0Cord.x2 -= rx/2; gp0Cord.y2 -= ry/2;
				_x = gp0Cord.x2+this.baseX; _y = gp0Cord.y2+this.baseY-34;
				
				if (this.recentChanges.spotClicks[ID] == undefined || this.recentChanges.spotClicks[ID] != _x+"|"+_y)
				{
					//obj = this.spotbotClicks.find(".spotclick[objID='"+ID+"']");
					obj = this.spotbotClicksObjs[ID];
					if (!obj || !obj.length)
					{
						obj = $(document.createElement("div")).attr({
							objID: ID
						}).addClass("spotclick clickevents").css({
							position: "absolute",
							left: _x+"px",
							top: _y+"px",
							width: rx+"px",
							height: ry+"px"
							//background: "red", opacity: 0.5
						}).click(function()
						{
							var ID = $(this).attr("objID");
							
							//Open up popup
							if (!GameGP0Display.resourceSelected)
							{
								GameGP0Display.spotSelected = ID;
								GameGP0Display.popupOpen("spot_addbot", function()
								{
									GameGP0Display.spotSelected = null;
									$(".spotclick").remove();
								});
								
							//Add Bot
							} else {
								var spot = Game.spots[ID];
								Game.botsAdd(GameGP0Display.resourceSelected, spot.x, spot.y, spot.x2, spot.y2);
								$(this).remove();
								
								var str = _t("gamepad_topmessage6").replace(/\[botname\]/i, _t(__Store[GameGP0Display.resourceSelected].name));
								GameGP0Display.messageDisplayed = {
									msg: str,
									date: Date.now()
								};
								
								GameGP0Display.resourceSelected = null;
							}
						});
						this.spotbotClicks.append(obj);
						this.spotbotClicksObjs[ID] = obj;
					} else {
						obj.css({
							left: _x+"px",
							top: _y+"px",
							width: rx+"px",
							height: ry+"px"
						});
					}
					this.recentChanges.spotClicks[ID] = _x+"|"+_y;
				}
			}
		break;
		
		case "resources":
			if (this.resourceExtraAdded != undefined)
			{
				if (this.recentChanges.resourceExtraAdded == undefined || !this.recentChanges.resourceExtraAdded || (this.resourceExtraAdded && this.recentChanges.resourceExtraAddedText != this.resourceExtraAdded.message))
				{
					$("#resourceextradded").remove();
					div = $(document.createElement("div"));
					div.attr({
						id: "resourceextradded"
					}).css({
						position: "absolute",
						left: (tab.width()-15-200)+"px",
						width: "200px",
						top: "10px",
						color: this.resourceExtraAdded.color ? this.resourceExtraAdded.color : "green",
						"font-size": "14px",
						"text-align": "right"
					}).html(this.resourceExtraAdded.message);
					tab.append(div);
					
					this.recentChanges.resourceExtraAdded = true;
					this.recentChanges.resourceExtraAddedText = this.resourceExtraAdded.message;
				}
				
				if (Date.now() > this.resourceExtraAdded.timer)
				{
					delete this.resourceExtraAdded;
					$("#resourceextradded").remove();
				}
			} else {
				if (this.recentChanges.resourceExtraAdded != undefined && this.recentChanges.resourceExtraAdded)
				{
					$("#resourceextradded").remove();
					this.recentChanges.resourceExtraAdded = false;
				}
			}
			
			if (this.recentChanges.bankamt == undefined || this.recentChanges.bankamt != Game.money)
			{
				tab.find(".bankamt").html("$"+Leaderboard.numberFormat(Game.money));
				this.recentChanges.bankamt = Game.money;
			}
			
			if (this.recentChanges.items == undefined) this.recentChanges.items = {};
			var item, cost;
			for(var type in __Store)
			{
				item = __Store[type];
				if (item.displayForPurchase != undefined && !item.displayForPurchase) continue;
				if (Game.mapClass.storeRules[type] && Game.mapClass.storeRules[type].enabled != undefined
					&& !Game.mapClass.storeRules[type].enabled) continue;
				
				cost = item.cost;
				if (item.costupgrade != undefined) cost = item.costupgrade();
				
				if (this.recentChanges.items[type] == undefined || this.recentChanges.items[type] != "$"+cost)
				{
					tab.find(".items[type='"+type+"'] .cost").html("$"+cost);
					this.recentChanges.items[type] = "$"+cost;
				}
				if (this.recentChanges.items[type+"_costmoney"] == undefined
					|| this.recentChanges.items[type+"_costmoney"] != cost+"-"+Game.money)
				{
					if (cost <= Game.money)
					{
						tab.find(".items[type='"+type+"'] .buybtn").find(".img_on").show();
						tab.find(".items[type='"+type+"'] .buybtn").find(".img_off").hide();
					} else {
						tab.find(".items[type='"+type+"'] .buybtn").find(".img_on").hide();
						tab.find(".items[type='"+type+"'] .buybtn").find(".img_off").show();
					}
					this.recentChanges.items[type+"_costmoney"] = cost+"-"+Game.money;
				}
			}
			
			
			if (this.recentChanges.bankloans == undefined) this.recentChanges.bankloans = {};
			var loanOption;
			for(var type in Game.bankLoanOptions)
			{
				loanOption = Game.bankLoanOptions[type];
				
				if (this.recentChanges.bankloans[type] == undefined || this.recentChanges.bankloans[type] != "$"+loanOption.amount())
				{
					tab.find(".loanoptions[type='"+type+"'] .amount").html("$"+Leaderboard.numberFormat(loanOption.amount()));
					this.recentChanges.bankloans[type] = "$"+loanOption.amount();
				}
			}
			if (this.recentChanges.amountowed == undefined) this.recentChanges.amountowed = 0;
			if (Game.bankLoanActive)
			{
				if (this.recentChanges.amountowed == undefined || this.recentChanges.amountowed != "$"+Game.bankLoanAmountOwed)
				{
					if (Game.bankLoanAmountOwed <= Game.money)
					{
						tab.find("#bankpayoffloan").find(".img_on").show();
						tab.find("#bankpayoffloan").find(".img_off").hide();
					} else {
						tab.find("#bankpayoffloan").find(".img_on").hide();
						tab.find("#bankpayoffloan").find(".img_off").show();
					}
					
					tab.find(".amountowed").html("$"+Leaderboard.numberFormat(Game.bankLoanAmountOwed, "short"));
					
					this.recentChanges.amountowed = "$"+Game.bankLoanAmountOwed;
				}
			}
			
			
			if (this.recentChanges.specials == undefined) this.recentChanges.specials = {};
			var specials = this.specials;
			var special, numLeft;
			for(var type in specials)
			{
				special = specials[type];
				numLeft = Game.specials[type];
				
				if (this.recentChanges.specials[type] == undefined || this.recentChanges.specials[type] != numLeft)
				{
					tab.find(".specials[type='"+type+"'] .title .howmany").html(numLeft ? "("+_t("specials_left").replace(/\[amt\]/i, numLeft)+")" : "("+_t("none available")+")");
					this.recentChanges.specials[type] = numLeft;
				}
				if (this.recentChanges.specials[type+"_numLeft"] == undefined
					|| this.recentChanges.specials[type+"_numLeft"] != numLeft)
				{
					if (numLeft > 0)
					{
						tab.find(".specials[type='"+type+"'] .usebtn").find(".img_on").show();
						tab.find(".specials[type='"+type+"'] .usebtn").find(".img_off").hide();
					} else {
						tab.find(".specials[type='"+type+"'] .usebtn").find(".img_on").hide();
						tab.find(".specials[type='"+type+"'] .usebtn").find(".img_off").show();
					}
					this.recentChanges.specials[type+"_numLeft"] = numLeft;
				}
			}
			
			var overflow = tab.find(".overflow");
			if (this.recentChanges.overflowHeight == undefined || this.recentChanges.overflowHeight != overflow.get(0).scrollHeight)
			{
				if (overflow.get(0).scrollHeight > overflow.height())
				{
					tab.find(".scrollbarDisplay").show();
					overflow.css({
						width: (tab.width()-40)+"px"
					});
				} else {
					tab.find(".scrollbarDisplay").hide();
					overflow.css({
						width: (tab.width()-30)+"px"
					});
				}
				
				this.recentChanges.overflowHeight = overflow.get(0).scrollHeight;
			}
		break;
		
		case "bots":
			if (this.recentChanges.bankamt == undefined || this.recentChanges.bankamt != Game.money)
			{
				tab.find(".bankamt").html("$"+Leaderboard.numberFormat(Game.money));
				this.recentChanges.bankamt = Game.money;
			}
			
			var types = {}, botsCount = 0, botCounts = {};
			for(var type in __Store)
			{
				types[type] = {};
				botCounts[type] = 0;
			}
			for(var ID in Game.bots)
			{
				types[Game.bots[ID].type][ID] = Game.bots[ID];
				botCounts[Game.bots[ID].type]++;
				botsCount++;
			}
			
			if (this.recentChanges.botscount == undefined || this.recentChanges.botscount != botsCount)
			{
				var text = tab.find(".sellalltext");
				if (text.height() > 30)
				{
					while(text.height() > 30)
					{
						var w = text.width()+5;
						text.parent().width(w);
						text.parent().children().width(w);
					}
					var w = text.width()+10;
					text.parent().width(w);
					text.parent().children().width(w);
				}
				
				if (botsCount == 0)
				{
					tab.find(".none").show();
					tab.find(".overflow").hide();
				} else {
					tab.find(".overflow").show();
					tab.find(".none").hide();
					
					var itemDiv;
					var bots, bots, item, count, _x, _w, str, sellAmt, botIDs = [];
					for(type in types)
					{
						itemDiv = tab.find(".items[type='"+type+"']");
						if (botCounts[type] == 0 || (typeof __Store[type].displayOnActiveBotsTab != "undefined" && !__Store[type].displayOnActiveBotsTab))
						{
							itemDiv.hide();
							continue;
						}
						
						itemDiv.show();
						
						bots = types[type];
						item = __Store[type];
						count = 1;
						
						botIDs = [];
						for(ID in bots)
						{
							bot = bots[ID];
							botIDs.push(ID);
							sellAmt = whatIsResellAmount(bot);
							
							bot.itemCountNumber = count;
							
							if (!itemDiv.find(".bot[botID='"+ID+"']").length)
							{
								var botDiv = $(document.createElement("div"));
								botDiv.addClass("bot").attr({
									botID: ID
								});
								itemDiv.append(botDiv);
								
								div = $(document.createElement("div"));
								div.addClass("fl botmanagetitle").css({
									"font-size": "16px"
								}).html(_t(item.name)+" - #"+count);
								botDiv.append(div);
								
								div = $(document.createElement("div"));
								div.attr({
									botID: ID
								}).addClass("fr managebtn clickevents").css({
									position: "relative",
									width: "120px",
									height: "26px",
									//"margin-top": "15px",
									"margin-left": "15px",
									border: "1px solid #666",
									"font-size": "16px"
								}).html("<img src='"+Render.images["button2"].src+"' style='width:120px;height:26px;' />" +
										"<div class='text' style='position:absolute;left:0px;top:0px;width:120px;text-align:center;'>"+_t("Manage")+"</div>")
									.click(function()
									{
										GameGP0Display.botSelected = $(this).attr("botID");
										GameGP0Display.popupOpen("bot_upgrade", function()
										{
											GameGP0Display.botSelected = null;
										});
									});
								botDiv.append(div);
								
								div = $(document.createElement("div"));
								div.attr({
									botID: ID,
									type: type,
									sellAmt: sellAmt
								}).addClass("fr sellbtn clickevents").css({
									position: "relative",
									width: "100px",
									height: "26px",
									//"margin-top": "15px",
									border: "1px solid #666",
									"font-size": "16px"
								}).html("<img src='"+Render.images["button2"].src+"' style='width:100px;height:26px;' />" +
										"<div class='text' style='position:absolute;left:0px;top:0px;width:60px;text-align:center;'>"+_t("Sell")+" $"+Leaderboard.numberFormat(sellAmt, "short")+"</div>")
									.click(function()
									{
										var bot = Game.bots[$(this).attr("botID")];
										var resellAmt = whatIsResellAmount(bot);
										
										GameGP0Display.sellBotConfirmation(function(data)
										{
											var me = data.me;
											
											Game.botsSell(me.attr("botID"));
											me.closest(".bot").remove();
											var obj = GameGP0Display.spotbotClicks.find(".botclick[objID='"+me.attr("botID")+"']");
											if (obj)
											{
												obj.remove();
												GameGP0Display.spotbotClicksObjs = {};
												GameGP0Display.recentChanges = {};
											}
										}, {
											type: $(this).attr("type"),
											value: resellAmt,
											me: $(this)
										});
									});
								botDiv.append(div);
								botDiv.append("<div class='clear'></div>");
		
								div = $(document.createElement("div"));
								div.css({
									width: botDiv.width()+"px",
									height: "1px",
									"margin": "6px 0",
									background: "#1A1A1A"
								}).html("&nbsp;");
								botDiv.append(div);

								var text = itemDiv.find(".bot[botID='"+ID+"']").find(".sellbtn .text");
								if (text.height() > 30)
								{
									while(text.height() > 30)
									{
										var w = text.width()+5;
										text.parent().width(w);
										text.parent().children().width(w);
									}
									var w = text.width()+10;
									text.parent().width(w);
									text.parent().children().width(w);
									
									GameGP0DisplayClicks.resetSetWidthHeight(text);
								}
							} else {
								itemDiv.find(".bot[botID='"+ID+"']").find(".botmanagetitle").html(_t(item.name)+" - #"+count);
								itemDiv.find(".bot[botID='"+ID+"']").find(".sellbtn .text").html(_t("Sell")+" $"+Leaderboard.numberFormat(sellAmt, "short"));
								var text = itemDiv.find(".bot[botID='"+ID+"']").find(".sellbtn .text");
								if (text.height() > 30)
								{
									while(text.height() > 30)
									{
										var w = text.width()+5;
										text.parent().width(w);
										text.parent().children().width(w);
									}
									var w = text.width()+10;
									text.parent().width(w);
									text.parent().children().width(w);
									
									GameGP0DisplayClicks.resetSetWidthHeight(text);
								}
							}
							
							count++;
						}
						
						itemDiv.find(".bot").each(function()
						{
							var botID = $(this).attr("botID");
							if ($.inArray(botID, botIDs) == -1)
								$(this).remove();
						});
					}
				}
				
				this.recentChanges.botscount = botsCount;
			}
			
			var overflow = tab.find(".overflow");
			if (this.recentChanges.overflowHeight == undefined || this.recentChanges.overflowHeight != overflow.get(0).scrollHeight)
			{
				if (overflow.get(0).scrollHeight > overflow.height())
				{
					tab.find(".scrollbarDisplay").show();
					overflow.css({
						width: (tab.width()-40)+"px"
					});
				} else {
					tab.find(".scrollbarDisplay").hide();
					overflow.css({
						width: (tab.width()-30)+"px"
					});
				}
				
				this.recentChanges.overflowHeight = overflow.get(0).scrollHeight;
			}
		break;
		}
		
		
		//Show Popup
		this.popupDisplay();
	};
	
	//Switch the tab
	this.switchTab = function(tab)
	{
		this.tab = tab;
		this.scrollbarOffsetY = 0;
		this.tabData = {};
		this.recentChanges = {};
		
		$(".tab_buttons").find(".img_off").show();
		$(".tab_buttons").find(".img_on").hide();
		$(".tab_buttons").find(".dark").hide();
		$(".tab_buttons[tab='"+tab+"']").find(".img_off").hide();
		$(".tab_buttons[tab='"+tab+"']").find(".img_on").show();
		$(".tab_buttons[tab='"+tab+"']").find(".dark").show();
		$(".tab").hide();
		$(".tab[tab='"+tab+"']").show();
		
		setTimeout(function()
		{
			$("body").find(".clickevents > .text").each(function()
			{
				var w = $(this).parent().width();
				if ($(this).textWidth() < w) return true;
				
				var font = 16;
				while($(this).textWidth() > w && font >= 10)
				{
					$(this).css("font-size", font+"px");
					font--;
				}
			});
		}, 25);
	};
	
	//Add a Scrollbar to right side
	this.scrollbarData = null; this.scrollbarCustomMoveFunc = null;
	this.scrollbarDisplay = function(gxt, myHeight, x, y, width, height, moveCustomFunc)
	{
		this.scrollbarActive = false;
		if (myHeight <= height) return false;
		this.scrollbarActive = true;
		
		this.scrollbarData = {myHeight:myHeight, x:x, y:y, width:width, height:height};
		this.scrollbarCustomMoveFunc = moveCustomFunc;
		
		gxt.fillStyle = "#000";
		gxt.strokeStyle = "#FFF";
		
		gxt.drawImage(Render.images["scrollbar_bar"], x, y, width, height);
		gxt.globalAlpha = 0.7;
		gxt.fillRect(x, y, width, height);
		gxt.globalAlpha = 1;
		gxt.strokeRect(x, y, width, height);
		
		gxt.drawImage(Render.images["scrollbar_arrow"], x, y, width, width);
		
		gxt.save();
		gxt.translate(x+width/2, y+height-width/2);
		gxt.rotate(180*Math.PI/180);
		gxt.drawImage(Render.images["scrollbar_arrow"], -width/2, -width/2, width, width);
		gxt.restore();

		ClickBank.add({
			id: "scrollbar_up",
			x: x, y: y, w: width, h: width,
			held: function(clickID, vaultEntry)
			{
				GameGP0Display.scrollbarScrollUp();
			}
		});
		ClickBank.add({
			id: "scrollbar_down",
			x: x, y: y+height-width, w: width, h: width,
			held: function(clickID, vaultEntry)
			{
				GameGP0Display.scrollbarScrollDown();
			}
		});
	}
	
	//Scroll Up
	this.scrollbarScrollUp = function()
	{
		//try{
		GameGP0Display.container.find(".tab[tab='"+this.tab+"'] .overflow").get(0).scrollTop -= 5;
		
		if (!this.scrollbarActive) return false;
		
		this.scrollbarOffsetY -= 5;
		if (this.scrollbarOffsetY < 0)
			this.scrollbarOffsetY = 0;
		
		if (this.scrollbarCustomMoveFunc)
			this.scrollbarCustomMoveFunc();
	};
	
	//Scroll Down
	this.scrollbarScrollDown = function()
	{
		//try{
		GameGP0Display.container.find(".tab[tab='"+this.tab+"'] .overflow").get(0).scrollTop += 5;
		
		if (!this.scrollbarActive) return false;
		
		this.scrollbarOffsetY += 5;
		if (this.scrollbarOffsetY > this.scrollbarData.myHeight-this.scrollbarData.height)
			this.scrollbarOffsetY = this.scrollbarData.myHeight-this.scrollbarData.height;
		
		if (this.scrollbarCustomMoveFunc)
			this.scrollbarCustomMoveFunc();
	};
	
	
	
	//Open a popup
	this.popupOpen = function(area, closeFunc)
	{
		this.popupEnabled = true;
		this.popupArea = area;
		this.popupCanvas = null; this.popupClicks = [];
		if (closeFunc == "function")
			this.popupCloseFunc = closeFunc;
	};
	
	//Close the popup
	this.popupClose = function()
	{
		if (this.popupDiv) this.popupDiv.remove();
		this.popupDiv = null;
		this.popupEnabled = false;
		this.popupCanvas = null; this.popupClicks = [];
		if (this.popupCloseFunc == "function")
		{
			this.popupCloseFunc();
			this.popupCloseFunc = null;
		}
		this.botSelected = null;
		this.botsSelected = null;
		this.recentChanges = {};
	};
	
	//Display the popup, if one is active
	this.popupDiv = null;
	this.popupCanvas = null; this.popupClicks = []; this.popupData = {money:0};
	this.popupDisplay = function()
	{
		if (!this.popupEnabled) return false;
		
		if (!this.popupDiv)
		{
			this.popupDiv = $(document.createElement("div"));
			this.popupDiv.css({
				position: "relative",
				width: Render.gp0Width+"px",
				height: Render.gp0Height+"px",
				"z-index": 10
			});
			this.container.append(this.popupDiv);
			
			var background = $(document.createElement("div"));
			background.css({
				position: "absolute",
				left: "0px",
				top: "0px",
				width: this.popupDiv.width()+"px",
				height: this.popupDiv.height()+"px",
				background: "#000",
				opacity: "0.75"
			}).click(function()
			{
				GameGP0Display.popupClose();
				//ClickBank.delayClickByOneFrame();
			});
			this.popupDiv.append(background);
			
			var popup = $(document.createElement("div"));
			popup.css({
				position: "absolute",
				left: "0px",
				top: "0px",
				width: (this.popupArea == "spot_addbot" ? "600px" : "650px"),
				padding: "15px"
			});
			this.popupDiv.append(popup);
			
			//Content
			var div;
			switch(this.popupArea)
			{
			case "spot_addbot":
				var ID, spot;
				ID = this.spotSelected;
				spot = Game.spots[ID];
				var allowedBotsAny = true, allowedBots = [];
				if (spot.rules.bots && spot.rules.bots.length >= 1)
				{
					allowedBotsAny = false;
					allowedBots = spot.rules.bots;
				}
				
				div = $(document.createElement("div"));
				div.css({
					"height": "40px",
					"font-size": "20px"
				}).html(_t("addbot_title"));
				popup.append(div);
				
				var w = 70, h = 26;
				var img_off = $(Render.images["button_grey"]);
				img_off.addClass("img_off").css({
					width: w+"px",
					height: h+"px",
					display: "none"
				});
				var img_on = $(Render.images["button2"]);
				img_on.addClass("img_on").css({
					width: w+"px",
					height: h+"px"
				});
				
				var item, cost, itemDiv;
				for(var type in __Store)
				{
					item = __Store[type];
					if (item.type != "bot") continue;
					if (allowedBotsAny)
					{
						if (item.displayForPurchase != undefined && !item.displayForPurchase)
							continue;
					} else {
						if (jQuery.inArray(type, allowedBots) == -1)
							continue;
					}
					if (Game.mapClass.storeRules[type] && Game.mapClass.storeRules[type].enabled != undefined
						&& !Game.mapClass.storeRules[type].enabled) continue;
					
					div = $(document.createElement("div"));
					div.css({
						height: "1px",
						"margin": "6px 0",
						background: "#1A1A1A"
					}).html("&nbsp;");
					popup.append(div);
					
					itemDiv = $(document.createElement("div"));
					itemDiv.attr({
						type: type
					}).addClass("item");
					popup.append(itemDiv);
					
					cost = item.cost;
					if (item.costupgrade != undefined) cost = item.costupgrade();
					
					img_on = img_on.clone();
					img_off = img_off.clone();
					div = $(document.createElement("div"));
					div.attr({
						type: type
					}).addClass("fr btn clickevents").css({
						position: "relative",
						width: w+"px",
						height: h+"px",
						"font-size": "16px",
						border: "1px solid #666",
						"text-align": "center"
					}).append(img_off).append(img_on)
					  .append(//"<img class='img_off' src='"+Render.images["button_grey"].src+"' style='width:"+w+"px;height:"+h+"px;display:none;' />" +
							//"<img class='img_on' src='"+Render.images["button2"].src+"' style='width:"+w+"px;height:"+h+"px;display:block;' />" +
							"<div class='text' style='position:absolute;left:0px;top:2px;width:"+w+"px;'>"+_t("Add")+"</div>").click(function()
					{
						var type = $(this).attr("type");
						var ID = GameGP0Display.spotSelected;
						if (!ID)
						{
							GameGP0Display.popupClose();
							return false;
						}
						var spot = Game.spots[ID],
							item = __Store[type];
						var cost = item.cost;
						if (item.costupgrade != undefined) cost = item.costupgrade();
						if (cost > Game.money) return false;
						
						//Make sure wasn't clicked twice.
						if ($(this).hasClass("hadclick")) return false;
						$(this).addClass("hasclick");
						
						Game.botsAdd(type, spot.x, spot.y, spot.x2, spot.y2);
						
						if (GameGP0Display.spotbotClicks)
						{
							var obj = GameGP0Display.spotbotClicks.find(".spotclick[objID='"+ID+"']");
							if (obj && obj.length) obj.remove();
						}
						
						GameGP0Display.popupClose();
						
						var str = _t("gamepad_topmessage6").replace(/\[botname\]/i, _t(__Store[type].name));
						GameGP0Display.messageDisplayed = {
							msg: str,
							date: Date.now()
						};
					});
					itemDiv.append(div);
					
					div = $(document.createElement("div"));
					div.addClass("fl").css({
						"font-size": "16px"
					}).html("<div class='fl' style='width:175px;height:28px;'>"+_t(item.name)+"</div>" +
							"<div class='fl' style='color:#FFFFFF;'>$"+cost+"</div>" +
							"<div class='clear'></div>");
					itemDiv.append(div);
					itemDiv.append("<div class='clear'></div>");
					
					div = $(document.createElement("div"));
					div.css({
						"margin-bottom": "6px",
						"font-size": "14px"
					}).html(_t(item.description));
					itemDiv.append(div);
				}
				
				setTimeout(function()
				{
					$("body").find(".clickevents > .text").each(function()
					{
						var w = $(this).parent().width();
						if ($(this).textWidth() < w) return true;
						
						var font = 16;
						while($(this).textWidth() > w && font >= 10)
						{
							$(this).css("font-size", font+"px");
							font--;
						}
					});
				}, 25);
			break;
			
			case "bot_upgrade":
				var ID, bot;
				ID = this.botSelected;
				bot = Game.bots[ID];
				var storeItem = __Store[bot.type];
				
				var resell = whatIsResellAmount(bot);
				var str = _t("managebot_sell").replace(/\[amt\]/i, "<span class='sellamt'>$"+Leaderboard.numberFormat(resell, "short")+"</span>");
				var w = 100, h = 28;
				var img_on = $(Render.images["button2"]);
				img_on.css({
					width: w+"px",
					height: h+"px"
				});
				div = $(document.createElement("div"));
				div.attr({
					type: type,
					bottype: bot.type,
					resell: resell
				}).addClass("fr sellbtn clickevents").css({
					position: "relative",
					width: w+"px",
					height: h+"px",
					"font-size": "16px",
					border: "1px solid #666",
					"text-align": "center"
				}).append(img_on)
				  .append("<div class='text' style='position:absolute;left:0px;top:2px;width:"+w+"px;'>"+str+"</div>").click(function()
				{
					GameGP0Display.sellBotConfirmation(function(data)
					{
						var ID = GameGP0Display.botSelected;
						
						Game.botsSell(ID);
						
						if (GameGP0Display.spotbotClicks)
						{
							var obj = GameGP0Display.spotbotClicks.find(".botclick[objID='"+ID+"']");
							if (obj && obj.length)
							{
								obj.remove();
								GameGP0Display.spotbotClicksObjs = {};
							}
						}
						
						GameGP0Display.popupClose();
					}, {
						type: $(this).attr("bottype"),
						value: $(this).attr("resell")
					});
				});
				popup.append(div);
				
				var text = this.popupDiv.find(".sellbtn .text");
				if (text.height() > 30)
				{
					while(text.height() > 30)
					{
						var w = text.width()+5;
						text.parent().width(w);
						text.parent().children().width(w);
					}
					var w = text.width()+10;
					text.parent().width(w);
					text.parent().children().width(w);
					
					GameGP0DisplayClicks.resetSetWidthHeight(text);
				}
				
				
				div = $(document.createElement("div"));
				div.addClass("fl").css({
					"height": "40px",
					"font-size": "16px"
				}).html(_t("managebot_title").replace(/\[botname\]/i, _t(storeItem.name)));
				popup.append(div);
				popup.append("<div class='clear'></div>");
				
				
				var w = 95, h = 26;
				var img_off = $(Render.images["button_grey"]).clone();
				img_off.addClass("img_off").css({
					width: w+"px",
					height: h+"px",
					display: "none"
				});
				var img_on = $(Render.images["button2"]).clone();
				img_on.addClass("img_on").css({
					width: w+"px",
					height: h+"px"
				});
				
				var item, itemDiv, cost, lv, lines, line, allowUpgrade, itemDivContainer;
				for(var type in __Store[bot.type].upgrades)
				{
					item = __Store[bot.type].upgrades[type];
					if (item.maxLv != 0 && item.maxLv <= bot.upgrades[type]) allowUpgrade = false;
					else allowUpgrade = true;
					
					lv = bot.upgrades[type];
					cost = whatIsUpgradeCost(item.cost, bot.upgrades[type]);
					
					itemDivContainer = $(document.createElement("div"));
					/*itemDivContainer.attr({
						id: "dslajkdlkasd"+type
					});*/
					popup.append(itemDivContainer);
					
					div = $(document.createElement("div"));
					div.css({
						height: "1px",
						"margin": "6px 0",
						background: "#1A1A1A"
					}).html("&nbsp;");
					itemDivContainer.append(div);
					
					itemDiv = $(document.createElement("div"));
					itemDiv.attr({
						type: type
					}).addClass("item");
					itemDivContainer.append(itemDiv);
					
					if (allowUpgrade)
					{
						img_on = img_on.clone();
						img_off = img_off.clone();
						div = $(document.createElement("div"));
						div.attr({
							type: type
						}).addClass("fr btn clickevents").css({
							position: "relative",
							width: w+"px",
							height: h+"px",
							"font-size": "16px",
							border: "1px solid #666",
							"text-align": "center"
						}).append(img_off).append(img_on)
						  .append("<div class='text' style='position:absolute;left:0px;top:2px;width:"+w+"px;'>"+_t("Upgrade")+"</div>").click(function()
						{
							var type = $(this).attr("type");
							var ID = GameGP0Display.botSelected,
								bot = Game.bots[ID];
							
							Game.botsUpgrade(ID, type);
							
							GameGP0Display.popupCanvas = null;
						});
						itemDiv.append(div);
					}
					setTimeout(function()
					{
						$("body").find(".clickevents > .text").each(function()
						{
							var w = $(this).parent().width();
							if ($(this).textWidth() < w) return true;
							
							var font = 16;
							while($(this).textWidth() > w && font >= 10)
							{
								$(this).css("font-size", font+"px");
								font--;
							}
						});
					}, 25);

					div = $(document.createElement("div"));
					div.addClass("fl").css({
						"font-size": "16px",
						"min-width": "150px",
						"margin-right": "15px",
						height: "35px"
					}).html(_t(item.name));
					itemDiv.append(div);
					
					div = $(document.createElement("div"));
					div.addClass("fl").css({
						"font-size": "16px",
						"min-width": "60px",
						"margin-right": "15px"
					}).html(_t("lv_show").replace(/\[number\]/i, "<span class='lv'>"+lv+"</span>"));
					itemDiv.append(div);
					
					div = $(document.createElement("div"));
					div.addClass("fl statrender").css({
						"font-size": "16px",
						"min-width": "150px",
						"margin-right": "15px"
					}).html(item.statRender(bot));
					itemDiv.append(div);
					
					if (allowUpgrade)
					{
						div = $(document.createElement("div"));
						div.addClass("fl buydiv").css({
							"font-size": "16px",
							color: "#FFFFFF"
						}).html("$"+Leaderboard.numberFormat(cost, "short"));
						itemDiv.append(div);
					}
					
					itemDiv.append("<div class='clear'></div>");
				}
				
				
				//Attack Mode - showattackmode:false
				if (!bot.type.match(/cloud|teslacoil|drone/i) && (storeItem.showAttackMode == undefined || storeItem.showAttackMode))
				{
					var w = 130, h = 26;
					var img_off = $(Render.images["button_grey"]).clone();
					img_off.addClass("img_off").css({
						width: w+"px",
						height: h+"px",
						display: "none"
					});
					var img_on = $(Render.images["button2"]).clone();
					img_on.addClass("img_on").css({
						width: w+"px",
						height: h+"px"
					});
					
					div = $(document.createElement("div"));
					div.css({
						"height": "40px",
						"margin-top": "15px",
						"font-size": "16px"
					}).html(_t("Attack Mode"));
					popup.append(div);
					
					var modes = {
						closest: "Closest",
						farthest: "Farthest",
						lowhealth: "Low Health",
						highhealth: "High Health"
					}, _x = x, _w;
					for(var mode in modes)
					{
						img_on = img_on.clone();
						img_off = img_off.clone();
						div = $(document.createElement("div"));
						div.attr({
							mode: mode
						}).addClass("fl attack_mode clickevents").css({
							position: "relative",
							width: w+"px",
							height: h+"px",
							"margin-right": (mode != "highhealth" ? "10px" : "0px"),
							"font-size": "16px",
							border: "1px solid #666",
							"text-align": "center"
						}).append(img_off).append(img_on)
						  .append("<div class='text' style='position:absolute;left:0px;top:2px;width:"+w+"px;'>"+_t(modes[mode])+"</div>").click(function()
						{
							var ID = GameGP0Display.botSelected,
								bot = Game.bots[ID];
							
							bot.data.whofirst = $(this).attr("mode");
							
							GameGP0Display.popupCanvas = null;
						});
						popup.append(div);
					}
					popup.append("<div class='clear'></div>");
					setTimeout(function()
					{
						$("body").find(".attack_mode > .text").each(function()
						{
							if ($(this).height() < 30) return true;
							
							var font = 16;
							while($(this).height() > 30 && font >= 10)
							{
								$(this).css("font-size", font+"px");
								font--;
							}
						});
					}, 25);
					
					var str = "";
					switch(bot.data.whofirst)
					{
					case "closest":
						str = _t("closest_desc");
					break;
					
					case "farthest":
						str = _t("farthest_desc");
					break;
					
					case "lowhealth":
						str = _t("lowhealth_desc");
					break;
					
					case "highhealth":
						str = _t("highhealth_desc");
					break;
					}
					
					//Show Bank
					div = $(document.createElement("div"));
					div.addClass("fr").css({
						marginTop: "35px"
					}).html("<div class='fl' style='min-width:50px;margin-right:5px;'>"+_t("Bank")+":</div>" +
							"<div class='bankamt fl'>$"+Leaderboard.numberFormat(Game.money, "short")+"</div>" +
							"<div class='clear'></div>");
					popup.append(div);
					
					if (str != "")
					{
						div = $(document.createElement("div"));
						div.addClass("attack_mode_str fl").css({
							"margin-top": "35px",
							"font-size": "16px"
						}).html(str);
						popup.append(div);
					}

					popup.append("<div class='clear'></div>");
				} else {
					//Show Bank
					div = $(document.createElement("div"));
					div.addClass("fr").css({
						marginTop: "35px"
					}).html("<div class='fl' style='min-width:50px;margin-right:5px;'>"+_t("Bank")+":</div>" +
							"<div class='bankamt fl'>$"+Leaderboard.numberFormat(Game.money, "short")+"</div>" +
							"<div class='clear'></div>");
					popup.append(div);
					popup.append("<div class='clear'></div>");
				}
			break;
			
			case "bots_upgrade":
				var ID, bots, bot;
				bots = {};
				for(var key in this.botsSelected)
					bots[this.botsSelected[key]] = Game.bots[this.botsSelected[key]];
				bot = Game.bots[this.botsSelected[0]];
				var botType = bot.type;
				var storeItem = __Store[botType];
				
				var resell = 0;
				for(var ID in Game.bots)
				{
					bot = Game.bots[ID];
					if (bot.type != botType) continue;
					
					resell += whatIsResellAmount(bot);
				}
				var str = _t("managebot_sell").replace(/\[amt\]/i, "<span class='sellamt'>$"+Leaderboard.numberFormat(resell, "short")+"</span>");
				var w = 100, h = 28;
				var img_on = $(Render.images["button2"]);
				img_on.css({
					width: w+"px",
					height: h+"px"
				});
				div = $(document.createElement("div"));
				div.attr({
					type: type,
					bottype: botType,
					resell: resell
				}).addClass("fr sellbtn clickevents").css({
					position: "relative",
					width: w+"px",
					height: h+"px",
					"font-size": "16px",
					border: "1px solid #666",
					"text-align": "center"
				}).append(img_on)
				  .append("<div class='text' style='position:absolute;left:0px;top:2px;width:"+w+"px;'>"+str+"</div>").click(function()
				{
					var type = $(this).attr("bottype");
					
					var sellAmt = 0;
					var bot;
					for(var ID in Game.bots)
					{
						bot = Game.bots[ID];
						if (bot.type != type) continue;
						
						sellAmt += whatIsResellAmount(bot);
					}
					
					GameGP0Display.sellBotConfirmation(function(data)
					{
						var bot;
						for(var ID in Game.bots)
						{
							bot = Game.bots[ID];
							if (bot.type != data.type) continue;
							
							Game.botsSell(ID);
						}
						
						GameGP0Display.popupClose();
						GameGP0Display.spotbotClicksObjs = {};
					}, {
						type: type,
						value: sellAmt,
						me: $(this),
						multi: true
					});
				});
				popup.append(div);
				
				var text = this.popupDiv.find(".sellbtn .text");
				if (text.height() > 30)
				{
					while(text.height() > 30)
					{
						var w = text.width()+5;
						text.parent().width(w);
						text.parent().children().width(w);
					}
					var w = text.width()+10;
					text.parent().width(w);
					text.parent().children().width(w);
					
					GameGP0DisplayClicks.resetSetWidthHeight(text);
				}
				
				div = $(document.createElement("div"));
				div.addClass("fl").css({
					"height": "40px",
					"font-size": "16px"
				}).html(_t("managebot_title2").replace(/\[botname\]/i, _t(storeItem.name)));
				popup.append(div);
				popup.append("<div class='clear'></div>");
				
				
				var w = 95, h = 26;
				var img_off = $(Render.images["button_grey"]).clone();
				img_off.addClass("img_off").css({
					width: w+"px",
					height: h+"px",
					display: "none"
				});
				var img_on = $(Render.images["button2"]).clone();
				img_on.addClass("img_on").css({
					width: w+"px",
					height: h+"px"
				});
				
				var item, itemDiv, cost, lv, lines, line, allowUpgrade, itemDivContainer;
				var upgradeCosts;
				for(var type in __Store[botType].upgrades)
				{
					item = __Store[botType].upgrades[type];
					upgradeCosts = 0;
					lv = 0.0;
					
					for(var ID in bots)
					{
						bot = bots[ID];
						
						if (item.maxLv != 0 && item.maxLv <= bot.upgrades[type]) allowUpgrade = false;
						else allowUpgrade = true;
						
						if (allowUpgrade)
							upgradeCosts += whatIsUpgradeCost(item.cost, bot.upgrades[type]);
						lv += bot.upgrades[type];
					}
					lv /= this.botsSelected.length;
					lv = lv.toFixed(1);
					
					itemDivContainer = $(document.createElement("div"));
					popup.append(itemDivContainer);
					
					div = $(document.createElement("div"));
					div.css({
						height: "1px",
						"margin": "6px 0",
						background: "#1A1A1A"
					}).html("&nbsp;");
					itemDivContainer.append(div);
					
					itemDiv = $(document.createElement("div"));
					itemDiv.attr({
						type: type,
						botType: botType
					}).addClass("item");
					itemDivContainer.append(itemDiv);
					
					if (upgradeCosts > 0)
					{
						img_on = img_on.clone();
						img_off = img_off.clone();
						div = $(document.createElement("div"));
						div.attr({
							type: type,
							botType: botType
						}).addClass("fr btn clickevents").css({
							position: "relative",
							width: w+"px",
							height: h+"px",
							"font-size": "16px",
							border: "1px solid #666",
							"text-align": "center"
						}).append(img_off).append(img_on)
						  .append("<div class='text' style='position:absolute;left:0px;top:2px;width:"+w+"px;'>"+_t("Upgrade")+"</div>").click(function()
						{
							var type = $(this).attr("type");
							var botType = $(this).attr("botType");
							var ID, bots, bot;
							bots = {};
							for(var key in GameGP0Display.botsSelected)
								bots[GameGP0Display.botsSelected[key]] = Game.bots[GameGP0Display.botsSelected[key]];
							
							var storeItem = __Store[botType];
							var item = storeItem.upgrades[type];
							
							upgradeCosts = 0;
							for(var ID in bots)
							{
								bot = bots[ID];
								
								if (item.maxLv != 0 && item.maxLv <= bot.upgrades[type]) allowUpgrade = false;
								else allowUpgrade = true;
								
								if (allowUpgrade)
									upgradeCosts += whatIsUpgradeCost(item.cost, bot.upgrades[type]);
							}
							
							if (Game.money >= upgradeCosts && upgradeCosts > 0)
								for(var ID in bots)
									Game.botsUpgrade(ID, type);
							
							GameGP0Display.popupCanvas = null;
						});
						itemDiv.append(div);
					}
					setTimeout(function()
					{
						$("body").find(".clickevents > .text").each(function()
						{
							var w = $(this).parent().width();
							if ($(this).textWidth() < w) return true;
							
							var font = 16;
							while($(this).textWidth() > w && font >= 10)
							{
								$(this).css("font-size", font+"px");
								font--;
							}
						});
					}, 25);

					div = $(document.createElement("div"));
					div.addClass("fl").css({
						"font-size": "16px",
						"min-width": "150px",
						"margin-right": "15px",
						height: "35px"
					}).html(_t(item.name));
					itemDiv.append(div);
					
					div = $(document.createElement("div"));
					div.addClass("fl").css({
						"font-size": "16px",
						"min-width": "60px",
						"margin-right": "15px"
					}).html(_t("lv_show").replace(/\[number\]/i, "<span class='lv'>"+lv+"</span>"));
					itemDiv.append(div);
					
					div = $(document.createElement("div"));
					div.addClass("fl statrender").css({
						"font-size": "16px",
						"min-width": "150px",
						"margin-right": "15px"
					}).html("0");
					itemDiv.append(div);
					
					if (upgradeCosts > 0)
					{
						div = $(document.createElement("div"));
						div.addClass("fl buydiv").css({
							"font-size": "16px",
							color: "#FFFFFF"
						}).html("$"+Leaderboard.numberFormat(upgradeCosts, "short"));
						itemDiv.append(div);
					}
					
					itemDiv.append("<div class='clear'></div>");
				}
				
				
				//Attack Mode - showattackmode:false
				if (0)
				{
					
				} else {
					//Show Bank
					div = $(document.createElement("div"));
					div.addClass("fr").css({
						marginTop: "35px"
					}).html("<div class='fl' style='min-width:50px;margin-right:5px;'>"+_t("Bank")+":</div>" +
							"<div class='bankamt fl'>$"+Leaderboard.numberFormat(Game.money, "short")+"</div>" +
							"<div class='clear'></div>");
					popup.append(div);
					popup.append("<div class='clear'></div>");
				}
			break;
			}
			
			
			var width = popup.width(), height = popup.height();
			var x = ((this.container.width() - width - 30)/2), y = ((this.container.height() - height - 30)/2);
			popup.css({
				left: x+"px",
				top: y+"px"
			});

			background = $(Render.images["popup"]).clone();
			background.css({
				position: "absolute",
				left: x+"px",
				top: y+"px",
				width: (width+30)+"px",
				height: (height+30)+"px"
			});
			popup.before(background);
			background = $(document.createElement("div"));
			background.css({
				position: "absolute",
				left: (x+5)+"px",
				top: (y+5)+"px",
				width: (width+20)+"px",
				height: (height+20)+"px",
				background: "#000",
				opacity: "0.88"
			});
			popup.before(background);
			
			var close = $(Render.images["popup_x"]).clone();
			close.addClass("clickevents").css({
				position: "absolute",
				right: "-13px",
				top: "-13px",
				width: "30px",
				height: "30px"
			}).click(function()
			{
				GameGP0Display.popupClose();
			});
			popup.append(close);
			
			var arrs = [{
				x: 0, y: 0, w: this.popupDiv.width(), h: y
			}, {
				x: 0, y: y, w: x, h: height+30
			}, {
				x: this.popupDiv.width()-x, y: y, w: x, h: height+30
			}, {
				x: 0, y: this.popupDiv.height()-y, w: this.popupDiv.width(), h: y
			}], arr;
			for(var key in arrs)
			{
				arr = arrs[key];
				
				background = $(document.createElement("div")); 
				background.addClass("clickevents").css({
					position: "absolute",
					left: arr.x+"px",
					top: arr.y+"px",
					width: arr.w+"px",
					height: arr.h+"px",
				}).click(function()
				{
					GameGP0Display.popupClose();
					//ClickBank.delayClickByOneFrame();
				});
				this.popupDiv.append(background);
			}
			
			
		} else {
			if (this.recentChanges.popupdata == undefined)
				this.recentChanges.popupdata = {};
			var popupdata = this.recentChanges.popupdata;
			
			switch(this.popupArea)
			{
			case "spot_addbot":
				var ID, spot;
				ID = this.spotSelected;
				spot = Game.spots[ID];
				
				var item, cost;
				for(var type in __Store)
				{
					item = __Store[type];
					if (item.type != "bot") continue;
					if (Game.mapClass.storeRules[type] && Game.mapClass.storeRules[type].enabled != undefined
						&& !Game.mapClass.storeRules[type].enabled) continue;
					
					cost = item.cost;
					if (item.costupgrade != undefined) cost = item.costupgrade();
					
					if (popupdata["item_"+type] == undefined) popupdata["item_"+type] = {};
					if (popupdata["item_"+type].money == undefined || popupdata["item_"+type].money != Game.money)
					{
						if (Game.money >= cost)
						{
							this.popupDiv.find(".item[type='"+type+"']").find(".img_off").hide();
							this.popupDiv.find(".item[type='"+type+"']").find(".img_on").show();
						} else {
							this.popupDiv.find(".item[type='"+type+"']").find(".img_off").show();
							this.popupDiv.find(".item[type='"+type+"']").find(".img_on").hide();
						}
						
						popupdata["item_"+type].money = Game.money;
					}
				}
			break;
			
			case "bot_upgrade":
				var ID, bot;
				ID = this.botSelected;
				bot = Game.bots[ID];
				var storeItem = __Store[bot.type];
				
				if (this.recentChanges.bankamtPopup == undefined || this.recentChanges.bankamtPopup != Game.money)
				{
					this.popupDiv.find(".bankamt").html("$"+Leaderboard.numberFormat(Game.money, "short"));
					this.recentChanges.bankamtPopup = Game.money;
				}
				
				var resell = whatIsResellAmount(bot);
				if (popupdata.sellamt == undefined || popupdata.sellamt != resell)
				{
					this.popupDiv.find(".sellamt").html("$"+Leaderboard.numberFormat(resell, "short"));
					this.popupDiv.find(".sellbtn").attr({resell: resell});
					popupdata.sellamt = resell;
					
					var text = this.popupDiv.find(".sellbtn .text");
					if (text.height() > 30)
					{
						while(text.height() > 30)
						{
							var w = text.width()+5;
							text.parent().width(w);
							text.parent().children().width(w);
						}
						var w = text.width()+10;
						text.parent().width(w);
						text.parent().children().width(w);
						
						GameGP0DisplayClicks.resetSetWidthHeight(text);
					}
				}
				
				var item, itemDiv, cost, lv, statrender, lines, line, allowUpgrade;
				for(var type in __Store[bot.type].upgrades)
				{
					item = __Store[bot.type].upgrades[type];
					if (item.maxLv != 0 && item.maxLv <= bot.upgrades[type]) allowUpgrade = false;
					else allowUpgrade = true;
					
					lv = bot.upgrades[type];
					cost = whatIsUpgradeCost(item.cost, bot.upgrades[type]);
					statrender = item.statRender(bot);
					
					if (popupdata["item_"+type] == undefined) popupdata["item_"+type] = {};
					if (popupdata["item_"+type].money == undefined || popupdata["item_"+type].money != Game.money)
					{
						if (Game.money >= cost)
						{
							this.popupDiv.find(".item[type='"+type+"']").find(".img_off").hide();
							this.popupDiv.find(".item[type='"+type+"']").find(".img_on").show();
						} else {
							this.popupDiv.find(".item[type='"+type+"']").find(".img_off").show();
							this.popupDiv.find(".item[type='"+type+"']").find(".img_on").hide();
						}
						
						popupdata["item_"+type].money = Game.money;
					}
					if (popupdata["item_"+type].lv == undefined || popupdata["item_"+type].lv != lv)
					{
						this.popupDiv.find(".item[type='"+type+"']").find(".lv").html(lv);
						popupdata["item_"+type].lv = lv;
					}
					if (popupdata["item_"+type].statrender == undefined || popupdata["item_"+type].statrender != statrender)
					{
						this.popupDiv.find(".item[type='"+type+"']").find(".statrender").html(statrender);
						popupdata["item_"+type].statrender = statrender;
					}
					if (popupdata["item_"+type].buyamt == undefined || popupdata["item_"+type].buyamt != cost)
					{
						this.popupDiv.find(".item[type='"+type+"']").find(".buydiv").html("$"+Leaderboard.numberFormat(cost, "short"));
						popupdata["item_"+type].buyamt = cost;
					}
					
					if (!allowUpgrade)
					{
						if (popupdata["item_"+type].allowUpgrade == undefined || popupdata["item_"+type].allowUpgrade != "n")
						{
							this.popupDiv.find(".item[type='"+type+"']").find(".buydiv,.btn").hide();
							popupdata["item_"+type].allowUpgrade = "n";
						}
					}
				}
				
				
				//Attack Mode
				if (bot.type != "cloud" && bot.type != "teslacoil" && (storeItem.showAttackMode == undefined || storeItem.showAttackMode))
				{
					var modes = {
						closest: "Closest",
						farthest: "Farthest",
						lowhealth: "Low Health",
						highhealth: "High Health"
					}, isSelected;
					for(var mode in modes)
					{
						isSelected = bot.data.whofirst == mode ? "y" : "n";
						if (popupdata["attackmode_"+mode] == undefined || popupdata["attackmode_"+mode] != isSelected)
						{
							if (isSelected == "y")
							{
								this.popupDiv.find(".attack_mode[mode='"+mode+"']").find(".img_off").hide();
								this.popupDiv.find(".attack_mode[mode='"+mode+"']").find(".img_on").show();
							} else {
								this.popupDiv.find(".attack_mode[mode='"+mode+"']").find(".img_off").show();
								this.popupDiv.find(".attack_mode[mode='"+mode+"']").find(".img_on").hide();
							}
							
							popupdata["attackmode_"+mode] = isSelected;
						}
					}
					
					var str = "";
					switch(bot.data.whofirst)
					{
					case "closest":
						str = _t("closest_desc");
					break;
					
					case "farthest":
						str = _t("farthest_desc");
					break;
					
					case "lowhealth":
						str = _t("lowhealth_desc");
					break;
					
					case "highhealth":
						str = _t("highhealth_desc");
					break;
					}
					if (popupdata["attack_mode_str"] == undefined || popupdata["attack_mode_str"] != str)
					{
						this.popupDiv.find(".attack_mode_str").html(str);
						
						popupdata["attack_mode_str"] = str;
					}
				}
			break;
			
			case "bots_upgrade":
				var ID, bots, bot;
				bots = {};
				for(var key in this.botsSelected)
					bots[this.botsSelected[key]] = Game.bots[this.botsSelected[key]];
				bot = Game.bots[this.botsSelected[0]];
				var botType = bot.type;
				var storeItem = __Store[botType];
				
				if (this.recentChanges.bankamtPopup == undefined || this.recentChanges.bankamtPopup != Game.money)
				{
					this.popupDiv.find(".bankamt").html("$"+Leaderboard.numberFormat(Game.money, "short"));
					this.recentChanges.bankamtPopup = Game.money;
				}
				
				var resell = 0;
				for(var ID in Game.bots)
				{
					bot = Game.bots[ID];
					if (bot.type != botType) continue;
					
					resell += whatIsResellAmount(bot);
				}
				if (popupdata.sellamt == undefined || popupdata.sellamt != resell)
				{
					this.popupDiv.find(".sellamt").html("$"+Leaderboard.numberFormat(resell, "short"));
					this.popupDiv.find(".sellbtn").attr({resell: resell});
					popupdata.sellamt = resell;
					
					var text = this.popupDiv.find(".sellbtn .text");
					if (text.height() > 30)
					{
						while(text.height() > 30)
						{
							var w = text.width()+5;
							text.parent().width(w);
							text.parent().children().width(w);
						}
						var w = text.width()+10;
						text.parent().width(w);
						text.parent().children().width(w);
						
						GameGP0DisplayClicks.resetSetWidthHeight(text);
					}
				}
				
				var item, itemDiv, cost, lv, statrender, lines, line, allowUpgrade;
				var upgradeCosts;
				for(var type in __Store[botType].upgrades)
				{
					item = __Store[botType].upgrades[type];
					upgradeCosts = 0;
					lv = 0.0;
					
					statrender = 0;
					for(var ID in bots)
					{
						bot = bots[ID];
						
						if (item.maxLv != 0 && item.maxLv <= bot.upgrades[type]) allowUpgrade = false;
						else allowUpgrade = true;
						
						if (allowUpgrade)
							upgradeCosts += whatIsUpgradeCost(item.cost, bot.upgrades[type]);
						lv += bot.upgrades[type];
						statrender += bot.data[type];
					}
					lv /= this.botsSelected.length;
					lv = lv.toFixed(1);
					statrender /= this.botsSelected.length;
					statrender = item.statRender(statrender);
					
					//lv = bot.upgrades[type];
					cost = upgradeCosts;
					
					if (popupdata["item_"+type] == undefined) popupdata["item_"+type] = {};
					if (popupdata["item_"+type].money == undefined || popupdata["item_"+type].money != Game.money)
					{
						if (Game.money >= cost && cost > 0.0)
						{
							this.popupDiv.find(".item[type='"+type+"']").find(".img_off").hide();
							this.popupDiv.find(".item[type='"+type+"']").find(".img_on").show();
						} else {
							this.popupDiv.find(".item[type='"+type+"']").find(".img_off").show();
							this.popupDiv.find(".item[type='"+type+"']").find(".img_on").hide();
						}
						
						popupdata["item_"+type].money = Game.money;
					}
					if (popupdata["item_"+type].lv == undefined || popupdata["item_"+type].lv != lv)
					{
						this.popupDiv.find(".item[type='"+type+"']").find(".lv").html(lv);
						popupdata["item_"+type].lv = lv;
					}
					if (popupdata["item_"+type].statrender == undefined || popupdata["item_"+type].statrender != statrender)
					{
						this.popupDiv.find(".item[type='"+type+"']").find(".statrender").html(statrender);
						popupdata["item_"+type].statrender = statrender;
					}
					if (popupdata["item_"+type].buyamt == undefined || popupdata["item_"+type].buyamt != cost)
					{
						this.popupDiv.find(".item[type='"+type+"']").find(".buydiv").html("$"+Leaderboard.numberFormat(cost, "short"));
						popupdata["item_"+type].buyamt = cost;
					}
					
					if (upgradeCosts == 0.0)
					{
						if (popupdata["item_"+type].allowUpgrade == undefined || popupdata["item_"+type].allowUpgrade != "n")
						{
							this.popupDiv.find(".item[type='"+type+"']").find(".buydiv,.btn").hide();
							popupdata["item_"+type].allowUpgrade = "n";
						}
					}
				}
			break;
			}
		}
	};
	this.popupAddClick = function(id, x, y, w, h, click, data)
	{
		if (data == undefined) data = {};
		
		ClickBank.add({
			id: id,
			x: x, y: y,
			w: w, h: h,
			click: function(clickID, vaultEntry)
			{
				click(clickID, vaultEntry);
			},
			data: data
		});
	};
	
	
	//Popup to sell the bot
	this.popupSellDiv = null;
	this.sellActionFunc = null; this.sellActionData = null;
	this.sellBotConfirmation = function(func, data)
	{
		if (this.popupSellDiv) this.sellBotConfirmationClose();
		
		//data.type = data.type.substr(0, 1).toUpperCase()+data.type.substr(1, data.type.length-1);
		data.name = __Store[data.type].name;
		
		this.sellActionFunc = func;
		this.sellActionData = data;
		this.popupSellDiv = $("<div />");

		var objContainer = !GameGP0Display.popupEnabled ? GameGP0Display.container : GameGP0Display.popupDiv;
		if (!objContainer) return false;
		objContainer.append(this.popupSellDiv);
		this.popupSellDiv.css({
			position: "absolute",
			left: "0px",
			top: "0px",
			width: Render.gp0Width+"px",
			height: Render.gp0Height+"px",
			"z-index": 20
		});
		
		var background = $("<div />");
		this.popupSellDiv.append(background);
		background.css({
			position: "absolute",
			left: "0px",
			top: "0px",
			width: Render.gp0Width+"px",
			height: Render.gp0Height+"px",
			background: "#000",
			opacity: "0.75"
		});
		
		var popup = $("<div />");
		this.popupSellDiv.append(popup);
		popup.addClass("popupselldivs").css({
			position: "absolute",
			width: "400px",
			height: "70px",
			"z-index": 21
		});
		
		//Contents
		var inner = $("<div />");
		popup.append(inner);
		inner.css({
			padding: "10px 15px"
		});
		
		var str = "";
		if (!data.multi) str = _t("sell_desc1").replace(/\[botname\]/i, _t(data.name)).replace(/\[amt\]/i, "$"+Leaderboard.numberFormat(data.value, "short"));
		else str = _t("sell_desc2").replace(/\[botname\]/i, _t(data.name)).replace(/\[amt\]/i, "$"+Leaderboard.numberFormat(data.value, "short"));
		inner.append("<div style='margin-bottom:25px;'>"+str+"</div>");
		
		var w = 95, h = 26, div;
		var img_on = $(Render.images["button2"]).clone();
		img_on.addClass("img_on").css({
			width: w+"px",
			height: h+"px"
		});
		
		img_on = img_on.clone();
		div = $(document.createElement("div"));
		div.addClass("fl btn clickevents").css({
			position: "relative",
			width: w+"px",
			height: h+"px",
			"margin-right": "10px",
			"font-size": "16px",
			border: "1px solid #666",
			"text-align": "center"
		}).append(img_on)
		  .append("<div style='position:absolute;left:0px;top:2px;width:"+w+"px;'>"+_t("Sell")+"</div>").click(function()
		{
			GameGP0Display.sellBotAction();
		});
		inner.append(div);
		
		img_on = img_on.clone();
		div = $(document.createElement("div"));
		div.addClass("fl btn clickevents").css({
			position: "relative",
			width: w+"px",
			height: h+"px",
			"margin-right": "10px",
			"font-size": "16px",
			border: "1px solid #666",
			"text-align": "center"
		}).append(img_on)
		  .append("<div style='position:absolute;left:0px;top:2px;width:"+w+"px;'>"+_t("Cancel")+"</div>").click(function()
		{
			GameGP0Display.sellBotConfirmationClose();
		});
		inner.append(div);
		inner.append("<div class='clear'></div>");
		
		//Background
		var width = popup.width(), height = popup.height();
		var x = ((this.container.width() - width - 30)/2), y = ((this.container.height() - height - 30)/2);
		popup.css({
			left: x+"px",
			top: y+"px"
		});

		background = $(Render.images["popup"]).clone();
		background.css({
			position: "absolute",
			left: x+"px",
			top: y+"px",
			width: (width+30)+"px",
			height: (height+30)+"px"
		});
		popup.before(background);
		background = $(document.createElement("div"));
		background.css({
			position: "absolute",
			left: (x+5)+"px",
			top: (y+5)+"px",
			width: (width+20)+"px",
			height: (height+20)+"px",
			background: "#000",
			opacity: "0.88"
		});
		popup.before(background);
		
		var arrs = [{
			x: 0, y: 0, w: this.popupSellDiv.width(), h: y
		}, {
			x: 0, y: y, w: x, h: height+30
		}, {
			x: this.popupSellDiv.width()-x, y: y, w: x, h: height+30
		}, {
			x: 0, y: this.popupSellDiv.height()-y, w: this.popupSellDiv.width(), h: y
		}], arr;
		for(var key in arrs)
		{
			arr = arrs[key];
			
			background = $(document.createElement("div")); 
			background.addClass("clickevents").css({
				position: "absolute",
				left: arr.x+"px",
				top: arr.y+"px",
				width: arr.w+"px",
				height: arr.h+"px",
			}).click(function()
			{
				GameGP0Display.sellBotConfirmationClose();
			});
			this.popupSellDiv.append(background);
		}
	};
	this.sellBotConfirmationClose = function()
	{
		this.popupSellDiv.remove();
		this.sellActionFunc = null;
		this.sellActionData = null;
	};
	this.sellBotAction = function()
	{
		if (this.sellActionFunc) this.sellActionFunc(this.sellActionData);
		
		this.sellBotConfirmationClose();
	};
};
var GameGP0Display = new GameGP0Display();


//Handles and stores the clicks for the HTML here
function GameGP0DisplayClicks()
{
	this.count = 0;
	this.vault = {};
	this.heldCount = 0;
	this.heldVault = {};
	
	this.isMouseDown = false; this.isMouseMoving = false;
	this.heldCord = {x:0,y:0};
	this.prevCord = {x:0,y:0};
	this.totalMovement = {x:0,y:0};
	this.mouseDownLoopHandle = null;
	
	//Start Up fucntion
	this.init = function()
	{
		this.count = 0;
		this.vault = {};
		this.heldCount = 0;
		this.heldVault = {};
		
		this.isMouseDown = false;
		this.isMouseMoving = false;
		clearInterval(this.mouseDownLoopHandle);
		this.mouseDownLoopHandle = setInterval(function()
		{
			GameGP0DisplayClicks.mouseDownLoop();
		}, 10);
	};
	
	//Exit
	this.exit = function()
	{
		this.count = 0;
		this.vault = {};
		this.heldCount = 0;
		this.heldVault = {};
		
		this.isMouseDown = false;
		this.isMouseMoving = false;
		clearInterval(this.mouseDownLoopHandle);
	};
	
	//Handles the addition|update of clicks
	this.handleVaultCheckTTL = 0;
	this.handleVault = function()
	{
		return false;
		//this.handleVaultCheckTTL--;
		if (this.handleVaultCheckTTL > 0 || 1) return false;

		GameGP0Display.container.find(".clickevents").each(function()
		{
			var obj = $(this),x=obj.offset().left,y=obj.offset().top,
				w=obj.width(),h=obj.height();
			
			//New
			if (obj.attr("clickevent") == undefined)
			{
				var clickevent = GameGP0DisplayClicks.count++;
				obj.attr("clickevent", clickevent);
				
				GameGP0DisplayClicks.vault[clickevent] = {
					x: x, y: y,
					w: w, h: h
				};
				
			//Check to see if we need to update
			} else {
				var clickevent = parseInt(obj.attr("clickevent"));
				var entry = GameGP0DisplayClicks.vault[clickevent];
				
				if (entry.x != x || entry.y != y || entry.w != w || entry.h != h)
				{
					GameGP0DisplayClicks.vault[clickevent] = {
						x: x, y: y,
						w: w, h: h
					};
				}
			}
		});
		GameGP0Display.container.find(".heldevents").each(function()
		{
			var obj = $(this),x=obj.offset().left,y=obj.offset().top,
				w=obj.width(),h=obj.height();
			
			//New
			if (obj.attr("heldevent") == undefined)
			{
				var heldevent = GameGP0DisplayClicks.heldCount++;
				obj.attr("clickevent", heldevent);
				
				GameGP0DisplayClicks.heldVault[clickevent] = {
					x: x, y: y,
					w: w, h: h
				};
				
			//Check to see if we need to update
			} else {
				var heldevent = parseInt(obj.attr("heldevent"));
				var entry = GameGP0DisplayClicks.vault[heldevent];
				
				if (entry.x != x || entry.y != y || entry.w != w || entry.h != h)
				{
					GameGP0DisplayClicks.heldVault[heldevent] = {
						x: x, y: y,
						w: w, h: h
					};
				}
			}
		});
		
		this.handleVaultCheckTTL = 25;
	};
	
	//Let's us know that we should update the entries
	this.handleVaultCheck = function()
	{
		this.handleVaultCheckTTL = 0;
	}
	
	//Check for potential click
	//GameGP0DisplayClicks
	this.clicksCount = 0;
	this.click = function(e)
	{
		//try{
		var objContainer = !GameGP0Display.popupEnabled ? GameGP0Display.container : GameGP0Display.popupDiv;
		if (!objContainer) return false;
		
		//var ms = Date.now();
		var _x = e.pageX, _y = e.pageY;
		
		var clickFound = false;
		$(objContainer.find(".clickevents").get().reverse()).each(function()
		{
			if (clickFound) return true;
			var obj = $(this),
				x=obj.offset().left,
				y=obj.offset().top;
			if (obj.is(":hidden")) return true;
			if (obj.attr("cwidth") == undefined)
			{
				var w=obj.width(),
					h=obj.height();
				
				obj.attr({
					cwidth: w,
					cheight: h
				});
			} else {
				var w=parseInt(obj.attr("cwidth")),
					h=parseInt(obj.attr("cheight"));
			}
			
			if (x <= _x && _x <= x+w && y <= _y && _y <= y+h)
			{
				clickFound = true;
				obj.click();
			}
		});
		
		//console.log(Date.now() - ms);
	};
	
	//Trigger Held Clicks
	this.heldClicks = function(_x, _y)
	{
		var objContainer = !GameGP0Display.popupEnabled ? GameGP0Display.container : GameGP0Display.popupDiv;
		if (!objContainer) return false;
		
		var clickFound = false;
		objContainer.find(".heldevents:visible").each(function()
		{
			//if (clickFound) return true;
			var obj = $(this),
				x=obj.offset().left,
				y=obj.offset().top;
			if (obj.attr("cwidth") == undefined)
			{
				var w=obj.width(),
					h=obj.height();
				
				obj.attr({
					cwidth: w,
					cheight: h
				});
			} else {
				var w=parseInt(obj.attr("cwidth")),
					h=parseInt(obj.attr("cheight"));
			}
			
			if (x <= _x && _x <= x+w && y <= _y && _y <= y+h)
			{
				clickFound = true;
				obj.click();
			}
		});
	};

	//Trigger Touch Move functions
	this.moveTouch = function()
	{
		var _x = this.prevCord.x - this.heldCord.x, _y = this.prevCord.y - this.heldCord.y;
		
		if (GameGP0Display.tab == "overview" && !GameGP0Display.popupEnabled)
		{
			var gpCord = Game.calculateTVCords(GameGP0Display.mapWidth, GameGP0Display.mapHeight, true);
			
			var xMove = Math.round(_x), yMove = Math.round(_y);
			GameGP0Display.mapOffset.x += xMove;
			GameGP0Display.mapOffset.y += yMove;

			if (GameGP0Display.mapOffset.y > GameGP0Display.mapOffsetLimit.h-gpCord.y)
				GameGP0Display.mapOffset.y = GameGP0Display.mapOffsetLimit.h-gpCord.y;
			else if (GameGP0Display.mapOffset.y < GameGP0Display.mapOffsetLimit.y)
				GameGP0Display.mapOffset.y = GameGP0Display.mapOffsetLimit.y;
			if (GameGP0Display.mapOffset.x > GameGP0Display.mapOffsetLimit.w-gpCord.x)
				GameGP0Display.mapOffset.x = GameGP0Display.mapOffsetLimit.w-gpCord.x;
			else if (GameGP0Display.mapOffset.x < GameGP0Display.mapOffsetLimit.x)
				GameGP0Display.mapOffset.x = GameGP0Display.mapOffsetLimit.x;
			
			Game.mapOffsetX = GameGP0Display.mapOffset.x;
			Game.mapOffsetY = GameGP0Display.mapOffset.y;
			
		}
	};
	
	//Mouse Down function
	this.mouseDown = function(e)
	{
		this.isMouseDown = true;
		this.isMouseMoving = false;
		
		this.heldCord.x = e.pageX;
		this.heldCord.y = e.pageY;
		this.prevCord.x = e.pageX;
		this.prevCord.y = e.pageY;
		this.totalMovement = {x:0,y:0};
	};
	
	//Mouse Down function
	this.mouseMove = function(e)
	{
		this.prevCord.x = this.heldCord.x;
		this.prevCord.y = this.heldCord.y;
		this.heldCord.x = e.pageX;
		this.heldCord.y = e.pageY;
		this.totalMovement.x += this.prevCord.x - this.heldCord.x;
		this.totalMovement.y += this.prevCord.y - this.heldCord.y;
		
		if (this.heldCord.x != this.prevCord.x || this.heldCord.y != this.prevCord.y)
		{
			if (Math.abs(this.totalMovement.x) >= 10 || Math.abs(this.totalMovement.y) >= 10)
				this.isMouseMoving = true;
		}
	};
	
	//Mouse Down function
	this.mouseUp = function(e)
	{
		this.isMouseDown = false;
		this.isMouseMoving = false;
	};
	
	//Set Interval loop
	this.mouseDownLoop = function()
	{
		if (!this.isMouseDown) return false;
		
		if (!this.isMouseMoving)
			this.heldClicks(this.heldCord.x, this.heldCord.y);
		else
			this.moveTouch();
	};
	
	this.resetSetWidthHeight = function(obj)
	{
		obj.removeAttr("cwidth");
		obj.removeAttr("cheight");
	};
};
var GameGP0DisplayClicks = new GameGP0DisplayClicks();