function Language()
{
	//Holds the translated text for each language
	this.text = {};
	
	//Who do we choose from?
	this.useLang = "english";
	this.defaultLang = "english";
	this.allowedLang = ["english", "spanish", "french", "german", "italian"];
	
	//Add extra character to help determine if this is working.
	this.debugMode = 0;
	
	//Given an unique hash, will return the translated text in the choosen language
	this.translate = function(hash)
	{
		var _lang = this.getLanguage();
		
		var rtr = "";
		if (!(typeof this.text[_lang] == "undefined"))
		{
			if (typeof this.text[_lang][hash] != "undefined")
				rtr = this.text[_lang][hash];
			else if (typeof this.text[this.defaultLang][hash] != "undefined")
				rtr = this.text[this.defaultLang][hash];
		}
		
		if (this.debugMode) rtr = "|"+rtr+"|";
		
		return rtr;
	};
	
	this.setLanguage = function(lang)
	{
		if (jQuery.inArray(lang, this.allowedLang) != -1)
			this.useLang = lang;
		else
			this.useLang = this.defaultLang;
	};
	
	this.getLanguage = function()
	{
		var _lang = this.useLang;
		if (jQuery.inArray(_lang, this.allowedLang) == -1)
			_lang = this.defaultLang;
		
		return _lang;
	};
	
	this.change = function(num)
	{
		switch(num)
		{
		case 1: this.useLang = "english"; break;
		case 2: this.useLang = "spanish"; break;
		case 3: this.useLang = "french"; break;
		case 4: this.useLang = "german"; break;
		case 5: this.useLang = "italian"; break;
		}
	};
};
var Language = new Language();

function _t(hash)
{
	return Language.translate(hash);
};