function Leaderboard()
{
	this.options = {};
	this.map = null;
	this.area = null;
	this.mode = null;
	this.onlineAreas = ["all"];
	
	//Local Highscore
	this.scores = {};
	
	//Online Highscores
	this.onlineScores = {};
	this.scorePresetLoaded = false;
	this.canSwitchPages = true;
	this.scoresYOffset = 0;
	
	//Online Limits
	this.onlineFuncsLimit = 25; this.onlineFuncsTimeLimit = 6*60*1000;
	this.onlineFuncsLimitTypes = {"": 21, get: 21, put: 25};
	this.onlineFuncsTimes = [];
	
	//Startup the Leaderboard Screen
	this.init = function(options)
	{
		ClickBank.archive();
		InputBank.archive();
		
		if (!this.scorePresetLoaded) this.loadScorePreset();
		this.scorePresetLoaded = true;
		
		this.options = options;
		if (typeof options.map != "undefined") this.map = options.map;
		if (options.area) this.area = options.area;
		if (options.mode) this.mode = options.mode;
		this.area = "all";
		if (!Render.actCanInternet)
		{
			if (this.map == "") this.map = "ss001";
			this.area = "local";
		}
		if (this.mode == "Easy" || this.mode == "easy") this.area = "local";
		this.canSwitchPages = true;
		//this.area = "local";
		this.grabMapOnlineScores(this.map, this.mode, this.area);
		
		this.scoresYOffset = 0;

		Render.renderControl = function(){ Leaderboard.render(); };
		
		//Buttons
		InputBank.add({
			id: "button",
			type: ["up", "down", "b", "x", "y", "l", "r", "l2", "r2"],
			action: function(clickID, vaultEntry, type)
			{
				if (!Leaderboard.canSwitchPages) return false;
				switch(type)
				{
				case "up":
					Leaderboard.scoresYOffset++;
				break;
				
				case "down":
					Leaderboard.scoresYOffset--;
				break;
				
				case "b":
					Leaderboard.close();
				break;
				
				case "x":
					Leaderboard.switchArea(-1);
				break;
				
				case "y":
					Leaderboard.switchArea(1);
				break;
				
				case "l":
					Leaderboard.prevMap();
				break;
				
				case "r":
					Leaderboard.nextMap();
				break;
				
				case "l2":
					Leaderboard.prevMode();
				break;
				
				case "r2":
					Leaderboard.nextMode();
				break;
				}
			}
		});
	};
	
	//Close and return to previous area
	this.close = function()
	{
		ClickBank.unarchive();
		InputBank.unarchive();
		
		switch(this.options.type)
		{
		case "gameover":
			Render.renderControl = function(){ GameOver.render(); };
			GameOver.area = "gameover";
		break;

		case "mainmenu":
		case "mainmenu_map":
			Render.renderControl = function(){ MainMenu.render(); };
		break;
		}
		
		this.options = {};
		this.map = null;
		this.area = null;
		this.mode = null;
		this.scoresYOffset = 0;
		this.canSwitchPages = true;
	};
	
	//Render function
	this.render = function()
	{
		//Clear
		Render.renderClear("all");
		var cxt = Render.tvContext, gxt = Render.gp0Context;
		
		//Black Background
		cxt.fillStyle = "#000"; gxt.fillStyle = "#000";
		cxt.drawImage(Render.images["space1"], 0, 0, Render.tvWidth, Render.tvHeight);
		gxt.drawImage(Render.images["space1"], 0, 0, Render.gp0Width, Render.gp0Height);
		cxt.globalAlpha = 0.7; gxt.globalAlpha = 0.7;
		cxt.fillRect(0, 0, Render.tvWidth, Render.tvHeight);
		gxt.fillRect(0, 0, Render.gp0Width, Render.gp0Height);
		cxt.globalAlpha = 1; gxt.globalAlpha = 1;
		
		//Choose Map
		if (this.map == null)
		{
			//May not ever be used
			
		//Display Map Screen
		} else {
			var modeUppercase = this.mode.substr(0, 1).toUpperCase()+this.mode.substr(1, this.mode.length-1);
			if (modeUppercase == "Endless") modeUppercase = "Endurance";
			
			var listType = "Monthly";
			switch(this.area)
			{
			case "all": listType = "All Time"; break;
			case "friends": listType = "Friends"; break;
			case "local": listType = "Local"; break;
			}
			
			//Titles
			/*cxt.fillStyle = "#FFF"; gxt.fillStyle = "#FFF";
			cxt.font = "40px Verdana"; gxt.font = "24px Verdana";
			cxt.textAlign = "left"; gxt.textAlign = "left";
			
			if (this.map)
			{
				cxt.fillText(_t("Map")+": "+__Maps[this.map].title, Render.tvWidth*(1/3), 30*Render.renderTVRatio);
				gxt.fillText(_t("Map")+": "+__Maps[this.map].title, Render.gp0Width*(1/3), 25);
			} else {
				cxt.fillText(_t("Top Five Average!"), Render.tvWidth*(1/3), 30*Render.renderTVRatio);
				gxt.fillText(_t("Top Five Average!"), Render.gp0Width*(1/3), 25);
			}
			
			cxt.fillText(_t("Mode")+": "+modeUppercase, Render.tvWidth*(1/3), 110*Render.renderTVRatio);
			gxt.fillText(_t("Mode")+": "+modeUppercase, Render.gp0Width*(1/3), 65);
			
			cxt.fillText(_t("List")+": "+listType, Render.tvWidth*(1/3)+10, 190*Render.renderTVRatio);
			gxt.fillText(_t("List")+": "+listType, Render.gp0Width*(1/3)+5, 105);*/
			
			cxt.fillStyle = "#FFF"; gxt.fillStyle = "#FFF";
			cxt.font = "40px Verdana"; gxt.font = "24px Verdana";
			cxt.textAlign = "center"; gxt.textAlign = "center";
			
			if (this.map)
			{
				cxt.fillText(_t("Map")+": "+_t(this.map+"_title"), Render.tvWidth*0.5, 30*Render.renderTVRatio);
				gxt.fillText(_t("Map")+": "+_t(this.map+"_title"), Render.gp0Width*0.5, 25);
			} else {
				cxt.fillText(_t("Top Five Average!"), Render.tvWidth*0.5, 30*Render.renderTVRatio);
				gxt.fillText(_t("Top Five Average!"), Render.gp0Width*0.5, 25);
			}
			
			/*var str = _t(modeUppercase+" Mode");
			cxt.fillText(str, Render.tvWidth*0.5, 110*Render.renderTVRatio);
			gxt.fillText(str, Render.gp0Width*0.5, 65);*/
			
			cxt.textAlign = "right"; gxt.textAlign = "right";
			var str = _t(modeUppercase+" Mode");
			cxt.font = "40px Verdana"; gxt.font = "24px Verdana";
			var font = 40, font2 = 24;
			while(font > 30 && cxt.measureText(str).width+75 > Render.tvWidth/2)
			{
				font--;
				cxt.font = font+"px Verdana";
			}
			while(font2 > 14 && gxt.measureText(str).width > Render.gp0Width/3)
			{
				font2--;
				gxt.font = font2+"px Verdana";
			}
			cxt.textBaseline = "bottom"; gxt.textBaseline = "bottom";
			cxt.fillText(str, Render.tvWidth*0.45, 194*Render.renderTVRatio);
			gxt.fillText(str, Render.gp0Width*0.45, 98);
			cxt.font = "40px Verdana"; gxt.font = "24px Verdana";
			cxt.textBaseline = "top"; gxt.textBaseline = "top";
			
			cxt.textAlign = "left"; gxt.textAlign = "left";
			var str = _t(listType);
			cxt.fillText(str, Render.tvWidth*0.55, 110*Render.renderTVRatio);
			gxt.fillText(str, Render.gp0Width*0.55, 65);
			
			cxt.textAlign = "center"; gxt.textAlign = "center";
			cxt.fillText("~", Render.tvWidth*0.5, 110*Render.renderTVRatio);
			gxt.fillText("~", Render.gp0Width*0.5, 65);
			
			cxt.textAlign = "left"; gxt.textAlign = "left";
			
			
			//Add Arrows
			/*gxt.drawImage(Render.images["arrow2"], 25, 30, 20, 30);
			gxt.drawImage(Render.images["arrow1"], Render.gp0Width-45, 30, 20, 30);
			
			gxt.drawImage(Render.images["arrow2"], 25, 70, 20, 30);
			gxt.drawImage(Render.images["arrow1"], Render.gp0Width-45, 70, 20, 30);
			
			gxt.drawImage(Render.images["arrow2"], 25, 110, 20, 30);
			gxt.drawImage(Render.images["arrow1"], Render.gp0Width-45, 110, 20, 30);*/
			gxt.drawImage(Render.images["arrow2"], 25, 30, 20, 30);
			gxt.drawImage(Render.images["arrow1"], Render.gp0Width-45, 30, 20, 30);
			
			gxt.drawImage(Render.images["arrow2"], 25, 70, 20, 30);
			gxt.drawImage(Render.images["arrow1"], 65, 70, 20, 30);
			
			gxt.drawImage(Render.images["arrow2"], Render.gp0Width-85, 70, 20, 30);
			gxt.drawImage(Render.images["arrow1"], Render.gp0Width-45, 70, 20, 30);
			ClickBank.add({
				id: "arrow_1",
				x: 25, y: 30, w: 20, h: 30,
				click: function()
				{
					Leaderboard.prevMap();
				}
			});
			ClickBank.add({
				id: "arrow_2",
				x: Render.gp0Width-45, y: 30, w: 20, h: 30,
				click: function()
				{
					Leaderboard.nextMap();
				}
			});
			ClickBank.add({
				id: "arrow_3",
				x: 25, y: 70, w: 20, h: 30,
				click: function()
				{
					Leaderboard.prevMode();
				}
			});
			ClickBank.add({
				id: "arrow_4",
				x: 65, y: 70, w: 20, h: 30,
				click: function()
				{
					Leaderboard.nextMode();
				}
			});
			ClickBank.add({
				id: "arrow_5",
				x: Render.gp0Width-85, y: 70, w: 20, h: 30,
				click: function()
				{
					Leaderboard.switchArea(-1);
				}
			});
			ClickBank.add({
				id: "arrow_6",
				x: Render.gp0Width-45, y: 70, w: 20, h: 30,
				click: function()
				{
					Leaderboard.switchArea(1);
					//Leaderboard.nextMode();
				}
			});
			
			//Box
			cxt.fillStyle = "#000"; gxt.fillStyle = "#000";
			cxt.strokeStyle = "#FFF"; gxt.strokeStyle = "#FFF";
			/*cxt.fillRect(350*Render.renderTVRatio, 285*Render.renderTVRatio, (Render.trueWidth-700)*Render.renderTVRatio, (Render.trueHeight-375)*Render.renderTVRatio);
			cxt.strokeRect(350*Render.renderTVRatio, 285*Render.renderTVRatio, (Render.trueWidth-700)*Render.renderTVRatio, (Render.trueHeight-375)*Render.renderTVRatio);
			gxt.fillRect(150, 150, Render.gp0Width-300, Render.gp0Height-190);
			gxt.strokeRect(150, 150, Render.gp0Width-300, Render.gp0Height-190);*/
			cxt.fillRect(350*Render.renderTVRatio, 220*Render.renderTVRatio, (Render.trueWidth-700)*Render.renderTVRatio, (Render.trueHeight-329)*Render.renderTVRatio);
			cxt.strokeRect(350*Render.renderTVRatio, 220*Render.renderTVRatio, (Render.trueWidth-700)*Render.renderTVRatio, (Render.trueHeight-329)*Render.renderTVRatio);
			gxt.fillRect(150, 105, Render.gp0Width-299, Render.gp0Height-148);
			gxt.strokeRect(150, 105, Render.gp0Width-299, Render.gp0Height-148);
			
			cxt.font = "30px Verdana"; gxt.font = "18px Verdana";
			cxt.fillStyle = "#FFF"; gxt.fillStyle = "#FFF";
			/*var x = 365*Render.renderTVRatio, y = 295*Render.renderTVRatio,
				x2 = 158, y2 = 160, rank, str, rankData;*/
			var x = 365*Render.renderTVRatio, y = 230*Render.renderTVRatio,
				x2 = 158, y2 = 110, rank, str, rankData,
				w = (Render.trueWidth-700)*Render.renderTVRatio, w2 = Render.gp0Width-299;
			
			//Header
			cxt.fillText(_t("Rank"), x, y);
			gxt.fillText(_t("Rank"), x2, y2);
			if (this.area != "local" && this.mode != "endless" && this.map != "" && 0)
			{
				cxt.fillText("Lv.", x+150*Render.renderTVRatio, y);
				gxt.fillText("Lv.", x2+60, y2);
				cxt.fillText(_t("Name"), x+265*Render.renderTVRatio, y);
				gxt.fillText(_t("Name"), x2+120, y2);
			} else {
				cxt.fillText(_t("Name"), x+150*Render.renderTVRatio, y);
				gxt.fillText(_t("Name"), x2+60, y2);
			}
			cxt.textAlign = "right"; gxt.textAlign = "right";
			cxt.fillText(_t("Score"), Render.tvWidth-x, y);
			gxt.fillText(_t("Score"), Render.gp0Width-x2, y2);
			cxt.textAlign = "left"; gxt.textAlign = "left";
			
			cxt.font = "28px Verdana";
			
			y += 85*Render.renderTVRatio; y2 += 38;
			
			cxt.beginPath();
			cxt.moveTo(350*Render.renderTVRatio, y-10);
			cxt.lineTo(Render.tvWidth-350*Render.renderTVRatio, y-10);
			cxt.stroke();
			gxt.beginPath();
			gxt.moveTo(150, y2-5);
			gxt.lineTo(Render.gp0Width-150, y2-5);
			gxt.stroke();
			
			y -= 8; y2 -= 2;
			cxt.font = "24px Verdana";
			gxt.font = "16px";// Verdana";
			
			//Display Area
			switch(this.area)
			{
			default:
			case "online":
			case "month":
			case "all":
			case "friends":
				//Scores ready?
				if (this.onlineScores[this.map] == null || this.onlineScores[this.map][this.mode] == null ||
					this.onlineScores[this.map][this.mode][this.area] == null || this.onlineScores[this.map][this.mode][this.area].ranks == null ||
					this.onlineScores[this.map][this.mode][this.area].ranks.length == 0)
				{
					if (this.onlineScores[this.map] && this.onlineScores[this.map][this.mode] && this.onlineScores[this.map][this.mode][this.area])
					{
						var str = "";
						
						if (this.onlineScores[this.map][this.mode][this.area].message)
						{
							str = _t(this.onlineScores[this.map][this.mode][this.area].message);
							cxt.fillText(str, x, y);
							gxt.fillText(_t(this.onlineScores[this.map][this.mode][this.area].message), x2, y2);
						} else if (this.onlineScores[this.map][this.mode][this.area].isGrabbing == "y") {
							str = _t("Loading...");
						} else if (!Render.actCanInternet) {
							str = _t("noscoresfound_cant");
						} else {
							var str = _t("noscoresfound"); //this.onlineScores[map][mode][area].errorTime
							
							if (this.onlineScores[this.map][this.mode][this.area].errorCode == "106-1105" ||
								this.onlineScores[this.map][this.mode][this.area].errorCode == "1061105")
								str = _t("noscoresfound_cant2");
							
							if (0) {
							if (this.onlineScores[this.map][this.mode][this.area].errorCode == "" &&
								this.onlineScores[this.map][this.mode][this.area].errorTime)
							{
								var t = this.onlineScores[this.map][this.mode][this.area].errorTime;
								if (__lastErrorCode && __lastErrorCodeTime && Math.abs(__lastErrorCodeTime - t) <= 1000)
								{
									this.onlineScores[this.map][this.mode][this.area].errorCode = __lastErrorCode;
								}
							}
							}
							if (this.onlineScores[this.map][this.mode][this.area].errorCode != "" && 0)
							{
								var str2 = "";
								var code = this.onlineScores[this.map][this.mode][this.area].errorCode.toString();
								code = [code.substr(0, 3), code.substr(3, code.length-3)];
								str2 += "Error Code: "+code[0]+"-"+code[1];
								
								switch(this.onlineScores[this.map][this.mode][this.area].errorCode)
								{
								case 1061105:
									str2 += "\nCould not load leaderboard. Please try again later.";
								break;
								
								case 1022106:
									str = "";
									str2 += "\nUnable to connect to the Internet.";
								break;
								
								case 1034101:
									str = "";
									str2 += "\nA communication error has occured.";
								break;
								}
								
								if (str) str += "\n\n";
								str += str2;
							}
						}
					} else {
						str = _t("Loading...");
					}
					
					var lines = Render.splitText(cxt, str, w);
					for(var key in lines)
						cxt.fillText(lines[key], x, y+parseInt(key)*28);
					var lines = Render.splitText(gxt, str, w2);
					for(var key in lines)
						gxt.fillText(lines[key], x2, y2+parseInt(key)*20);
					
				} else {
					if (this.scoresYOffset < -1*this.onlineScores[this.map][this.mode][this.area].ranks.length+12)
						this.scoresYOffset = -1*this.onlineScores[this.map][this.mode][this.area].ranks.length+12;
					if (this.scoresYOffset > 0) this.scoresYOffset = 0;
					var maxTVYOffset = Math.max(this.scoresYOffset, -1*this.onlineScores[this.map][this.mode][this.area].ranks.length+12);
					if (maxTVYOffset > 0) maxTVYOffset = 0;
					y += maxTVYOffset*37;//60*Render.renderTVRatio;
					y2 += this.scoresYOffset*24;
					
					rank = 1;
					for(var key in this.onlineScores[this.map][this.mode][this.area].ranks)
					{
						rankData = this.onlineScores[this.map][this.mode][this.area].ranks[key];
						rank = rankData.order;
						
						//if (160+25 <= y2 && y2 <= 110+50+Render.gp0Height-170-50)
						if (160-15 <= y2 && y2 <= 110+50+Render.gp0Height-170-50)
						{
							if (parseInt(key) % 2 == 1)
							{
								var prevFillStyle = cxt.fillStyle;
								cxt.fillStyle = "#111"; gxt.fillStyle = "#111";
								
								cxt.fillRect(x-9, y, Render.tvWidth-x*2+19, 37);//60*Render.renderTVRatio);
								gxt.fillRect(x2-6, y2, Render.gp0Width-x2*2+13, 24);
								
								cxt.fillStyle = prevFillStyle; gxt.fillStyle = prevFillStyle;
							}
							
							if (Render.act.accountID == rankData["name"])
							{
								var prevFillStyle = cxt.fillStyle;
								cxt.fillStyle = "#000020"; gxt.fillStyle = "#000020";
								
								cxt.fillRect(x-9, y, Render.tvWidth-x*2+19, 37);//60*Render.renderTVRatio);
								gxt.fillRect(x2-6, y2, Render.gp0Width-x2*2+13, 24);
								
								cxt.fillStyle = prevFillStyle; gxt.fillStyle = prevFillStyle;
							}
							
							cxt.fillText(this.numberFormat(rank), x, y);
							gxt.fillText(this.numberFormat(rank), x2, y2);
							
							if (this.mode != "endless" && this.map != "" && 0)
							{
								cxt.fillText(this.mode != "endless" ? this.numberFormat(rankData["level"]) : "--", x+150*Render.renderTVRatio, y);
								gxt.fillText(this.mode != "endless" ? this.numberFormat(rankData["level"]) : "--", x2+60, y2);
								
								cxt.fillText(rankData["name"], x+265*Render.renderTVRatio, y);
								gxt.fillText(rankData["name"], x2+120, y2);
							} else {
								cxt.fillText(rankData["name"], x+150*Render.renderTVRatio, y);
								gxt.fillText(rankData["name"], x2+60, y2);
							}
							
							cxt.textAlign = "right"; gxt.textAlign = "right";
							cxt.fillText(this.numberFormat(rankData["score"]), Render.tvWidth-x, y);
							gxt.fillText(this.numberFormat(rankData["score"]), Render.gp0Width-x2, y2);
							cxt.textAlign = "left"; gxt.textAlign = "left";
						}/* else if ((160+25-Math.abs(this.scoresYOffset-maxTVYOffset)*24 <= y2 && y2 <= 110+50+Render.gp0Height-170-50) ||
							(y2 > 110+50+Render.gp0Height-170-50 && y2 <= 110+50+Render.gp0Height-170-50+50)) {
							
							if (parseInt(key) % 2 == 1)
							{
								var prevFillStyle = cxt.fillStyle;
								cxt.fillStyle = "#111";
								cxt.fillRect(x-9, y, Render.tvWidth-x*2+19, 37);//60*Render.renderTVRatio);
								cxt.fillStyle = prevFillStyle;
							}
							
							cxt.fillText(this.numberFormat(rank), x, y);
							
							if (this.mode != "endless" && this.map != "")
							{
								cxt.fillText(this.mode != "endless" ? this.numberFormat(rankData["level"]) : "--", x+150*Render.renderTVRatio, y);
								cxt.fillText(rankData["name"], x+265*Render.renderTVRatio, y);
							} else {
								cxt.fillText(rankData["name"], x+150*Render.renderTVRatio, y);
							}
							
							cxt.textAlign = "right";
							cxt.fillText(this.numberFormat(rankData["score"]), Render.tvWidth-x, y)
							cxt.textAlign = "left";
						}*/
						
						y += 37; y2 += 24;
					}
				}
			break;
				
			case "local":
				//Scores ready?
				if (this.scores[this.map] == null || this.scores[this.map][this.mode] == null)
				{
					cxt.fillText(_t("Loading..."), x, y);
					gxt.fillText(_t("Loading..."), x2, y2);
				} else {
					/*if (this.scoresYOffset < -1*this.scores[this.map][this.mode].length+10)
						this.scoresYOffset = -1*this.scores[this.map][this.mode].length+10;
					if (this.scoresYOffset > 0) this.scoresYOffset = 0;
					var maxTVYOffset = Math.max(this.scoresYOffset, -1*this.scores[this.map][this.mode].length+10);
					if (maxTVYOffset > 0) maxTVYOffset = 0;
					y += maxTVYOffset*37;//60*Render.renderTVRatio;
					y2 += this.scoresYOffset*24;*/
					
					rank = 1;
					for(var key in this.scores[this.map][this.mode])
					{
						rankData = this.scores[this.map][this.mode][key];
						
						//if (160+25 <= y2 && y2 <= 110+50+Render.gp0Height-170-50)
						if (160-15 <= y2 && y2 <= 110+50+Render.gp0Height-170-50)
						{
							if (parseInt(key) % 2 == 1)
							{
								var prevFillStyle = cxt.fillStyle;
								cxt.fillStyle = "#111"; gxt.fillStyle = "#111";
								
								cxt.fillRect(x-9, y, Render.tvWidth-x*2+19, 37);//60*Render.renderTVRatio);
								gxt.fillRect(x2-6, y2, Render.gp0Width-x2*2+13, 24);
								
								cxt.fillStyle = prevFillStyle; gxt.fillStyle = prevFillStyle;
							}
							
							cxt.fillText(rank+".", x+(rank<10?20:0), y);
							gxt.fillText(rank+".", x2+(rank<10?13:0), y2);
							
							cxt.fillText(rankData["name"], x+150*Render.renderTVRatio, y);
							gxt.fillText(rankData["name"], x2+60, y2);
							
							cxt.textAlign = "right"; gxt.textAlign = "right";
							cxt.fillText(this.numberFormat(rankData["score"]), Render.tvWidth-x, y);
							gxt.fillText(this.numberFormat(rankData["score"]), Render.gp0Width-x2, y2);
							cxt.textAlign = "left"; gxt.textAlign = "left";
						}/* else if ((160+25-Math.abs(this.scoresYOffset-maxTVYOffset)*30 <= y2 && y2 <= 110+50+Render.gp0Height-170-50) ||
							(y2 > 110+50+Render.gp0Height-170-50 && y2 <= 110+50+Render.gp0Height-170-50+50)) {
							
							if (parseInt(key) % 2 == 1)
							{
								var prevFillStyle = cxt.fillStyle;
								cxt.fillStyle = "#111";
								cxt.fillRect(x-9, y, Render.tvWidth-x*2+19, 60*Render.renderTVRatio);
								cxt.fillStyle = prevFillStyle;
							}
							
							cxt.fillText(rank+".", x+(rank<10?20:0), y);
							cxt.fillText(rankData["name"], x+150*Render.renderTVRatio, y);
							
							cxt.textAlign = "right";
							cxt.fillText(this.numberFormat(rankData["score"]), Render.tvWidth-x, y)
							cxt.textAlign = "left";
						}*/

						rank++;
						y += 37; y2 += 24;
					}
				}
			break;
			}
			
			//Message at bottom showing hit b
			cxt.textAlign = "center"; gxt.textAlign = "center";
			cxt.font = "30px Verdana"; gxt.font = "25px Verdana";
			
			var str = _t("pressbtoreturn");
			cxt.fillText(str, Render.tvWidth/2, Render.tvHeight-78*Render.renderTVRatio);
			/*cxt.fillText("Press", Render.tvWidth/2-135*Render.renderTVRatio, Render.tvHeight-78*Render.renderTVRatio);
			cxt.fillText("to return", Render.tvWidth/2+100*Render.renderTVRatio, Render.tvHeight-78*Render.renderTVRatio);
			cxt.drawImage(fontImages["b"], Render.tvWidth/2-60*Render.renderTVRatio, Render.tvHeight-68*Render.renderTVRatio, 48*Render.renderTVRatio, 48*Render.renderTVRatio);*/
			
			gxt.fillText(str, Render.gp0Width/2, Render.gp0Height-40);
			/*gxt.fillText("Press", Render.gp0Width/2-65, Render.gp0Height-40);
			gxt.fillText("to return", Render.gp0Width/2+65, Render.gp0Height-40);
			gxt.drawImage(fontImages["b"], Render.gp0Width/2-25, Render.gp0Height-33, 28, 28);*/
			
			cxt.textAlign = "left"; gxt.textAlign = "left";
		}
	};
	
	
	//Arrow Actions
	this.switchArea = function(dir)
	{
		if (typeof dir == undefined) dir = 1;
		if (!this.canSwitchPages) return false;
		
		switch(this.area)
		{
		case "local":
			if (dir == 1) this.area = "all";
			else this.area = "all";//friends
		break;
		
		case "month":
			if (dir == 1) this.area = "all";
			else {
				if (this.map != "") this.area = "local";
				else this.area = "friends";
			}
		break;
		
		case "all":
			if (this.map != "") this.area = "local";
			else this.area = "all";
			/*if (dir == 1) this.area = "friends";
			else {
				if (this.map != "") this.area = "local";
				else this.area = "friends";
			}*/
		break;
		
		case "friends":
			if (dir == 1)
			{
				if (this.map != "") this.area = "local";
				else this.area = "all";
			} else this.area = "all";
		break;
		}
		
		this.scoresYOffset = 0;
		if (this.mode == "easy") this.mode = "hard";
		
		if (this.area.match(/month|all|friends/i))
			this.grabMapOnlineScores(this.map, this.mode, this.area);
	};
	this.prevMap = function()
	{
		if (!this.canSwitchPages) return false;
		
		var i=0,index=0,maps=[];
		for(var map in __Maps)
		{
			maps[i] = map;
			if (map == this.map) index=i;
			i++
		}
		
		index--;
		var indexCheck = false;
		if (index < 0)
		{
			index = maps.length-1;
			indexCheck = true;
		}
		
		if ((this.area == "local" || !indexCheck) && this.map != "")
			this.map = maps[index];
		else {
			if (this.map == "") this.map = maps[maps.length-1];
			else this.map = "";
		}
		
		this.scoresYOffset = 0;
		
		if (this.area.match(/month|all|friends/i))
			this.grabMapOnlineScores(this.map, this.mode, this.area);
	};
	this.nextMap = function()
	{
		if (!this.canSwitchPages) return false;
		
		var i=0,index=0,maps=[];
		for(var map in __Maps)
		{
			maps[i] = map;
			if (map == this.map) index=i;
			i++
		}
		
		index++;
		var indexCheck = false;
		if (index >= maps.length)
		{
			index = 0;
			indexCheck = true;
		}
		
		if ((this.area == "local" || !indexCheck) && this.map != "")
			this.map = maps[index];
		else {
			if (this.map == "") this.map = maps[0];
			else this.map = "";
		}
		
		this.scoresYOffset = 0;
		
		if (this.area.match(/month|all|friends/i))
			this.grabMapOnlineScores(this.map, this.mode, this.area);
	};
	this.prevMode = function()
	{
		if (!this.canSwitchPages) return false;
		
		if (this.area.match(/month|all|friends/i))
		{
			if (this.mode == "hard") this.mode = "endless";
			else if (this.mode == "insanity") this.mode = "hard";
			else this.mode = "insanity";
		} else {
			if (this.mode == "easy") this.mode = "endless";
			else if (this.mode == "hard") this.mode = "easy";
			else if (this.mode == "insanity") this.mode = "hard";
			else this.mode = "insanity";
		}
		
		this.scoresYOffset = 0;
		
		if (this.area.match(/month|all|friends/i))
			this.grabMapOnlineScores(this.map, this.mode, this.area);
	};
	this.nextMode = function()
	{
		if (!this.canSwitchPages) return false;
		
		if (this.area.match(/month|all|friends/i))
		{
			if (this.mode == "hard") this.mode = "insanity";
			else if (this.mode == "insanity") this.mode = "endless";
			else this.mode = "hard";
		} else {
			if (this.mode == "easy") this.mode = "hard";
			else if (this.mode == "hard") this.mode = "insanity";
			else if (this.mode == "insanity") this.mode = "endless";
			else this.mode = "easy";
		}
		
		this.scoresYOffset = 0;
		
		if (this.area.match(/month|all|friends/i))
			this.grabMapOnlineScores(this.map, this.mode, this.area);
	};
	
	
	//Set up the arrays
	this.loadScorePreset = function()
	{
		var modes = ["hard", "easy", "insanity", "endless"];
		for(var map in __Maps)
		{
			if (Leaderboard.scores[map] == undefined) Leaderboard.scores[map] = {};
			if (Leaderboard.onlineScores[map] == undefined) Leaderboard.onlineScores[map] = {};
			for(var mode in modes)
			{
				mode = modes[mode];
				if (Leaderboard.scores[map][mode] == undefined) Leaderboard.scores[map][mode] = null;
				
				if (Leaderboard.onlineScores[map][mode] == undefined) Leaderboard.onlineScores[map][mode] = {};
				for(var key in this.onlineAreas)
				{
					if (Leaderboard.onlineScores[map][mode][this.onlineAreas[key]] == undefined)
						Leaderboard.onlineScores[map][mode][this.onlineAreas[key]] = {};
				}
			}
		}
		
		var map = "";
		if (Leaderboard.onlineScores[map] == undefined) Leaderboard.onlineScores[map] = {};
		for(var mode in modes)
		{
			mode = modes[mode];
			if (Leaderboard.onlineScores[map][mode] == undefined) Leaderboard.onlineScores[map][mode] = {};
			for(var key in this.onlineAreas)
			{
				if (Leaderboard.onlineScores[map][mode][this.onlineAreas[key]] == undefined)
					Leaderboard.onlineScores[map][mode][this.onlineAreas[key]] = {};
			}
		}
	};
	
	//Update the Online List
	this._grabMapOnlineScores_data = {};
	this.grabMapOnlineScores = function(map, mode, area)
	{
		if (area == "local" || mode == "easy" || mode == "Easy") return false;
		if (!this.onlineFuncsCallCheck() || !Render.actIsOnline)
		{
			if (this.onlineScores[map][mode][area])
			{
				this.onlineScores[map][mode][area].message = "noscoresfound";
			}
			return false;
		}
		if (this.onlineScores[map][mode][area])
		{
			this.onlineScores[map][mode][area].message = "";
			this.onlineScores[map][mode][area].errorTime = 0;
			this.onlineScores[map][mode][area].errorCode = "";
		}
		if (!Render.actCanInternet)
		{
			return false;
		}
		if (this.onlineScores[map][mode][area] &&
			(this.onlineScores[map][mode][area].isGrabbing == "y" || this.onlineScores[map][mode][area].lastGrab > Date.now()-30*60*1000))
			return false;
		if (!this.canSwitchPages) return false;
		this.canSwitchPages = false;
		
		if (!this.onlineScores[map][mode][area])
		{
			this.onlineScores[map][mode][area] = {};
			this.onlineScores[map][mode][area].ranks = [];
		}
		this.onlineScores[map][mode][area].isGrabbing = "y";
		this.onlineScores[map][mode][area].lastGrab = Date.now();
		
		this._grabMapOnlineScores_data = {map: map, mode: mode, area: area};
		
		function _getScores()
		{
			var map = Leaderboard._grabMapOnlineScores_data.map;
			var mode = Leaderboard._grabMapOnlineScores_data.mode;
			var area = Leaderboard._grabMapOnlineScores_data.area;
			
			var settings = {};
			switch(area)
			{
			case "month":
				settings.timeScope = nwf.nex.RankingTimeScope.CUSTOM_1;
				settings.length = 100;
			break;
			
			case "all":
				settings.length = 100;
			break;
			
			case "friends":
				settings.rankingMode = nwf.nex.RankingMode.FRIEND_RANGE;
				settings.length = 100;
			break;
			}
			
			var cat = 0;
			if (map != "") cat = __Maps[map].online[mode.substr(0, 1).toUpperCase()+mode.substr(1, mode.length-1)];
			else cat = Leaderboard.top5AvgModes[mode.substr(0, 1).toUpperCase()+mode.substr(1, mode.length-1)];
			
			__lastErrorCode = "";
			Leaderboard.getScores(cat, settings,
				/*Leaderboard.onlineScores[map][mode][area]*/
				{
					map: map,
					mode: mode,
					area: area
				}, "ranks",
				function(list)
				{
					var map = Leaderboard._grabMapOnlineScores_data.map;
					var mode = Leaderboard._grabMapOnlineScores_data.mode;
					var area = Leaderboard._grabMapOnlineScores_data.area;
					
					//console.log(list);
					Leaderboard.onlineScores[map][mode][area] = list; 
					Leaderboard.onlineScores[map][mode][area].isGrabbing = "n";
					Leaderboard.canSwitchPages = true;
				},
				function()
				{
					var map = Leaderboard._grabMapOnlineScores_data.map;
					var mode = Leaderboard._grabMapOnlineScores_data.mode;
					var area = Leaderboard._grabMapOnlineScores_data.area;
					
					//console.log("FAIL");
					Leaderboard.onlineScores[map][mode][area].isGrabbing = "n";
					//Leaderboard.onlineScores[map][mode][area].lastGrab = 0;
					Leaderboard.onlineScores[map][mode][area].errorTime = Date.now();
					if (__lastErrorCode)
						Leaderboard.onlineScores[map][mode][area].errorCode = __lastErrorCode;
					Leaderboard.canSwitchPages = true;
					
					__onErrorFunc = function(evt)
					{
						var map = Leaderboard._grabMapOnlineScores_data.map;
						var mode = Leaderboard._grabMapOnlineScores_data.mode;
						var area = Leaderboard._grabMapOnlineScores_data.area;
						
						Leaderboard.onlineScores[map][mode][area].errorCode = evt.errorCode;
					};
					__onErrorFuncTimeout = setTimeout(function()
					{
						__onErrorFunc = null;
					}, 500);
				});
		};
		function _reset()
		{
			//console.log("FAIL2");
			Leaderboard.onlineScores[map][mode][area].isGrabbing = "n";
			Leaderboard.onlineScores[map][mode][area].lastGrab = 0;
			Leaderboard.onlineScores[map][mode][area].errorTime = Date.now();
			if (__lastErrorCode)
				Leaderboard.onlineScores[map][mode][area].errorCode = __lastErrorCode;
			Leaderboard.canSwitchPages = true;
		}
		
		__errorAllowCommunicationErrorOnce = true;
		if (!Leaderboard.isOnline)
		{
			__lastErrorCode = "";
			Leaderboard.onlineConnect(0, _getScores, _reset);
		} else {
			_getScores();
		}
	};
	
	
	
	//Connect to Online Servers
	this.NEX; this.DS; this.GS; this.RC;
	this.locked = false; this.isOnline = false;
	this.onlineConnect = function(numAttempts, onceConnectedFunc, failedConnectFunc)
	{
		//if (failedConnectFunc) failedConnectFunc(); return false;
		if (!Render.actCanInternet)
		{
			if (failedConnectFunc) failedConnectFunc();
			return false;
		}
		
		if (typeof numAttempts == "undefined") numAttempts = 0;
		if (this.isOnline || this.locked)
		{
			if (this.isOnline)
			{
				if (onceConnectedFunc)
				{
					onceConnectedFunc();
					onceConnectedFunc = null;
				}
			} else if (this.locked) {
				if (failedConnectFunc)
				{
					failedConnectFunc();
					failedConnectFunc = null;
				}
			}
			return false;
		}
		
		this.NEX = window.nwf.nex;
		//this.DS = this.NEX.DataStore.getInstance();
		this.GS = this.NEX.GameServer.getInstance();
		this.RC = this.NEX.RankingClient.getInstance();
		this.locked = true;
		this.isOnline = false;
		
		/*if (!this.GS.isLoggedIn)
		{
			this.GS.addEventListener(nwf.events.GameServerEvent.LOGIN_SUCCESS, onLoginSuccess, this);
			this.GS.addEventListener(nwf.events.GameServerEvent.LOGIN_FAILED, onLoginFailure, this);
			this.GS.login();
		} else {
		   onLoginSuccess();
		}*/
		
		this.GS.addEventListener(nwf.events.GameServerEvent.DISCONNECTED, onDisconnect, this);
		
		// try to log in to the NEX Game Server
		tryLogin();
		
		function tryLogin() {
			log('[tryLogin] Trying to log in...');
			
			if (!Leaderboard.GS.isLoggedIn){
				Leaderboard.GS.addEventListener(nwf.events.GameServerEvent.LOGIN_SUCCESS, onLoginSuccess, this);
				Leaderboard.GS.addEventListener(nwf.events.GameServerEvent.LOGIN_FAILED, onLoginFailure, this);
				Leaderboard.locked = true;
				Leaderboard.GS.login();
			}
			else {
				onLoginSuccess();
			}
		}
		
		/**
		 * Notify the user that the login has completed.
		 * @param {Object} evt 
		 */
		function onLoginSuccess(evt) {
			Leaderboard.GS.removeEventListener(nwf.events.GameServerEvent.LOGIN_SUCCESS, onLoginSuccess, this);
			Leaderboard.GS.removeEventListener(nwf.events.GameServerEvent.LOGIN_FAILED, onLoginFailure, this);
			
			// bind the DataStore object
			/*if (!Leaderboard.DS.isBound) {
				Leaderboard.DS.bind();
			}*/
			// bind the DataStore object
			if (!Leaderboard.RC.isBound) {
				Leaderboard.RC.bind();
			}
			
			log('[onLoginSuccess] Login successful');
			Leaderboard.locked = false;
			Leaderboard.isOnline = true;
			
			if (onceConnectedFunc)
			{
				onceConnectedFunc();
				onceConnectedFunc = null;
			}
		}

		/**
		 * Notify the user that the login has failed.
		 * @param {Object} evt 
		 */
		function onLoginFailure(evt) {
			Leaderboard.GS.removeEventListener(nwf.events.GameServerEvent.LOGIN_SUCCESS, onLoginSuccess, this);
			Leaderboard.GS.removeEventListener(nwf.events.GameServerEvent.LOGIN_FAILED, onLoginFailure, this);
			log('[onLoginFailure] Failed to log in to NEX Game Server');
			Leaderboard.locked = false;
			Leaderboard.isOnline = false;
			
			if (numAttempts > 0)
			{
				setTimeout(function()
				{
					Leaderboard.onlineConnect(numAttempts-1, onceConnectedFunc);
				}, 2500);
			} else {
				if (failedConnectFunc)
				{
					failedConnectFunc();
					failedConnectFunc = null;
				}
			}
		}
		
		function onDisconnect(evt) {
			log('[onDisconnect] NEX Game Server has been disconnected');
			Leaderboard.locked = false;
			Leaderboard.isOnline = false;
		}
		
		function log(msg)
		{
			//console.log(msg);
		}
	};
	
	//Test Online
	this.onlineTest = function()
	{
		if (!this.isOnline) return false;
		
		//this.uploadScore(25, 1, ["UserA", 32]);
	};
	
	this.isUploadingScore = false;
	this.uploadScore = function(score, cat, params, onceUploadedFunc, failedUploadedFunc)
	{
		if (typeof params == "undefined") params = [];
		//Max = 4294967295
		if (score < 0)
		{
			onceUploadedFunc();
			return false;
		}
		if (typeof SplashScreen.setupData.uploadedCommons == "undefined")
			SplashScreen.setupData.uploadedCommons = {"": ""};
		if (!this.onlineFuncsCallCheck("put", (typeof SplashScreen.setupData.uploadedCommons[Render.act.accountID] != "undefined" ? 1 : 2)))
		{
			failedUploadedFunc();
			return false;
		}
		if (!Render.actIsOnline)
		{
			failedUploadedFunc();
			return false;
		}
		
		if (this.isUploadingScore)
		{
			failedUploadedFunc();
			return false;
		}
		this.isUploadingScore = true;
		
		this.RC.addEventListener(nwf.events.RankingClientEvent.UPLOAD_SCORE_SUCCESS, onUploadSuccess, this);
		this.RC.addEventListener(nwf.events.RankingClientEvent.UPLOAD_SCORE_FAILED, onUploadFailure, this);
		
		//( scoreValue, [scoreCategory], [scoreGroup0], [scoreGroup1], [scoreOrderDesc], [deleteOldScore], [scoreParamData], [uniqueID] ) : uint32
		this.onlineFuncsCallLog();
		this.RC.uploadScore(score, cat, 0, 0, true, !true, "");
		
		
		function onUploadSuccess(evt) {
			Leaderboard.RC.removeEventListener(nwf.events.RankingClientEvent.UPLOAD_SCORE_SUCCESS, onUploadSuccess, this);
			Leaderboard.RC.removeEventListener(nwf.events.RankingClientEvent.UPLOAD_SCORE_FAILED, onUploadFailure, this);
			
			Leaderboard.isUploadingScore = false;
			
			if (typeof SplashScreen.setupData.uploadedCommons[Render.act.accountID] == "undefined")
			{
				this.RC.addEventListener(nwf.events.RankingClientEvent.UPLOAD_COMMON_DATA_SUCCESS, onUpload2Success, this);
				this.RC.addEventListener(nwf.events.RankingClientEvent.UPLOAD_COMMON_DATA_FAILED, onUpload2Failure, this);
				
				var data = params.join("/");
				var blob = new Blob(data, {type: 'text/plain'});
				Leaderboard.onlineFuncsCallLog();
				Leaderboard.RC.uploadCommonData(blob);
				
				function onUpload2Success(evt) {
					Leaderboard.RC.removeEventListener(nwf.events.RankingClientEvent.UPLOAD_COMMON_DATA_SUCCESS, onUpload2Success, this);
					Leaderboard.RC.removeEventListener(nwf.events.RankingClientEvent.UPLOAD_COMMON_DATA_FAILED, onUpload2Failure, this);
					
					SplashScreen.setupData.uploadedCommons[Render.act.accountID] = Render.act.accountID;
					FileIO.saveFile("setup.txt", SplashScreen.setupData, function()
					{
						if (onceUploadedFunc)
						{
							onceUploadedFunc();
							onceUploadedFunc = null;
						}
					}, function()
					{
						if (onceUploadedFunc)
						{
							onceUploadedFunc();
							onceUploadedFunc = null;
						}
					});
				}
				function onUpload2Failure(evt) {
					Leaderboard.RC.removeEventListener(nwf.events.RankingClientEvent.UPLOAD_COMMON_DATA_SUCCESS, onUpload2Success, this);
					Leaderboard.RC.removeEventListener(nwf.events.RankingClientEvent.UPLOAD_COMMON_DATA_FAILED, onUpload2Failure, this);
					
					if (onceUploadedFunc)
					{
						onceUploadedFunc();
						onceUploadedFunc = null;
					}
				}
			} else {
				if (onceUploadedFunc)
				{
					onceUploadedFunc();
					onceUploadedFunc = null;
				}
			}
		}
		function onUploadFailure(evt) {
			Leaderboard.RC.removeEventListener(nwf.events.RankingClientEvent.UPLOAD_SCORE_SUCCESS, onUploadSuccess, this);
			Leaderboard.RC.removeEventListener(nwf.events.RankingClientEvent.UPLOAD_SCORE_FAILED, onUploadFailure, this);
			
			Leaderboard.isUploadingScore = false;
			
			if (failedUploadedFunc)
			{
				failedUploadedFunc();
				failedUploadedFunc = null;
			}
		}
	};
	
	//Grab the Top 5 scores for this user and avg them and upload
	this.top5AvgModes = {Hard: 100, Insanity: 101, Endless: 102};
	this.uploadTop5Avg = function(playerName, mode, endFunc)
	{
		var scores = [];
		
		if (typeof SplashScreen.setupData.topScores == "undefined")
			SplashScreen.setupData.topScores = {"": ""};
		//var SaveType = actName+"/"+GameOver.data.map+"/"+GameOver.data.mode;
		var topScoreSplit, topScore;
		for(var topScoreKey in SplashScreen.setupData.topScores)
		{
			topScoreSplit = topScoreKey.split("/");
			if (topScoreSplit[0] != playerName) continue;
			if (topScoreSplit[2] != mode) continue;
			
			topScore = SplashScreen.setupData.topScores[topScoreKey];
			
			scores.push(topScore.score);
		}
		
		if (typeof SplashScreen.setupData.uploadedCommons == "undefined")
			SplashScreen.setupData.uploadedCommons = {"": ""};
		if (scores.length < 5 || !this.onlineFuncsCallCheck("put", (typeof SplashScreen.setupData.uploadedCommons[Render.act.accountID] != "undefined" ? 1 : 2)))
		{
			endFunc();
			return false;
		}
		
		scores.sort(function(a, b)
		{
			return a >= b ? -1 : 1;
		});
		var avgScore = Math.floor((scores[0]+scores[1]+scores[2]+scores[3]+scores[4])/5);
		avgScore = Math.ceil(avgScore/100);
		
		if (Leaderboard.onlineScores[""] && Leaderboard.onlineScores[""][mode.toLowerCase()] &&
			Leaderboard.onlineScores[""][mode.toLowerCase()]["all"])
			Leaderboard.onlineScores[""][mode.toLowerCase()]["all"].lastGrab = 0;
		Leaderboard.uploadScore(avgScore, this.top5AvgModes[mode], [playerName], endFunc, endFunc);
	};
	
	//DONT ALLOW CHANGE< MAKE IT CONTIUE TO GET OR FAIL UNTIL DONE
	this.isGettingScores = false;
	this.getScores = function(cat, settings, ranksArray, ranksArrayName, onceRetrievedFunc, failedRetrievedFunc)
	{
		if (typeof settings == "undefined") settings = {};
		var map = ranksArray.map, mode = ranksArray.mode, area = ranksArray.area;
		//Leaderboard.onlineScores[map][mode][area]
		
		if (this.isGettingScores || !this.onlineFuncsCallCheck())
		{
			failedRetrievedFunc();
			return false;
		}
		this.isGettingScores = true;
		
		this.RC.addEventListener(nwf.events.RankingClientEvent.DOWNLOAD_RANKING_LIST_SUCCESS, onDownloadSuccess, this);
		this.RC.addEventListener(nwf.events.RankingClientEvent.DOWNLOAD_RANKING_LIST_FAILED, onDownloadFailure, this);
		
		var RSP = new nwf.nex.RankingSearchParam();
		RSP.category = cat;
		for(var key in settings)
			RSP[key] = settings[key];
		
		this.onlineFuncsCallLog();
		this.RC.downloadRankingList(RSP);
		
		
		function onDownloadSuccess(evt) {
			Leaderboard.RC.removeEventListener(nwf.events.RankingClientEvent.DOWNLOAD_RANKING_LIST_SUCCESS, onDownloadSuccess, this);
			Leaderboard.RC.removeEventListener(nwf.events.RankingClientEvent.DOWNLOAD_RANKING_LIST_FAILED, onDownloadFailure, this);
			
			Leaderboard.isGettingScores = false;
			//ranksArray[ranksArrayName] = [];
			var map = ranksArray.map, mode = ranksArray.mode, area = ranksArray.area;
			Leaderboard.onlineScores[map][mode][area][ranksArrayName] = [];
			
			var ranks = evt.ranks, score=0;
			for(var key in ranks)
			{
				//if (key > 0) continue;
				var rank = ranks[key];
				score = Math.floor(rank.score*100);// / 1000;
				
				//var names = ["Bloodix", "GulAtiCa", "Slayer", "TooGoodAtThis", "Player24c5", "ZeNfA", "Greg", "EmilieAutumn", "RCMADIAX", "FakeNameError"];
				//var scores = [5250000, 2756000, 985000, 965251, 750000, 658000, 485000, 250000, 100000, 24601];
				//for(var i=0; i<10; i++)
				//{
				var rankData = {};
				rankData.order = rank.order;//+i;
				rankData.score = Math.floor(score);
				rankData.name = "";
				rankData.level = "";
				//if (score.toString().match(/\./))
					//rankData.level = parseInt(score.toString().replace(/^[^\.]+?\./, ''));
				Leaderboard.readRankData(rank, rankData);
				//ranksArray[ranksArrayName].push(rankData);
				Leaderboard.onlineScores[map][mode][area][ranksArrayName].push(rankData);
				//}
				
				/*Leaderboard._rank = rank;
				
				var reader = new FileReader();
				reader.onloadend = function(evt) {
				   // reader.result contains the contents of blob as a typed array
					Leaderboard._blob = evt;
					var string = new TextDecoder("utf8").decode(evt.target.result);
					console.log(string);
				};
				reader.readAsArrayBuffer(rank.commonData);*/
			}
			
			if (onceRetrievedFunc)
			{
				onceRetrievedFunc(Leaderboard.onlineScores[map][mode][area]);
				onceRetrievedFunc = null;
			}
		}
		function onDownloadFailure(evt) {
			Leaderboard.RC.removeEventListener(nwf.events.RankingClientEvent.UPLOAD_SCORE_SUCCESS, onDownloadSuccess, this);
			Leaderboard.RC.removeEventListener(nwf.events.RankingClientEvent.UPLOAD_SCORE_FAILED, onDownloadFailure, this);
			
			Leaderboard.isGettingScores = false;
			var map = ranksArray.map, mode = ranksArray.mode, area = ranksArray.area;
			Leaderboard.onlineScores[map][mode][area][ranksArrayName] = [];
			
			if (failedRetrievedFunc)
			{
				failedRetrievedFunc();
				failedRetrievedFunc = null;
			}
		}
	};
	this.readRankData = function(rank, rankData)
	{
		var reader = new FileReader();
		reader.onloadend = function(evt) {
		   // reader.result contains the contents of blob as a typed array
			Leaderboard._blob = evt;
			var string = new TextDecoder("utf8").decode(evt.target.result);
			if (string != "")
			{
				string = string.split("/");
				rankData.name = string[0];
				//if (string[1]) rankData.level = string[1];
			}
		};
		reader.readAsArrayBuffer(rank.commonData);
	};
	
	//Upload previous Offline Scores
	this.uploadOfflineScores = function(finishFunc, failFunc)
	{
		var myAct = nwf.act.NintendoAccountManager.getInstance().getActiveAccount();
		var playerName = myAct.accountID ? myAct.accountID : "Player";
		
		var offlineScoresToUpload = [];
		
		if (typeof SplashScreen.setupData.offlineScores == "undefined")
			SplashScreen.setupData.offlineScores = {"": ""};
		var offlineScore, offlineScoreSplit;
		for(var offlineScoreKey in SplashScreen.setupData.offlineScores)
		{
			offlineScoreSplit = offlineScoreKey.split("/");
			if (offlineScoreSplit[0] != playerName) continue;
			
			offlineScore = SplashScreen.setupData.offlineScores[offlineScoreKey];
			
			offlineScoresToUpload.push({key: offlineScoreKey, split: offlineScoreSplit, data: offlineScore});
		}
		
		if (offlineScoresToUpload.length > 0)
		{
			function _uploadOfflineScore(offlineScoresToUpload, index)
			{
				var offlineScore = offlineScoresToUpload[index];
				
				//var SaveType = actName+"/"+GameOver.data.map+"/"+GameOver.data.mode;
				function _saveScore()
				{
					delete SplashScreen.setupData.offlineScores[offlineScore.key];
					
					var newScore = Math.ceil(parseInt(offlineScore.data.score)/100);
					Leaderboard.uploadScore(newScore, __Maps[offlineScore.split[1]].online[offlineScore.split[2]],
						[offlineScore.split[0]],
						function()
						{
							if (offlineScoresToUpload.length-1 == index)
							{
								var playerName = myAct.accountID ? myAct.accountID : "Player";
								Leaderboard.uploadTop5Avg(playerName, GameOver.data.mode, function()
								{
									FileIO.saveFile("setup.txt", SplashScreen.setupData, function()
									{
										finishFunc();
									}, function()
									{
										finishFunc();
									});
								});
							} else {
								_uploadOfflineScore(offlineScoresToUpload, index+1);
							}
						}, _nosaveScore);
				};
				function _nosaveScore()
				{
					failFunc();
				};
				
				if (!Leaderboard.isOnline)
				{
					Leaderboard.onlineConnect(0, _saveScore, _nosaveScore);
				} else {
					_saveScore();
				}
			};
			_uploadOfflineScore(offlineScoresToUpload, 0);
		} else {
			finishFunc();
		}
	};
	
	//Log the time instance of this call
	this.onlineFuncsCallLog = function()
	{
		this.onlineFuncsTimes.push(Date.now());
	};
	
	//Make sure this call can happen
	this.onlineFuncsCallCheck = function(type, numAdd)
	{
		if (typeof type == "undefined") type = "";
		if (typeof numAdd == "undefined") numAdd = 1;

		//console.log(type, this.onlineFuncsTimes.length+numAdd, this.onlineFuncsLimitTypes[type]);
		if (this.onlineFuncsTimes.length+numAdd <= this.onlineFuncsLimitTypes[type]) return true;
		//if (this.onlineFuncsTimes.length < this.onlineFuncsLimit) return true;
		
		var dateNow = Date.now();
		var list = [];
		for(var key in this.onlineFuncsTimes)
			if (this.onlineFuncsTimes[key] > dateNow - this.onlineFuncsTimeLimit)
				list.push(this.onlineFuncsTimes[key]);
		this.onlineFuncsTimes = list;
		
		if (this.onlineFuncsTimes.length+numAdd <= this.onlineFuncsLimitTypes[type]) return true;
		//if (this.onlineFuncsTimes.length < this.onlineFuncsLimit) return true;
		return false;
	};
	
	
	
	//Number Format
	this.numberFormat = function(number, format)
	{
		if (typeof format == "undefined") format = "long";
		
		//return (number+"").replace(/(\d)(?=(\d{3})+(?!\d))/g, "$1,");
		if ((number < 0 ? -number : number) < 1000) return number;
		var isNeg = number < 0, after = "";
		number = number < 0 ? -number : number;
		
		switch(format)
		{
		default:
			number = number.toString();
		break;
		
		case "short":
			if (number >= 1000000000000)
			{
				number = (Math.floor(number / 100000000000)/10).toString();
				after = "T";
			} else if (number >= 1000000000) {
				number = (~~(number / 100000000)/10).toString();
				after = "B";
			} else if (number >= 1000000) {
				number = (~~(number / 100000)/10).toString();
				after = "M";
			} else {
				number = number.toString();
			}
		break;
		
		case "short2":
			if (number >= 1000000000000)
			{
				number = (Math.floor(number / 100000000000)/10).toString();
				after = "T";
			} else if (number >= 1000000000) {
				number = (~~(number / 100000000)/10).toString();
				after = "B";
			} else if (number >= 1000000) {
				number = (~~(number / 100000)/10).toString();
				after = "M";
			} else if (number >= 100000) {
				number = (~~(number / 1000)).toString();
				after = "K";
			} else {
				number = number.toString();
			}
		break;
		}
		
		var rtr = "", i=number.length-1, c=0;
		var hasDecimal = (number.match(/\./) != null), decimalFound = false;
		
		do
		{
			rtr = number[i]+rtr;
			
			if (!hasDecimal || decimalFound) c++;
			if (c > 0 && c % 3 == 0) rtr = ","+rtr;
			if (number[i] == ".") decimalFound = true;
		} while(i--);
		if (rtr.substr(0, 1) == ",")
			rtr = rtr.substr(1, rtr.length-1);
		number = null;
		
		return (isNeg ? "-" : "")+rtr+after;
	};
};
var Leaderboard = new Leaderboard();