//Handles a loading screen to stall the game if not everything is ready
function LoadingScreen()
{
	this.handle = null;
	this.funcs = {};
	this.initcallIsCalled = false;
	
	this.initCall = 0;
	
	//Init
	this.init = function(toLoadFunc, toLoadFunc2, isLoadedFuncCheck, IsLoadedFunc)
	{
		ClickBank.clearAll();
		InputBank.clearAll();
		
		this.initcallIsCalled = false;
		this.initCall = Date.now();
		
		this.funcs = {init:toLoadFunc, initcall:toLoadFunc2, isLoaded:isLoadedFuncCheck, onLoad:IsLoadedFunc, data:{}};
		if (this.funcs.init())
		{
			clearInterval(this.handle);
			this.handle = setInterval(function()
			{
				if (!LoadingScreen.initcallIsCalled)
				{
					LoadingScreen.initcallIsCalled = true;
					LoadingScreen.funcs.initcall();
				}
				LoadingScreen.checkIfLoaded();
			}, 100);
			
			Render.renderControl = function(){ LoadingScreen.render(); };
		}
	};
	
	//Check to see if the custom script is loaded
	this.checkIfLoaded = function()
	{
		if (this.funcs.isLoaded())
		{
			clearInterval(this.handle);
			this.funcs.onLoad();
		}
	};
	
	//Render function
	this.render = function()
	{
		//Clear
		Render.renderClear();
		var cxt = Render.tvContext, gxt = Render.gp0Context;
		
		//Black Background
		cxt.fillStyle = "#000"; gxt.fillStyle = "#000";
		cxt.drawImage(Render.images["space1"], 0, 0, Render.tvWidth, Render.tvHeight);
		gxt.drawImage(Render.images["space1"], 0, 0, Render.gp0Width, Render.gp0Height);
		cxt.globalAlpha = 0.7; gxt.globalAlpha = 0.7;
		cxt.fillRect(0, 0, Render.tvWidth, Render.tvHeight);
		gxt.fillRect(0, 0, Render.gp0Width, Render.gp0Height);
		cxt.globalAlpha = 1; gxt.globalAlpha = 1;
		
		/*
		cxt.fillStyle = "#FFF";
		cxt.font = "32px Verdana";
		cxt.textAlign = "right";
		cxt.fillText(Date.now() - this.initCall, Render.tvWidth-5, 5);
		gxt.fillStyle = "#FFF";
		gxt.font = "14px Verdana";
		gxt.textAlign = "right";
		gxt.fillText(Date.now() - this.initCall, Render.gp0Width-5, 5);
		*/
		
		
		//Loading Message
		var x = Render.tvWidth/2, y = Render.tvHeight/2, fontSize = 65,
			x2 = Render.gp0Width/2, y2 = Render.gp0Height/2, fontSize2 = 50;
		
		cxt.fillStyle = "#FFF";
		cxt.font = fontSize+"px Verdana";
		cxt.textAlign = "center";
		cxt.fillText(_t("Loading..."), x, y-fontSize/2);
		cxt.textAlign = "left";
		
		gxt.fillStyle = "#FFF";
		gxt.font = fontSize2+"px Verdana";
		gxt.textAlign = "center";
		gxt.fillText(_t("Loading..."), x2, y2-fontSize2/2);
		gxt.textAlign = "left";

	};
};
var LoadingScreen = new LoadingScreen();