function MainMenu()
{
	this.area = "";
	this.map = null;
	this.mapPreviewFlow = 1;
	
	this.page = 0;
	this.pageSliding = false;
	this.pageShowHidden = false;
	this.mapmenuOffsetX = 0;
	this.mapmenuOffsetX2 = 0;
	
	this.onIndex = 0;
	this.options = [{
		value: "Hard Mode",
		action: function()
		{
			MainMenu.loadMap(MainMenu.map, "Hard");
		}
	}, {
		value: "Easy Mode",
		action: function()
		{
			MainMenu.loadMap(MainMenu.map, "Easy");
		}
	}, {
		value: "Insanity Mode",
		action: function()
		{
			MainMenu.loadMap(MainMenu.map, "Insanity");
		}
	}, {
		value: "Endurance Mode",
		action: function()
		{
			MainMenu.loadMap(MainMenu.map, "Endless");
		}
	}, {
		value: "Highscores",
		action: function()
		{
			Leaderboard.init({
				type: "mainmenu_map",
				map: MainMenu.map,
				area: "local",
				mode: "hard"
			});
		}
	}, {
		value: "Map Screen",
		action: function()
		{
			ClickBank.clearAll();
			MainMenu.area = "mapscreen";
			MainMenu.map = null;
			MainMenu.recentChanges = {};
		}
	}];
	
	this.inputCommandsFromUser = [];
	
	//Init
	this.init = function(area, map)
	{
		if (area == undefined) area = "mapscreen";
		if (map == undefined) map = null;
		
		nwf.system.WiiUSystem.getInstance().homeButtonEnabled = true;
		//nwf.system.Memory.requestGC();
		ClickBank.clearAll();
		InputBank.clearAll();
		Render.soundsStopAll();
		Render.clearGeneratedIDs();
		
		if (!Leaderboard.scorePresetLoaded) Leaderboard.loadScorePreset();
		//Leaderboard.onlineConnect(0);
		
		if (Game && Game.map)
			__Maps[Game.map].scriptUnset();
		
		this.area = area;
		this.map = map;
		this.onIndex = 0;
		this.recentChanges = {};
		
		/*this.page = 0;
		this.mapmenuOffsetX = 0;
		this.mapmenuOffsetX2 = 0;*/
		
		Render.renderControl = function(){ MainMenu.render(); };
		
		if (Render.sounds["mainmenu"].readyState > 0)
			Render.sounds["mainmenu"].currentTime = 0;
		Render.sounds["mainmenu"].play();
		
		
		//Generate Previews
		var imgW=492,imgH=328;
		for(var _mapID in __Maps)
		{
			map = __Maps[_mapID];
			
			if (map.previewGenerate != undefined)
			{
				map.previewGenerate(imgW, imgH);
			}
		}
		
		
		//Buttons
		InputBank.add({
			id: "button",
			type: ["b", "a", "up", "down", "left", "right", "start", "r", "r2", "l", "l2"],
			action: function(clickID, vaultEntry, type)
			{
				switch(type)
				{
				case "left":
				case "up":
					if (MainMenu.area == "mapmenu")
					{
						MainMenu.onIndex--;
						if (MainMenu.onIndex < 0) MainMenu.onIndex = 0;
					}
				break;
				
				case "right":
				case "down":
					if (MainMenu.area == "mapmenu")
					{
						MainMenu.onIndex++;
						if (MainMenu.onIndex >= MainMenu.options.length) MainMenu.onIndex = MainMenu.options.length-1;
					}
				break;
				
				case "b":
					if (MainMenu.area)
					{
						if (MainMenu.area == "mapmenu")
						{
							ClickBank.clearAll();
							MainMenu.area = "mapscreen";
							MainMenu.map = null;
							MainMenu.recentChanges = {};
						} else if (MainMenu.area.match(/submitscores_(not)?saved/i)) {
							ClickBank.clearAll();
							MainMenu.area = "mapscreen";
							MainMenu.map = null;
							MainMenu.recentChanges = {};
						}
					}
				break;
				
				case "a":
					if (MainMenu.area == "mapmenu")
					{
						MainMenu.options[MainMenu.onIndex].action();
					}
				break;
				
				case "l":
				case "l2":
					MainMenu.loadPrevPage();
				break;
				
				case "r":
				case "r2":
					MainMenu.loadNextPage();
				break;
				}
				
				//UUDDLRLRBA
				MainMenu.inputCommandsFromUser.unshift(type);
				var combos = ["up", "up", "down", "down", "left", "right", "left", "right", "b", "a"];
				if (MainMenu.inputCommandsFromUser.length > combos.length) MainMenu.inputCommandsFromUser.pop();
				if (MainMenu.inputCommandsFromUser.length == combos.length)
				{
					var isCorrect = true;
					combos.reverse();
					for(var i=0; i<combos.length; i++)
					{
						if (MainMenu.inputCommandsFromUser[i] != combos[i])
							isCorrect = false;
					}
					
					if (isCorrect)
					{
						MainMenu.mapPreviewFlow *= -1;
					}
				}
			}
		});
	};
	
	//Render Function
	this.recentChanges = {};
	this.render = function()
	{
		var cxt = Render.renderContext;
		
		//Clear
		Render.renderClear("all");
		var cxt = Render.tvContext, gxt = Render.gp0Context;
		
		switch(this.area)
		{
		default:
		case "mapscreen":
			
			//Background
			//cxt.fillStyle = "#FFF";
			//cxt.fillRect(0, 0, Render.tvWidth, Render.tvHeight);
			cxt.fillStyle = "#000"; gxt.fillStyle = "#000";
			cxt.drawImage(Render.images["space1"], 0, 0, Render.tvWidth, Render.tvHeight);
			gxt.drawImage(Render.images["space1"], 0, 0, Render.gp0Width, Render.gp0Height);
			cxt.globalAlpha = 0.7; gxt.globalAlpha = 0.7;
			cxt.fillRect(0, 0, Render.tvWidth, Render.tvHeight);
			gxt.fillRect(0, 0, Render.gp0Width, Render.gp0Height);
			cxt.globalAlpha = 1; gxt.globalAlpha = 1;
			
			//Game Title
			/*var title = SplashScreen.NATitle;
			if (SplashScreen.regionVersion == "Europe") title = SplashScreen.EuropeTitle;
			cxt.strokeStyle = "#000";
			cxt.font = "55px Verdana";
			cxt.textAlign = "center";
			cxt.strokeText(title, Render.tvWidth/2, 10);
			//cxt.fillText("ZaciSa: Defense of the", Render.tvWidth/2, 10);
			//cxt.fillText("Crayon Dimension!", Render.tvWidth/2, 110);
			cxt.textAlign = "left";
			
			gxt.fillStyle = "#FFF";
			gxt.font = "32px Verdana";
			gxt.textAlign = "center";
			gxt.fillText(title, Render.gp0Width/2, 5);
			gxt.textAlign = "left";*/
			
			//Game Title
			if (SplashScreen.regionVersion == "Europe")
			{
				var w = 1300*Render.renderTVRatio, h = w*(122/925);
				cxt.drawImage(Render.images["zacisa_title_europe2"], Render.tvWidth/2-w/2, 16*Render.renderTVRatio, w, h);
				var w = 500, h = w*(122/925);
				gxt.drawImage(Render.images["zacisa_title_europe2"], Render.gp0Width/2-w/2, 5, w, h);
			} else {
				var w = 1200*Render.renderTVRatio, h = w*(191/1372);
				cxt.drawImage(Render.images["zacisa_title"], Render.tvWidth/2-w/2, 20*Render.renderTVRatio, w, h);
				var w = 350, h = w*(191/1372);
				gxt.drawImage(Render.images["zacisa_title"], Render.gp0Width/2-w/2, 15, w, h);
			}
			
			//Loop through the maps and display
			var x=Render.tvWidth/3,y=-50*Render.renderTVRatio,map,imgW=492*Render.renderTVRatio,imgH=328*Render.renderTVRatio,
				x2=Render.gp0Width/3,y2=-40,imgW2=492*0.45,imgH2=328*0.45,
				pg=0;
			cxt.textAlign = "center"; gxt.textAlign = "center";
			cxt.font = "32px Verdana"; gxt.font = "20px Verdana";
			cxt.lineWidth = 1; gxt.lineWidth = 1;
			for(var _mapID in __Maps)
			{
				map = __Maps[_mapID];
				if (map.isHidden) continue
				if (x == Render.tvWidth/3)
				{
					y += 430*Render.renderTVRatio;
					y2 += 195;
					
					if (y == (-50+430+430+430)*Render.renderTVRatio)
					{
						pg++;
						y = (-50+430)*Render.renderTVRatio;
						y2 = -40+195;
					}
				}

				cxt.save();
				cxt.translate(x+Render.tvWidth*pg+this.mapmenuOffsetX, y);
				gxt.save();
				gxt.translate(x2+Render.gp0Width*pg+this.mapmenuOffsetX2, y2);
				
				//Draw image
				if (map.previewGenerate != undefined)
				{
					if (-250 <= x+Render.tvWidth*pg+this.mapmenuOffsetX && x+Render.tvWidth*pg+this.mapmenuOffsetX <= Render.tvWidth*1.2)
					{
						//if (MainMenu.disbaleMe == undefined || !MainMenu.disbaleMe )
						map.previewGenerate(492, 328);
						cxt.drawImage(map.previewCanvas, -imgW/2, -imgH/2, imgW, imgH);
						gxt.drawImage(map.previewCanvas, -imgW2/2, -imgH2/2, imgW2, imgH2);
					}
				} else {
					//cxt.drawImage(Render.images["map_"+_mapID], -imgW/2, -imgH/2, imgW, imgH);
					//gxt.drawImage(Render.images["map_"+_mapID], -imgW2/2, -imgH2/2, imgW2, imgH2);
				}
				
				//Draw border
				cxt.strokeStyle = "#666";
				cxt.strokeRect(-imgW/2, -imgH/2, imgW, imgH);
				gxt.strokeStyle = "#666";
				gxt.strokeRect(-imgW2/2, -imgH2/2, imgW2, imgH2);
				
				//Disabled?
				if (map.disabled)
				{
					cxt.globalAlpha = 0.7; gxt.globalAlpha = 0.7;
					cxt.fillStyle = "#000"; gxt.fillStyle = "#000";
					cxt.fillRect(-imgW/2, -imgH/2, imgW, imgH);
					gxt.fillRect(-imgW2/2, -imgH2/2, imgW2, imgH2);
					cxt.globalAlpha = 1; gxt.globalAlpha = 1;
				}
				
				//Title
				if (map.disabled)
				{
					cxt.fillStyle = "#666"; gxt.fillStyle = "#666";
				} else {
					cxt.fillStyle = "#FFF"; gxt.fillStyle = "#FFF";
				}
				cxt.fillText(_t(_mapID+"_title"), 0, imgH/2+5);
				gxt.fillText(_t(_mapID+"_title"), 0, imgH2/2+5);
				
				cxt.restore();
				gxt.restore();
				
				//Add click
				if (!this.pageSliding)
				{
					if (this.recentChanges["mapclick_"+_mapID] == undefined || this.recentChanges["mapclick_"+_mapID] == "n")
					{
						if (!map.disabled)
						{
							ClickBank.add({
								id: "map_"+_mapID,
								x: x2-imgW2/2+Render.gp0Width*pg+this.mapmenuOffsetX2,
								y: y2-imgH2/2,
								w: imgW2,
								h: imgH2,
								click: function(clickID, vaultEntry)
								{
									//MainMenu.loadMap(vaultEntry.data.mapID, "Hard");
									ClickBank.clearAll();
									MainMenu.area = "mapmenu";
									MainMenu.map = vaultEntry.data.mapID;
									MainMenu.onIndex = 0;
									MainMenu.recentChanges = {};
								},
								data: {
									mapID: _mapID
								}
							});
						}
						
						this.recentChanges["mapclick_"+_mapID] = "y";
					}
				} else {
					if (this.recentChanges["mapclick_"+_mapID] == "y")
					{
						ClickBank.clear("map_"+_mapID);
						this.recentChanges["mapclick_"+_mapID] = "n";
					}
				}
				//if (_mapID == "ss001") MainMenu.loadMap(_mapID);
				//if (_mapID == "ams6") MainMenu.loadMap(_mapID);
				//if (_mapID == "hyperspace") MainMenu.loadMap(_mapID);
				//if (_mapID == "moonbase") MainMenu.loadMap(_mapID);
				//if (_mapID == "nebula") MainMenu.loadMap(_mapID);
				//if (_mapID == "circle") MainMenu.loadMap(_mapID);
				//if (_mapID == "twin") MainMenu.loadMap(_mapID);
				//if (_mapID == "ams2") MainMenu.loadMap(_mapID);
				//if (_mapID == "ping15plus") MainMenu.loadMap(_mapID);
				//if (_mapID == "bdu") MainMenu.loadMap(_mapID);
				//if (_mapID == "gaf") MainMenu.loadMap(_mapID);
				//if (_mapID == "karabelt") MainMenu.loadMap(_mapID);
				//if (_mapID == "pollux") MainMenu.loadMap(_mapID);
				/*Game.map = "ss001";
				Game.mapClass = MapSS001;
				Game.score = 0;
				Game.money = 10;
				Game.level = 1;
				GameOver.init({
					map: Game.map,
					mode: Game.mode,
					score: Game.score,
					money: Game.money,
					level: Game.level
				});*/
				
				x += Render.tvWidth/3;
				if (Math.abs(Render.tvWidth - x) <= 10) x = Render.tvWidth/3;
				x2 += Render.gp0Width/3;
				if (Math.abs(Render.gp0Width - x2) <= 10) x2 = Render.gp0Width/3;
			}
			//cxt.textAlign = "left"; gxt.textAlign = "left";
			
			//Page Options
			if (this.page > (!this.pageShowHidden ? 0 : 0-Math.ceil(mapsCountHidden/4)) && !this.pageSliding)
			{
				gxt.drawImage(Render.images["arrow2"], 25, Render.gp0Height/2-150/2, 40, 150);
				if (this.recentChanges["pageleft"] == undefined || this.recentChanges["pageleft"] == "n")
				{
					ClickBank.add({
						id: "page_left",
						x: 25, y: Render.gp0Height/2-150/2, w: 40, h: 150,
						click: function()
						{
							MainMenu.loadPrevPage();
						}
					});
					
					this.recentChanges["pageleft"] = "y";
				}
			} else {
				if (this.recentChanges["pageleft"] == "y")
				{
					ClickBank.clear("page_left");
					this.recentChanges["pageleft"] = "n";
				}
			}

			if (this.page < pg && !this.pageSliding)
			{
				gxt.drawImage(Render.images["arrow1"], Render.gp0Width-25-40, Render.gp0Height/2-150/2, 40, 150);
				if (this.recentChanges["pageright"] == undefined || this.recentChanges["pageright"] == "n")
				{
					ClickBank.add({
						id: "page_right",
						x: Render.gp0Width-25-40, y: Render.gp0Height/2-150/2, w: 40, h: 150,
						click: function()
						{
							MainMenu.loadNextPage();
						}
					});
					
					this.recentChanges["pageright"] = "y";
				}
			} else {
				if (this.recentChanges["pageright"] == "y")
				{
					ClickBank.clear("page_right");
					this.recentChanges["pageright"] = "n";
				}
			}
			
			//Options on Gamepad
			/*gxt.font = "28px Single Sleeve";//Single Sleeve|Verdana
			gxt.fillStyle = "#FFF";
			gxt.textAlign = "center";
			gxt.strokeStyle = "#999";*/
			gxt.font = "20px Verdana";
			gxt.fillStyle = "#FFF";
			gxt.textAlign = "center";
			gxt.textBaseline = "middle";
			gxt.strokeStyle = "#666";
			
			//How to play
			var x = 15, y = 15, w = 130, h = 35;
			var str = _t("How to play");
			var lines = Render.splitText(gxt, str, w-6);
			gxt.drawImage(Render.images["button1"], x, y, w, h+(lines.length-1)*h*0.7);
			gxt.strokeRect(x, y, w, h+(lines.length-1)*h*0.7);
			for(var key in lines)
			{
				gxt.font = "20px Verdana";
				var font2 = 20;
				while(font2 > 13 && gxt.measureText(lines[key]).width+6 > w)
				{
					font2--;
					gxt.font = font2+"px Verdana";
				}
				
				gxt.fillText(lines[key], x+w/2, y+16+(parseInt(key)*h*0.7));
			}
			if (this.recentChanges["howtoplay"] == undefined || this.recentChanges["howtoplay"] == "n")
			{
				ClickBank.add({
					id: "howtoplay",
					x: x, y: y, w: w, h: h+(lines.length-1)*h*0.7,
					click: function(clickID, vaultEntry)
					{
						howToPlayShow();
					}
				});
				this.recentChanges["howtoplay"] = "y";
			}
			gxt.font = "20px Verdana";
			gxt.textBaseline = "top";
			
			
			if (this.recentChanges["submitscores"] == undefined || this.recentChanges["submitscores"] == "n")
			{
				var myAct = nwf.act.NintendoAccountManager.getInstance().getActiveAccount();
				var playerName = myAct.accountID ? myAct.accountID : "Player";
				
				var offlineScoresToUpload = [];
				
				if (typeof SplashScreen.setupData.offlineScores == "undefined")
					SplashScreen.setupData.offlineScores = {"": ""};
				var offlineScore, offlineScoreSplit;
				for(var offlineScoreKey in SplashScreen.setupData.offlineScores)
				{
					offlineScoreSplit = offlineScoreKey.split("/");
					if (offlineScoreSplit[0] != playerName) continue;
					
					offlineScore = SplashScreen.setupData.offlineScores[offlineScoreKey];
					
					offlineScoresToUpload.push({key: offlineScoreKey, split: offlineScoreSplit, data: offlineScore});
				}
				
				this.recentChanges["submitscores"] = offlineScoresToUpload.length > 0 ? "y2" : "y";
			}
			if (this.recentChanges["submitscores"] == "y2" && Render.actCanInternet)
			{
				var str = _t("Submit Online Scores");
				var lines = Render.splitText(gxt, str, w);
				var w = 150, h = lines.length*26+(lines.length==1 ? 5 : 0), x = 15, y = Render.gp0Height-28-h;
				gxt.drawImage(Render.images["button1"], x, y, w, h);
				gxt.strokeRect(x, y, w, h);
				
				for(var key in lines)
					gxt.fillText(lines[key], x+w/2, y+2+23*parseInt(key));
				//gxt.fillText("Submit", x+w/2, y+2);
				//gxt.fillText("Online Scores", x+w/2, y+h*0.45);
				
				ClickBank.add({
					id: "submitscores",
					x: x, y: y, w: w, h: h,
					click: function(clickID, vaultEntry)
					{
						ClickBank.clearAll();
						MainMenu.area = "submitscores";
						MainMenu.onIndex = 0;
						MainMenu.recentChanges = {};
					}
				});
			}
			
			
			//Challenges
			if (0) {
			var x = 15, y = 65, w = 150, h = 35;
			var str = _t("Challenges");
			gxt.drawImage(Render.images["button1"], x, y, w, h);
			gxt.strokeRect(x, y, w, h);
			gxt.fillText(str, x+w/2, y+2);
			if (this.recentChanges["challenges"] == undefined || this.recentChanges["challenges"] == "n")
			{
				ClickBank.add({
					id: "challenges",
					x: x, y: y, w: w, h: h,
					click: function(clickID, vaultEntry)
					{
						Challenges.init();
					}
				});
				this.recentChanges["challenges"] = "y";
				//Challenges.init();
			}
			}
			
			
			//Options
			var str = _t("Options");
			var lines = Render.splitText(gxt, str, w);
			var w = 130, h = lines.length*26+(lines.length==1 ? 5 : 0)+(lines.length==1 ? 3 : 0), x = (Render.gp0Width-15)-130, y = 15;
			gxt.drawImage(Render.images["button1"], x, y, w, h);
			gxt.fillStyle = "#FFF";
			gxt.strokeRect(x, y, w, h);
			for(var key in lines)
				gxt.fillText(lines[key], x+w/2, y+2+23*parseInt(key));
			if (this.recentChanges["options"] == undefined || this.recentChanges["options"] == "n")
			{
				ClickBank.add({
					id: "options",
					x: x, y: y, w: w, h: h,
					click: function(clickID, vaultEntry)
					{
						MainMenuOptions.init();
					}
				});
				this.recentChanges["options"] = "y";
			}
			
			//Leaderboard
			y += h+15;
			var str = _t("Highscores");
			var lines = Render.splitText(gxt, str, w);
			var w = 130, h = lines.length*26+(lines.length==1 ? 5 : 0), x = (Render.gp0Width-15)-130;
			gxt.drawImage(Render.images["button1"], x, y, w, h);
			gxt.fillStyle = "#FFF";
			gxt.strokeRect(x, y, w, h);
			for(var key in lines)
				gxt.fillText(lines[key], x+w/2, y+2+23*parseInt(key));
			if (this.recentChanges["highscores"] == undefined || this.recentChanges["highscores"] == "n")
			{
				ClickBank.add({
					id: "highscores",
					x: x, y: y, w: w, h: h,
					click: function(clickID, vaultEntry)
					{
						Leaderboard.init({
							type: "mainmenu",
							map: "",
							area: "month",
							mode: "hard"
						});
					}
				});
				this.recentChanges["highscores"] = "y";
			}
			
			
			//Music Player
			var str = _t("Music Player");
			var lines = Render.splitText(gxt, str, w);
			var w = 130, h = lines.length*26+(lines.length==1 ? 5 : 0), x = (Render.gp0Width-15)-130, y = Render.gp0Height-h-15;
			gxt.drawImage(Render.images["button1"], x, y, w, h);
			gxt.strokeRect(x, y, w, h);
			for(var key in lines)
				gxt.fillText(lines[key], x+w/2, y+2+23*parseInt(key));
			if (this.recentChanges["musicplayer"] == undefined || this.recentChanges["musicplayer"] == "n")
			{
				ClickBank.add({
					id: "musicplayer",
					x: x, y: y, w: w, h: h,
					click: function(clickID, vaultEntry)
					{
						MusicPlayer.init();
					}
				});
				this.recentChanges["musicplayer"] = "y";
			}
			
			//Credits
			var str = _t("Credits");
			var lines = Render.splitText(gxt, str, w);
			var w = 130, h = lines.length*26+(lines.length==1 ? 5 : 0), x = (Render.gp0Width-15)-130; y -= h+15;
			gxt.drawImage(Render.images["button1"], x, y, w, h);
			gxt.strokeRect(x, y, w, h);
			for(var key in lines)
				gxt.fillText(lines[key], x+w/2, y+2+23*parseInt(key));
			if (this.recentChanges["credits"] == undefined || this.recentChanges["credits"] == "n")
			{
				ClickBank.add({
					id: "credits2",
					x: x, y: y, w: w, h: h,
					click: function(clickID, vaultEntry)
					{
						Credits.init();
					}
				});
				this.recentChanges["credits"] = "y";
			}
			
			
			gxt.textAlign = "left";
			
			//Game Version
			var version = SplashScreen.gameVersion;
			if (SplashScreen.regionVersion == "Europe") version = SplashScreen.europeVerion;
			if (version > 1.0)
			{
				cxt.textAlign = "left"; gxt.textAlign = "left";
				cxt.font = "22px Verdana"; gxt.font = "12px Verdana";
				cxt.fillStyle = "#FFF"; gxt.fillStyle = "#FFF";
				cxt.fillText(_t("Version")+" "+version, 8, Render.tvHeight-38);
				gxt.fillText(_t("Version")+" "+version, 5, Render.gp0Height-20);
			}
		break;
		
		case "mapmenu":
			var map = this.map, mapObj = __Maps[map];
			
			//Background
			if (!this.mapPreviewImg || this.mapPreviewImgMap != map)
			{
				this.mapPreviewImgMap = map;
				this.mapPreviewImg = new Image();
				this.mapPreviewImg.src = "media/maps/preview/"+map+".jpg";
			}
			cxt.drawImage(this.mapPreviewImg, 0, 0, Render.tvWidth, Render.tvHeight);
			gxt.drawImage(this.mapPreviewImg, 0, 0, Render.gp0Width, Render.gp0Height);
			cxt.fillStyle = "#000"; gxt.fillStyle = "#000";
			cxt.globalAlpha = 0.25; gxt.globalAlpha = 0.25;
			cxt.fillRect(0, 0, Render.tvWidth, Render.tvHeight);
			gxt.fillRect(0, 0, Render.gp0Width, Render.gp0Height);
			cxt.globalAlpha = 1; gxt.globalAlpha = 1;
			
			
			//Map Title
			cxt.strokeStyle = "blue";
			cxt.fillStyle = "#FFF";
			cxt.font = "65px Verdana";
			cxt.textAlign = "center";
			cxt.fillText(_t(map+"_title"), Render.tvWidth/2, 50*Render.renderTVRatio);
			cxt.strokeText(_t(map+"_title"), Render.tvWidth/2, 50*Render.renderTVRatio);
			
			gxt.strokeStyle = "blue";
			gxt.fillStyle = "#FFF";
			gxt.font = "42px Verdana";
			gxt.textAlign = "center";
			gxt.fillText(_t(map+"_title"), Render.gp0Width/2, 30);
			gxt.strokeText(_t(map+"_title"), Render.gp0Width/2, 30);

			cxt.textBaseline = "middle"; gxt.textBaseline = "middle";
			
			var option, str;
			cxt.lineWidth = 1; gxt.lineWidth = 1;
			//cxt.font = "55px Single Sleeve"; gxt.font = "45px Single Sleeve";
			cxt.font = "55px Verdana"; gxt.font = "40px Verdana";
			cxt.textBaseline = "middle"; gxt.textBaseline = "middle";
			var x = Render.tvWidth/3, y = 300*Render.renderTVRatio, w = 600*Render.renderTVRatio, h = 125*Render.renderTVRatio,
				x2 = Render.gp0Width/3-12, y2 = 150, w2 = 290, h2 = 60,
				_h = 100*Render.renderTVRatio, _h2 = 50,
				bcDefault = "#AAA", bcOn = "#FFF", bc,
				bgDefault = "#000", bgOn = "#333", bg;
			for(var i=0,n=2; i<n; i++)
			{
				option = this.options[i];
				
				str = _t(option.value);
				gxt.font = "40px Verdana";
				var font2 = 40;
				while(font2 > 25 && gxt.measureText(str).width+6 > w2)
				{
					font2--;
					gxt.font = font2+"px Verdana";
				}
				
				bc = this.onIndex == i ? bcOn : bcDefault;
				bg = this.onIndex == i ? bgOn : bgDefault;
				cxt.strokeStyle = bc; gxt.strokeStyle = bc;
				cxt.fillStyle = bg; gxt.fillStyle = bg;
				//cxt.drawImage(Render.images["button"+(this.onIndex == i ? "2" : "1")], x-w/2, y-h/2, w, h);
				gxt.drawImage(Render.images["button"+(this.onIndex == i ? "2" : "1")], x2-w2/2, y2-h2/2, w2, h2);
				cxt.strokeStyle = "#666"; gxt.strokeStyle = "#666";
				//cxt.strokeRect(x-w/2, y-h/2, w, h);
				gxt.strokeRect(x2-w2/2, y2-h2/2, w2, h2);
				
				cxt.fillStyle = "#FFF"; gxt.fillStyle = "#FFF";
				//cxt.fillText(option.value, x, y);
				gxt.fillText(str, x2, y2);
				
				if (this.recentChanges["clickbutton_"+i] == undefined || this.recentChanges["clickbutton_"+i] == "n")
				{
					ClickBank.add({
						id: "button_"+i,
						group: "options",
						x: x2-w2/2, y: y2-h2/2, w: w2, h: h2,
						click: option.action,
						data: {
							index: i
						}
					});
					
					this.recentChanges["clickbutton_"+i] = "y";
				}
				
				//x += w*1.15; x2 += w2*1.15;
				//x *= 2; x2 *= 2+20;
				x2 += Render.gp0Width/3+24;
			}
			
			cxt.font = "55px Verdana"; gxt.font = "40px Verdana";
			cxt.textBaseline = "middle"; gxt.textBaseline = "middle";
			var x = Render.tvWidth/3, y = 300*Render.renderTVRatio, w = 600*Render.renderTVRatio, h = 125*Render.renderTVRatio,
				x2 = Render.gp0Width/3-12, y2 = 150, w2 = 290, h2 = 60,
				_h = 100*Render.renderTVRatio, _h2 = 50,
				bcDefault = "#AAA", bcOn = "#FFF", bc,
				bgDefault = "#000", bgOn = "#333", bg;
			y += h*1.5; y2 += h2*1.5;
			for(var i=2,n=4; i<n; i++)
			{
				option = this.options[i];
				
				str = _t(option.value);
				gxt.font = "40px Verdana";
				var font2 = 40;
				while(font2 > 25 && gxt.measureText(str).width+6 > w2)
				{
					font2--;
					gxt.font = font2+"px Verdana";
				}
				
				bc = this.onIndex == i ? bcOn : bcDefault;
				bg = this.onIndex == i ? bgOn : bgDefault;
				cxt.strokeStyle = bc; gxt.strokeStyle = bc;
				cxt.fillStyle = bg; gxt.fillStyle = bg;
				//cxt.drawImage(Render.images["button"+(this.onIndex == i ? "2" : "1")], x-w/2, y-h/2, w, h);
				gxt.drawImage(Render.images["button"+(this.onIndex == i ? "2" : "1")], x2-w2/2, y2-h2/2, w2, h2);
				cxt.strokeStyle = "#666"; gxt.strokeStyle = "#666";
				//cxt.strokeRect(x-w/2, y-h/2, w, h);
				gxt.strokeRect(x2-w2/2, y2-h2/2, w2, h2);
				
				cxt.fillStyle = "#FFF"; gxt.fillStyle = "#FFF";
				//cxt.fillText(option.value, x, y);
				gxt.fillText(str, x2, y2);
				
				if (this.recentChanges["clickbutton_"+i] == undefined || this.recentChanges["clickbutton_"+i] == "n")
				{
					ClickBank.add({
						id: "button_"+i,
						group: "options",
						x: x2-w2/2, y: y2-h2/2, w: w2, h: h2,
						click: option.action,
						data: {
							index: i
						}
					});
					
					this.recentChanges["clickbutton_"+i] = "y";
				}
				
				//x += w*1.15; x2 += w2*1.15;
				//x *= 2; x2 *= 2+20;
				x2 += Render.gp0Width/3+24;
			}
			
			cxt.lineWidth = 1; gxt.lineWidth = 1;
			//cxt.font = "55px Single Sleeve"; gxt.font = "45px Single Sleeve";
			cxt.font = "55px Verdana"; gxt.font = "40px Verdana";
			cxt.textBaseline = "middle"; gxt.textBaseline = "middle";
			var x = Render.tvWidth/2, y = 300*Render.renderTVRatio, w = 900*Render.renderTVRatio, h = 125*Render.renderTVRatio,
				x2 = Render.gp0Width/2, y2 = 150, w2 = 600, h2 = 60,
				_h = 100*Render.renderTVRatio, _h2 = 50,
				bcDefault = "#AAA", bcOn = "#FFF", bc,
				bgDefault = "#000", bgOn = "#333", bg;
			y += h*1.5; y2 += h2*1.5;
			y += h*1.5; y2 += h2*1.5;
			for(var i=4,n=this.options.length; i<n; i++)
			{
				option = this.options[i];
				
				str = _t(option.value);
				gxt.font = "40px Verdana";
				var font2 = 40;
				while(font2 > 30 && gxt.measureText(str).width+6 > w2)
				{
					font2--;
					gxt.font = font2+"px Verdana";
				}
				
				bc = this.onIndex == i ? bcOn : bcDefault;
				bg = this.onIndex == i ? bgOn : bgDefault;
				cxt.strokeStyle = bc; gxt.strokeStyle = bc;
				cxt.fillStyle = bg; gxt.fillStyle = bg;
				//cxt.drawImage(Render.images["button"+(this.onIndex == i ? "2" : "1")], x-w/2, y-h/2, w, h);
				gxt.drawImage(Render.images["button"+(this.onIndex == i ? "2" : "1")], x2-w2/2, y2-h2/2, w2, h2);
				cxt.strokeStyle = "#666"; gxt.strokeStyle = "#666";
				//cxt.strokeRect(x-w/2, y-h/2, w, h);
				gxt.strokeRect(x2-w2/2, y2-h2/2, w2, h2);
				
				cxt.fillStyle = "#FFF"; gxt.fillStyle = "#FFF";
				//cxt.fillText(option.value, x, y);
				gxt.fillText(str, x2, y2);
				
				if (this.recentChanges["clickbutton_"+i] == undefined || this.recentChanges["clickbutton_"+i] == "n")
				{
					ClickBank.add({
						id: "button_"+i,
						group: "options",
						x: x2-w2/2, y: y2-h2/2, w: w2, h: h2,
						click: option.action,
						data: {
							index: i
						}
					});
					
					this.recentChanges["clickbutton_"+i] = "y";
				}
				
				y += h*1.5; y2 += h2*1.5;
			}

			cxt.textBaseline = "top"; gxt.textBaseline = "top";
			cxt.textAlign = "left"; gxt.textAlign = "left";
		break;
		
		case "submitscores":
			this.area = "submitscores2";
			
			__lastErrorCode = "";
			this.lastErrorCode = "";
			Leaderboard.uploadOfflineScores(function()
			{
				MainMenu.area = "submitscores_saved";
			}, function()
			{
				MainMenu.area = "submitscores_notsaved";
			});
		break;
		case "submitscores2":
			cxt.fillStyle = "#000"; gxt.fillStyle = "#000";
			cxt.drawImage(Render.images["space1"], 0, 0, Render.tvWidth, Render.tvHeight);
			gxt.drawImage(Render.images["space1"], 0, 0, Render.gp0Width, Render.gp0Height);
			cxt.globalAlpha = 0.7; gxt.globalAlpha = 0.7;
			cxt.fillRect(0, 0, Render.tvWidth, Render.tvHeight);
			gxt.fillRect(0, 0, Render.gp0Width, Render.gp0Height);
			cxt.globalAlpha = 1; gxt.globalAlpha = 1;
			
			var title = _t("submitscores_1");//"Attempting to save your new highscore online...";
			
			cxt.strokeStyle = "blue";
			cxt.fillStyle = "#FFF";
			cxt.font = "60px Verdana";
			cxt.textAlign = "center";
			var lines = Render.splitText(cxt, title, 1000);
			for(var key in lines)
				cxt.fillText(lines[key], Render.tvWidth/2, (400+parseInt(key)*110)*Render.renderTVRatio);
			//cxt.strokeText(title, Render.tvWidth/2, 500*Render.renderTVRatio);
			
			gxt.strokeStyle = "blue";
			gxt.fillStyle = "#FFF";
			gxt.font = "42px Verdana";
			gxt.textAlign = "center";
			var lines = Render.splitText(gxt, title, 700);
			for(var key in lines)
				gxt.fillText(lines[key], Render.gp0Width/2, 190+parseInt(key)*55);
			//gxt.strokeText(title, Render.gp0Width/2, 250);
		break;
		
		case "submitscores_saved":
			cxt.fillStyle = "#000"; gxt.fillStyle = "#000";
			cxt.drawImage(Render.images["space1"], 0, 0, Render.tvWidth, Render.tvHeight);
			gxt.drawImage(Render.images["space1"], 0, 0, Render.gp0Width, Render.gp0Height);
			cxt.globalAlpha = 0.7; gxt.globalAlpha = 0.7;
			cxt.fillRect(0, 0, Render.tvWidth, Render.tvHeight);
			gxt.fillRect(0, 0, Render.gp0Width, Render.gp0Height);
			cxt.globalAlpha = 1; gxt.globalAlpha = 1;
			
			var title = _t("submitscores_2");//"Online Scores Saved";
			
			cxt.strokeStyle = "blue";
			cxt.fillStyle = "#FFF";
			cxt.font = "60px Verdana";
			cxt.textAlign = "center";
			var lines = Render.splitText(cxt, title, 1000);
			for(var key in lines)
				cxt.fillText(lines[key], Render.tvWidth/2, (400+parseInt(key)*110)*Render.renderTVRatio);
			//cxt.strokeText(title, Render.tvWidth/2, 500*Render.renderTVRatio);
			
			gxt.strokeStyle = "blue";
			gxt.fillStyle = "#FFF";
			gxt.font = "42px Verdana";
			gxt.textAlign = "center";
			var lines = Render.splitText(gxt, title, 700);
			for(var key in lines)
				gxt.fillText(lines[key], Render.gp0Width/2, 200+parseInt(key)*55);
			//gxt.strokeText(title, Render.gp0Width/2, 250);
			
			
			var str = _t("pressbtoreturn_mainmenu");
			cxt.font = "30px Verdana";
			cxt.fillText(str, Render.tvWidth/2, Render.tvHeight-72*Render.renderTVRatio);
			//cxt.fillText("press", Render.tvWidth/2-265*Render.renderTVRatio, Render.tvHeight-72*Render.renderTVRatio);
			//cxt.fillText("to return to Main Menu", Render.tvWidth/2+120*Render.renderTVRatio, Render.tvHeight-72*Render.renderTVRatio);
			//cxt.drawImage(fontImages["b"], Render.tvWidth/2-190*Render.renderTVRatio, Render.tvHeight-62*Render.renderTVRatio, 48*Render.renderTVRatio, 48*Render.renderTVRatio);
			
			gxt.font = "25px Verdana";
			gxt.fillText(str, Render.gp0Width/2, Render.gp0Height-50);
			//gxt.fillText("press", Render.gp0Width/2-145, Render.gp0Height-50);
			//gxt.fillText("to return to Main Menu", Render.gp0Width/2+75, Render.gp0Height-50);
			//gxt.drawImage(fontImages["b"], Render.gp0Width/2-100, Render.gp0Height-45, 28, 28);
		break;
		
		case "submitscores_notsaved":
			cxt.fillStyle = "#000"; gxt.fillStyle = "#000";
			cxt.drawImage(Render.images["space1"], 0, 0, Render.tvWidth, Render.tvHeight);
			gxt.drawImage(Render.images["space1"], 0, 0, Render.gp0Width, Render.gp0Height);
			cxt.globalAlpha = 0.7; gxt.globalAlpha = 0.7;
			cxt.fillRect(0, 0, Render.tvWidth, Render.tvHeight);
			gxt.fillRect(0, 0, Render.gp0Width, Render.gp0Height);
			cxt.globalAlpha = 1; gxt.globalAlpha = 1;
			
			var title = _t("submitscores_3");//"Online Scores could not be saved at this time. Please try again later.";
			
			cxt.strokeStyle = "blue";
			cxt.fillStyle = "#FFF";
			cxt.font = "55px Verdana";
			cxt.textAlign = "center";
			var lines = Render.splitText(cxt, title, 1000);
			for(var key in lines)
				cxt.fillText(lines[key], Render.tvWidth/2, (50+parseInt(key)*110)*Render.renderTVRatio);
			//cxt.strokeText(title, Render.tvWidth/2, 500*Render.renderTVRatio);
			
			gxt.strokeStyle = "blue";
			gxt.fillStyle = "#FFF";
			gxt.font = "40px Verdana";
			gxt.textAlign = "center";
			var lines = Render.splitText(gxt, title, 700);
			for(var key in lines)
				gxt.fillText(lines[key], Render.gp0Width/2, 30+parseInt(key)*55);
			//gxt.strokeText(title, Render.gp0Width/2, 250);
			
			
			var str = _t("pressbtoreturn_mainmenu");
			cxt.font = "30px Verdana";
			cxt.fillText(str, Render.tvWidth/2, Render.tvHeight-72*Render.renderTVRatio);
			//cxt.fillText("press", Render.tvWidth/2-265*Render.renderTVRatio, Render.tvHeight-72*Render.renderTVRatio);
			//cxt.fillText("to return to Main Menu", Render.tvWidth/2+120*Render.renderTVRatio, Render.tvHeight-72*Render.renderTVRatio);
			//cxt.drawImage(fontImages["b"], Render.tvWidth/2-190*Render.renderTVRatio, Render.tvHeight-62*Render.renderTVRatio, 48*Render.renderTVRatio, 48*Render.renderTVRatio);
			
			gxt.font = "25px Verdana";
			gxt.fillText(str, Render.gp0Width/2, Render.gp0Height-50);
			//gxt.fillText("press", Render.gp0Width/2-145, Render.gp0Height-50);
			//gxt.fillText("to return to Main Menu", Render.gp0Width/2+75, Render.gp0Height-50);
			//gxt.drawImage(fontImages["b"], Render.gp0Width/2-100, Render.gp0Height-45, 28, 28);
		break;
		}
		
		delete x; delete x2; delete y; delete y2;
		delete imgW; delete imgW2; delete imgH; delete imgH2;
		delete map; delete str;
	};
	
	//Slides the page to the left
	this.loadingNewPage = null;
	this.loadNextPage = function()
	{
		if (this.pageSliding) return false;
		if (MainMenu.page >= Math.ceil(mapsCount/4)-1) return false;
		this.pageSliding = true;
		
		MainMenu.mapmenuOffsetX0 = Render.tvWidth;
		
		clearInterval(this.loadingNewPage);
		this.loadingNewPage = setInterval(function()
		{
			MainMenu.mapmenuOffsetX -= Render.tvWidth/50;
			MainMenu.mapmenuOffsetX2 -= Render.gp0Width/50;
			MainMenu.mapmenuOffsetX0 -= Render.tvWidth/50;
			
			if (Math.abs(MainMenu.mapmenuOffsetX0) < 5)
			{
				clearInterval(MainMenu.loadingNewPage);
				MainMenu.page++;
				MainMenu.pageSliding = false;
				MainMenu.mapmenuOffsetX = -Render.tvWidth*MainMenu.page;
				MainMenu.mapmenuOffsetX2 = -Render.gp0Width*MainMenu.page;
			}
		}, 15);
	};
	
	//Slides the page to the right
	this.loadPrevPage = function()
	{
		if (this.pageSliding) return false;
		if ((!this.pageShowHidden && MainMenu.page <= 0) || (this.pageShowHidden && MainMenu.page <= 0-Math.ceil(mapsCountHidden/4))) return false;
		this.pageSliding = true;
		
		MainMenu.mapmenuOffsetX0 = Render.tvWidth;
		
		clearInterval(this.loadingNewPage);
		this.loadingNewPage = setInterval(function()
		{
			MainMenu.mapmenuOffsetX += Render.tvWidth/50;
			MainMenu.mapmenuOffsetX2 += Render.gp0Width/50;
			MainMenu.mapmenuOffsetX0 -= Render.tvWidth/50;
			
			if (Math.abs(MainMenu.mapmenuOffsetX0) < 5)
			{
				clearInterval(MainMenu.loadingNewPage);
				MainMenu.page--;
				MainMenu.pageSliding = false;
				MainMenu.mapmenuOffsetX = -Render.tvWidth*MainMenu.page;
				MainMenu.mapmenuOffsetX2 = -Render.gp0Width*MainMenu.page;
			}
		}, 15);
	};
	
	
	//Will load the map
	this.loadMap = function(mapID, mode)
	{
		//Clear all Image cache
		delete this.mapPreviewImg;
		this.mapPreviewImg = null;
		for(var tempMap in __Maps)
		{
			if (__Maps[tempMap].previewCanvas)
				$(__Maps[tempMap].previewCanvas).remove();
			__Maps[tempMap].previewCanvas = null;
			__Maps[tempMap].previewContext = null;
			if (__Maps[tempMap].previewImages)
				for(var key in __Maps[tempMap].previewImages)
					delete __Maps[tempMap].previewImages[key];
			__Maps[tempMap].previewImages = {};
			if (__Maps[tempMap].previewData)
			{
				if (__Maps[tempMap].previewData.bgs)
				{
					for(var key in __Maps[tempMap].previewData.bgs)
						delete __Maps[tempMap].previewData.bgs[key];
					__Maps[tempMap].previewData.bgs = [];
				}
				__Maps[tempMap].previewData.enemies = [];
				if (__Maps[tempMap].previewData.paths)
					for(var key in __Maps[tempMap].previewData.paths)
						for(var key2 in __Maps[tempMap].previewData.paths[key].path)
						{
							__Maps[tempMap].previewData.paths[key].path[key2].x = __Maps[tempMap].previewData.paths[key].path[key2].x0;
							__Maps[tempMap].previewData.paths[key].path[key2].y = __Maps[tempMap].previewData.paths[key].path[key2].y0;
						}
			}
		}
		
		LoadingScreen.init(function()
		{
			nwf.system.WiiUSystem.getInstance().homeButtonEnabled = false;
			
			this.data.mapID = mapID;
			this.data.mode = mode;
			var map = __Maps[mapID];
			
			if (!map.scriptLoaded)
			{
				/*var _script = $(document.createElement("script"));
				_script.attr({
					src: "js/maps/"+mapID+".js",
					type: "text/javascript"
				});
				$("head").append(_script);*/
				
				return true;
			} else {
				map.scriptLoaded = false;
				//map.initCall(mode);
				
				return true;
			}
		}, function()
		{
			var map = __Maps[mapID];
			if (map.scriptLoadCall != undefined)
				map.scriptLoadCall();
		}, function()
		{
			var mapID = this.data.mapID;
			var map = __Maps[mapID];
			
			map.scriptIsLoaded();
			
			return map.scriptLoaded;
		}, function()
		{
			var mapID = this.data.mapID;
			var map = __Maps[mapID];
			
			map.scriptLoaded = true;
			map.initCall(this.data.mode);
			//nwf.system.WiiUSystem.getInstance().homeButtonEnabled = true;
		});
	};
};
var MainMenu = new MainMenu();

SplashScreen.loadedScripts["mainmenu"] = true;