var musicVolumeOptions = [], etcVolumeOptions = [];
for(var i=0; i<=10; i++)
{
	musicVolumeOptions.push({
		v: i,
		value: "",
		iftrue: function()
		{
			return Render.soundMusicVolume*10 == this.v;
		},
		action: function()
		{
			Render.soundMusicVolume = this.v/10;
			Render.soundApplyNewVolume(Render.soundMusicVolume, "music");
		}
	});
	etcVolumeOptions.push({
		v: i,
		value: "",
		iftrue: function()
		{
			return Render.soundEtcVolume*10 == this.v;
		},
		action: function()
		{
			Render.soundEtcVolume = this.v/10;
			Render.soundApplyNewVolume(Render.soundEtcVolume, "etc");
		}
	});
}

function MainMenuOptions()
{
	this.tvData;
	this.gp0Data;
	
	this.onIndex = 0;
	this.onLevel = "0";
	this.level;
	this.levels = [{
		title: "Options",
		children: [{
			type: "button",
			title: "Settings",
			value: "Settings",
			levelaction: "next",
			children: [{
				type: "options_slider",
				value: "HUD Enabled",
				options: [{
					value: "No",
					iftrue: function()
					{
						return !Game.tvGUI;
					},
					action: function()
					{
						Game.tvGUI = false;
					}
				}, {
					value: "Yes",
					iftrue: function()
					{
						return Game.tvGUI;
					},
					action: function()
					{
						Game.tvGUI = true;
					}
				}],
				action: function()
				{
					Game.tvGUI = !Game.tvGUI;
				}
			}, {
				type: "options_slider",
				value: "Music",
				options: musicVolumeOptions,
				action: function()
				{
				
				}
			}, {
				type: "options_slider",
				value: "Sound Effects",
				options: etcVolumeOptions,
				action: function()
				{
					
				}
			}, {
				type: "button",
				value: "Back",
				levelaction: "back"
			}]
		}, {
			type: "button",
			title: "Language",
			value: "Language",
			levelaction: "next",
			levelactionChange: function()
			{
				switch(Language.useLang)
				{
				case "english": MainMenuOptions.onIndex = 0; break;
				case "spanish": MainMenuOptions.onIndex = 1; break;
				case "french": MainMenuOptions.onIndex = 2; break;
				case "german": MainMenuOptions.onIndex = 3; break;
				case "italian": MainMenuOptions.onIndex = 4; break;
				}
			},
			children: [{
				type: "buttonmini",
				value: "English",
				action: function()
				{
					Language.useLang = "english";
				}
			}, {
				type: "buttonmini",
				value: "Spanish",
				action: function()
				{
					Language.useLang = "spanish";
				}
			}, {
				type: "buttonmini",
				value: "French",
				action: function()
				{
					Language.useLang = "french";
				}
			}, {
				type: "buttonmini",
				value: "German",
				action: function()
				{
					Language.useLang = "german";
				}
			}, {
				type: "buttonmini",
				value: "Italian",
				action: function()
				{
					Language.useLang = "italian";
				}
			}, {
				type: "buttonmini",
				value: "Cancel",
				levelaction: "back"
			}]
		}, {
			type: "button",
			title: "Reset Highscores",
			value: "Reset Highscores",
			innerdescription: "resethighscores_desc",
			levelaction: "next",
			children: [{
				type: "button",
				value: "Yes",
				action: function()
				{
					SplashScreen.setup_createLeaderboard(true);
					MainMenuOptions.changeCurrentLevel("set", "0/4");
				}
			}, {
				type: "button",
				value: "Cancel",
				levelaction: "back"
			}]
		}, {
			type: "button",
			value: "Main Menu",
			action: function()
			{
				MainMenuOptions.resumeGame();
			}
		}, {
			type: "hidden",
			value: "",
			title: "Reset Highscores",
			innerdescription: "resethighscores_desc2",
			levelaction: "next",
			children: [{
				type: "button",
				value: "Back",
				levelaction: "back"
			}]
		}]
	}];
	
	this.inputCommandsFromUser = [];
	
	//Start up the Pause Screen
	this.init = function()
	{
		//nwf.system.Memory.requestGC();
		ClickBank.archive();
		InputBank.archive();
		Game.gamePause = true;
		
		//this.tvData = Render.tvContext.getImageData(0, 0, Render.tvWidth, Render.tvHeight);
		//this.gp0Data = Render.gp0Context.getImageData(0, 0, Render.gp0Width, Render.gp0Height);
		
		this.recentChanges = {};
		this.onIndex = 0;
		this.onLevel = "0";
		this.level = this.getCurrentLevel();
		Render.renderControl = function(){ MainMenuOptions.render(); };
		
		this.inputCommandsFromUser = [];
		
		//Buttons
		InputBank.add({
			id: "button",
			type: ["start", "b", "a", "y", "x", "up", "down", "left", "right"],
			action: function(clickID, vaultEntry, type)
			{
				switch(type)
				{
				case "up":
					MainMenuOptions.onIndex--;
					while(MainMenuOptions.onIndex >= 0 && MainMenuOptions.level.children[MainMenuOptions.onIndex].type == "hidden")
						MainMenuOptions.onIndex--;
					
					if (MainMenuOptions.onIndex < 0) MainMenuOptions.onIndex = 0;
					while(MainMenuOptions.onIndex < MainMenuOptions.level.children.length && MainMenuOptions.level.children[MainMenuOptions.onIndex].type == "hidden")
						MainMenuOptions.onIndex++;
				break;
				
				case "down":
					MainMenuOptions.onIndex++;
					while(MainMenuOptions.onIndex < MainMenuOptions.level.children.length && MainMenuOptions.level.children[MainMenuOptions.onIndex].type == "hidden")
						MainMenuOptions.onIndex++;
					
					if (MainMenuOptions.onIndex >= MainMenuOptions.level.children.length) MainMenuOptions.onIndex = MainMenuOptions.level.children.length-1;
					while(MainMenuOptions.onIndex >= 0 && MainMenuOptions.level.children[MainMenuOptions.onIndex].type == "hidden")
						MainMenuOptions.onIndex--;
				break;
				
				case "left":
					var option = MainMenuOptions.level.children[MainMenuOptions.onIndex];
					if (option.options != undefined)
					{
						var _onIndex = -1;
						for(var key in option.options)
							if (option.options[key].iftrue())
								_onIndex = key;
						_onIndex = parseInt(_onIndex);
						if (_onIndex == -1) return false;
						if (_onIndex != 0) MainMenuOptions.triggerOptionsAction(MainMenuOptions.onIndex, _onIndex-1);
					}
				break;
				
				case "right":
					var option = MainMenuOptions.level.children[MainMenuOptions.onIndex];
					if (option.options != undefined)
					{
						var _onIndex = -1;
						for(var key in option.options)
							if (option.options[key].iftrue())
								_onIndex = key;
						_onIndex = parseInt(_onIndex);
						if (_onIndex == -1) return false;
						if (_onIndex != option.options.length-1) MainMenuOptions.triggerOptionsAction(MainMenuOptions.onIndex, _onIndex+1);
					}
				break;
				
				case "start":
					MainMenuOptions.resumeGame();
				break;
				
				case "b":
					if (MainMenuOptions.onLevel == "0") MainMenuOptions.resumeGame();
					else MainMenuOptions.changeCurrentLevel("back");
				break;
				
				case "a":
					MainMenuOptions.triggerAction(MainMenuOptions.onIndex);
				break;
				}
				
				//XXYYXXXYYY
				MainMenuOptions.inputCommandsFromUser.unshift(type);
				var combos = ["x", "x", "y", "y", "x", "x", "x", "y", "y", "y"];
				if (MainMenuOptions.inputCommandsFromUser.length > combos.length) MainMenuOptions.inputCommandsFromUser.pop();
				if (MainMenuOptions.inputCommandsFromUser.length == combos.length)
				{
					var isCorrect = true;
					combos.reverse();
					for(var i=0; i<combos.length; i++)
					{
						if (MainMenuOptions.inputCommandsFromUser[i] != combos[i])
							isCorrect = false;
					}
					
					if (isCorrect)
					{
						if (typeof SplashScreen.setupData.offlineScores == "undefined")
							SplashScreen.setupData.offlineScores = {"": ""};
						
						var myAct = nwf.act.NintendoAccountManager.getInstance().getActiveAccount();
						var actName = myAct.accountID ? myAct.accountID : "Player";
						var SaveType = actName+"/ss001/Hard";
						
						if (typeof SplashScreen.setupData.offlineScores[SaveType] == "undefined")
							SplashScreen.setupData.offlineScores[SaveType] = {score: 100, level: 1};
						MainMenu.recentChanges = {};
					}
				}
			}
		});
	};
	
	//Render the Pause Menu over the Game
	this.recentChanges = {};
	this.render = function()
	{
		//Clear
		Render.renderClear("all");
		var cxt = Render.tvContext, gxt = Render.gp0Context;
		
		//Draw background - darken it
		/*cxt.putImageData(this.tvData, 0, 0);
		gxt.putImageData(this.gp0Data, 0, 0);
		cxt.fillStyle = "rgba(0, 0, 0, 0.8)"; gxt.fillStyle = "rgba(0, 0, 0, 0.8)";
		cxt.fillRect(0, 0, Render.tvWidth, Render.tvHeight);
		gxt.fillRect(0, 0, Render.gp0Width, Render.gp0Height);*/
		cxt.fillStyle = "#000"; gxt.fillStyle = "#000";
		cxt.drawImage(Render.images["space1"], 0, 0, Render.tvWidth, Render.tvHeight);
		gxt.drawImage(Render.images["space1"], 0, 0, Render.gp0Width, Render.gp0Height);
		cxt.globalAlpha = 0.7; gxt.globalAlpha = 0.7;
		cxt.fillRect(0, 0, Render.tvWidth, Render.tvHeight);
		gxt.fillRect(0, 0, Render.gp0Width, Render.gp0Height);
		cxt.globalAlpha = 1; gxt.globalAlpha = 1;
		
		
		/*switch(this.area)
		{
		default:
		case "top":*/
		var level = this.level;
		if (!level)
		{
			level = this.levels[0];
			this.level = level;
		}
		
		//Title
		cxt.fillStyle = "#FFF"; gxt.fillStyle = "#FFF";
		cxt.textAlign = "center"; gxt.textAlign = "center";
		cxt.font = "75px Verdana"; gxt.font = "60px Verdana";
		
		var str = _t(level.title);
		var font = 75, font2 = 60;
		while(font > 60 && cxt.measureText(str).width+100 > Render.tvWidth)
		{
			font--;
			cxt.font = font+"px Verdana";
		}
		while(font2 > 45 && gxt.measureText(str).width+100 > Render.gp0Width)
		{
			font2--;
			gxt.font = font2+"px Verdana";
		}
		cxt.fillText(str, Render.tvWidth/2, 5);
		gxt.fillText(str, Render.gp0Width/2, 10);
		
		var y01 = 0; y02 = 0;
		
		//Inner Description
		if (level.innerdescription != undefined)
		{
			cxt.fillStyle = "#FFF"; gxt.fillStyle = "#FFF";
			cxt.textAlign = "center"; gxt.textAlign = "center";
			cxt.font = "35px Verdana"; gxt.font = "25px Verdana";
			
			var ystart = 175*Render.renderTVRatio, ystart2 = 85;
			var lines = Render.splitText(cxt, _t(level.innerdescription), Render.tvWidth*0.75);
			for(var key in lines)
			{
				cxt.fillText(lines[key], Render.tvWidth/2, ystart+y01);
				y01 += 65*Render.renderTVRatio;
			}
			var lines = Render.splitText(gxt, _t(level.innerdescription), Render.gp0Width*0.75);
			for(var key in lines)
			{
				gxt.fillText(lines[key], Render.gp0Width/2, ystart2+y02);
				y02 += 30;
			}
			
			y01 += 35;
			y02 += 30;
		} else {
			y01 += 35;
			y02 += 30;
		}
		
		
		//Options
		cxt.lineWidth = 1; gxt.lineWidth = 1;
		cxt.font = "55px Verdana"; gxt.font = "40px Verdana";
		cxt.textBaseline = "middle"; gxt.textBaseline = "middle";
		var x = Render.tvWidth/2, y = 250*Render.renderTVRatio+y01, w = 800*Render.renderTVRatio, h = 125*Render.renderTVRatio,
			x2 = Render.gp0Width/2, y2 = 125+y02, w2 = 400, h2 = 60,
			_h = 100*Render.renderTVRatio, _h2 = 50,
			bcDefault = "#AAA", bcOn = "#FFF", bc,
			bgDefault = "#000", bgOn = "#333", bg;
		
		var option, opt, cw, cw2, _x, _x2;
		for(var i in level.children)
		{
			option = level.children[i];
			
			switch(option.type)
			{
			case "button":
				var wold = w, wold2 = w2;
				w *= 1.25;
				w2 *= 1.25;
				
				var str = _t(option.value);
				var font = 55, font2 = 40;
				while(font > 40 && cxt.measureText(str).width+30 > w)
				{
					font--;
					cxt.font = font+"px Verdana";
				}
				while(font2 > 25 && gxt.measureText(str).width+30 > w2)
				{
					font2--;
					gxt.font = font2+"px Verdana";
				}
				
				bc = this.onIndex == i ? bcOn : bcDefault;
				bg = this.onIndex == i ? bgOn : bgDefault;
				cxt.strokeStyle = bc; gxt.strokeStyle = bc;
				cxt.fillStyle = bg; gxt.fillStyle = bg;
				cxt.drawImage(Render.images["button"+(this.onIndex == i ? "2" : "1")], x-w/2, y-h/2, w, h);
				gxt.drawImage(Render.images["button"+(this.onIndex == i ? "2" : "1")], x2-w2/2, y2-h2/2, w2, h2);
				cxt.strokeStyle = "#666"; gxt.strokeStyle = "#666";
				cxt.strokeRect(x-w/2, y-h/2, w, h);
				gxt.strokeRect(x2-w2/2, y2-h2/2, w2, h2);
				cxt.fillStyle = "#FFF"; gxt.fillStyle = "#FFF";
				cxt.fillText(str, x, y);
				gxt.fillText(str, x2, y2);
				
				if (this.recentChanges["button_"+i] == undefined || this.recentChanges["button_"+i] == "n")
				{
					ClickBank.add({
						id: "button_"+i,
						group: "options",
						x: x2-w2/2, y: y2-h2/2, w: w2, h: h2,
						click: function(clickID, vaultEntry)
						{
							MainMenuOptions.triggerAction(vaultEntry.data.index);
						},
						data: {
							index: i
						}
					});
					
					this.recentChanges["button_"+i] = "y";
				}
				
				w = wold;
				w2 = wold2;
				cxt.font = "55px Verdana"; gxt.font = "40px Verdana";
			break;
			
			case "buttonmini":
				var xDiff = (i % 2 == 0) ? -Render.tvWidth/4 : Render.tvWidth/4;
				var x2Diff = (i % 2 == 0) ? -Render.gp0Width/4 : Render.gp0Width/4;
				
				bc = this.onIndex == i ? bcOn : bcDefault;
				bg = this.onIndex == i ? bgOn : bgDefault;
				cxt.strokeStyle = bc; gxt.strokeStyle = bc;
				cxt.fillStyle = bg; gxt.fillStyle = bg;
				cxt.drawImage(Render.images["button"+(this.onIndex == i ? "2" : "1")], x-w/2+xDiff, y-h/2, w, h);
				gxt.drawImage(Render.images["button"+(this.onIndex == i ? "2" : "1")], x2-w2/2+x2Diff, y2-h2/2, w2, h2);
				cxt.strokeStyle = "#666"; gxt.strokeStyle = "#666";
				cxt.strokeRect(x-w/2+xDiff, y-h/2, w, h);
				gxt.strokeRect(x2-w2/2+x2Diff, y2-h2/2, w2, h2);
				cxt.fillStyle = "#FFF"; gxt.fillStyle = "#FFF";
				cxt.fillText(_t(option.value), x+xDiff, y);
				gxt.fillText(_t(option.value), x2+x2Diff, y2);
				
				if (this.recentChanges["button_"+i] == undefined || this.recentChanges["button_"+i] == "n")
				{
					ClickBank.add({
						id: "button_"+i,
						group: "options",
						x: x2-w2/2+x2Diff, y: y2-h2/2, w: w2, h: h2,
						click: function(clickID, vaultEntry)
						{
							MainMenuOptions.triggerAction(vaultEntry.data.index);
						},
						data: {
							index: i
						}
					});
					
					this.recentChanges["button_"+i] = "y";
				}
				
				if (i % 2 == 0)
				{
					y -= h*1.25; y2 -= h2*1.25;
				}
			break;
			
			case "options_slider":
				cxt.font = "30px Verdana"; gxt.font = "25px Verdana";
				cxt.textAlign = "left"; gxt.textAlign = "left";
				
				var str = _t(option.value);
				var font = 30, font2 = 25;
				while(font > 20 && cxt.measureText(str).width+30 > (w*3/4))
				{
					font--;
					cxt.font = font+"px Verdana";
				}
				while(font2 > 15 && gxt.measureText(str).width+30 > (w2*3/4))
				{
					font2--;
					gxt.font = font2+"px Verdana";
				}
				
				bc = this.onIndex == i ? bcOn : bcDefault;
				bg = this.onIndex == i ? bgOn : bgDefault;
				cxt.strokeStyle = bc; gxt.strokeStyle = bc;
				cxt.fillStyle = bc; gxt.fillStyle = bc;
				cxt.fillText(str, x-(w*3/4), y);
				gxt.fillText(str, x2-(w2*3/4), y2);

				cxt.textAlign = "center"; gxt.textAlign = "center";
				cxt.font = "30px Verdana"; gxt.font = "20px Verdana";
				
				cw = w / option.options.length; cw2 = w2 / option.options.length;
				_x = 0; _x2 = 0;
				for(var key in option.options)
				{
					opt = option.options[key];
					
					bc = opt.iftrue() ? bcOn : bcDefault;
					bg = opt.iftrue() ? bgOn : bgDefault;
					cxt.strokeStyle = bc; gxt.strokeStyle = bc;
					//cxt.fillStyle = bg; gxt.fillStyle = bg;
					//cxt.fillRect(x+_x, y-_h/2, cw, _h);
					//gxt.fillRect(x2+_x2, y2-_h2/2, cw2, _h2);
					//cxt.strokeRect(x+_x, y-_h/2, cw, _h);
					//gxt.strokeRect(x2+_x2, y2-_h2/2, cw2, _h2);
					cxt.drawImage(Render.images["button"+(opt.iftrue() ? "2" : "1")], x+_x, y-_h/2, cw, _h);
					gxt.drawImage(Render.images["button"+(opt.iftrue() ? "2" : "1")], x2+_x2, y2-_h2/2, cw2, _h2);
					cxt.strokeStyle = "#666"; gxt.strokeStyle = "#666";
					cxt.strokeRect(x+_x, y-_h/2, cw, _h);
					gxt.strokeRect(x2+_x2, y2-_h2/2, cw2, _h2);
					cxt.fillStyle = "#FFF"; gxt.fillStyle = "#FFF";
					cxt.fillText(_t(opt.value), x+_x+cw/2, y);
					gxt.fillText(_t(opt.value), x2+_x2+cw2/2, y2);
					
					if (this.recentChanges["button_"+i+"_"+key] == undefined || this.recentChanges["button_"+i+"_"+key] == "n")
					{
						ClickBank.add({
							id: "button_"+i+"_"+key,
							group: "options",
							x: x2+_x2, y: y2-_h2/2, w: cw2, h: _h2,
							click: function(clickID, vaultEntry)
							{
								MainMenuOptions.triggerOptionsAction(vaultEntry.data.index, vaultEntry.data.option);
							},
							data: {
								index: i,
								option: key
							}
						});
						
						this.recentChanges["button_"+i+"_"+key] = "y";
					}
					
					_x += cw; _x2 += cw2;
				}
				
				cxt.font = "55px Verdana"; gxt.font = "40px Verdana";
			break;
			}
			
			if (option.type != "hidden")
			{
				y += h*1.25; y2 += h2*1.25;
			}
		}
		//break;
		//}

		cxt.textBaseline = "top"; gxt.textBaseline = "top";
		cxt.textAlign = "left"; gxt.textAlign = "left";
	};
	
	//Trigger specific action for a click/etc
	this.triggerAction = function(index)
	{
		var option = this.level.children[index];
		
		if (option.action != undefined)
		{
			this.onIndex = index;
			option.action();
		} else if (option.levelaction != undefined) {
			this.changeCurrentLevel(option.levelaction, index);
			if (option.levelactionChange != undefined)
				option.levelactionChange();
		}
		
		this.recentChanges = {};
	};
	
	//Trigger specific action for a options trigger
	this.triggerOptionsAction = function(index, option_index)
	{
		var option = this.level.children[index];
		
		if (option.options[option_index] != undefined)
			option.options[option_index].action();
		
		this.recentChanges = {};
	};
	
	//Change the current level
	this.changeCurrentLevel = function(type, nextIndex)
	{
		//Wipe current buttons
		ClickBank.clearGroup("options");
		
		switch(type)
		{
		case "set":
			this.onLevel = nextIndex;
			this.onIndex = 0;
		break;
		
		case "next":
			this.onLevel += "/"+nextIndex;
			this.onIndex = 0;
		break;
		
		case "back":
			var lvlTree = this.onLevel.split("/");
			if (lvlTree.length > 1)
			{
				var lvlTree2 = [];
				for(var i=0,n=lvlTree.length; i<n-1; i++)
					lvlTree2.push(lvlTree[i]);
				this.onLevel = lvlTree2.join("/");
				this.onIndex = lvlTree[lvlTree.length-1];
			}
		break;
		}
		
		this.level = this.getCurrentLevel();
		this.recentChanges = {};
	}
	
	//Return current level
	this.getCurrentLevel = function(lvlTree, level)
	{
		if (lvlTree == undefined) lvlTree = this.onLevel.split("/");
		if (level == undefined) level = this.levels;
		
		var rtr = level[lvlTree[0]];
		lvlTree.shift();
		
		if (lvlTree.length > 0) return this.getCurrentLevel(lvlTree, rtr.children);
		return rtr;
	};
	
	//Resume the Game
	this.resumeGame = function()
	{
		this.exit();
		
		ClickBank.clearAll();
		//InputBank.clearAll();
		MainMenu.recentChanges = {};
		Render.renderControl = function(){ MainMenu.render(); };
		
		//Save Language changes?
		if (SplashScreen.setupData && SplashScreen.setupData.lang && SplashScreen.setupData.lang != Language.useLang)
		{
			SplashScreen.setupData.lang = Language.useLang;
			FileIO.saveFile("setup.txt", SplashScreen.setupData, function()
			{
				
			}, function()
			{
				
			});
		}
	};
	
	//Clear out anything that needs to be cleared
	this.exit = function()
	{
		ClickBank.unarchive();
		InputBank.unarchive();
		
		this.recentChanges = {};
		
		this.tvData = null;
		this.gp0Data = null;
	};
};
var MainMenuOptions = new MainMenuOptions();