var __MapsHidden = [];
var __Maps = {
	"ss001": {
		title: "Space Station 001",
		src: "media/maps/ss001.jpg",
		online: {Hard: 0, Insanity: 1, Endless: 2},
		scriptLoaded: false,
		scriptImagesLoaded: 0, scriptImagesToLoad: 0,
		scriptSoundsLoaded: 0, scriptSoundsToLoad: 0,
		backgroundmusic: {file: "audio/map_ss001.ogg", title: "Azimuth"},
		scriptLoadCall: function()
		{
			//if (this.scriptImagesLoaded > 0) return false;
			
			var mapCustomSounds = {
				"levelbg": {
					src: "map_ss001.ogg"/*"map_ss001.ogg"*/,
					data: {
						volume: 1,
						gamepad1Volume: 1,
						tvVolume: 1,
						loop: true,
						preload: "auto"
					},
					group: "music"
				}
			};
			
			var path = "media/", img;
			var list = mapCommonImages;
			for(var ID in list)
			{
				this.scriptImagesToLoad++;
				
				if (Render.images[ID] == undefined)
				{
					img = new Image();
					img.map = "ss001";
					img.onload = _mapsImgOnLoad;
					img.src = path+list[ID];
					Render.images[ID] = img;
				} else this.scriptImagesLoaded++;
			}
			
			//Load in Sound
			var path = "audio/", audio, lData;
			list = mapCommonSounds;
			for(var ID in list)
			{
				lData = list[ID];
				this.scriptSoundsToLoad++;
				
				if (Render.sounds[ID] == undefined)
				{
					Render.soundAdd(ID, path+lData.src, lData, function()
					{
						__Maps["ss001"].scriptSoundsLoaded++;
					});
					Render.soundAddGroup(ID, lData.group);
				} else this.scriptSoundsLoaded++;
			}
			list = mapCustomSounds;
			for(var ID in list)
			{
				lData = list[ID];
				this.scriptSoundsToLoad++;
				
				if (Render.sounds[ID] == undefined)
				{
					Render.soundAdd(ID, path+lData.src, lData, function()
					{
						__Maps["ss001"].scriptSoundsLoaded++;
					});
					Render.soundAddGroup(ID, lData.group);
				} else this.scriptSoundsLoaded++;
			}
		},
		scriptIsLoaded: function()
		{
			if (MapSS001 != undefined
				&& this.scriptImagesLoaded == this.scriptImagesToLoad
				&& this.scriptSoundsLoaded == this.scriptSoundsToLoad
				&& mapCommonMediaToLoad == mapCommonMediaLoaded)
				this.scriptLoaded = true;
		},
		initCall: function(mode)
		{
			MapSS001.init({mode: mode});
		},
		scriptUnset: function()
		{
			var list = [];
			for(var key in list)
				delete Render.images[list[key]];
	
			var list = ["levelbg"];
			for(var key in list)
				delete Render.sounds[list[key]];
		},
		
		//Preview on Main Menu
		previewCanvas: null, previewContext: null,
		previewGenerate: function(width, height)
		{
			if (!this.previewCanvas)
			{
				this.previewCanvas = document.createElement("canvas");
				this.previewContext = this.previewCanvas.getContext("2d");
				this.previewCanvas.width = width;
				this.previewCanvas.height = height;
	
				this.previewImages["background"] = new Image();
				this.previewImages["background"].src = this.previewData.background;
				this.previewImages["enemy"] = new Image();
				this.previewImages["enemy"].src = this.previewData.enemyImg;
	
				var paths, path;
				for(var key in this.previewData.paths)
				{
					for(var i in this.previewData.paths[key].path)
					{
						this.previewData.paths[key].path[i].x0 = this.previewData.paths[key].path[i].x;
						this.previewData.paths[key].path[i].y0 = this.previewData.paths[key].path[i].y;
						this.previewData.paths[key].path[i].x *= width;
						this.previewData.paths[key].path[i].y *= height;
					}
				}
				
				var obj, pointMap;
				for(var i=0; i<this.previewData.maxEnemies; i++)
				{
					obj = {
						path: Math.floor(Math.random()*this.previewData.paths.length),
						point: 0, x: 0, y: 0
					};
					pointMap = this.previewData.paths[obj.path].path[0];
					obj.x = pointMap.x; obj.y = pointMap.y;
					this.previewData.enemies.push(obj);
				}
				
				return true;
			}
			var c = this.previewContext, imgs = this.previewImages;
			
			//Background
			c.drawImage(imgs.background, 0, 0, width, height);
			
			//Show Enemy Paths
			/*var paths, path;
			c.strokeStyle = "green";
			for(var key in this.previewData.paths)
			{
				paths = this.previewData.paths[key].path;
				
				c.beginPath();
				for(var i in paths)
				{
					path = paths[i];
					
					if (i == 0) c.moveTo(path.x, path.y);
					else c.lineTo(path.x, path.y);
				}
				c.stroke();
			}*/
			
			//Advance Enemies
			var obj, degree, endpath, w = 50, h = 25;
			for(var key in this.previewData.enemies)
			{
				obj = this.previewData.enemies[key];
				previewEnemyMovement(key, obj, this);
				
				endpath = this.previewData.paths[obj.path].path[this.previewData.paths[obj.path].path.length-1];
				degree = Render.determineAngle(obj.x, obj.y, endpath.x, endpath.y);
				c.save();
				c.translate(obj.x, obj.y);
				c.rotate(degree*Math.PI/180);
				c.drawImage(imgs.enemy, -w/2, 0, w, h);
				c.restore();
			}
		},
		previewData: {
			background: "media/maps/ss001.jpg",
			paths: [{
				speed: 2.5,
				path: [{x:0.5,y:0},
				       {x:0.5,y:0.38}]
			}, {
				speed: 2.5,
				path: [{x:0,y:0.5},
				       {x:0.4,y:0.5}]
			}, {
				speed: 2.5,
				path: [{x:1,y:1},
				       {x:0.6,y:0.6}]
			}],
			enemies: [], maxEnemies: 1,
			enemyImg: "media/enemies/red1.png"
		},
		previewImages: {}
	},
	
	"ams6": {
		//disabled: true,
		title: "Asteroid Mining Station 6",
		src: "media/maps/ams6.jpg",
		online: {Hard: 3, Insanity: 4, Endless: 5},
		scriptLoaded: false,
		scriptImagesLoaded: 0, scriptImagesToLoad: 0,
		scriptSoundsLoaded: 0, scriptSoundsToLoad: 0,
		backgroundmusic: {file: "audio/map_ams6.ogg", title: "1990"},
		scriptLoadCall: function()
		{
			//if (this.scriptImagesLoaded > 0) return false;
			
			var mapCustomImages = {
				"ams6_background": "background/ams6.png"
			};
			var mapCustomSounds = {
				"levelbg": {
					src: "map_ams6.ogg"/*laser.wav*/,
					data: {
						volume: 1,
						gamepad1Volume: 1,
						tvVolume: 1,
						loop: true,
						preload: "auto"
					},
					group: "music"
				}
			};
			
			var path = "media/", img;
			var list = mapCommonImages;
			for(var ID in list)
			{
				this.scriptImagesToLoad++;

				if (Render.images[ID] == undefined)
				{
					img = new Image();
					img.map = "ams6";
					img.onload = _mapsImgOnLoad;
					img.src = path+list[ID];
					Render.images[ID] = img;
				} else this.scriptImagesLoaded++;
			}
			list = mapCustomImages;
			for(var ID in list)
			{
				this.scriptImagesToLoad++;

				if (Render.images[ID] == undefined)
				{
					img = new Image();
					img.map = "ams6";
					img.onload = _mapsImgOnLoad;
					img.src = path+list[ID];
					Render.images[ID] = img;
				} else this.scriptImagesLoaded++;
			}
			
			//Load in Sound
			var path = "audio/", audio, lData;
			list = mapCommonSounds;
			for(var ID in list)
			{
				lData = list[ID];
				this.scriptSoundsToLoad++;
				
				if (Render.sounds[ID] == undefined)
				{
					Render.soundAdd(ID, path+lData.src, lData, function()
					{
						__Maps["ams6"].scriptSoundsLoaded++;
					});
					Render.soundAddGroup(ID, lData.group);
				} else this.scriptSoundsLoaded++;
			}
			list = mapCustomSounds;
			for(var ID in list)
			{
				lData = list[ID];
				this.scriptSoundsToLoad++;
				
				if (Render.sounds[ID] == undefined)
				{
					Render.soundAdd(ID, path+lData.src, lData, function()
					{
						__Maps["ams6"].scriptSoundsLoaded++;
					});
					Render.soundAddGroup(ID, lData.group);
				} else this.scriptSoundsLoaded++;
			}
		},
		scriptIsLoaded: function()
		{
			if (MapAMS6 != undefined
				&& this.scriptImagesLoaded == this.scriptImagesToLoad
				&& this.scriptSoundsLoaded == this.scriptSoundsToLoad
				&& mapCommonMediaToLoad == mapCommonMediaLoaded)
				this.scriptLoaded = true;
		},
		initCall: function(mode)
		{
			MapAMS6.init({mode: mode});
		},
		scriptUnset: function()
		{
			var list = ["ams6_background"];
			for(var key in list)
				delete Render.images[list[key]];

			var list = ["levelbg"];
			for(var key in list)
				delete Render.sounds[list[key]];
		},
		
		//Preview on Main Menu
		previewCanvas: null, previewContext: null,
		previewGenerate: function(width, height)
		{
			if (!this.previewCanvas)
			{
				this.previewCanvas = document.createElement("canvas");
				this.previewContext = this.previewCanvas.getContext("2d");
				this.previewCanvas.width = width;
				this.previewCanvas.height = height;

				this.previewImages["background"] = new Image();
				this.previewImages["background"].src = this.previewData.background;
				this.previewImages["enemy"] = new Image();
				this.previewImages["enemy"].src = this.previewData.enemyImg;

				var paths, path;
				for(var key in this.previewData.paths)
				{
					for(var i in this.previewData.paths[key].path)
					{
						this.previewData.paths[key].path[i].x0 = this.previewData.paths[key].path[i].x;
						this.previewData.paths[key].path[i].y0 = this.previewData.paths[key].path[i].y;
						this.previewData.paths[key].path[i].x *= width;
						this.previewData.paths[key].path[i].y *= height;
					}
				}
				
				var obj, pointMap;
				for(var i=0; i<this.previewData.maxEnemies; i++)
				{
					obj = {
						path: Math.floor(Math.random()*this.previewData.paths.length),
						point: 0, x: 0, y: 0
					};
					pointMap = this.previewData.paths[obj.path].path[0];
					obj.x = pointMap.x; obj.y = pointMap.y;
					this.previewData.enemies.push(obj);
				}
				
				return true;
			}
			var c = this.previewContext, imgs = this.previewImages;
			
			//Background
			c.drawImage(imgs.background, 0, 0, width, height);
			
			//Show Enemy Paths
			/*var paths, path;
			c.strokeStyle = "green";
			for(var key in this.previewData.paths)
			{
				paths = this.previewData.paths[key].path;
				
				c.beginPath();
				for(var i in paths)
				{
					path = paths[i];
					
					if (i == 0) c.moveTo(path.x, path.y);
					else c.lineTo(path.x, path.y);
				}
				c.stroke();
			}*/
			
			//Advance Enemies
			var obj, degree, endpath, w = 50, h = 25;
			for(var key in this.previewData.enemies)
			{
				obj = this.previewData.enemies[key];
				previewEnemyMovement(key, obj, this);
				
				endpath = this.previewData.paths[obj.path].path[obj.point+1];
				degree = Render.determineAngle(obj.x, obj.y, endpath.x, endpath.y);
				c.save();
				c.translate(obj.x, obj.y);
				c.rotate(degree*Math.PI/180);
				c.drawImage(imgs.enemy, -w/2, 0, w, h);
				c.restore();
			}
		},
		previewData: {
			background: "media/maps/ams6.jpg",
			paths: [{
				speed: 4.5,
				path: [{x:0.1,y:0},
				       {x:0.4,y:0.4},
				       {x:0.78,y:0.3}]
			}, {
				speed: 4,
				path: [{x:0.5,y:1},
				       {x:0.78,y:0.32}]
			}, {
				speed: 4,
				path: [{x:0.9,y:1},
				       {x:0.2,y:0.62}]
			}, {
				speed: 4,
				path: [{x:0.1,y:0},
				       {x:0.15,y:0.5}]
			}],
			enemies: [], maxEnemies: 1,
			enemyImg: "media/enemies/red2.png"
		},
		previewImages: {}
	},
	
	"hyperspace": {
		title: "Hyperspace",
		src: "media/maps/hyperspace.png",
		online: {Hard: 6, Insanity: 7, Endless: 8},
		scriptLoaded: false,
		scriptImagesLoaded: 0, scriptImagesToLoad: 0,
		scriptSoundsLoaded: 0, scriptSoundsToLoad: 0,
		backgroundmusic: {file: "audio/map_hyperspace.ogg", title: "Angry Robot III"},
		scriptLoadCall: function()
		{
			//if (this.scriptImagesLoaded > 0) return false;
			
			var mapCustomImages = {
				"space_long": "background/space_long.jpg", "space_long2": "background/space_long2.jpg"
			};
			var mapCustomSounds = {
				"levelbg": {
					src: "map_hyperspace.ogg",
					data: {
						volume: 0.8,
						gamepad1Volume: 1,
						tvVolume: 1,
						loop: true,
						preload: "auto"
					},
					group: "music"
				}
			};
			
			var path = "media/", img;
			var list = mapCommonImages;
			for(var ID in list)
			{
				this.scriptImagesToLoad++;

				if (Render.images[ID] == undefined)
				{
					img = new Image();
					img.map = "hyperspace";
					img.onload = _mapsImgOnLoad;
					img.src = path+list[ID];
					Render.images[ID] = img;
				} else this.scriptImagesLoaded++;
			}
			list = mapCustomImages;
			for(var ID in list)
			{
				this.scriptImagesToLoad++;

				if (Render.images[ID] == undefined)
				{
					img = new Image();
					img.map = "hyperspace";
					img.onload = _mapsImgOnLoad;
					img.src = path+list[ID];
					Render.images[ID] = img;
				} else this.scriptImagesLoaded++;
			}
			
			//Load in Sound
			var path = "audio/", audio, lData;
			list = mapCommonSounds;
			for(var ID in list)
			{
				lData = list[ID];
				this.scriptSoundsToLoad++;
				
				if (Render.sounds[ID] == undefined)
				{
					Render.soundAdd(ID, path+lData.src, lData, function()
					{
						__Maps["hyperspace"].scriptSoundsLoaded++;
					});
					Render.soundAddGroup(ID, lData.group);
				} else this.scriptSoundsLoaded++;
			}
			list = mapCustomSounds;
			for(var ID in list)
			{
				lData = list[ID];
				this.scriptSoundsToLoad++;
				
				if (Render.sounds[ID] == undefined)
				{
					Render.soundAdd(ID, path+lData.src, lData, function()
					{
						__Maps["hyperspace"].scriptSoundsLoaded++;
					});
					Render.soundAddGroup(ID, lData.group);
				} else this.scriptSoundsLoaded++;
			}
		},
		scriptIsLoaded: function()
		{
			if (MapHyperspace != undefined
				&& this.scriptImagesLoaded == this.scriptImagesToLoad
				&& this.scriptSoundsLoaded == this.scriptSoundsToLoad
				&& mapCommonMediaToLoad == mapCommonMediaLoaded)
				this.scriptLoaded = true;
		},
		initCall: function(mode)
		{
			MapHyperspace.init({mode: mode});
		},
		scriptUnset: function()
		{
			var list = ["space_long", "space_long2"];
			for(var key in list)
				delete Render.images[list[key]];

			var list = ["levelbg"];
			for(var key in list)
				delete Render.sounds[list[key]];
		},
		
		//Preview on Main Menu
		previewCanvas: null, previewContext: null,
		previewGenerate: function(width, height)
		{
			if (!this.previewCanvas)
			{
				this.previewCanvas = document.createElement("canvas");
				this.previewContext = this.previewCanvas.getContext("2d");
				this.previewCanvas.width = width;
				this.previewCanvas.height = height;
				
				this.previewData.bgs.push([1, 0]);
				this.previewData.bgs.push([2, width]);
				
				this.previewImages["background"] = new Image();
				this.previewImages["background"].src = this.previewData.background;
				this.previewImages["bg1"] = new Image();
				this.previewImages["bg1"].src = this.previewData.bg1;
				this.previewImages["bg2"] = new Image();
				this.previewImages["bg2"].src = this.previewData.bg2;
				this.previewImages["enemy"] = new Image();
				this.previewImages["enemy"].src = this.previewData.enemyImg;

				var paths, path;
				for(var key in this.previewData.paths)
				{
					for(var i in this.previewData.paths[key].path)
					{
						this.previewData.paths[key].path[i].x0 = this.previewData.paths[key].path[i].x;
						this.previewData.paths[key].path[i].y0 = this.previewData.paths[key].path[i].y;
						this.previewData.paths[key].path[i].x *= width;
						this.previewData.paths[key].path[i].y *= height;
					}
				}
				
				var obj, pointMap;
				for(var i=0; i<this.previewData.maxEnemies; i++)
				{
					obj = {
						path: Math.floor(Math.random()*this.previewData.paths.length),
						point: 0, x: 0, y: 0
					};
					pointMap = this.previewData.paths[obj.path].path[0];
					obj.x = pointMap.x; obj.y = pointMap.y;
					this.previewData.enemies.push(obj);
				}
				
				return true;
			}
			var c = this.previewContext, imgs = this.previewImages;
			
			//Background
			var bg;
			for(var key in this.previewData.bgs)
			{
				bg = this.previewData.bgs[key];
				
				c.drawImage(imgs["bg"+bg[0]], bg[1], 0, width, height);
				
				bg[1] -= 20;
			}
			bg = this.previewData.bgs[0];
			if (bg[1]+width <= 0)
			{
				this.previewData.bgs.shift();
				this.previewData.bgs.push([bg[0], this.previewData.bgs[0][1]+width]);
			}
			c.drawImage(imgs.background, 0, 0, width, height);
			
			//Show Enemy Paths
			/*var paths, path;
			c.strokeStyle = "green";
			for(var key in this.previewData.paths)
			{
				paths = this.previewData.paths[key].path;
				
				c.beginPath();
				for(var i in paths)
				{
					path = paths[i];
					
					if (i == 0) c.moveTo(path.x, path.y);
					else c.lineTo(path.x, path.y);
				}
				c.stroke();
			}*/
			
			//Advance Enemies
			var obj, degree, endpath, w = 50, h = 25;
			for(var key in this.previewData.enemies)
			{
				obj = this.previewData.enemies[key];
				previewEnemyMovement(key, obj, this);
				
				endpath = this.previewData.paths[obj.path].path[this.previewData.paths[obj.path].path.length-1];
				degree = Render.determineAngle(obj.x, obj.y, endpath.x, endpath.y);
				c.save();
				c.translate(obj.x, obj.y);
				c.rotate(degree*Math.PI/180);
				c.drawImage(imgs.enemy, -w/2, 0, w, h);
				c.restore();
			}
		},
		previewData: {
			background: "media/maps/hyperspace.png",
			bg1: "media/maps/hyperspace_bg1.jpg", bg2: "media/maps/hyperspace_bg2.jpg",
			bgs: [],
			
			paths: [{
				speed: 5,
				path: [{x:0,y:0.5},
				       {x:0.75,y:0.5}]
			}, {
				speed: 5,
				path: [{x:0,y:0.2},
				       {x:0.75,y:0.5}]
			}, {
				speed: 5,
				path: [{x:0,y:0.8},
				       {x:0.75,y:0.5}]
			}],
			enemies: [], maxEnemies: 1,
			enemyImg: "media/enemies/red2.png"
		},
		previewImages: {}
	},
	
	"moonbase": {
		//disabled: true,
		title: "Moon Base",
		src: "media/maps/moonbase.jpg",
		online: {Hard: 9, Insanity: 10, Endless: 11},
		scriptLoaded: false,
		scriptImagesLoaded: 0, scriptImagesToLoad: 0,
		scriptSoundsLoaded: 0, scriptSoundsToLoad: 0,
		backgroundmusic: {file: "audio/map_moonbase.ogg", title: "Break Out"},
		scriptLoadCall: function()
		{
			//if (this.scriptImagesLoaded > 0) return false;
			
			var mapCustomImages = {
				"moonbase_background": "background/moonbase.png"
			};
			var mapCustomSounds = {
				"levelbg": {
					src: "map_moonbase.ogg",
					data: {
						volume: 1,
						gamepad1Volume: 1,
						tvVolume: 1,
						loop: true,
						preload: "auto"
					},
					group: "music"
				}
			};
			
			var path = "media/", img;
			var list = mapCommonImages;
			for(var ID in list)
			{
				this.scriptImagesToLoad++;

				if (Render.images[ID] == undefined)
				{
					img = new Image();
					img.map = "moonbase";
					img.onload = _mapsImgOnLoad;
					img.src = path+list[ID];
					Render.images[ID] = img;
				} else this.scriptImagesLoaded++;
			}
			list = mapCustomImages;
			for(var ID in list)
			{
				this.scriptImagesToLoad++;

				if (Render.images[ID] == undefined)
				{
					img = new Image();
					img.map = "moonbase";
					img.onload = _mapsImgOnLoad;
					img.src = path+list[ID];
					Render.images[ID] = img;
				} else this.scriptImagesLoaded++;
			}
			
			//Load in Sound
			var path = "audio/", audio, lData;
			list = mapCommonSounds;
			for(var ID in list)
			{
				lData = list[ID];
				this.scriptSoundsToLoad++;
				
				if (Render.sounds[ID] == undefined)
				{
					Render.soundAdd(ID, path+lData.src, lData, function()
					{
						__Maps["moonbase"].scriptSoundsLoaded++;
					});
					Render.soundAddGroup(ID, lData.group);
				} else this.scriptSoundsLoaded++;
			}
			list = mapCustomSounds;
			for(var ID in list)
			{
				lData = list[ID];
				this.scriptSoundsToLoad++;
				
				if (Render.sounds[ID] == undefined)
				{
					Render.soundAdd(ID, path+lData.src, lData, function()
					{
						__Maps["moonbase"].scriptSoundsLoaded++;
					});
					Render.soundAddGroup(ID, lData.group);
				} else this.scriptSoundsLoaded++;
			}
		},
		scriptIsLoaded: function()
		{
			if (MapMoonbase != undefined
				&& this.scriptImagesLoaded == this.scriptImagesToLoad
				&& this.scriptSoundsLoaded == this.scriptSoundsToLoad
				&& mapCommonMediaToLoad == mapCommonMediaLoaded)
				this.scriptLoaded = true;
		},
		initCall: function(mode)
		{
			MapMoonbase.init({mode: mode});
		},
		scriptUnset: function()
		{
			var list = ["moonbase_background"];
			for(var key in list)
				delete Render.images[list[key]];

			var list = ["levelbg"];
			for(var key in list)
				delete Render.sounds[list[key]];
		},
		
		//Preview on Main Menu
		previewCanvas: null, previewContext: null,
		previewGenerate: function(width, height)
		{
			if (!this.previewCanvas)
			{
				this.previewCanvas = document.createElement("canvas");
				this.previewContext = this.previewCanvas.getContext("2d");
				this.previewCanvas.width = width;
				this.previewCanvas.height = height;

				this.previewImages["background"] = new Image();
				this.previewImages["background"].src = this.previewData.background;
				this.previewImages["enemy"] = new Image();
				this.previewImages["enemy"].src = this.previewData.enemyImg;

				var paths, path;
				for(var key in this.previewData.paths)
				{
					for(var i in this.previewData.paths[key].path)
					{
						this.previewData.paths[key].path[i].x0 = this.previewData.paths[key].path[i].x;
						this.previewData.paths[key].path[i].y0 = this.previewData.paths[key].path[i].y;
						this.previewData.paths[key].path[i].x *= width;
						this.previewData.paths[key].path[i].y *= height;
					}
				}
				
				var obj, pointMap;
				for(var i=0; i<this.previewData.maxEnemies; i++)
				{
					obj = {
						path: Math.floor(Math.random()*this.previewData.paths.length),
						point: 0, x: 0, y: 0
					};
					pointMap = this.previewData.paths[obj.path].path[0];
					obj.x = pointMap.x; obj.y = pointMap.y;
					this.previewData.enemies.push(obj);
				}
				
				return true;
			}
			var c = this.previewContext, imgs = this.previewImages;
			
			//Background
			c.drawImage(imgs.background, 0, 0, width, height);
			
			//Show Enemy Paths
			/*var paths, path;
			c.strokeStyle = "green";
			for(var key in this.previewData.paths)
			{
				paths = this.previewData.paths[key].path;
				
				c.beginPath();
				for(var i in paths)
				{
					path = paths[i];
					
					if (i == 0) c.moveTo(path.x, path.y);
					else c.lineTo(path.x, path.y);
				}
				c.stroke();
			}*/
			
			//Advance Enemies
			var obj, degree, endpath, w = 50, h = 25;
			for(var key in this.previewData.enemies)
			{
				obj = this.previewData.enemies[key];
				previewEnemyMovement(key, obj, this);
				
				endpath = this.previewData.paths[obj.path].path[this.previewData.paths[obj.path].path.length-1];
				degree = Render.determineAngle(obj.x, obj.y, endpath.x, endpath.y);
				c.save();
				c.translate(obj.x, obj.y);
				c.rotate(degree*Math.PI/180);
				c.drawImage(imgs.enemy, -w/2, 0, w, h);
				c.restore();
			}
		},
		previewData: {
			background: "media/maps/moonbase.jpg",
			paths: [{
				speed: 3.5,
				path: [{x:0.5,y:0},
				       {x:0.5,y:0.75}]
			}, {
				speed: 3.5,
				path: [{x:0.15,y:0},
				       {x:0.15,y:0.75}]
			}, {
				speed: 3.5,
				path: [{x:0.85,y:0},
				       {x:0.85,y:0.75}]
			}, {
				speed: 4.5,
				path: [{x:0.15,y:0},
				       {x:0.85,y:0.75}]
			}, {
				speed: 4.5,
				path: [{x:0.85,y:0},
				       {x:0.15,y:0.75}]
			}],
			enemies: [], maxEnemies: 2,
			enemyImg: "media/enemies/red1.png"
		},
		previewImages: {}
	},
	
	"nebula": {
		//disabled: true,
		title: "Nebula Ka'tlTa",
		src: "media/maps/ss001.jpg",
		online: {Hard: 12, Insanity: 13, Endless: 14},
		scriptLoaded: false,
		scriptImagesLoaded: 0, scriptImagesToLoad: 0,
		scriptSoundsLoaded: 0, scriptSoundsToLoad: 0,
		backgroundmusic: {file: "audio/map_nebula.ogg", title: "Cv-X"},
		scriptLoadCall: function()
		{
			//if (this.scriptImagesLoaded > 0) return false;
			
			var mapCustomImages = {
				"nebula_background1": "background/nebula1.png",
				"nebula_background2": "background/nebula2.png",
				"nebula_background3": "background/nebula3.png"
			};
			var mapCustomSounds = {
				"levelbg": {
					src: "map_nebula.ogg",
					data: {
						volume: 1,
						gamepad1Volume: 1,
						tvVolume: 1,
						loop: true,
						preload: "auto"
					},
					group: "music"
				}
			};
			
			var path = "media/", img;
			var list = mapCommonImages;
			for(var ID in list)
			{
				this.scriptImagesToLoad++;
				
				if (Render.images[ID] == undefined)
				{
					img = new Image();
					img.map = "nebula";
					img.onload = _mapsImgOnLoad;
					img.src = path+list[ID];
					Render.images[ID] = img;
				} else this.scriptImagesLoaded++;
			}
			var list = mapCustomImages;
			for(var ID in list)
			{
				this.scriptImagesToLoad++;
				
				if (Render.images[ID] == undefined)
				{
					img = new Image();
					img.map = "nebula";
					img.onload = _mapsImgOnLoad;
					img.src = path+list[ID];
					Render.images[ID] = img;
				} else this.scriptImagesLoaded++;
			}
			
			//Load in Sound
			var path = "audio/", audio, lData;
			list = mapCommonSounds;
			for(var ID in list)
			{
				lData = list[ID];
				this.scriptSoundsToLoad++;
				
				if (Render.sounds[ID] == undefined)
				{
					Render.soundAdd(ID, path+lData.src, lData, function()
					{
						__Maps["nebula"].scriptSoundsLoaded++;
					});
					Render.soundAddGroup(ID, lData.group);
				} else this.scriptSoundsLoaded++;
			}
			list = mapCustomSounds;
			for(var ID in list)
			{
				lData = list[ID];
				this.scriptSoundsToLoad++;
				
				if (Render.sounds[ID] == undefined)
				{
					Render.soundAdd(ID, path+lData.src, lData, function()
					{
						__Maps["nebula"].scriptSoundsLoaded++;
					});
					Render.soundAddGroup(ID, lData.group);
				} else this.scriptSoundsLoaded++;
			}
		},
		scriptIsLoaded: function()
		{
			if (MapNebula != undefined
				&& this.scriptImagesLoaded == this.scriptImagesToLoad
				&& this.scriptSoundsLoaded == this.scriptSoundsToLoad
				&& mapCommonMediaToLoad == mapCommonMediaLoaded)
				this.scriptLoaded = true;
		},
		initCall: function(mode)
		{
			MapNebula.init({mode: mode});
		},
		scriptUnset: function()
		{
			var list = ["nebula_background1", "nebula_background2", "nebula_background3"];
			for(var key in list)
				delete Render.images[list[key]];

			var list = ["levelbg"];
			for(var key in list)
				delete Render.sounds[list[key]];
		},
		
		//Preview on Main Menu
		previewCanvas: null, previewContext: null,
		previewGenerate: function(width, height)
		{
			if (!this.previewCanvas)
			{
				this.previewCanvas = document.createElement("canvas");
				this.previewContext = this.previewCanvas.getContext("2d");
				this.previewCanvas.width = width;
				this.previewCanvas.height = height;

				this.previewImages["background"] = new Image();
				this.previewImages["background"].src = this.previewData.background;
				this.previewImages["background2"] = new Image();
				this.previewImages["background2"].src = this.previewData.background2;
				this.previewImages["enemy"] = new Image();
				this.previewImages["enemy"].src = this.previewData.enemyImg;

				var paths, path;
				for(var key in this.previewData.paths)
				{
					for(var i in this.previewData.paths[key].path)
					{
						this.previewData.paths[key].path[i].x0 = this.previewData.paths[key].path[i].x;
						this.previewData.paths[key].path[i].y0 = this.previewData.paths[key].path[i].y;
						this.previewData.paths[key].path[i].x *= width;
						this.previewData.paths[key].path[i].y *= height;
					}
				}
				
				var obj, pointMap;
				for(var i=0; i<this.previewData.maxEnemies; i++)
				{
					obj = {
						path: Math.floor(Math.random()*this.previewData.paths.length),
						point: 0, x: 0, y: 0
					};
					pointMap = this.previewData.paths[obj.path].path[0];
					obj.x = pointMap.x; obj.y = pointMap.y;
					this.previewData.enemies.push(obj);
				}
				
				return true;
			}
			var c = this.previewContext, imgs = this.previewImages;
			c.clearRect(0, 0, width, height);

			c.drawImage(imgs.background, 0, 0, width, height);
			
			//Show Enemy Paths
			/*var paths, path;
			c.strokeStyle = "green";
			for(var key in this.previewData.paths)
			{
				paths = this.previewData.paths[key].path;
				
				c.beginPath();
				for(var i in paths)
				{
					path = paths[i];
					
					if (i == 0) c.moveTo(path.x, path.y);
					else c.lineTo(path.x, path.y);
				}
				c.stroke();
			}*/
			
			//Advance Enemies
			var obj, degree, endpath, w = 50, h = 25;
			for(var key in this.previewData.enemies)
			{
				obj = this.previewData.enemies[key];
				previewEnemyMovement(key, obj, this);
				
				endpath = this.previewData.paths[obj.path].path[this.previewData.paths[obj.path].path.length-1];
				degree = Render.determineAngle(obj.x, obj.y, endpath.x, endpath.y);
				c.save();
				c.translate(obj.x, obj.y);
				c.rotate(degree*Math.PI/180);
				c.drawImage(imgs.enemy, -w/2, 0, w, h);
				c.restore();
			}
			
			//Background
			c.globalAlpha = 0.75;
			c.drawImage(imgs.background2, 0, 0, width, height);
			c.globalAlpha = 1;
		},
		previewData: {
			background: "media/maps/nebula.jpg", background2: "media/maps/nebula.png",
			paths: [{
				speed: 2.5,
				path: [{x:0,y:0.25},
				       {x:0.4,y:0.5}]
			}, {
				speed: 2.5,
				path: [{x:1,y:0.3},
				       {x:0.55,y:0.5}]
			}, {
				speed: 2.5,
				path: [{x:1,y:0.8},
				       {x:0.55,y:0.6}]
			}],
			enemies: [], maxEnemies: 1,
			enemyImg: "media/enemies/red2.png"
		},
		previewImages: {}
	},
	
	
	"circle": {
		title: "Cir'ce Station",
		src: "media/maps/ss001.jpg",
		online: {Hard: 15, Insanity: 16, Endless: 17},
		scriptLoaded: false,
		scriptImagesLoaded: 0, scriptImagesToLoad: 0,
		scriptSoundsLoaded: 0, scriptSoundsToLoad: 0,
		backgroundmusic: {file: "audio/map_circle.ogg", title: "Bay Side"},
		scriptLoadCall: function()
		{
			//if (this.scriptImagesLoaded > 0) return false;
			
			var mapCustomImages = {
				"circle_two": "etc/circle_two.png",
				"circle_three": "etc/circle_three.png"
			};
			var mapCustomSounds = {
				"levelbg": {
					src: "map_circle.ogg",
					data: {
						volume: 1,
						gamepad1Volume: 1,
						tvVolume: 1,
						loop: true,
						preload: "auto"
					},
					group: "music"
				}
			};
			
			var path = "media/", img;
			var list = mapCommonImages;
			for(var ID in list)
			{
				this.scriptImagesToLoad++;
				
				if (Render.images[ID] == undefined)
				{
					img = new Image();
					img.map = "circle";
					img.onload = _mapsImgOnLoad;
					img.src = path+list[ID];
					Render.images[ID] = img;
				} else this.scriptImagesLoaded++;
			}
			var list = mapCustomImages;
			for(var ID in list)
			{
				this.scriptImagesToLoad++;
				
				if (Render.images[ID] == undefined)
				{
					img = new Image();
					img.map = "circle";
					img.onload = _mapsImgOnLoad;
					img.src = path+list[ID];
					Render.images[ID] = img;
				} else this.scriptImagesLoaded++;
			}
			
			//Load in Sound
			var path = "audio/", audio, lData;
			list = mapCommonSounds;
			for(var ID in list)
			{
				lData = list[ID];
				this.scriptSoundsToLoad++;
				
				if (Render.sounds[ID] == undefined)
				{
					Render.soundAdd(ID, path+lData.src, lData, function()
					{
						__Maps["circle"].scriptSoundsLoaded++;
					});
					Render.soundAddGroup(ID, lData.group);
				} else this.scriptSoundsLoaded++;
			}
			list = mapCustomSounds;
			for(var ID in list)
			{
				lData = list[ID];
				this.scriptSoundsToLoad++;
				
				if (Render.sounds[ID] == undefined)
				{
					Render.soundAdd(ID, path+lData.src, lData, function()
					{
						__Maps["circle"].scriptSoundsLoaded++;
					});
					Render.soundAddGroup(ID, lData.group);
				} else this.scriptSoundsLoaded++;
			}
		},
		scriptIsLoaded: function()
		{
			if (MapCircle != undefined
				&& this.scriptImagesLoaded == this.scriptImagesToLoad
				&& this.scriptSoundsLoaded == this.scriptSoundsToLoad
				&& mapCommonMediaToLoad == mapCommonMediaLoaded)
				this.scriptLoaded = true;
		},
		initCall: function(mode)
		{
			MapCircle.init({mode: mode});
		},
		scriptUnset: function()
		{
			var list = ["circle_two", "circle_three"];
			for(var key in list)
				delete Render.images[list[key]];

			var list = ["levelbg"];
			for(var key in list)
				delete Render.sounds[list[key]];
		},
		
		//Preview on Main Menu
		previewCanvas: null, previewContext: null,
		previewGenerate: function(width, height)
		{
			if (!this.previewCanvas)
			{
				this.previewCanvas = document.createElement("canvas");
				this.previewContext = this.previewCanvas.getContext("2d");
				this.previewCanvas.width = width;
				this.previewCanvas.height = height;

				this.previewImages["background"] = new Image();
				this.previewImages["background"].src = this.previewData.background;
				this.previewImages["base"] = new Image();
				this.previewImages["base"].src = this.previewData.baseImg;
				this.previewImages["heart"] = new Image();
				this.previewImages["heart"].src = this.previewData.heartImg;
				this.previewImages["circle"] = new Image();
				this.previewImages["circle"].src = this.previewData.circleImg;
				this.previewImages["enemy"] = new Image();
				this.previewImages["enemy"].src = this.previewData.enemyImg;

				var paths, path;
				for(var key in this.previewData.paths)
				{
					for(var i in this.previewData.paths[key].path)
					{
						this.previewData.paths[key].path[i].x0 = this.previewData.paths[key].path[i].x;
						this.previewData.paths[key].path[i].y0 = this.previewData.paths[key].path[i].y;
						this.previewData.paths[key].path[i].x *= width;
						this.previewData.paths[key].path[i].y *= height;
					}
				}
				
				var obj, pointMap;
				for(var i=0; i<this.previewData.maxEnemies; i++)
				{
					obj = {
						path: Math.floor(Math.random()*this.previewData.paths.length),
						point: 0, x: 0, y: 0
					};
					pointMap = this.previewData.paths[obj.path].path[0];
					obj.x = pointMap.x; obj.y = pointMap.y;
					this.previewData.enemies.push(obj);
				}
				
				return true;
			}
			var c = this.previewContext, imgs = this.previewImages;
			
			//Background
			c.drawImage(imgs.background, 0, 0, width, height);
			
			//Base
			c.save();
			c.translate(width/2, height/2);
			c.drawImage(imgs.base, -35, -35, 70, 70);
			c.drawImage(imgs.heart, -15, -15, 30, 30);
			c.restore();
			
			//Spinng Circle
			c.save();
			c.translate(width/2, height/2);
			c.rotate(this.previewData.circleDegree*Math.PI/180);
			c.drawImage(imgs.circle, -135, -135, 270, 270);
			c.restore();
			this.previewData.circleDegree += 3;
			if (this.previewData.circleDegree >= 360)
				this.previewData.circleDegree -= 360;
			
			//Show Enemy Paths
			/*var paths, path;
			c.strokeStyle = "green";
			for(var key in this.previewData.paths)
			{
				paths = this.previewData.paths[key].path;
				
				c.beginPath();
				for(var i in paths)
				{
					path = paths[i];
					
					if (i == 0) c.moveTo(path.x, path.y);
					else c.lineTo(path.x, path.y);
				}
				c.stroke();
			}*/
			
			//Advance Enemies
			var obj, degree, endpath, w = 50, h = 25;
			for(var key in this.previewData.enemies)
			{
				obj = this.previewData.enemies[key];
				previewEnemyMovement(key, obj, this);
				
				endpath = this.previewData.paths[obj.path].path[this.previewData.paths[obj.path].path.length-1];
				degree = Render.determineAngle(obj.x, obj.y, endpath.x, endpath.y);
				c.save();
				c.translate(obj.x, obj.y);
				c.rotate(degree*Math.PI/180);
				c.drawImage(imgs.enemy, -w/2, 0, w, h);
				c.restore();
			}
		},
		previewData: {
			background: "media/maps/hyperspace_bg1.jpg",
			baseImg: "media/base_spots/base.png",
			heartImg: "media/base_spots/heart.png",
			circleImg: "media/etc/circle_two.png", circleDegree: 0,
			paths: [{
				speed: 2.5,
				path: [{x:0.5,y:0},
				       {x:0.5,y:0.38}]
			}, {
				speed: 2.5,
				path: [{x:0,y:0.5},
				       {x:0.4,y:0.5}]
			}, {
				speed: 2.5,
				path: [{x:1,y:1},
				       {x:0.6,y:0.6}]
			}],
			enemies: [], maxEnemies: 1,
			enemyImg: "media/enemies/red1.png"
		},
		previewImages: {}
	},
	
	
	"twin": {
		title: "Twin Souls",
		src: "media/maps/ss001.jpg",
		online: {Hard: 18, Insanity: 19, Endless: 20},
		scriptLoaded: false,
		scriptImagesLoaded: 0, scriptImagesToLoad: 0,
		scriptSoundsLoaded: 0, scriptSoundsToLoad: 0,
		backgroundmusic: {file: "audio/map_twin.ogg", title: "Dream Master"},
		scriptLoadCall: function()
		{
			var mapCustomImages = {
				"circle_two": "etc/circle_two.png",
				"circle_three": "etc/circle_three.png"
			};
			var mapCustomSounds = {
				"levelbg": {
					src: "map_twin.ogg",
					data: {
						volume: 1,
						gamepad1Volume: 1,
						tvVolume: 1,
						loop: true,
						preload: "auto"
					},
					group: "music"
				}
			};
			
			var path = "media/", img;
			var list = mapCommonImages;
			for(var ID in list)
			{
				this.scriptImagesToLoad++;
				
				if (Render.images[ID] == undefined)
				{
					img = new Image();
					img.map = "twin";
					img.onload = _mapsImgOnLoad;
					img.src = path+list[ID];
					Render.images[ID] = img;
				} else this.scriptImagesLoaded++;
			}
			var list = mapCustomImages;
			for(var ID in list)
			{
				this.scriptImagesToLoad++;
				
				if (Render.images[ID] == undefined)
				{
					img = new Image();
					img.map = "twin";
					img.onload = _mapsImgOnLoad;
					img.src = path+list[ID];
					Render.images[ID] = img;
				} else this.scriptImagesLoaded++;
			}
			
			//Load in Sound
			var path = "audio/", audio, lData;
			list = mapCommonSounds;
			for(var ID in list)
			{
				lData = list[ID];
				this.scriptSoundsToLoad++;
				
				if (Render.sounds[ID] == undefined)
				{
					Render.soundAdd(ID, path+lData.src, lData, function()
					{
						__Maps["twin"].scriptSoundsLoaded++;
					});
					Render.soundAddGroup(ID, lData.group);
				} else this.scriptSoundsLoaded++;
			}
			list = mapCustomSounds;
			for(var ID in list)
			{
				lData = list[ID];
				this.scriptSoundsToLoad++;
				
				if (Render.sounds[ID] == undefined)
				{
					Render.soundAdd(ID, path+lData.src, lData, function()
					{
						__Maps["twin"].scriptSoundsLoaded++;
					});
					Render.soundAddGroup(ID, lData.group);
				} else this.scriptSoundsLoaded++;
			}
		},
		scriptIsLoaded: function()
		{
			if (MapTwin != undefined
				&& this.scriptImagesLoaded == this.scriptImagesToLoad
				&& this.scriptSoundsLoaded == this.scriptSoundsToLoad
				&& mapCommonMediaToLoad == mapCommonMediaLoaded)
				this.scriptLoaded = true;
		},
		initCall: function(mode)
		{
			MapTwin.init({mode: mode});
		},
		scriptUnset: function()
		{
			var list = ["circle_two", "circle_three"];
			for(var key in list)
				delete Render.images[list[key]];

			var list = ["levelbg"];
			for(var key in list)
				delete Render.sounds[list[key]];
		},
		
		//Preview on Main Menu
		previewCanvas: null, previewContext: null,
		previewGenerate: function(width, height)
		{
			if (!this.previewCanvas)
			{
				this.previewCanvas = document.createElement("canvas");
				this.previewContext = this.previewCanvas.getContext("2d");
				this.previewCanvas.width = width;
				this.previewCanvas.height = height;

				this.previewImages["background"] = new Image();
				this.previewImages["background"].src = this.previewData.background;
				this.previewImages["base"] = new Image();
				this.previewImages["base"].src = this.previewData.baseImg;
				this.previewImages["heart"] = new Image();
				this.previewImages["heart"].src = this.previewData.heartImg;
				this.previewImages["circle"] = new Image();
				this.previewImages["circle"].src = this.previewData.circleImg;
				this.previewImages["enemy"] = new Image();
				this.previewImages["enemy"].src = this.previewData.enemyImg;

				var paths, path;
				for(var key in this.previewData.paths)
				{
					for(var i in this.previewData.paths[key].path)
					{
						this.previewData.paths[key].path[i].x0 = this.previewData.paths[key].path[i].x;
						this.previewData.paths[key].path[i].y0 = this.previewData.paths[key].path[i].y;
						this.previewData.paths[key].path[i].x *= width;
						this.previewData.paths[key].path[i].y *= height;
					}
				}
				
				var obj, pointMap;
				for(var i=0; i<this.previewData.maxEnemies; i++)
				{
					obj = {
						path: Math.floor(Math.random()*this.previewData.paths.length),
						point: 0, x: 0, y: 0
					};
					pointMap = this.previewData.paths[obj.path].path[0];
					obj.x = pointMap.x; obj.y = pointMap.y;
					this.previewData.enemies.push(obj);
				}
				
				return true;
			}
			var c = this.previewContext, imgs = this.previewImages;
			
			//Background
			c.drawImage(imgs.background, 0, 0, width, height);
			
			//Base
			c.save();
			c.translate(width*0.7, height*0.3);
			c.drawImage(imgs.base, -35, -35, 70, 70);
			c.drawImage(imgs.heart, -15, -15, 30, 30);
			c.restore();
			c.save();
			c.translate(width*0.3, height*0.7);
			c.drawImage(imgs.base, -35, -35, 70, 70);
			c.drawImage(imgs.heart, -15, -15, 30, 30);
			c.restore();
			
			//Spinng Circle
			c.save();
			c.translate(width*0.7, height*0.3);
			c.rotate(this.previewData.circleDegree*Math.PI/180);
			c.drawImage(imgs.circle, -125, -125, 250, 250);
			c.restore();
			c.save();
			c.translate(width*0.3, height*0.7);
			c.rotate(-this.previewData.circleDegree*Math.PI/180);
			c.drawImage(imgs.circle, -125, -125, 250, 250);
			c.restore();
			this.previewData.circleDegree += 3;
			if (this.previewData.circleDegree >= 360)
				this.previewData.circleDegree -= 360;
			
			//Show Enemy Paths
			/*var paths, path;
			c.strokeStyle = "green";
			for(var key in this.previewData.paths)
			{
				paths = this.previewData.paths[key].path;
				
				c.beginPath();
				for(var i in paths)
				{
					path = paths[i];
					
					if (i == 0) c.moveTo(path.x, path.y);
					else c.lineTo(path.x, path.y);
				}
				c.stroke();
			}*/
			
			//Advance Enemies
			var obj, degree, endpath, w = 50, h = 25;
			for(var key in this.previewData.enemies)
			{
				obj = this.previewData.enemies[key];
				previewEnemyMovement(key, obj, this);
				
				endpath = this.previewData.paths[obj.path].path[this.previewData.paths[obj.path].path.length-1];
				degree = Render.determineAngle(obj.x, obj.y, endpath.x, endpath.y);
				c.save();
				c.translate(obj.x, obj.y);
				c.rotate(degree*Math.PI/180);
				c.drawImage(imgs.enemy, -w/2, 0, w, h);
				c.restore();
			}
		},
		previewData: {
			background: "media/maps/hyperspace_bg2.jpg",
			baseImg: "media/base_spots/base.png",
			heartImg: "media/base_spots/heart.png",
			circleImg: "media/etc/circle_two.png", circleDegree: 0,
			paths: [{
				speed: 2.5,
				path: [{x:1,y:0},
				       {x:0.7,y:0.3}]
			}, {
				speed: 2.5,
				path: [{x:1,y:1},
				       {x:0.7,y:0.3}]
			}, {
				speed: 2.5,
				path: [{x:0,y:1},
				       {x:0.3,y:0.7}]
			}, {
				speed: 2.5,
				path: [{x:0,y:0},
				       {x:0.3,y:0.7}]
			}],
			enemies: [], maxEnemies: 1,
			enemyImg: "media/enemies/red1.png"
		},
		previewImages: {}
	},
	
	
	"ams2": {
		//disabled: true,
		title: "Asteroid Mining Station 2",
		src: "media/maps/ams2.jpg",
		online: {Hard: 21, Insanity: 22, Endless: 23},
		scriptLoaded: false,
		scriptImagesLoaded: 0, scriptImagesToLoad: 0,
		scriptSoundsLoaded: 0, scriptSoundsToLoad: 0,
		backgroundmusic: {file: "audio/map_ams2.ogg", title: "Derelict"},
		scriptLoadCall: function()
		{
			var mapCustomImages = {
				"ams2_background": "background/ams2.png",
				"ams2_background2": "background/ams2-2.png",
			};
			var mapCustomSounds = {
				"levelbg": {
					src: "map_ams2.ogg",
					data: {
						volume: 1,
						gamepad1Volume: 1,
						tvVolume: 1,
						loop: true,
						preload: "auto"
					},
					group: "music"
				}
			};
			
			var path = "media/", img;
			var list = mapCommonImages;
			for(var ID in list)
			{
				this.scriptImagesToLoad++;
				
				if (Render.images[ID] == undefined)
				{
					img = new Image();
					img.map = "ams2";
					img.onload = _mapsImgOnLoad;
					img.src = path+list[ID];
					Render.images[ID] = img;
				} else this.scriptImagesLoaded++;
			}
			var list = mapCustomImages;
			for(var ID in list)
			{
				this.scriptImagesToLoad++;
				
				if (Render.images[ID] == undefined)
				{
					img = new Image();
					img.map = "ams2";
					img.onload = _mapsImgOnLoad;
					img.src = path+list[ID];
					Render.images[ID] = img;
				} else this.scriptImagesLoaded++;
			}
			
			//Load in Sound
			var path = "audio/", audio, lData;
			list = mapCommonSounds;
			for(var ID in list)
			{
				lData = list[ID];
				this.scriptSoundsToLoad++;
				
				if (Render.sounds[ID] == undefined)
				{
					Render.soundAdd(ID, path+lData.src, lData, function()
					{
						__Maps["ams2"].scriptSoundsLoaded++;
					});
					Render.soundAddGroup(ID, lData.group);
				} else this.scriptSoundsLoaded++;
			}
			list = mapCustomSounds;
			for(var ID in list)
			{
				lData = list[ID];
				this.scriptSoundsToLoad++;
				
				if (Render.sounds[ID] == undefined)
				{
					Render.soundAdd(ID, path+lData.src, lData, function()
					{
						__Maps["ams2"].scriptSoundsLoaded++;
					});
					Render.soundAddGroup(ID, lData.group);
				} else this.scriptSoundsLoaded++;
			}
		},
		scriptIsLoaded: function()
		{
			if (MapAMS2 != undefined
				&& this.scriptImagesLoaded == this.scriptImagesToLoad
				&& this.scriptSoundsLoaded == this.scriptSoundsToLoad
				&& mapCommonMediaToLoad == mapCommonMediaLoaded)
				this.scriptLoaded = true;
		},
		initCall: function(mode)
		{
			MapAMS2.init({mode: mode});
		},
		scriptUnset: function()
		{
			var list = ["ams2_background", "ams2_background2"];
			for(var key in list)
				delete Render.images[list[key]];

			var list = ["levelbg"];
			for(var key in list)
				delete Render.sounds[list[key]];
		},
		
		//Preview on Main Menu
		previewCanvas: null, previewContext: null,
		previewGenerate: function(width, height)
		{
			if (!this.previewCanvas)
			{
				this.previewCanvas = document.createElement("canvas");
				this.previewContext = this.previewCanvas.getContext("2d");
				this.previewCanvas.width = width;
				this.previewCanvas.height = height;

				this.previewImages["background"] = new Image();
				this.previewImages["background"].src = this.previewData.background;
				this.previewImages["enemy"] = new Image();
				this.previewImages["enemy"].src = this.previewData.enemyImg;

				var paths, path;
				for(var key in this.previewData.paths)
				{
					for(var i in this.previewData.paths[key].path)
					{
						this.previewData.paths[key].path[i].x0 = this.previewData.paths[key].path[i].x;
						this.previewData.paths[key].path[i].y0 = this.previewData.paths[key].path[i].y;
						this.previewData.paths[key].path[i].x *= width;
						this.previewData.paths[key].path[i].y *= height;
					}
				}
				
				var obj, pointMap;
				for(var i=0; i<this.previewData.maxEnemies; i++)
				{
					obj = {
						path: Math.floor(Math.random()*this.previewData.paths.length),
						point: 0, x: 0, y: 0
					};
					pointMap = this.previewData.paths[obj.path].path[0];
					obj.x = pointMap.x; obj.y = pointMap.y;
					this.previewData.enemies.push(obj);
				}
				
				return true;
			}
			var c = this.previewContext, imgs = this.previewImages;
			
			//Background
			c.drawImage(imgs.background, 0, 0, width, height);
			
			//Show Enemy Paths
			/*var paths, path;
			c.strokeStyle = "green";
			for(var key in this.previewData.paths)
			{
				paths = this.previewData.paths[key].path;
				
				c.beginPath();
				for(var i in paths)
				{
					path = paths[i];
					
					if (i == 0) c.moveTo(path.x, path.y);
					else c.lineTo(path.x, path.y);
				}
				c.stroke();
			}*/
			
			//Advance Enemies
			var obj, degree, endpath, w = 50, h = 25;
			for(var key in this.previewData.enemies)
			{
				obj = this.previewData.enemies[key];
				previewEnemyMovement(key, obj, this);
				
				endpath = this.previewData.paths[obj.path].path[this.previewData.paths[obj.path].path.length-1];
				degree = Render.determineAngle(obj.x, obj.y, endpath.x, endpath.y);
				c.save();
				c.translate(obj.x, obj.y);
				c.rotate(degree*Math.PI/180);
				c.drawImage(imgs.enemy, -w/2, 0, w, h);
				c.restore();
			}
		},
		previewData: {
			background: "media/maps/ams2.jpg",
			paths: [{
				speed: 2.5,
				path: [{x:0.5,y:0.5},
				       {x:.1,y:0.1}]
			}, {
				speed: 2.5,
				path: [{x:0.5,y:0.5},
				       {x:0.9,y:0.1}]
			}, {
				speed: 2.5,
				path: [{x:0.5,y:0.5},
				       {x:0.9,y:0.9}]
			}, {
				speed: 2.5,
				path: [{x:0.5,y:0.5},
				       {x:0.1,y:0.9}]
			}],
			enemies: [], maxEnemies: 2,
			enemyImg: "media/enemies/red2.png"
		},
		previewImages: {}
	},
	

	"ping15plus": {
		title: "PING 1.5+",
		src: "media/maps/ss001.jpg",
		online: {Hard: 24, Insanity: 25, Endless: 26},
		scriptLoaded: false,
		scriptImagesLoaded: 0, scriptImagesToLoad: 0,
		scriptSoundsLoaded: 0, scriptSoundsToLoad: 0,
		backgroundmusic: {file: "audio/map_ping.ogg", title: "Xeno Blaster"},
		scriptLoadCall: function()
		{
			//if (this.scriptImagesLoaded > 0) return false;
			
			var mapCustomImages = {
				"ping_bg": "background/ping15plus.png"
			};
			var mapCustomSounds = {
				"levelbg": {
					src: "map_ping.ogg",
					data: {
						volume: 0.9,
						gamepad1Volume: 0.9,
						tvVolume: 0.9,
						loop: true,
						preload: "auto"
					},
					group: "music"
				},
				"ping_bounce": {
					src: "ping_bounce.wav",
					data: {
						volume: 0.9,
						gamepad1Volume: 0.9,
						tvVolume: 0.9,
						loop: false,
						preload: "auto"
					},
					group: "etc"
				},
				"ping_break": {
					src: "ping_break.wav",
					data: {
						volume: 0.9,
						gamepad1Volume: 0.9,
						tvVolume: 0.9,
						loop: false,
						preload: "auto"
					},
					group: "etc"
				}
			};
			
			var path = "media/", img;
			var list = mapCommonImages;
			for(var ID in list)
			{
				this.scriptImagesToLoad++;
				
				if (Render.images[ID] == undefined)
				{
					img = new Image();
					img.map = "ping15plus";
					img.onload = _mapsImgOnLoad;
					img.src = path+list[ID];
					Render.images[ID] = img;
				} else this.scriptImagesLoaded++;
			}
			list = mapCustomImages;
			for(var ID in list)
			{
				this.scriptImagesToLoad++;

				if (Render.images[ID] == undefined)
				{
					img = new Image();
					img.map = "ping15plus";
					img.onload = _mapsImgOnLoad;
					img.src = path+list[ID];
					Render.images[ID] = img;
				} else this.scriptImagesLoaded++;
			}
			
			//Load in Sound
			var path = "audio/", audio, lData;
			list = mapCommonSounds;
			for(var ID in list)
			{
				lData = list[ID];
				this.scriptSoundsToLoad++;
				
				if (Render.sounds[ID] == undefined)
				{
					Render.soundAdd(ID, path+lData.src, lData, function()
					{
						__Maps["ping15plus"].scriptSoundsLoaded++;
					});
					Render.soundAddGroup(ID, lData.group);
				} else this.scriptSoundsLoaded++;
			}
			list = mapCustomSounds;
			for(var ID in list)
			{
				lData = list[ID];
				this.scriptSoundsToLoad++;
				
				if (Render.sounds[ID] == undefined)
				{
					Render.soundAdd(ID, path+lData.src, lData, function()
					{
						__Maps["ping15plus"].scriptSoundsLoaded++;
					});
					Render.soundAddGroup(ID, lData.group);
				} else this.scriptSoundsLoaded++;
			}
		},
		scriptIsLoaded: function()
		{
			if (MapPING15Plus != undefined
				&& this.scriptImagesLoaded == this.scriptImagesToLoad
				&& this.scriptSoundsLoaded == this.scriptSoundsToLoad
				&& mapCommonMediaToLoad == mapCommonMediaLoaded)
				this.scriptLoaded = true;
		},
		initCall: function(mode)
		{
			MapPING15Plus.init({mode: mode});
		},
		scriptUnset: function()
		{
			var list = ["ping_bg"];
			for(var key in list)
				delete Render.images[list[key]];

			var list = ["levelbg", "ping_bounce", "ping_break"];
			for(var key in list)
				delete Render.sounds[list[key]];
		},
		
		//Preview on Main Menu
		previewCanvas: null, previewContext: null,
		previewGenerate: function(width, height)
		{
			if (!this.previewCanvas)
			{
				this.previewCanvas = document.createElement("canvas");
				this.previewContext = this.previewCanvas.getContext("2d");
				this.previewCanvas.width = width;
				this.previewCanvas.height = height;

				this.previewImages["background"] = new Image();
				this.previewImages["background"].src = this.previewData.background;
				
				return true;
			}
			var c = this.previewContext, imgs = this.previewImages;
			
			//Background
			c.drawImage(imgs.background, 0, 0, width, height);
		},
		previewData: {
			background: "media/maps/ping.png",
			paths: [{
				speed: 2.5,
				path: [{x:0.5,y:0},
				       {x:0.5,y:0.38}]
			}, {
				speed: 2.5,
				path: [{x:0,y:0.5},
				       {x:0.4,y:0.5}]
			}, {
				speed: 2.5,
				path: [{x:1,y:1},
				       {x:0.6,y:0.6}]
			}],
			enemies: [], maxEnemies: 1,
			enemyImg: "media/enemies/red1.png"
		},
		previewImages: {}
	},
	
	
	"bdu": {
		title: "BLOK DROP U",
		src: "media/maps/ss001.jpg",
		online: {Hard: 27, Insanity: 28, Endless: 29},
		scriptLoaded: false,
		scriptImagesLoaded: 0, scriptImagesToLoad: 0,
		scriptSoundsLoaded: 0, scriptSoundsToLoad: 0,
		backgroundmusic: {file: "audio/map_bdu.ogg", title: "In Circles"},
		scriptLoadCall: function()
		{
			var mapCustomImages = {
				"bdu_background": "background/bdu.png",
				"bdu_ground": "etc/bdu_ground.png",
				"bdu_blok1": "etc/bdu_blok1.png",
				"bdu_blok2": "etc/bdu_blok2.png",
				"bdu_blok3": "etc/bdu_blok3.png",
				"bdu_blade": "etc/bdu_blade.png",
				"bdu_blade_shadow": "etc/bdu_blade_shadow.png",
				"bdu_ball": "etc/bdu_ball.png",
				"bdu_bounce": "etc/bdu_bounce.png"
			};
			var mapCustomSounds = {
				"levelbg": {
					src: "map_bdu.ogg",
					data: {
						volume: 0.9,
						gamepad1Volume: 0.9,
						tvVolume: 0.9,
						loop: true,
						preload: "auto"
					},
					group: "music"
				}
			};
			
			var path = "media/", img;
			var list = mapCommonImages;
			for(var ID in list)
			{
				this.scriptImagesToLoad++;
				
				if (Render.images[ID] == undefined)
				{
					img = new Image();
					img.map = "bdu";
					img.onload = _mapsImgOnLoad;
					img.src = path+list[ID];
					Render.images[ID] = img;
				} else this.scriptImagesLoaded++;
			}
			list = mapCustomImages;
			for(var ID in list)
			{
				this.scriptImagesToLoad++;

				if (Render.images[ID] == undefined)
				{
					img = new Image();
					img.map = "bdu";
					img.onload = _mapsImgOnLoad;
					img.src = path+list[ID];
					Render.images[ID] = img;
				} else this.scriptImagesLoaded++;
			}
			
			//Load in Sound
			var path = "audio/", audio, lData;
			list = mapCommonSounds;
			for(var ID in list)
			{
				lData = list[ID];
				this.scriptSoundsToLoad++;
				
				if (Render.sounds[ID] == undefined)
				{
					Render.soundAdd(ID, path+lData.src, lData, function()
					{
						__Maps["bdu"].scriptSoundsLoaded++;
					});
					Render.soundAddGroup(ID, lData.group);
				} else this.scriptSoundsLoaded++;
			}
			list = mapCustomSounds;
			for(var ID in list)
			{
				lData = list[ID];
				this.scriptSoundsToLoad++;
				
				if (Render.sounds[ID] == undefined)
				{
					Render.soundAdd(ID, path+lData.src, lData, function()
					{
						__Maps["bdu"].scriptSoundsLoaded++;
					});
					Render.soundAddGroup(ID, lData.group);
				} else this.scriptSoundsLoaded++;
			}
		},
		scriptIsLoaded: function()
		{
			if (MapBDU != undefined
				&& this.scriptImagesLoaded == this.scriptImagesToLoad
				&& this.scriptSoundsLoaded == this.scriptSoundsToLoad
				&& mapCommonMediaToLoad == mapCommonMediaLoaded)
				this.scriptLoaded = true;
		},
		initCall: function(mode)
		{
			MapBDU.init({mode: mode});
		},
		scriptUnset: function()
		{
			var list = ["bdu_background", "bdu_ground", "bdu_blok1", "bdu_blok2", "bdu_blok3", "bdu_blade", "bdu_blade_shadow", "bdu_ball",
			            "bdu_bounce"];
			for(var key in list)
				delete Render.images[list[key]];

			var list = ["levelbg"];
			for(var key in list)
				delete Render.sounds[list[key]];
		},
		
		//Preview on Main Menu
		previewCanvas: null, previewContext: null,
		previewGenerate: function(width, height)
		{
			if (!this.previewCanvas)
			{
				this.previewCanvas = document.createElement("canvas");
				this.previewContext = this.previewCanvas.getContext("2d");
				this.previewCanvas.width = width;
				this.previewCanvas.height = height;

				this.previewImages["background"] = new Image();
				this.previewImages["background"].src = this.previewData.background;
				
				return true;
			}
			var c = this.previewContext, imgs = this.previewImages;
			
			//Background
			c.drawImage(imgs.background, 0, 0, width, height);
		},
		previewData: {
			background: "media/maps/bdu.png",
			paths: [{
				speed: 2.5,
				path: [{x:0.5,y:0},
				       {x:0.5,y:0.38}]
			}, {
				speed: 2.5,
				path: [{x:0,y:0.5},
				       {x:0.4,y:0.5}]
			}, {
				speed: 2.5,
				path: [{x:1,y:1},
				       {x:0.6,y:0.6}]
			}],
			enemies: [], maxEnemies: 1,
			enemyImg: "media/enemies/red1.png"
		},
		previewImages: {}
	},
	
	
	"gaf": {
		title: "GAF",
		src: "media/maps/ss001.jpg",
		online: {Hard: 30, Insanity: 31, Endless: 32},
		scriptLoaded: false,
		scriptImagesLoaded: 0, scriptImagesToLoad: 0,
		scriptSoundsLoaded: 0, scriptSoundsToLoad: 0,
		backgroundmusic: {file: "audio/map_gaf.ogg", title: "X To Fly"},
		scriptLoadCall: function()
		{
			var mapCustomImages = {
				"gaf_background": "background/gaf.png",
				"gaf_gold_background": "background/gaf_gold.png",
			};
			var mapCustomSounds = {
				"levelbg": {
					src: "map_gaf.ogg",
					data: {
						volume: 0.8,
						gamepad1Volume: 0.8,
						tvVolume: 0.8,
						loop: true,
						preload: "auto"
					},
					group: "music"
				}
			};
			
			var path = "media/", img;
			var list = mapCommonImages;
			for(var ID in list)
			{
				this.scriptImagesToLoad++;
				
				if (Render.images[ID] == undefined)
				{
					img = new Image();
					img.map = "gaf";
					img.onload = _mapsImgOnLoad;
					img.src = path+list[ID];
					Render.images[ID] = img;
				} else this.scriptImagesLoaded++;
			}
			list = mapCustomImages;
			for(var ID in list)
			{
				this.scriptImagesToLoad++;

				if (Render.images[ID] == undefined)
				{
					img = new Image();
					img.map = "gaf";
					img.onload = _mapsImgOnLoad;
					img.src = path+list[ID];
					Render.images[ID] = img;
				} else this.scriptImagesLoaded++;
			}
			
			//Load in Sound
			var path = "audio/", audio, lData;
			list = mapCommonSounds;
			for(var ID in list)
			{
				lData = list[ID];
				this.scriptSoundsToLoad++;
				
				if (Render.sounds[ID] == undefined)
				{
					Render.soundAdd(ID, path+lData.src, lData, function()
					{
						__Maps["gaf"].scriptSoundsLoaded++;
					});
					Render.soundAddGroup(ID, lData.group);
				} else this.scriptSoundsLoaded++;
			}
			list = mapCustomSounds;
			for(var ID in list)
			{
				lData = list[ID];
				this.scriptSoundsToLoad++;
				
				if (Render.sounds[ID] == undefined)
				{
					Render.soundAdd(ID, path+lData.src, lData, function()
					{
						__Maps["gaf"].scriptSoundsLoaded++;
					});
					Render.soundAddGroup(ID, lData.group);
				} else this.scriptSoundsLoaded++;
			}
		},
		scriptIsLoaded: function()
		{
			if (MapGAF != undefined
				&& this.scriptImagesLoaded == this.scriptImagesToLoad
				&& this.scriptSoundsLoaded == this.scriptSoundsToLoad
				&& mapCommonMediaToLoad == mapCommonMediaLoaded)
				this.scriptLoaded = true;
		},
		initCall: function(mode)
		{
			MapGAF.init({mode: mode});
		},
		scriptUnset: function()
		{
			var list = ["gaf_background", "gaf_gold_background"];
			for(var key in list)
				delete Render.images[list[key]];

			var list = ["levelbg"];
			for(var key in list)
				delete Render.sounds[list[key]];
		},
		
		//Preview on Main Menu
		previewCanvas: null, previewContext: null,
		previewGenerate: function(width, height)
		{
			if (!this.previewCanvas)
			{
				this.previewCanvas = document.createElement("canvas");
				this.previewContext = this.previewCanvas.getContext("2d");
				this.previewCanvas.width = width;
				this.previewCanvas.height = height;

				this.previewImages["background"] = new Image();
				this.previewImages["background"].src = this.previewData.background;
				
				return true;
			}
			var c = this.previewContext, imgs = this.previewImages;
			
			//Background
			c.drawImage(imgs.background, 0, 0, width, height);
		},
		previewData: {
			background: "media/maps/gaf.png",
			paths: [{
				speed: 2.5,
				path: [{x:0.5,y:0},
				       {x:0.5,y:0.38}]
			}, {
				speed: 2.5,
				path: [{x:0,y:0.5},
				       {x:0.4,y:0.5}]
			}, {
				speed: 2.5,
				path: [{x:1,y:1},
				       {x:0.6,y:0.6}]
			}],
			enemies: [], maxEnemies: 1,
			enemyImg: "media/enemies/red1.png"
		},
		previewImages: {}
	},
	
	
	"pollux": {
		title: "Pollux System",
		src: "media/maps/ss001.jpg",
		online: {Hard: 33, Insanity: 34, Endless: 35},
		scriptLoaded: false,
		scriptImagesLoaded: 0, scriptImagesToLoad: 0,
		scriptSoundsLoaded: 0, scriptSoundsToLoad: 0,
		backgroundmusic: {file: "audio/map_pollux.ogg", title: "Mechanikal"},
		scriptLoadCall: function()
		{
			var mapCustomImages = {
				"pollux1": "etc/pollux1.png",
				"pollux2": "etc/pollux2.png",
				"pollux3": "etc/pollux3.png",
				"pollux1_edge": "etc/pollux1_edge.png",
				"pollux2_edge": "etc/pollux2_edge.png",
				"pollux3_edge": "etc/pollux3_edge.png",
				
				/*"planet_brown": "etc/planet_brown.png",
				"planet_blue": "etc/planet_blue.png",
				"planet_red": "etc/planet_red.png",
				"planet_green": "etc/planet_green.png"*/
			};
			var mapCustomSounds = {
				"levelbg": {
					src: "map_pollux.ogg",
					data: {
						volume: 0.8,
						gamepad1Volume: 1.0,
						tvVolume: 1.0,
						loop: true,
						preload: "auto"
					},
					group: "music"
				}
			};
			
			var path = "media/", img;
			var list = mapCommonImages;
			for(var ID in list)
			{
				this.scriptImagesToLoad++;
				
				if (Render.images[ID] == undefined)
				{
					img = new Image();
					img.map = "pollux";
					img.onload = _mapsImgOnLoad;
					img.src = path+list[ID];
					Render.images[ID] = img;
				} else this.scriptImagesLoaded++;
			}
			list = mapCustomImages;
			for(var ID in list)
			{
				this.scriptImagesToLoad++;

				if (Render.images[ID] == undefined)
				{
					img = new Image();
					img.map = "pollux";
					img.onload = _mapsImgOnLoad;
					img.src = path+list[ID];
					Render.images[ID] = img;
				} else this.scriptImagesLoaded++;
			}
			
			//Load in Sound
			var path = "audio/", audio, lData;
			list = mapCommonSounds;
			for(var ID in list)
			{
				lData = list[ID];
				this.scriptSoundsToLoad++;
				
				if (Render.sounds[ID] == undefined)
				{
					Render.soundAdd(ID, path+lData.src, lData, function()
					{
						__Maps["pollux"].scriptSoundsLoaded++;
					});
					Render.soundAddGroup(ID, lData.group);
				} else this.scriptSoundsLoaded++;
			}
			list = mapCustomSounds;
			for(var ID in list)
			{
				lData = list[ID];
				this.scriptSoundsToLoad++;
				
				if (Render.sounds[ID] == undefined)
				{
					Render.soundAdd(ID, path+lData.src, lData, function()
					{
						__Maps["pollux"].scriptSoundsLoaded++;
					});
					Render.soundAddGroup(ID, lData.group);
				} else this.scriptSoundsLoaded++;
			}
		},
		scriptIsLoaded: function()
		{
			if (MapPollux != undefined
				&& this.scriptImagesLoaded == this.scriptImagesToLoad
				&& this.scriptSoundsLoaded == this.scriptSoundsToLoad
				&& mapCommonMediaToLoad == mapCommonMediaLoaded)
				this.scriptLoaded = true;
		},
		initCall: function(mode)
		{
			MapPollux.init({mode: mode});
		},
		scriptUnset: function()
		{
			var list = ["pollux1", "pollux2", "pollux3", "pollux_edge1", "pollux_edge2", "pollux_edge3"];
			for(var key in list)
				delete Render.images[list[key]];

			var list = ["levelbg"];
			for(var key in list)
				delete Render.sounds[list[key]];
		},
		
		//Preview on Main Menu
		previewCanvas: null, previewContext: null,
		previewGenerate: function(width, height)
		{
			if (!this.previewCanvas)
			{
				this.previewCanvas = document.createElement("canvas");
				this.previewContext = this.previewCanvas.getContext("2d");
				this.previewCanvas.width = width;
				this.previewCanvas.height = height;
	
				this.previewImages["background"] = new Image();
				this.previewImages["background"].src = this.previewData.background;
				this.previewImages["enemy"] = new Image();
				this.previewImages["enemy"].src = this.previewData.enemyImg;
	
				var paths, path;
				for(var key in this.previewData.paths)
				{
					for(var i in this.previewData.paths[key].path)
					{
						this.previewData.paths[key].path[i].x0 = this.previewData.paths[key].path[i].x;
						this.previewData.paths[key].path[i].y0 = this.previewData.paths[key].path[i].y;
						this.previewData.paths[key].path[i].x *= width;
						this.previewData.paths[key].path[i].y *= height;
					}
				}
				
				var obj, pointMap;
				for(var i=0; i<this.previewData.maxEnemies; i++)
				{
					obj = {
						path: Math.floor(Math.random()*this.previewData.paths.length),
						point: 0, x: 0, y: 0
					};
					pointMap = this.previewData.paths[obj.path].path[0];
					obj.x = pointMap.x; obj.y = pointMap.y;
					this.previewData.enemies.push(obj);
				}
				
				return true;
			}
			var c = this.previewContext, imgs = this.previewImages;
			
			//Background
			c.drawImage(imgs.background, 0, 0, width, height);
			
			//Show Enemy Paths
			/*var paths, path;
			c.strokeStyle = "green";
			for(var key in this.previewData.paths)
			{
				paths = this.previewData.paths[key].path;
				
				c.beginPath();
				for(var i in paths)
				{
					path = paths[i];
					
					if (i == 0) c.moveTo(path.x, path.y);
					else c.lineTo(path.x, path.y);
				}
				c.stroke();
			}*/
			
			//Advance Enemies
			var obj, degree, endpath, w = 50, h = 25;
			for(var key in this.previewData.enemies)
			{
				obj = this.previewData.enemies[key];
				previewEnemyMovement(key, obj, this);
				
				endpath = this.previewData.paths[obj.path].path[this.previewData.paths[obj.path].path.length-1];
				degree = Render.determineAngle(obj.x, obj.y, endpath.x, endpath.y);
				c.save();
				c.translate(obj.x, obj.y);
				c.rotate(degree*Math.PI/180);
				c.drawImage(imgs.enemy, -w/2, 0, w, h);
				c.restore();
			}
		},
		previewData: {
			background: "media/maps/pollux.jpg",
			paths: [{
				speed: 2.5,
				path: [{x:0,y:0.3},
				       {x:0.45,y:0.5}]
			}, {
				speed: 2.5,
				path: [{x:0,y:0.5},
				       {x:0.45,y:0.5}]
			}, {
				speed: 2.5,
				path: [{x:0,y:0.7},
				       {x:0.45,y:0.5}]
			}],
			enemies: [], maxEnemies: 1,
			enemyImg: "media/enemies/red2.png"
		},
		previewImages: {}
	}/*,
	
	
	"karabelt": {
		title: "Ka'Ra Belt",
		src: "media/maps/ss001.jpg",
		online: {Hard: 30, Insanity: 31, Endless: 32},
		scriptLoaded: false,
		scriptImagesLoaded: 0, scriptImagesToLoad: 0,
		scriptSoundsLoaded: 0, scriptSoundsToLoad: 0,
		backgroundmusic: {file: "audio/map_gaf.ogg", title: "X To Fly"},
		scriptLoadCall: function()
		{
			var mapCustomImages = {};
			var mapCustomSounds = {
				"levelbg": {
					src: "map_gaf.ogg",
					data: {
						volume: 0.8,
						gamepad1Volume: 0.8,
						tvVolume: 0.8,
						loop: true,
						preload: "auto"
					},
					group: "music"
				}
			};
			
			var path = "media/", img;
			var list = mapCommonImages;
			for(var ID in list)
			{
				this.scriptImagesToLoad++;
				
				if (Render.images[ID] == undefined)
				{
					img = new Image();
					img.map = "karabelt";
					img.onload = _mapsImgOnLoad;
					img.src = path+list[ID];
					Render.images[ID] = img;
				} else this.scriptImagesLoaded++;
			}
			list = mapCustomImages;
			for(var ID in list)
			{
				this.scriptImagesToLoad++;

				if (Render.images[ID] == undefined)
				{
					img = new Image();
					img.map = "karabelt";
					img.onload = _mapsImgOnLoad;
					img.src = path+list[ID];
					Render.images[ID] = img;
				} else this.scriptImagesLoaded++;
			}
			
			//Load in Sound
			var path = "audio/", audio, lData;
			list = mapCommonSounds;
			for(var ID in list)
			{
				lData = list[ID];
				this.scriptSoundsToLoad++;
				
				if (Render.sounds[ID] == undefined)
				{
					Render.soundAdd(ID, path+lData.src, lData, function()
					{
						__Maps["karabelt"].scriptSoundsLoaded++;
					});
					Render.soundAddGroup(ID, lData.group);
				} else this.scriptSoundsLoaded++;
			}
			list = mapCustomSounds;
			for(var ID in list)
			{
				lData = list[ID];
				this.scriptSoundsToLoad++;
				
				if (Render.sounds[ID] == undefined)
				{
					Render.soundAdd(ID, path+lData.src, lData, function()
					{
						__Maps["karabelt"].scriptSoundsLoaded++;
					});
					Render.soundAddGroup(ID, lData.group);
				} else this.scriptSoundsLoaded++;
			}
		},
		scriptIsLoaded: function()
		{
			if (MapKaRaBelt != undefined
				&& this.scriptImagesLoaded == this.scriptImagesToLoad
				&& this.scriptSoundsLoaded == this.scriptSoundsToLoad
				&& mapCommonMediaToLoad == mapCommonMediaLoaded)
				this.scriptLoaded = true;
		},
		initCall: function(mode)
		{
			MapKaRaBelt.init({mode: mode});
		},
		scriptUnset: function()
		{
			var list = [];
			for(var key in list)
				delete Render.images[list[key]];

			var list = ["levelbg"];
			for(var key in list)
				delete Render.sounds[list[key]];
		},
		
		//Preview on Main Menu
		previewCanvas: null, previewContext: null,
		previewGenerate: function(width, height)
		{
			if (!this.previewCanvas)
			{
				this.previewCanvas = document.createElement("canvas");
				this.previewContext = this.previewCanvas.getContext("2d");
				this.previewCanvas.width = width;
				this.previewCanvas.height = height;

				this.previewImages["background"] = new Image();
				this.previewImages["background"].src = this.previewData.background;
				
				return true;
			}
			var c = this.previewContext, imgs = this.previewImages;
			
			//Background
			c.drawImage(imgs.background, 0, 0, width, height);
		},
		previewData: {
			background: "media/maps/gaf.png",
			paths: [{
				speed: 2.5,
				path: [{x:0.5,y:0},
				       {x:0.5,y:0.38}]
			}, {
				speed: 2.5,
				path: [{x:0,y:0.5},
				       {x:0.4,y:0.5}]
			}, {
				speed: 2.5,
				path: [{x:1,y:1},
				       {x:0.6,y:0.6}]
			}],
			enemies: [], maxEnemies: 1,
			enemyImg: "media/enemies/red1.png"
		},
		previewImages: {}
	}*/
};
var map, mapsCount = 0, mapsCountHidden = 0;
for(var _mapID in __Maps)
{
	map = __Maps[_mapID];
	
	if (!map.isHidden) mapsCount++;
	else {
		__MapsHidden.push(_mapID);
		mapsCountHidden++;
	}
	map.previewGenerate(492, 328);
}

SplashScreen.loadedScripts["maps"] = true;

function previewEnemyMovement(ID, obj, map)
{
	var pathData = map.previewData.paths[obj.path],
		path = pathData.path,
		pathPoint = obj.point,
		speed = pathData.speed;
	
	//Forward
	if (MainMenu.mapPreviewFlow == 1)
	{
		if (pathPoint >= path.length-1)
		{
			obj.path++;
			if (obj.path >= map.previewData.paths.length) obj.path = 0;
			pathData = map.previewData.paths[obj.path],
			path = pathData.path,
			obj.point = 0;
			obj.x = path[0].x; obj.y = path[0].y;
			previewEnemyMovement(ID, obj, map);
			return true;
		}
		
		var newpoint = pathPoint+1;
		var pointMap = path[newpoint];
		var d = Math.sqrt((pointMap.x - obj.x)*(pointMap.x - obj.x) + (pointMap.y - obj.y)*(pointMap.y - obj.y));
		if (d < speed*2)
		{
			obj.point = newpoint;
			previewEnemyMovement(ID, obj, map);
			return true;
		}
		
	//Backwards
	} else {
		if (pathPoint < 0)
		{
			obj.path--;
			if (obj.path < 0) obj.path = map.previewData.paths.length-1;
			pathData = map.previewData.paths[obj.path],
			path = pathData.path,
			obj.point = path.length-2;
			obj.x = path[path.length-1].x; obj.y = path[path.length-1].y;
			previewEnemyMovement(ID, obj, map);
			return true;
		}
		
		var newpoint = pathPoint;
		var pointMap = path[newpoint];
		var d = Math.sqrt((pointMap.x - obj.x)*(pointMap.x - obj.x) + (pointMap.y - obj.y)*(pointMap.y - obj.y));
		if (d < speed*2)
		{
			obj.point = newpoint-1;
			previewEnemyMovement(ID, obj, map);
			return true;
		}
	}
	
	var dX = Math.abs(pointMap.x - obj.x), dY = Math.abs(pointMap.y - obj.y);
	var xSide = 0, ySide = 0;
	if (dX == 0 && pointMap.y - obj.y < 0) { ySide = -1*speed; }
	else if (dX == 0 && pointMap.y - obj.y > 0) { ySide = speed; }
	else if (dY == 0 && pointMap.x - obj.x < 0) { xSide = -1*speed; }
	else if (dY == 0 && pointMap.x - obj.x > 0) { xSide = speed; }
	else {
		var angleA = Math.atan(dX/dY);
		xSide = Math.abs(speed*Math.sin(angleA));
		ySide = Math.abs(speed*Math.cos(angleA));
		
		if (pointMap.x - obj.x < 0 && pointMap.y - obj.y < 0) { xSide *= -1; ySide *= -1; }
		else if (pointMap.x - obj.x > 0 && pointMap.y - obj.y < 0) { ySide *= -1; }
		else if (pointMap.x - obj.x > 0 && pointMap.y - obj.y > 0) {  }
		else if (pointMap.x - obj.x < 0 && pointMap.y - obj.y > 0) { xSide *= -1; }
	}
	
	obj.x += xSide; obj.y += ySide;
};


//Common Media
var mapCommonMediaLoaded = 0, mapCommonMediaToLoad = 0;
var mapCommonImages = {
	"space1": "background/space1.jpg", "space1_60d": "background/space1_60d.jpg",
	"base": "base_spots/base.png", "base_blue": "base_spots/base_blue.png", "base_red": "base_spots/base_dark.png",
	"heart1": "base_spots/heart.png", "heart2": "base_spots/heart2.png",
	"heart_dark1": "base_spots/heart_dark.png", "heart_dark2": "base_spots/heart_dark2.png",
	"spot": "base_spots/spot.png", "spot_white": "base_spots/spot_white.png",
	"enemy1": "enemies/red1.png", "enemy2": "enemies/red2.png", "enemy3": "enemies/x.png",
	"enemy_bug": "enemies/bug.png", "enemy_miniboss": "enemies/miniboss.png",
	"enemy_destroyer": "enemies/destroyer.png", "enemy_destroyer_side": "enemies/destroyer_side.png",
	"enemy_lifebar": "enemies/lifebar.png", "enemy_lifebarblank": "enemies/lifebar_blank.png",
	
	"bot_range_sentry": "base_spots/bot_range_sentry_50p.png",
	"bot_range_bomber": "base_spots/bot_range_bomber_50p.png",
	"bot_range_cloud": "base_spots/bot_range_cloud_50p.png",
	"bot_range_helper": "base_spots/bot_range_helper_50p.png",
	"bot_range_drone": "base_spots/bot_range_drone_50p.png",
	"bot_range_missilesilo": "base_spots/bot_range_missilesilo.png",
	"bot_range_ping": "base_spots/bottype_ping.png",
	"bot_range_teslacoil": "base_spots/bot_range_teslacoil.png",
	
	"bot_rangeedge_sentry": "base_spots/bot_rangeedge_sentry.png",
	"bot_rangeedge_bomber": "base_spots/bot_rangeedge_bomber.png",
	"bot_rangeedge_cloud": "base_spots/bot_rangeedge_cloud.png",
	"bot_rangeedge_helper": "base_spots/bot_rangeedge_helper.png",
	"bot_rangeedge_drone": "base_spots/bot_rangeedge_drone.png",
	"bot_rangeedge_missilesilo": "base_spots/bot_rangeedge_missilesilo.png",
	"bot_rangeedge_ping": "base_spots/bottype_ping.png",
	"bot_rangeedge_teslacoil": "base_spots/bot_rangeedge_teslacoil.png",
	
	"special_item_ani2": "etc/special_item_ani2.png",
	"special_item_ani3": "etc/special_item_ani3.png", "special_item_ani4": "etc/special_item_ani4.png",
	
	"popup": "etc/popup.jpg", "popup_x": "etc/popup_x.png",
	
	"bottype_sentry": "base_spots/bottype_sentry.png", "bottype_bomber": "base_spots/bottype_bomber.png",
	"bottype_cloud": "base_spots/bottype_cloud.png", "bottype_helper": "base_spots/bottype_helper.png",
	"bottype_drone": "base_spots/bottype_drone.png", "bottype_missilesilo": "base_spots/bottype_missilesilo.png",
	"bottype_ping": "base_spots/bottype_ping.png", "bottype_teslacoil": "base_spots/bottype_teslacoil.png",
	
	"atomic_yellow": "etc/atomic_yellow.png", "atomic_grey": "etc/atomic_grey.png", "atomic_red": "etc/atomic_red.png"
};
var mapCommonSounds = {
	"laser": {
		src: "laser.wav",
		data: {
			volume: 0.4,
			gamepad1Volume: 1,
			tvVolume: 1
		},
		group: "etc"
	},
	"hit": {
		src: "hit.wav",
		data: {
			volume: 1,
			gamepad1Volume: 1,
			tvVolume: 1
		},
		group: "etc"
	},
	"build": {
		src: "build.wav",
		data: {
			volume: 0.85,
			gamepad1Volume: 1,
			tvVolume: 1
		},
		group: "etc"
	},
	"special": {
		src: "special.wav",
		data: {
			volume: 0.85,
			gamepad1Volume: 1,
			tvVolume: 1
		},
		group: "etc"
	}
};

function _mapsImgOnLoad()
{
	__Maps[this.map].scriptImagesLoaded++;
	
	this.removeEventListener("onload", _mapsImgOnLoad);
};