var   b2Vec2 = Box2D.Common.Math.b2Vec2
	,	b2BodyDef = Box2D.Dynamics.b2BodyDef
	,	b2Body = Box2D.Dynamics.b2Body
	,	b2FixtureDef = Box2D.Dynamics.b2FixtureDef
	,	b2Fixture = Box2D.Dynamics.b2Fixture
	,	b2World = Box2D.Dynamics.b2World
	,	b2MassData = Box2D.Collision.Shapes.b2MassData
	,	b2PolygonShape = Box2D.Collision.Shapes.b2PolygonShape
	,	b2CircleShape = Box2D.Collision.Shapes.b2CircleShape
	,	b2DebugDraw = Box2D.Dynamics.b2DebugDraw
	;

function MapBDU()
{
	this.map = "bdu";
	this.base = [{
		x: Render.trueWidth/2,	x2: Render.gp0Width/2,
		y: Render.trueHeight*0.85,y2: Render.gp0Height*0.85,
		r: 100/2,				r2: (100/2)*Render.gp0RenderRatio,
		life: 100,
		maxLife: 100,
		shield: 0, shieldUse: 0
	}];
	this.gp0ScreenOffset = {x: 0, y: 168};
	this.storeRules = {
		drone: {
			enabled: false
		}
	};
	this.walls = [];
	this.dronePathPoints = [{
		x: Render.trueWidth*0.5, y: Render.trueHeight*0.1
	}, {
		x: Render.trueWidth*0.66, y: Render.trueHeight*0.125
	}, {
		x: Render.trueWidth*0.8, y: Render.trueHeight*0.2
	}, {
		x: Render.trueWidth*0.88, y: Render.trueHeight*0.28
	}, {
		x: Render.trueWidth*0.935, y: Render.trueHeight*0.39
	}, {
		
		x: Render.trueWidth*0.95, y: Render.trueHeight*0.5
	}, {
		x: Render.trueWidth*0.935, y: Render.trueHeight*0.61
	}, {
		x: Render.trueWidth*0.88, y: Render.trueHeight*0.72
	}, {
		x: Render.trueWidth*0.8, y: Render.trueHeight*0.8
	}, {
		x: Render.trueWidth*0.66, y: Render.trueHeight*0.875
	}, {
		
		x: Render.trueWidth*0.5, y: Render.trueHeight*0.9
	}, {
		x: Render.trueWidth*0.34, y: Render.trueHeight*0.875
	}, {
		x: Render.trueWidth*0.2, y: Render.trueHeight*0.8
	}, {
		x: Render.trueWidth*0.12, y: Render.trueHeight*0.72
	}, {
		x: Render.trueWidth*0.065, y: Render.trueHeight*0.61
	}, {
		
		x: Render.trueWidth*0.05, y: Render.trueHeight*0.5
	}, {
		x: Render.trueWidth*0.065, y: Render.trueHeight*0.39
	}, {
		x: Render.trueWidth*0.12, y: Render.trueHeight*0.28
	}, {
		x: Render.trueWidth*0.2, y: Render.trueHeight*0.2
	}, {
		x: Render.trueWidth*0.34, y: Render.trueHeight*0.125
	}];
	this.dronePathPointsOnReturn = [];
	this.enemyPaths = [{
		speed: 6.5,
		base: 0,
		path: [{
			x: 0,
			y: 100
		}, {
			x: this.base[0].x,
			y: this.base[0].y
		}]
	}, {
		speed: 6.5,
		base: 0,
		path: [{
			x: Render.trueWidth,
			y: 100
		}, {
			x: this.base[0].x,
			y: this.base[0].y
		}]
	}];
	
	
	this.bduLevel = -1;
	this.bduLevels = [];
	this.bduLevels.push({
		bduGrounds: [{
			x: 0, y: 17,
			w: 1, h: 4,
			d: 32
		}, {
			x: 0, y: 21,
			w: 2, h: 4,
			d: 32
		}, {
			x: 0, y: 25,
			w: 3, h: 9,
			d: 32
		},
		
		{
			x: 3, y: 32,
			w: 4, h: 2,
			d: 32
		}, {
			x: 14, y: 32,
			w: 6, h: 2,
			d: 32
		}, {
			x: 40, y: 32,
			w: 6, h: 2,
			d: 32
		}, {
			x: 53, y: 32,
			w: 4, h: 2,
			d: 32
		},
		
		{
			x: 57, y: 25,
			w: 3, h: 9,
			d: 32
		}, {
			x: 58, y: 21,
			w: 2, h: 4,
			d: 32
		}, {
			x: 59, y: 17,
			w: 1, h: 4,
			d: 32
		},
		
		{
			x: 18, y: 24,
			w: 2, h: 8,
			d: 32
		}, {
			x: 40, y: 24,
			w: 2, h: 8,
			d: 32
		},
		
		{
			x: 24, y: 19,
			w: 2, h: 1,
			d: 32
		}, {
			x: 34, y: 19,
			w: 2, h: 1,
			d: 32
		}],
		bduBloks: [{
			x: 32*24+128/2, y: 32*15+128/2,
			w: 128, h: 128,
		}, {
			x: 32*22+256/2, y: 32*11+128/2,
			w: 256, h: 128,
		}, {
			x: 32*24+128/2, y: 32*3+256/2,
			w: 128, h: 256,
		},
		
		{
			x: 32*32+128/2, y: 32*15+128/2,
			w: 128, h: 128,
		}, {
			x: 32*30+256/2, y: 32*11+128/2,
			w: 256, h: 128,
		}, {
			x: 32*32+128/2, y: 32*3+256/2,
			w: 128, h: 256,
		},
		
		{
			x: 32*28+128/2, y: 32*7+128/2,
			w: 128, h: 128,
		}],
		bduBalls: [{
			x: 32*29+64/2, y: 32*5+64/2,
			w: 64, h: 64,
		}],
		bduBlades: [],
		bduBounces: []
	});
	this.bduLevels.push({
		bduGrounds: [{
			x: 0, y: 17,
			w: 1, h: 4,
			d: 32
		}, {
			x: 0, y: 21,
			w: 2, h: 4,
			d: 32
		}, {
			x: 0, y: 25,
			w: 3, h: 9,
			d: 32
		},
		
		{
			x: 3, y: 32,
			w: 4, h: 2,
			d: 32
		}, {
			x: 13, y: 32,
			w: 6, h: 2,
			d: 32
		}, {
			x: 41, y: 32,
			w: 6, h: 2,
			d: 32
		}, {
			x: 53, y: 32,
			w: 4, h: 2,
			d: 32
		},
		
		{
			x: 57, y: 25,
			w: 3, h: 9,
			d: 32
		}, {
			x: 58, y: 21,
			w: 2, h: 4,
			d: 32
		}, {
			x: 59, y: 17,
			w: 1, h: 4,
			d: 32
		},
		
		{
			x: 17, y: 24,
			w: 2, h: 8,
			d: 32
		}, {
			x: 41, y: 24,
			w: 2, h: 8,
			d: 32
		},
		
		{
			x: 29.5, y: 13,
			w: 1, h: 4,
			d: 32
		}],
		bduBloks: [{
			x: 32*26+256/2, y: 32*9+128/2,
			w: 256, h: 128,
		},
		
		{
			x: 32*24+128/2, y: 32*5+128/2,
			w: 128, h: 128,
		}, {
			x: 32*32+128/2, y: 32*5+128/2,
			w: 128, h: 128,
		}],
		bduBalls: [{
			x: 32*25+64/2, y: 32*3+64/2,
			w: 64, h: 64,
		}, {
			x: 32*33+64/2, y: 32*3+64/2,
			w: 64, h: 64,
		}],
		bduBlades: [],
		bduBounces: []
	});
	this.bduLevels.push({
		bduGrounds: [{
			x: 0, y: 17,
			w: 1, h: 4,
			d: 32
		}, {
			x: 0, y: 21,
			w: 2, h: 4,
			d: 32
		}, {
			x: 0, y: 25,
			w: 3, h: 9,
			d: 32
		},
		
		{
			x: 3, y: 32,
			w: 4, h: 2,
			d: 32
		}, {
			x: 13, y: 32,
			w: 6, h: 2,
			d: 32
		}, {
			x: 41, y: 32,
			w: 6, h: 2,
			d: 32
		}, {
			x: 53, y: 32,
			w: 4, h: 2,
			d: 32
		},
		
		{
			x: 57, y: 25,
			w: 3, h: 9,
			d: 32
		}, {
			x: 58, y: 21,
			w: 2, h: 4,
			d: 32
		}, {
			x: 59, y: 17,
			w: 1, h: 4,
			d: 32
		},
		
		{
			x: 19, y: 29,
			w: 2, h: 3,
			d: 32
		}, {
			x: 39, y: 29,
			w: 2, h: 3,
			d: 32
		},
		
		{
			x: 29.5, y: 15,
			w: 1, h: 1,
			d: 32
		}],
		bduBloks: [{
			x: 32*28+128/2, y: 32*7+256/2,
			w: 128, h: 256,
		},
		
		{
			x: 32*26+128/2, y: 32*3+128/2,
			w: 128, h: 128,
		}, {
			x: 32*30+128/2, y: 32*3+128/2,
			w: 128, h: 128,
		}],
		bduBalls: [{
			x: 32*29.25+64/2, y: 32*1+64/2,
			w: 64, h: 64,
			xRange: [32*28.5+64/2, 32*29.5+64/2]
		}],
		bduBlades: [],
		bduBounces: []
	});
	this.bduLevels.push({
		bduGrounds: [{
			x: 0, y: 17,
			w: 1, h: 4,
			d: 32
		}, {
			x: 0, y: 21,
			w: 2, h: 4,
			d: 32
		}, {
			x: 0, y: 25,
			w: 3, h: 4,
			d: 32
		}, {
			x: 0, y: 29,
			w: 2, h: 3,
			d: 32
		}, {
			x: 0, y: 32,
			w: 3, h: 2,
			d: 32
		},
		
		{
			x: 3, y: 32,
			w: 3, h: 2,
			d: 32
		}, {
			x: 15, y: 32,
			w: 5, h: 2,
			d: 32
		}, {
			x: 40, y: 32,
			w: 5, h: 2,
			d: 32
		}, {
			x: 54, y: 32,
			w: 3, h: 2,
			d: 32
		},
		
		{
			x: 57, y: 32,
			w: 3, h: 2,
			d: 32
		}, {
			x: 58, y: 29,
			w: 2, h: 3,
			d: 32
		}, {
			x: 57, y: 25,
			w: 3, h: 4,
			d: 32
		}, {
			x: 58, y: 21,
			w: 2, h: 4,
			d: 32
		}, {
			x: 59, y: 17,
			w: 1, h: 4,
			d: 32
		},
		
		{
			x: 18, y: 24,
			w: 2, h: 8,
			d: 32
		}, {
			x: 40, y: 24,
			w: 2, h: 8,
			d: 32
		},
		
		{
			x: 24, y: 19,
			w: 2, h: 1,
			d: 32
		}, {
			x: 34, y: 19,
			w: 2, h: 1,
			d: 32
		}],
		bduBloks: [{
			x: 32*24+128/2, y: 32*15+128/2,
			w: 128, h: 128,
		}, {
			x: 32*22+256/2, y: 32*11+128/2,
			w: 256, h: 128,
		}, {
			x: 32*24+128/2, y: 32*7+128/2,
			w: 128, h: 128,
		},
		
		{
			x: 32*32+128/2, y: 32*15+128/2,
			w: 128, h: 128,
		}, {
			x: 32*30+256/2, y: 32*11+128/2,
			w: 256, h: 128,
		}, {
			x: 32*32+128/2, y: 32*7+128/2,
			w: 128, h: 128,
		},
		
		{
			x: 32*28+128/2, y: 32*3+256/2,
			w: 128, h: 256,
		}],
		bduBalls: [{
			x: 32*29+64/2, y: 32*1+64/2,
			w: 64, h: 64,
			xRange: [32*28.5+64/2, 32*29.5+64/2]
		}],
		bduBlades: [{
			x: 32*7.5+(258*0.75)/2, y: 32*26+(258*0.75)/2,
			w: 258*0.75, h: 258*0.75,
			path: [{
				x: 32*6.5+(258*0.75)/2, y: 32*26+(258*0.75)/2
			}, {
				x: 32*10.5+(258*0.75)/2, y: 32*26+(258*0.75)/2
			}], pathIndex: 0, pathDir: 1, pathSpeed: 1
		}, {
			x: 32*46.5+(258*0.75)/2, y: 32*26+(258*0.75)/2,
			w: 258*0.75, h: 258*0.75,
			path: [{
				x: 32*43.5+(258*0.75)/2, y: 32*26+(258*0.75)/2
			}, {
				x: 32*47.5+(258*0.75)/2, y: 32*26+(258*0.75)/2
			}], pathIndex: 1, pathDir: -1, pathSpeed: 1
		}],
		bduBounces: []
	});
	this.bduLevels.push({
	//MapBDU.bduLevels[4] = ({
		bduGrounds: [{
			x: 0, y: 24,
			w: 2, h: 5,
			d: 32
		}, {
			x: 2, y: 32,
			w: 13, h: 2,
			d: 32
		},
		
		{
			x: 45, y: 32,
			w: 13, h: 2,
			d: 32
		}, {
			x: 58, y: 24,
			w: 2, h: 5,
			d: 32
		},
		
		{
			x: 27, y: 19,
			w: 1, h: 1,
			d: 32
		}, {
			x: 32, y: 19,
			w: 1, h: 1,
			d: 32
		}],
		bduBloks: [{
			x: 32*25+128/2, y: 32*15+128/2,
			w: 128, h: 128,
		}, {
			x: 32*31+128/2, y: 32*15+128/2,
			w: 128, h: 128,
		},
		
		{
			x: 32*26+256/2, y: 32*11+128/2,
			w: 256, h: 128,
		},
		
		{
			x: 32*28+128/2, y: 32*3+128/2,
			w: 128, h: 128,
		}],
		bduBalls: [{
			x: 32*29+64/2, y: 32*1+64/2,
			w: 64, h: 64,
			xRange: [32*28.5+64/2, 32*29.5+64/2]
		}],
		bduBlades: [{
			x: 32*14.5+(258*0.75)/2, y: 32*27.5+(258*0.75)/2,
			w: 258*0.75, h: 258*0.75,
			path: [{
				x: 32*5.0+(258*0.75)/2, y: 32*22+(258*0.75)/2
			}, {
				x: 32*14.5+(258*0.75)/2, y: 32*27.5+(258*0.75)/2
			}], pathIndex: 0, pathDir: 1, pathSpeed: 2
		}, {
			x: 32*39.5+(258*0.75)/2, y: 32*27.5+(258*0.75)/2,
			w: 258*0.75, h: 258*0.75,
			path: [{
				x: 32*39.5+(258*0.75)/2, y: 32*27.5+(258*0.75)/2
			}, {
				x: 32*49.0+(258*0.75)/2, y: 32*22+(258*0.75)/2
			}], pathIndex: 1, pathDir: -1, pathSpeed: 2
		}],
		bduBounces: [{
			x: 32*28+128/2, y: 32*7+128/2,
			w: 128, h: 128,
		}]
	});
	
	//60 x 34
	this.bduGrounds = [];
	
	//128 x 128, 256 x 128, 128 x 256
	this.bduBloks = [];
	
	//64 x 64
	this.bduBalls = [];
	
	//258 x 258
	this.bduBlades = [];
	
	//128 x 128
	this.bduBounces = [];
	
	this.world;
	this.bduDamageEnemiesLevel = 0;
	this.bduDamageEnemiesLevelTTL = 0;
	
	
	//Init
	this.hasSetupClick = false;
	this.init = function(options)
	{
		if (options == undefined) options = {};
		if (options.mode == undefined) options.mode = Game.mode;
		
		ClickBank.clearAll();
		InputBank.clearAll();
		Render.soundsStopAll();
		
		this.renderBackgroundTV = true;
		this.renderBackgroundGP0 = true;
		this.renderBackgroundGP0Cache = {};
		
		//Base
		this.base[0].life = this.base[0].maxLife;
		this.base[0].shield = 0;
		this.base[0].shieldUse = 0;
		var base;
		for(var key in this.base)
		{
			base = this.base[key];
			base.cache = {};
		}
		
		//Music
		if (Render.sounds["levelbg"].readyState > 0)
			Render.sounds["levelbg"].currentTime = 0;
		Render.sounds["levelbg"].play();
		
		//Game init
		Game.map = this.map;
		Game.mapClass = this;
		Game.mode = options.mode;
		Game.init({money: 750});
		
		this.bduDamageEnemiesLevel = 0;
		this.bduDamageEnemiesLevelTTL = 0;
		this.bduLevel = -1;
		this.setupBlokDropULevel(true);
		
		//var player1 = nwf.input.WiiRemote.getController( nwf.input.WiiRemote.REMOTE_1 );
		
		 // Keep in mind that any given controller may or may not be connected, so always check
		 //if (!player1.connected) return;

		 // Listen for the A Button
		if (!this.hasSetupClick)
		{
			InputBank.wiiRemoteMode = nwf.input.WiiRemote.MODE_DPD;
			var controllers = [0,1,2,3], controller;
			for(var key in controllers)
			{
				var remote = nwf.input.WiiRemote.getController(controllers[key]);
				remote.mode = InputBank.wiiRemoteMode;
			}
			
			$(tvDisplay.window.document).find("body").click(MapBDU.bduClickSetup);
			$(tvDisplay.window.document).find("body").css({cursor: "auto"});
			this.hasSetupClick = true;
		}
		
		
		//Spots
		Game.spotsAdd({
			x: Render.trueWidth/2, y: Render.trueHeight*0.7, r: 20,
			x2: Render.gp0Width/2, y2: Render.gp0Height*0.85, r2: 20*Render.gp0RenderRatio
		});
		Game.spotsAdd({
			x: Render.trueWidth*0.4, y: Render.trueHeight*0.775, r: 20,
			x2: Render.gp0Width/2, y2: Render.gp0Height*0.85, r2: 20*Render.gp0RenderRatio
		});
		Game.spotsAdd({
			x: Render.trueWidth*0.6, y: Render.trueHeight*0.775, r: 20,
			x2: Render.gp0Width/2, y2: Render.gp0Height*0.85, r2: 20*Render.gp0RenderRatio
		});
		/*Game.spotsAdd({
			x: Render.trueWidth/2, y: Render.trueHeight*0.85, r: 20,
			x2: Render.gp0Width/2, y2: Render.gp0Height*0.85, r2: 20*Render.gp0RenderRatio
		});
		Game.spotsAdd({
			x: Render.trueWidth/2-this.base[0].r-25, y: Render.trueHeight*0.85, r: 20,
			x2: Render.gp0Width/2-this.base[0].r2, y2: Render.gp0Height*0.85, r2: 20*Render.gp0RenderRatio
		});
		Game.spotsAdd({
			x: Render.trueWidth/2, y: Render.trueHeight*0.85-this.base[0].r-25, r: 20,
			x2: Render.gp0Width/2, y2: Render.gp0Height/2-this.base[0].r2, r2: 20*Render.gp0RenderRatio
		});
		Game.spotsAdd({
			x: Render.trueWidth/2+this.base[0].r+25, y: Render.trueHeight/2, r: 20,
			x2: Render.gp0Width/2+this.base[0].r2, y2: Render.gp0Height/2, r2: 20*Render.gp0RenderRatio
		});
		Game.spotsAdd({
			x: Render.trueWidth/2, y: Render.trueHeight/2+this.base[0].r+25, r: 20,
			x2: Render.gp0Width/2, y2: Render.gp0Height/2+this.base[0].r2, r2: 20*Render.gp0RenderRatio
		});*/
		
		Render.renderControl = function(){ MapBDU.render(); };
		
		Game.startGame();
		
		//Gamepad Extra
		$("#gp0displayClicks").click(function(e)
		{
			MapBDU.bduClickGamepad(e);
		});
		
		var tab = {tab: "extra", title: _t("About")}, type = "extra";
		var minbasey = 34;
		var x=315,y=5,w=100,h=minbasey-y-1;
		var div = $(document.createElement("div"));
		div.attr({
			tab: type
		}).addClass("tab_buttons clickevents").css({
			position: "absolute",
			left: x+"px",
			top: y+"px",
			width: w+"px",
			height: h+"px",
			border: "1px solid #AAA",
			//"font-family": "Noto Sans",
			"font-size": "14px",
			color: "#FFF"
		}).html("<img class='img_off' src='media/etc/tab_off.jpg' style='width:"+w+"px;height:"+h+"px;"+(GameGP0Display.tab != type ? "" : "display:none;")+"' />" +
				"<img class='img_on' src='media/etc/tab_on.jpg' style='width:"+w+"px;height:"+h+"px;"+(GameGP0Display.tab != type ? "display:none;" : "")+"' />" +
				"<div class='dark' style='position:absolute;left:0px;top:0px;width:"+w+"px;height:"+h+"px;background:#000;opacity:0.3;display:"+(this.tab != type ? "none" : "block")+";'>&nbsp;</div>" +
				"<div style='position:absolute;left:0px;top:4px;width:"+w+"px;text-align:center;'>"+tab.title+"</div>").click(function()
		{
			GameGP0Display.switchTab($(this).attr("tab"));
		});
		GameGP0Display.container.find(".tab_buttons:last").after(div);
		
		var tab = $(document.createElement("div"));
		GameGP0Display.container.find(".tab:last").after(tab);
		tab.addClass("tab").attr({tab: "extra"}).css({
			position: "absolute",
			left: "0px",
			top: (minbasey+1)+"px",
			width: Render.gp0Width+"px",
			height: (Render.gp0Height-minbasey)+"px",
			display: "none"
		});
		var background = $(document.createElement("div"));
		background.css({
			position: "absolute",
			left: "0px",
			top: "0px",
			width: tab.width()+"px",
			height: tab.height()+"px",
			background: "#000"
		});
		tab.append(background);
		background = $(document.createElement("div"));
		background.css({
			position: "absolute",
			left: "0px",
			top: "0px",
			width: tab.width()+"px",
			height: tab.height()+"px",
			background: "#000",
			opacity: "0.85"
		});
		tab.append(background);
		
		var overflow = $(document.createElement("div"));
		overflow.addClass("overflow").css({
			position: "absolute",
			left: "0px",
			top: "0px",
			width: (tab.width()-30)+"px",
			height: (tab.height()-30)+"px",
			padding: "15px 15px",
			"overflow-x": "hidden",
			"overflow-y": "overflow"
		});
		tab.append(overflow);
		
		var div = $("<div />");
		div.css({
			color: "#CCC"
		}).html("<h2 style='margin-top:0px;color:#FFF;'>"+_t("bdu_about_title")+"</h2>"+
			""+_t("bdu_about_desc")+"<br/>" +
			"<h2 style='margin-top:15px;color:#FFF;'>"+_t("bdu_about_title2")+"</h2>"+
			""+_t("bdu_about_desc2")+"");
		overflow.append(div);
		

		//Game.botsDroneAdd();
		/*Game.botsDroneAdd();
		Game.botsDroneAdd();
		Game.botsDroneAdd();
		Game.botsDroneAdd();*/
		//Game.botsAdd("sentry", Render.trueWidth/2, Render.trueHeight/2);
		/*for(var i=0; i<5; i++)
		{
			var xDiff = (Render.trueWidth/8)-~~(Math.random()*(Render.trueWidth/4));
			var botID = Game.botsAdd("sentry", Render.trueWidth/2+xDiff, Render.trueHeight/2);
			var bot = Game.bots[botID];
			bot.data.range = 500;
		}*/
	};
	
	//Custom Exit Game call
	this.exitGame = function()
	{
		if (this.hasSetupClick)
		{
			InputBank.wiiRemoteMode = nwf.input.WiiRemote.MODE_LITE;
			var controllers = [0,1,2,3], controller;
			for(var key in controllers)
			{
				var remote = nwf.input.WiiRemote.getController(controllers[key]);
				remote.mode = InputBank.wiiRemoteMode;
			}
			
			$(tvDisplay.window.document).find("body").unbind("click", MapBDU.bduClickSetup);
			$(tvDisplay.window.document).find("body").css({cursor: "URL('images/cursor.png'),auto"});
			this.hasSetupClick = false;
		}
	};
	
	//Map Render
	this.counter = 0;
	this.render = function()
	{
		//Clear
		Render.renderClear("all");
		var cxt = Render.tvContext, gxt = Render.gp0Context;
		
		//Gamepad Slice Cache Reset
		var gp0Cord = Game.calculateGPCords(0, 0);
		if (this.renderBackgroundGP0Cache.x0 == undefined || this.renderBackgroundGP0Cache.x0 != gp0Cord.x2
		 || this.renderBackgroundGP0Cache.y0 == undefined || this.renderBackgroundGP0Cache.y0 != gp0Cord.y2
		 || this.renderBackgroundGP0Cache.z0 == undefined || this.renderBackgroundGP0Cache.z0 != Render.gp0RenderRatio)
		{
			this.renderBackgroundGP0 = true;
			Game.resetGP0SliceCache = true;
			
			this.renderBackgroundGP0Cache.x0 = gp0Cord.x2;
			this.renderBackgroundGP0Cache.y0 = gp0Cord.y2;
			this.renderBackgroundGP0Cache.z0 = Render.gp0RenderRatio;
		}
		
		//Gamepad Display Move
		Render.gp0DisplayMoveStart();
		
		
		//Background
		this.renderBackground();
		
		//BDU
		this.renderBDU();
		
		//Bots
		Game.renderBots();
		
		//Render Bases
		Render.renderBases();
		
		//Call Gamer Render function
		Game.render();
		
		Game.resetGP0SliceCache = false;
	}
		
		//Show drone recorded path
		/*cxt.fillStyle = "red"; gxt.fillStyle = "red";
		cxt.strokeStyle = "red"; gxt.strokeStyle = "red";
		
		cxt.save();
		cxt.scale(2, 1);
		cxt.beginPath();
		cxt.arc(Render.tvWidth/4, Render.tvHeight/2, Render.tvWidth*0.225, 0, 2*Math.PI, false);
		cxt.stroke();
		cxt.restore();
		
		cxt.beginPath(); gxt.beginPath();
		
		var dronePath, gp0Cord;
		for(var i=0; i<this.dronePathPoints.length; i++)
		{
			dronePath = this.dronePathPoints[i];
			gp0Cord = Game.calculateGPCords(dronePath.x, dronePath.y);
			
			if (i == 0)
			{
				cxt.moveTo(dronePath.x, dronePath.y); gxt.moveTo(gp0Cord.x2, gp0Cord.y2);
			} else {
				cxt.lineTo(dronePath.x, dronePath.y); gxt.lineTo(gp0Cord.x2, gp0Cord.y2);
			}
			
			cxt.fillStyle = "#666"; gxt.fillStyle = "#666";
			cxt.fillRect(dronePath.x-10, dronePath.y-10, 20, 20);
			gxt.fillRect(gp0Cord.x2-5, gp0Cord.y2-5, 10, 10);
			cxt.fillStyle = "red"; gxt.fillStyle = "red";
		}
		dronePath = this.dronePathPoints[0];
		gp0Cord = Game.calculateGPCords(dronePath.x, dronePath.y);
		cxt.lineTo(dronePath.x, dronePath.y); gxt.lineTo(gp0Cord.x2, gp0Cord.y2);
		
		cxt.stroke(); gxt.stroke();*/
	//};
	
	//Hanldes the render of the Background
	//this.backgroundFade = []; this.lastcalltime = 0;
	this.renderBackgroundTV = true;
	this.renderBackgroundGP0 = true; this.renderBackgroundGP0Cache = {};
	this.renderBackground = function()
	{
		var x=0,y=0,x2,y2,
			_w = Render.tvWidth, _h = Render.tvHeight,
			_w2 = Render.trueWidth*Render.gp0RenderRatio, _h2 = Render.trueHeight*Render.gp0RenderRatio;
		var gp0Cord = Game.calculateGPCords(x, y);
		if (this.renderBackgroundTV)
		{
			var cxt = Render.returnTVSliceContext(1);
			cxt.clearRect(0, 0, Render.tvWidth, Render.tvHeight);
			
			cxt.drawImage(Render.images["bdu_background"], x, y, _w, _h);
			
			var gnd, d;
			for(var key in this.bduGrounds)
			{
				gnd = this.bduGrounds[key];
				d = gnd.d;
				
				for(var x=0; x<gnd.w; x++)
				{
					for(var y=0; y<gnd.h; y++)
					{
						cxt.drawImage(Render.images["bdu_ground"], (gnd.x+x)*gnd.d*Render.renderTVRatio, (gnd.y+y)*gnd.d*Render.renderTVRatio, d*Render.renderTVRatio, d*Render.renderTVRatio);
					}
				}
			}
			
			this.renderBackgroundTV = false;
		}
		if (this.renderBackgroundGP0)
		{
			var gxt = Render.returnGP0SliceContext(1);
			gxt.clearRect(0, 0, Render.gp0Width, Render.gp0Height);
			
			gxt.drawImage(Render.images["bdu_background"], gp0Cord.x2, gp0Cord.y2, _w2, _h2);
			
			var gnd, d;
			for(var key in this.bduGrounds)
			{
				gnd = this.bduGrounds[key];
				d = (Game.calculateGPCords(gnd.d, 0, true)).x2
				
				for(var x=0; x<gnd.w; x++)
				{
					for(var y=0; y<gnd.h; y++)
					{
						gp0Cord = Game.calculateGPCords((gnd.x+x)*gnd.d, (gnd.y+y)*gnd.d);
						gxt.drawImage(Render.images["bdu_ground"], gp0Cord.x2, gp0Cord.y2, d, d);
					}
				}
			}
			
			this.renderBackgroundGP0 = false;
		}
	};
	
	//Render Blok Drop U
	this.renderBDUStepCounter = 0;
	this.renderBDUStep = function(speed)
	{
		if (++this.renderBDUStepCounter % 3 == 0)
		{
			MapBDU.world.Step(
					speed / 15   //frame-rate
	             ,  5       //velocity iterations
	             ,  5       //position iterations
	          );
			this.renderBDUStepCounter = 0;
		}
	};
	this.renderBDU = function()
	{
		var speed = Game.isPaused || Game.gamePause || Game.gameOver ? 0 : 1;
		if (speed)
		{
			//speed = (Game.fastEnabled ? Game.fastRate : 1);
			//if (speed > 3) speed = 3;
			this.renderBDUStep(speed);
		}
		 //MapBDU.world.DrawDebugData();
         //MapBDU.world.ClearForces();
		
		var cxt = Render.returnTVSliceContext(3);
		cxt.clearRect(0, 0, Render.tvWidth, Render.tvHeight);
		var gxt = Render.returnGP0SliceContext(3);
		gxt.clearRect(0, 0, Render.gp0Width, Render.gp0Height);
		
		//Bloks
		var blokCount = 0;
		var blok, blokType, gp0Cord, gp0X, gp0Y, gp0W, gp0H, pos, angle;
		for(var key in this.bduBloks)
		{
			blok = this.bduBloks[key];
			if (!blok.b) continue;
			blokCount++;
			
			blokType = 1;
			if (blok.w > blok.h) blokType = 2;
			else if (blok.w < blok.h) blokType = 3;
			
			//Update Positions
			//blok.x = ((blok.b.m_aabb.lowerBound.x + blok.b.m_aabb.upperBound.x)/2)*30;
			//blok.y = ((blok.b.m_aabb.lowerBound.y + blok.b.m_aabb.upperBound.y)/2)*30;
			pos = blok.b.m_body.GetPosition();
			angle = blok.b.m_body.GetAngle();
			
			gp0Cord = Game.calculateGPCords(pos.x*30, pos.y*30);
			gp0X = gp0Cord.x2; gp0Y = gp0Cord.y2;
			gp0Cord = Game.calculateGPCords(blok.w, blok.h, true);
			gp0W = gp0Cord.x2; gp0H = gp0Cord.y2;
			
			cxt.save();
			cxt.translate(pos.x*30*Render.renderTVRatio, pos.y*30*Render.renderTVRatio);
			cxt.rotate(angle);
			cxt.drawImage(Render.images["bdu_blok"+blokType], -blok.w/2*Render.renderTVRatio, -blok.h/2*Render.renderTVRatio, blok.w*Render.renderTVRatio, blok.h*Render.renderTVRatio);
			cxt.restore();
			
			gxt.save();
			gxt.translate(gp0X, gp0Y);
			gxt.rotate(angle);
			gxt.drawImage(Render.images["bdu_blok"+blokType], -gp0W/2, -gp0H/2, gp0W, gp0H);
			gxt.restore();
			
			//Land on enemy?
			var eObj;
			for(var eID in Game.enemiesList)
			{
				if (!blok.b) continue;
				eObj = Game.enemiesList[eID];
				
				var dx = eObj.x - pos.x*30, dy = eObj.y - pos.y*30;
			    // distance between the point and the center of the rectangle
			    var h1 = Math.sqrt(dx*dx + dy*dy);
			    var currA = Math.atan2(dy,dx);
			    // Angle of point rotated around origin of rectangle in opposition
			    var newA = currA - angle;
			    // New position of mouse point when rotated
			    var x2 = Math.cos(newA) * h1;
			    var y2 = Math.sin(newA) * h1;
			    // Check relative to center of rectangle
			    if (x2 > -0.5 * blok.w && x2 < 0.5 * blok.w && y2 > -0.5 * blok.h && y2 < 0.5 * blok.h){
			    	this.world.DestroyBody(blok.b.GetBody());
					blok.b = null;
					blok.doDestroy = false;
					
					Render.sounds["laser"].play();
					
					eObj.life -= eObj.maxLife/10;
					if (eObj.life > 0)
					{
						eObj.data.renderBarTill = Date.now()+1500;
					} else {
						Game.destroyEnemy(eID, "killed");
					}
			    }
			}
			if (!blok.b) continue;
			
			//Touch a Blade?
			var bladeFound = false;
			var list = blok.b.m_body.GetContactList(), contact;
			for(var key in list)
			{
				contact = list[key];
				
				while(contact)
				{
					if (contact.contact && contact.contact.m_fixtureA
						&& contact.contact.m_fixtureA.m_body.m_userData && contact.contact.m_fixtureA.m_body.m_userData.type == "blade")
						bladeFound = true;
					if (contact.contact && contact.contact.m_fixtureB
						&& contact.contact.m_fixtureB.m_body.m_userData && contact.contact.m_fixtureB.m_body.m_userData.type == "blade")
						bladeFound = true;
					if (contact.m_fixtureA && contact.m_fixtureA.m_body.m_userData && contact.m_fixtureA.m_body.m_userData.type == "blade")
						bladeFound = true;
					if (contact.m_fixtureB && contact.m_fixtureB.m_body.m_userData && contact.m_fixtureB.m_body.m_userData.type == "blade")
						bladeFound = true;
					
					contact = contact && contact.next ? contact.next : null;
				}
			}
			if (bladeFound)
			{
				this.world.DestroyBody(blok.b.GetBody());
				blok.b = null;
				blok.doDestroy = false;
			}
			if (!blok.b) continue;
			
			//Out of bounds?
			if (pos.y*30+blok.h/2 > 1080 || blok.doDestroy)
			{
				this.world.DestroyBody(blok.b.GetBody());
				blok.b = null;
				blok.doDestroy = false;
			}
		}
		
		//Balls
		var advanceLevel = false;
		var ballCount = 0;
		for(var key in this.bduBalls)
		{
			blok = this.bduBalls[key];
			if (!blok.b) continue;
			ballCount++;
			
			//Update Positions
			//blok.x = ((blok.b.m_aabb.lowerBound.x + blok.b.m_aabb.upperBound.x)/2)*30;
			//blok.y = ((blok.b.m_aabb.lowerBound.y + blok.b.m_aabb.upperBound.y)/2)*30;
			pos = blok.b.m_body.GetPosition();
			angle = blok.b.m_body.GetAngle();
			
			gp0Cord = Game.calculateGPCords(pos.x*30, pos.y*30);
			gp0X = gp0Cord.x2; gp0Y = gp0Cord.y2;
			gp0Cord = Game.calculateGPCords(blok.w, blok.h, true);
			gp0W = gp0Cord.x2; gp0H = gp0Cord.y2;
			
			cxt.save();
			cxt.translate(pos.x*30*Render.renderTVRatio, pos.y*30*Render.renderTVRatio);
			cxt.rotate(angle);
			cxt.drawImage(Render.images["bdu_ball"], -blok.w/2*Render.renderTVRatio, -blok.h/2*Render.renderTVRatio, blok.w*Render.renderTVRatio, blok.h*Render.renderTVRatio);
			cxt.restore();
			
			gxt.save();
			gxt.translate(gp0X, gp0Y);
			gxt.rotate(angle);
			gxt.drawImage(Render.images["bdu_ball"], -gp0W/2, -gp0H/2, gp0W, gp0H);
			gxt.restore();
			
			//Out of bounds?
			if (pos.y*30+blok.h/2 > 1080 || blok.doDestroy)
			{
				this.world.DestroyBody(blok.b.GetBody());
				blok.b = null;
				blok.doDestroy = false;
				blok.ongroundcounter = 0;
			}
			if (!blok.b) continue;
			
			//Touch a Blade?
			var bladeFound = false;
			var list = blok.b.m_body.GetContactList(), contact;
			for(var key in list)
			{
				contact = list[key];
				
				while(contact)
				{
					if (contact.contact && contact.contact.m_fixtureA
						&& contact.contact.m_fixtureA.m_body.m_userData && contact.contact.m_fixtureA.m_body.m_userData.type == "blade")
						bladeFound = true;
					if (contact.contact && contact.contact.m_fixtureB
						&& contact.contact.m_fixtureB.m_body.m_userData && contact.contact.m_fixtureB.m_body.m_userData.type == "blade")
						bladeFound = true;
					if (contact.m_fixtureA && contact.m_fixtureA.m_body.m_userData && contact.m_fixtureA.m_body.m_userData.type == "blade")
						bladeFound = true;
					if (contact.m_fixtureB && contact.m_fixtureB.m_body.m_userData && contact.m_fixtureB.m_body.m_userData.type == "blade")
						bladeFound = true;
					
					contact = contact && contact.next ? contact.next : null;
				}
			}
			if (bladeFound)
			{
				this.world.DestroyBody(blok.b.GetBody());
				blok.b = null;
				blok.doDestroy = false;
				blok.ongroundcounter = 0;
			}
			if (!blok.b) continue;
			
			//On Ground?
			if (blok.ongroundcounter == undefined) blok.ongroundcounter = 0;
			var groundFound = false;
			var list = blok.b.m_body.GetContactList(), contact;
			for(var key in list)
			{
				contact = list[key];
				
				while(contact)
				{
					if (contact.contact && contact.contact.m_fixtureA
						&& contact.contact.m_fixtureA.m_body.m_userData && contact.contact.m_fixtureA.m_body.m_userData.type == "ground")
						groundFound = true;
					if (contact.contact && contact.contact.m_fixtureB
						&& contact.contact.m_fixtureB.m_body.m_userData && contact.contact.m_fixtureB.m_body.m_userData.type == "ground")
						groundFound = true;
					if (contact.m_fixtureA && contact.m_fixtureA.m_body.m_userData && contact.m_fixtureA.m_body.m_userData.type == "ground")
						groundFound = true;
					if (contact.m_fixtureB && contact.m_fixtureB.m_body.m_userData && contact.m_fixtureB.m_body.m_userData.type == "ground")
						groundFound = true;
					
					contact = contact && contact.next ? contact.next : null;
				}
			}
			if (groundFound) blok.ongroundcounter += speed;
			else blok.ongroundcounter = 0;
			
			if (blok.ongroundcounter > 150)
			{
				this.world.DestroyBody(blok.b.GetBody());
				blok.b = null;
				blok.doDestroy = false;
				blok.ongroundcounter = 0;
				advanceLevel = true;
				if (advanceLevel)
				{
					this.bduLevel++;
					if (this.bduLevel > this.bduLevels.length-1)
						this.bduLevel = this.bduLevels.length-2;
					advanceLevel = false;
					
					var blok2;
					for(var key in this.bduBalls)
					{
						blok2 = this.bduBalls[key];
						if (!blok2.b) continue;
						this.world.DestroyBody(blok2.b.GetBody());
						blok2.b = null;
					}
				}
				
				Render.sounds["laser"].play();
				
				//Damage all enemies
				this.bduDamageEnemiesLevel++;
				this.bduDamageEnemiesLevelTTL = 15;
				var eObj;
				for(var eID in Game.enemiesList)
				{
					eObj = Game.enemiesList[eID];
					
					if (eObj.life > eObj.maxLife/3)
					{
						eObj.life = eObj.life*(2/3);
						eObj.data.renderBarTill = Date.now()+1500;
					}
				}
			}
		}
		
		//Blades
		var blade;
		for(var key in this.bduBlades)
		{
			blade = this.bduBlades[key];
			if (!blade.b) continue;
			
			angle = blade.b.m_body.GetAngle();
			if (!(Game.isPaused || Game.gamePause))
				angle += Game.fastEnabled ? 0.05*speed : 0.05;
			blade.b.m_body.SetAngle(angle);
			
			pos = blade.b.m_body.GetPosition();
			angle = blade.b.m_body.GetAngle();

			blade.x = pos.x*30; blade.y = pos.y*30;
			
			gp0Cord = Game.calculateGPCords(pos.x*30, pos.y*30);
			gp0X = gp0Cord.x2; gp0Y = gp0Cord.y2;
			gp0Cord = Game.calculateGPCords(blade.w, blade.h, true);
			gp0W = gp0Cord.x2; gp0H = gp0Cord.y2;
			
			cxt.save();
			cxt.translate((pos.x*30-15)*Render.renderTVRatio, (pos.y*30+15)*Render.renderTVRatio);
			cxt.rotate(angle);
			cxt.drawImage(Render.images["bdu_blade_shadow"], -blade.w/2*Render.renderTVRatio, -blade.h/2*Render.renderTVRatio, blade.w*Render.renderTVRatio, blade.h*Render.renderTVRatio);
			cxt.restore();
			cxt.save();
			cxt.translate(pos.x*30*Render.renderTVRatio, pos.y*30*Render.renderTVRatio);
			cxt.rotate(angle);
			cxt.drawImage(Render.images["bdu_blade"], -blade.w/2*Render.renderTVRatio, -blade.h/2*Render.renderTVRatio, blade.w*Render.renderTVRatio, blade.h*Render.renderTVRatio);
			cxt.restore();
			
			gxt.save();
			gxt.translate(gp0X-15*Render.gp0RenderRatio, gp0Y+15*Render.gp0RenderRatio);
			gxt.rotate(angle);
			gxt.drawImage(Render.images["bdu_blade_shadow"], -gp0W/2, -gp0H/2, gp0W, gp0H);
			gxt.restore();
			gxt.save();
			gxt.translate(gp0X, gp0Y);
			gxt.rotate(angle);
			gxt.drawImage(Render.images["bdu_blade"], -gp0W/2, -gp0H/2, gp0W, gp0H);
			gxt.restore();
			
			//Blade Movement
			/*path: [{
					x: 32*7.5+(258*0.75)/2, y: 32*26+(258*0.75)/2
				}, {
					x: 32*9.0+(258*0.75)/2, y: 32*26+(258*0.75)/2
				}], pathIndex: 0, pathDir: 1*/
			if (blade.path && blade.path.length && speed)
			{
				var pathIndexNext = blade.pathIndex + blade.pathDir;
				var pathPointMap = blade.path[pathIndexNext];
				var pathSpeed = blade.pathSpeed*speed;
				
				var d = Math.sqrt((pathPointMap.x - blade.x)*(pathPointMap.x - blade.x) + (pathPointMap.y - blade.y)*(pathPointMap.y - blade.y));
				if (d < pathSpeed*2)
				{
					blade.b.m_body.SetPosition({x: pathPointMap.x/30, y: pathPointMap.y/30});
					
					blade.pathIndex += blade.pathDir;
					if (blade.pathIndex == 0 || blade.pathIndex == blade.path.length-1)
						blade.pathDir *= -1;
					
					continue;
				}
				
				var dX = ((pathPointMap.x - blade.x) < 0 ? -(pathPointMap.x - blade.x) : (pathPointMap.x - blade.x)),
					dY = ((pathPointMap.y - blade.y) < 0 ? -(pathPointMap.y - blade.y) : (pathPointMap.y - blade.y));
				var xSide = 0, ySide = 0;
				if (dX == 0 && pathPointMap.y - blade.y < 0) { ySide = -1*pathSpeed; }
				else if (dX == 0 && pathPointMap.y - blade.y > 0) { ySide = pathSpeed; }
				else if (dY == 0 && pathPointMap.x - blade.x < 0) { xSide = -1*pathSpeed; }
				else if (dY == 0 && pathPointMap.x - blade.x > 0) { xSide = pathSpeed; }
				else {
					var angleA = Math.atan(dX/dY);
					xSide = pathSpeed*Math.sin(angleA); if (xSide < 0) xSide *= -1;
					ySide = pathSpeed*Math.cos(angleA); if (ySide < 0) ySide *= -1;
					
					if (pathPointMap.x - blade.x < 0 && pathPointMap.y - blade.y < 0) { xSide *= -1; ySide *= -1; }
					else if (pathPointMap.x - blade.x > 0 && pathPointMap.y - blade.y < 0) { ySide *= -1; }
					else if (pathPointMap.x - blade.x > 0 && pathPointMap.y - blade.y > 0) {  }
					else if (pathPointMap.x - blade.x < 0 && pathPointMap.y - blade.y > 0) { xSide *= -1; }
				}
				
				blade.x += xSide; blade.y += ySide;
				blade.b.m_body.SetPosition({x: blade.x/30, y: blade.y/30});
			}
		}
		
		//Bounces
		var bounceCount = 0;
		var blok, gp0Cord, gp0X, gp0Y, gp0W, gp0H, pos, angle;
		for(var key in this.bduBounces)
		{
			blok = this.bduBounces[key];
			if (!blok.b) continue;
			bounceCount++;
			
			blokType = 1;
			if (blok.w > blok.h) blokType = 2;
			else if (blok.w < blok.h) blokType = 3;
			
			//Update Positions
			//blok.x = ((blok.b.m_aabb.lowerBound.x + blok.b.m_aabb.upperBound.x)/2)*30;
			//blok.y = ((blok.b.m_aabb.lowerBound.y + blok.b.m_aabb.upperBound.y)/2)*30;
			pos = blok.b.m_body.GetPosition();
			angle = blok.b.m_body.GetAngle();
			
			gp0Cord = Game.calculateGPCords(pos.x*30, pos.y*30);
			gp0X = gp0Cord.x2; gp0Y = gp0Cord.y2;
			gp0Cord = Game.calculateGPCords(blok.w, blok.h, true);
			gp0W = gp0Cord.x2; gp0H = gp0Cord.y2;
			
			cxt.save();
			cxt.translate(pos.x*30*Render.renderTVRatio, pos.y*30*Render.renderTVRatio);
			cxt.rotate(angle);
			cxt.drawImage(Render.images["bdu_bounce"], -blok.w/2*Render.renderTVRatio, -blok.h/2*Render.renderTVRatio, blok.w*Render.renderTVRatio, blok.h*Render.renderTVRatio);
			cxt.restore();
			
			gxt.save();
			gxt.translate(gp0X, gp0Y);
			gxt.rotate(angle);
			gxt.drawImage(Render.images["bdu_bounce"], -gp0W/2, -gp0H/2, gp0W, gp0H);
			gxt.restore();
			
			//Land on enemy?
			var eObj;
			for(var eID in Game.enemiesList)
			{
				if (!blok.b) continue;
				eObj = Game.enemiesList[eID];
				
				var dx = eObj.x - pos.x*30, dy = eObj.y - pos.y*30;
			    // distance between the point and the center of the rectangle
			    var h1 = Math.sqrt(dx*dx + dy*dy);
			    var currA = Math.atan2(dy,dx);
			    // Angle of point rotated around origin of rectangle in opposition
			    var newA = currA - angle;
			    // New position of mouse point when rotated
			    var x2 = Math.cos(newA) * h1;
			    var y2 = Math.sin(newA) * h1;
			    // Check relative to center of rectangle
			    if (x2 > -0.5 * blok.w && x2 < 0.5 * blok.w && y2 > -0.5 * blok.h && y2 < 0.5 * blok.h){
			    	this.world.DestroyBody(blok.b.GetBody());
					blok.b = null;
					blok.doDestroy = false;
					
					Render.sounds["laser"].play();
					
					eObj.life -= eObj.maxLife/10;
					if (eObj.life > 0)
					{
						eObj.data.renderBarTill = Date.now()+1500;
					} else {
						Game.destroyEnemy(eID, "killed");
					}
			    }
			}
			if (!blok.b) continue;
			
			//Touch a Blade?
			var bladeFound = false;
			var list = blok.b.m_body.GetContactList(), contact;
			for(var key in list)
			{
				contact = list[key];
				
				while(contact)
				{
					if (contact.contact && contact.contact.m_fixtureA
						&& contact.contact.m_fixtureA.m_body.m_userData && contact.contact.m_fixtureA.m_body.m_userData.type == "blade")
						bladeFound = true;
					if (contact.contact && contact.contact.m_fixtureB
						&& contact.contact.m_fixtureB.m_body.m_userData && contact.contact.m_fixtureB.m_body.m_userData.type == "blade")
						bladeFound = true;
					if (contact.m_fixtureA && contact.m_fixtureA.m_body.m_userData && contact.m_fixtureA.m_body.m_userData.type == "blade")
						bladeFound = true;
					if (contact.m_fixtureB && contact.m_fixtureB.m_body.m_userData && contact.m_fixtureB.m_body.m_userData.type == "blade")
						bladeFound = true;
					
					contact = contact && contact.next ? contact.next : null;
				}
			}
			if (bladeFound)
			{
				this.world.DestroyBody(blok.b.GetBody());
				blok.b = null;
				blok.doDestroy = false;
			}
			if (!blok.b) continue;
			
			//Out of bounds?
			if (pos.y*30+blok.h/2 > 1080 || blok.doDestroy)
			{
				this.world.DestroyBody(blok.b.GetBody());
				blok.b = null;
				blok.doDestroy = false;
			}
		}
		
		if (ballCount == 0)
		{
			this.setupBlokDropULevel(advanceLevel);
		}
	};
	
	//Wii Remote Pointer
	this.bduClickSetup = function(e)
	{
		if (Game.map == "bdu" && Game.gameEnabled)
			Game.mapClass.bduClick(e);
	};
	this.bduClick = function(e)
	{
		if (Game.isPaused || Game.gamePause || Game.gameOver) return true;
		
		var point = {x: (e.pageX*(1/Render.renderTVRatio))/30, y: (e.pageY*(1/Render.renderTVRatio))/30};
		
		this.world.QueryPoint(function(fixture)
		{
			var userData = fixture.GetBody().GetUserData();
			if (userData.type != "blok") return true;
			if (typeof userData.allowClickDestroy != "undefined" && !userData.allowClickDestroy) return true;
			var block = userData.obj;
			
	    	if (typeof block.clickDestroy == "undefined" || block.clickDestroy)
	    		block.doDestroy = true;
		}, point);
		return false;
		
		var blok, pos, angle;
		for(var key in this.bduBloks)
		{
			blok = this.bduBloks[key];
			if (!blok.b) continue;

			pos = blok.b.m_body.GetPosition();
			angle = blok.b.m_body.GetAngle();
			
			var dx = e.pageX - pos.x*30*Render.renderTVRatio, dy = e.pageY - pos.y*30*Render.renderTVRatio;
		    // distance between the point and the center of the rectangle
		    var h1 = Math.sqrt(dx*dx + dy*dy);
		    var currA = Math.atan2(dy,dx);
		    // Angle of point rotated around origin of rectangle in opposition
		    var newA = currA - angle;
		    // New position of mouse point when rotated
		    var x2 = Math.cos(newA) * h1;
		    var y2 = Math.sin(newA) * h1;
		    // Check relative to center of rectangle
		    if (x2 > -0.5 * blok.w && x2 < 0.5 * blok.w && y2 > -0.5 * blok.h && y2 < 0.5 * blok.h){
		    	blok.doDestroy = true;
		    }
		}
	}
	this.bduClickGamepad = function(e)
	{
		var x = e.pageX, y = e.pageY;
		if (x > GameGP0Display.mapWidth || y < 34 || GameGP0Display.popupEnabled) return true;
		if (Game.isPaused || Game.gamePause || Game.gameOver) return true;
		
		y -= 34;
		var tvCords = Game.calculateTVCords(x, y, false);
		x = tvCords.x; y = tvCords.y;
		
		this.bduClick({pageX: x*Render.renderTVRatio, pageY: y*Render.renderTVRatio});
	};
	
	//Setup Blok Drop U Level Physics/etc
	//this.bduLevel = -1;
	this.setupBlokDropULevel = function(advanceLevel)
	{
		if (typeof advanceLevel == "undefined") advanceLevel = false;
		if (advanceLevel)
		{
			this.bduLevel++;
			if (this.bduLevel > this.bduLevels.length-1)
				this.bduLevel = this.bduLevels.length-2;
		}
		
		var level = this.bduLevels[this.bduLevel];
		
		//Box 2D Web
		this.world = new b2World(
               new b2Vec2(0, 10)    //gravity
            ,  true                 //allow sleep
         );
		
		var fixDef = new b2FixtureDef;
        fixDef.density = 1.0;
        fixDef.friction = 0.5;
        fixDef.restitution = 0.2;
        
        var bodyDef = new b2BodyDef;
        
        //create ground
        /*bodyDef.type = b2Body.b2_staticBody;
        bodyDef.position.x = 9;
        bodyDef.position.y = 13;
        fixDef.shape = new b2PolygonShape;
        fixDef.shape.SetAsBox(10, 0.5);
        this.world.CreateBody(bodyDef).CreateFixture(fixDef);*/
        
        var gnd, d;
        this.bduGrounds = jQuery.extend(true, [], level.bduGrounds);
		for(var key in this.bduGrounds)
		{
			gnd = this.bduGrounds[key];
			d = gnd.d;
			
			bodyDef.type = b2Body.b2_staticBody;
			bodyDef.position.x = ((gnd.x+gnd.w/2)*gnd.d)/30;
			bodyDef.position.y = ((gnd.y+gnd.h/2)*gnd.d)/30;
			bodyDef.userData = {type: "ground"};
			fixDef.shape = new b2PolygonShape;
			fixDef.shape.SetAsBox((d*gnd.w)/30/2, (d*gnd.h)/30/2);
			this.world.CreateBody(bodyDef).CreateFixture(fixDef);
			/*for(var x=0; x<gnd.w; x++)
			{
				for(var y=0; y<gnd.h; y++)
				{
					bodyDef.type = b2Body.b2_staticBody;
					bodyDef.position.x = ((gnd.x+x)*gnd.d+d/2)/30;
					bodyDef.position.y = ((gnd.y+y)*gnd.d+d/2)/30;
					fixDef.shape = new b2PolygonShape;
					fixDef.shape.SetAsBox(d/30/2, d/30/2);
					this.world.CreateBody(bodyDef).CreateFixture(fixDef);
				}
			}*/
		}
        

        //create some objects
        bodyDef.type = b2Body.b2_dynamicBody;
        /*
        for(var i = 0; i < 10; ++i) {
           if(Math.random() >= 0) {
              fixDef.shape = new b2PolygonShape;
              fixDef.shape.SetAsBox(
                    Math.random() + 0.1 //half width
                 ,  Math.random() + 0.1 //half height
              );
           } else {
              fixDef.shape = new b2CircleShape(
                 Math.random() + 0.1 //radius
              );
           }
           bodyDef.position.x = Math.random() * 10;
           bodyDef.position.y = Math.random() * 10;
           this.world.CreateBody(bodyDef).CreateFixture(fixDef);
        }*/
        var blok;
        this.bduBloks = jQuery.extend(true, [], level.bduBloks);
        for(var key in this.bduBloks)
        {
        	blok = this.bduBloks[key];
        	
        	fixDef.shape = new b2PolygonShape;
            fixDef.shape.SetAsBox(blok.w/30/2, blok.h/30/2);
            bodyDef.position.x = blok.x/30;
            bodyDef.position.y = blok.y/30;
			bodyDef.userData = {type: "blok", obj: blok};
            blok.b = this.world.CreateBody(bodyDef).CreateFixture(fixDef);
        }
        this.bduBalls = jQuery.extend(true, [], level.bduBalls);
        for(var key in this.bduBalls)
        {
        	blok = this.bduBalls[key];
        	
        	var xPost = blok.x;//xRange
        	if (blok.xRange)
        		xPost = blok.xRange[0]+Math.random()*(blok.xRange[1]-blok.xRange[0]);
        	
        	fixDef.shape = new b2PolygonShape;
            fixDef.shape.SetAsBox(blok.w/30/2, blok.h/30/2);
            bodyDef.position.x = xPost/30;
            bodyDef.position.y = blok.y/30;
			bodyDef.userData = {type: "ball"};
            blok.b = this.world.CreateBody(bodyDef).CreateFixture(fixDef);
        }
        
        
        //Blades
        this.bduBlades = jQuery.extend(true, [], level.bduBlades);
        bodyDef.type = b2Body.b2_staticBody;
        var blade;
        for(var key in this.bduBlades)
        {
        	blade = this.bduBlades[key];
        	
        	fixDef.shape = new b2CircleShape(blade.w/30/5);
            bodyDef.position.x = blade.x/30;
            bodyDef.position.y = blade.y/30;
			bodyDef.userData = {type: "blade"};
			blade.b = this.world.CreateBody(bodyDef).CreateFixture(fixDef);
        }
        
        
        //Bounces
		fixDef = new b2FixtureDef;
        fixDef.density = 1.0;
        fixDef.friction = 0.5;
        fixDef.restitution = 1.0;
        bodyDef.type = b2Body.b2_dynamicBody;
        this.bduBounces = jQuery.extend(true, [], level.bduBounces);
        var bounce;
        for(var key in this.bduBounces)
        {
        	bounce = this.bduBounces[key];
        	
        	fixDef.shape = new b2PolygonShape;
            fixDef.shape.SetAsBox(bounce.w/30/2, bounce.h/30/2);
            bodyDef.position.x = bounce.x/30;
            bodyDef.position.y = bounce.y/30;
			bodyDef.userData = {type: "blok", skin: "bounce", obj: bounce, allowClickDestroy: false};
			bounce.b = this.world.CreateBody(bodyDef).CreateFixture(fixDef);
        }
        
        
        this.renderBackgroundTV = true;
        this.renderBackgroundGP0 = true;
        
        //setup debug draw
        return true;
        var debugDraw = new b2DebugDraw();
			debugDraw.SetSprite(Render.returnTVSliceContext(2));//document.getElementById("gp0Canvas10").getContext("2d"));
			debugDraw.SetDrawScale(30.0);
			debugDraw.SetFillAlpha(0.3);
			debugDraw.SetLineThickness(1.0);
			debugDraw.SetFlags(b2DebugDraw.e_shapeBit | b2DebugDraw.e_jointBit);
			this.world.SetDebugDraw(debugDraw);
	};
	
	
	//Listen in for the Start Level function
	this.startLevel = function()
	{
		this.bduDamageEnemiesLevel = 0;
		this.bduDamageEnemiesLevelTTL = 0;
	};
	
	//Map specific spawn enemy function
	//Returns specific data, such as pattern, start position, etc
	this.spawnEnemy = function()
	{
		var data = {};
		data.pattern = ~~(Math.random()*this.enemyPaths.length);
		
		var pathData = this.enemyPaths[data.pattern];
		data.speed = pathData.speed;
		data.point = 0;
		data.startX = pathData.path[0].x;
		data.startY = pathData.path[0].y;
		
		data.destination = {};
		data.destination.x = this.base[0].x;
		data.destination.y = this.base[0].y;
		
		return data;
	};

	//Map specific after spawn enemy function
	this.alterEnemySpawnData = function(ID)
	{
		var obj = Game.enemiesList[ID];
		if (!obj) return false;
		
		if (this.bduDamageEnemiesLevel > 0)
		{
			//obj.life /= (this.bduDamageEnemiesLevel+1);
			for(var i=0; i<this.bduDamageEnemiesLevel; i++)
				obj.life *= (2/3);
			
			this.bduDamageEnemiesLevelTTL--;
			if (this.bduDamageEnemiesLevelTTL <= 0)
			{
				this.bduDamageEnemiesLevel = 0;
			}
		}
	};
	
	//Map specific move enemy function
	this.moveEnemy = function(ID, obj, rate)
	{
		if (rate == undefined) rate = 1;
		var pathData = this.enemyPaths[obj.pattern],
			path = pathData.path,
			pathPoint = obj.data.point,
			speed = obj.speed*rate;
		if (obj.data.point >= pathData.path.length-1) return true;
		
		var newpoint = pathPoint+1;
		var pointMap = path[newpoint];
		var d = Math.sqrt((pointMap.x - obj.x)*(pointMap.x - obj.x) + (pointMap.y - obj.y)*(pointMap.y - obj.y));
		if (d < speed*2)
		{
			obj.data.point = newpoint;
			obj.x = pointMap.x; obj.y = pointMap.y;
			this.moveEnemy(ID, obj);
			return true;
		}
		
		//On final point?
		if (newpoint == path.length-1)
		{
			if (this.base[pathData.base].life <= 0)
			{
				if (obj.data.newbaseroute == undefined)
				{
					var base, newBase = null;
					for(var key in this.base)
					{
						if (newBase != null) continue;
						
						base = this.base[key];
						if (base.life > 0) newBase = key;
					}
					obj.data.newbaseroute = ~~(newBase);
				}
				
				pointMap = this.base[obj.data.newbaseroute];
			}
		}
		
		
		if (!pointMap) return false;
		
		//Change Destination Points
		obj.data.destination.x = pointMap.x;
		obj.data.destination.y = pointMap.y;
		
		//Determine x and y increases
		var dX = ((pointMap.x - obj.x) < 0 ? -(pointMap.x - obj.x) : (pointMap.x - obj.x)),
			dY = ((pointMap.y - obj.y) < 0 ? -(pointMap.y - obj.y) : (pointMap.y - obj.y));
		var xSide = 0, ySide = 0;
		if (dX == 0 && pointMap.y - obj.y < 0) { ySide = -1*speed; }
		else if (dX == 0 && pointMap.y - obj.y > 0) { ySide = speed; }
		else if (dY == 0 && pointMap.x - obj.x < 0) { xSide = -1*speed; }
		else if (dY == 0 && pointMap.x - obj.x > 0) { xSide = speed; }
		else {
			var angleA = Math.atan(dX/dY);// * (180 / Math.PI);
			xSide = speed*Math.sin(angleA); if (xSide < 0) xSide *= -1;
			ySide = speed*Math.cos(angleA); if (ySide < 0) ySide *= -1;
			//xSide = (angleA/90)*speed*1.3;
			//ySide = ((90-angleA)/90)*speed*1.3;
			
			if (pointMap.x - obj.x < 0 && pointMap.y - obj.y < 0) { xSide *= -1; ySide *= -1; }
			else if (pointMap.x - obj.x > 0 && pointMap.y - obj.y < 0) { ySide *= -1; }
			else if (pointMap.x - obj.x > 0 && pointMap.y - obj.y > 0) {  }
			else if (pointMap.x - obj.x < 0 && pointMap.y - obj.y > 0) { xSide *= -1; }

			//console.log(dX, dY, angleA, speed, xSide, ySide);
		}
		
		obj.x += xSide; obj.y += ySide;
		//this.enemyMovements.push({x: obj.x, y: obj.y});
		
		
		/*
		var x = obj.data.startX - this.base[0].x,
			y = obj.data.startY - this.base[0].y,
			s = obj.speed;
		
		//x: 1010 @ 580 ~17500 | 1.7414 | -1.74137
		//y: 590  @ 600 ~17500 | 0.9833
		var xs = x/s, ys = y/s;
		if (x != 0) xs = x/(s*Math.abs(580/s));
		//if (y != 0) ys = y/(s*Math.abs(600/s));
		
		obj.x -= xs;// * Math.abs(x/590));
		obj.y -= ys;// * Math.abs(y/590));*/
	};
	
	
	//Map Sepecific spawn drone function
	//Returns spawn data, specifically the x/y
	this.spawnDrone = function()
	{
		var data = {x: 0, y: 0, direction: ~~(Math.random()*2) == 0 ? -1 : 1};
		var pointindex = ~~(Math.random()*this.dronePathPoints.length);
		data.point = pointindex;
		
		//Choose point at random
		var point = this.dronePathPoints[pointindex];
		data.x = point.x;
		data.y = point.y;
		
		//Destination
		var newpoint = data.point + data.direction;
		if (newpoint < 0) newpoint = this.dronePathPoints.length - 1;
		else if (newpoint > this.dronePathPoints.length-1) newpoint = 0;
		var pointMap = this.dronePathPoints[newpoint];
		data.destination = {};
		data.destination.x = pointMap.x;
		data.destination.y = pointMap.y;
		
		return data;
	};
	
	//Map specific move drone function
	this.moveDroneCount = 0;
	this.moveDrone = function(ID, rate, fastRate)
	{
		if (rate == undefined) rate = 1;
		if (fastRate == undefined) fastRate = ~~(Game.fastRate);
		
		var bot = Game.bots[ID];
		var speed = bot.data.movespeed*rate*fastRate;
		
		//Special check to make sure we did not enter infiniti loop
		this.moveDroneCount++;
		if (this.moveDroneCount >= 10)
		{
			this.moveDroneCount = 0;
			bot.pointAccess = "direct";
			bot.point = ~~(Math.random()*this.dronePathPoints.length);
			return false;
		}
		
		//Direction?
		var newpoint = bot.point + bot.direction;
		if (newpoint < 0) newpoint = this.dronePathPoints.length - 1;
		else if (newpoint > this.dronePathPoints.length-1) newpoint = 0;
		var pointMap = this.dronePathPoints[newpoint];
		var d = Math.sqrt((pointMap.x - bot.x)*(pointMap.x - bot.x) + (pointMap.y - bot.y)*(pointMap.y - bot.y));
		if (d < speed*2)
		{
			bot.point = newpoint;
			this.moveDrone(ID);
			return true;
		}
		
		//var cxt = Render.tvContext, gxt = Render.gp0Context;
		//cxt.fillStyle = "red"; gxt.fillStyle = "red";
		
		//Determine where to go
		var pois = [bot.point-1, bot.point, bot.point+1, -2], poi, poiEntry, dcheck = 200, eObj, _d;
		var enemies = Game.enemiesList, eIDtoUse = null, eDtoUse = null;
		if (bot.enemyLockOn && enemies[bot.enemyLockOn] != undefined)
		{
			eIDtoUse = bot.enemyLockOn;
		} else delete bot.enemyLockOn;
		if (eIDtoUse == null)
		{
			for(var key in pois)
			{
				poi = pois[key];
				if (poi != -2)
				{
					if (poi < 0) poi = this.dronePathPoints.length - 1;
					else if (poi > this.dronePathPoints.length-1) poi = 0;
					poiEntry = this.dronePathPoints[poi];
				} else poiEntry = {x: bot.x, y: bot.y};
				
				//Check for enemies close by
				for(var eID in enemies)
				{
					eObj = enemies[eID];
					_d = Math.sqrt((eObj.x - poiEntry.x)*(eObj.x - poiEntry.x) + (eObj.y - poiEntry.y)*(eObj.y - poiEntry.y));
					if (_d <= dcheck)
					{
						_d = Math.sqrt((eObj.x - bot.x)*(eObj.x - bot.x) + (eObj.y - bot.y)*(eObj.y - bot.y));
						if (eIDtoUse == null || _d > eDtoUse)
						{
							eIDtoUse = eID;
							eDtoUse = _d;
						}
					}
				}
				
				//cxt.beginPath();
				//cxt.arc(poiEntry.x, poiEntry.y, dcheck, 0, 2*Math.PI, false);
				//cxt.fill();
			}
		}
		if (eIDtoUse)
		{
			pointMap = enemies[eIDtoUse];
			bot.enemyLockOn = eIDtoUse;
			
			/*cxt.strokeStyle = "yellow";
			cxt.beginPath();
			cxt.moveTo(bot.x, bot.y);
			cxt.lineTo(pointMap.x, pointMap.y);
			cxt.stroke();*/
		} else {
			//Advance smoothly to next point
			if (bot.fireduponenemy != undefined && bot.fireduponenemy)
			{
				var poiToUse = null, poiToUseD = null;
				pois = [bot.point, bot.point+bot.direction, bot.point+bot.direction*2]; _d;
				for(var key in pois)
				{
					poi = pois[key];
					if (poi < 0) poi = this.dronePathPoints.length - 1;
					else if (poi > this.dronePathPoints.length-1) poi = 0;
					poiEntry = this.dronePathPoints[poi];
					_d = Math.sqrt((bot.x - poiEntry.x)*(bot.x - poiEntry.x) + (bot.y - poiEntry.y)*(bot.y - poiEntry.y));
					
					if (poiToUseD == null || poiToUseD > _d)
					{
						poiToUse = poi;
						poiToUseD = _d;
					}
				}
				
				bot.fireduponenemy = false;
				
				if (poiToUse !== null)
				{
					poi = poiToUse+bot.direction;
					if (poi < 0) poi = this.dronePathPoints.length - 1;
					else if (poi > this.dronePathPoints.length-1) poi = 0;
					
					bot.point = poiToUse;
					pointMap = this.dronePathPoints[poi];
				}
			}
		}
		
		//Change Destination Points
		bot.destination.x = pointMap.x;
		bot.destination.y = pointMap.y;
		
		/*var cxt = Render.tvContext, gxt = Render.gp0Context;
		cxt.fillStyle = "red"; gxt.fillStyle = "red";
		cxt.strokeStyle = "red"; gxt.strokeStyle = "red";
		cxt.fillRect(pointMap.x-10, pointMap.y-10, 20, 20);*/
		
		//Determine if point is less then speed
		_d = Math.sqrt((bot.x - pointMap.x)*(bot.x - pointMap.x) + (bot.y - pointMap.y)*(bot.y - pointMap.y));
		if (_d < speed) speed = _d;
		if ((speed < 0 ? -speed : speed) < 0.01) return true;
		
		//Determine x and y increases
		var dX = ((pointMap.x - bot.x) < 0 ? -(pointMap.x - bot.x) : (pointMap.x - bot.x)),
			dY = ((pointMap.y - bot.y) < 0 ? -(pointMap.y - bot.y) : (pointMap.y - bot.y));
		var xSide = 0, ySide = 0;
		if (dX == 0 && pointMap.y - bot.y < 0) { ySide = -1*speed; }
		else if (dX == 0 && pointMap.y - bot.y > 0) { ySide = speed; }
		else if (dY == 0 && pointMap.x - bot.x < 0) { xSide = -1*speed; }
		else if (dY == 0 && pointMap.x - bot.x > 0) { xSide = speed; }
		else {
			var angleA = Math.atan(dX/dY);// * (180 / Math.PI);
			xSide = speed*Math.sin(angleA); if (xSide < 0) xSide *= -1;
			ySide = speed*Math.cos(angleA); if (ySide < 0) ySide *= -1;
			//xSide = (angleA/90)*speed;
			//ySide = ((90-angleA)/90)*speed;
			
			if (pointMap.x - bot.x < 0 && pointMap.y - bot.y < 0) { xSide *= -1; ySide *= -1; }
			else if (pointMap.x - bot.x > 0 && pointMap.y - bot.y < 0) { ySide *= -1; }
			else if (pointMap.x - bot.x > 0 && pointMap.y - bot.y > 0) {  }
			else if (pointMap.x - bot.x < 0 && pointMap.y - bot.y > 0) { xSide *= -1; }
		}
		
		bot.x += xSide; bot.y += ySide;
		var gp0Cord = Game.calculateGPCords(bot.x, bot.y);
		bot.x2 = gp0Cord.x2; bot.y2 = gp0Cord.y2;
		this.moveDroneCount = 0;
		
		/*
		var gxt = Render.gp0Context;
		gxt.fillStyle = "#FFF";
		gxt.fillRect(0, 0, 400, 200);
		gxt.font = "14px Noto Sans";
		gxt.fillStyle = "#000";
		gxt.fillText(dX, 15, 15);
		gxt.fillText(dY, 15, 35);
		gxt.fillText(xSide, 15, 55);
		gxt.fillText(ySide, 15, 75);
		gxt.fillText(bot.x, 15, 95);
		gxt.fillText(bot.y, 15, 115);*/
	};
};
var MapBDU = new MapBDU();