function MapHyperspace()
{
	this.map = "hyperspace";
	this.base = [{
		x: Render.trueWidth*0.85,	x2: Render.gp0Width*0.85,
		y: Render.trueHeight*0.5,y2: Render.gp0Height*0.5,
		r: 100/2,				r2: (100/2)*Render.gp0RenderRatio,
		life: 100,
		maxLife: 100,
		shield: 0, shieldUse: 0
	}];
	this.gp0ScreenOffset = {x: 225, y: 0};
	this.storeRules = {
		drone: {
			enabled: false
		}
	};
	this.walls = [];
	this.dronePathPoints = [];
	this.dronePathPointsOnReturn = [];
	this.enemyPaths = [{
		speed: 7.0,//1586
		base: 0,
		path: [{
			x: -50,
			y: Render.trueHeight*0.5
		}, {
			x: this.base[0].x,
			y: this.base[0].y
		}]
	}, {
		speed: 7.0,//1608.82
		base: 0,
		path: [{
			x: -50,
			y: Render.trueHeight*0.25
		}, {
			x: this.base[0].x,
			y: this.base[0].y
		}]
	}, {
		speed: 7.0,//1608.82
		base: 0,
		path: [{
			x: -50,
			y: Render.trueHeight*0.75
		}, {
			x: this.base[0].x,
			y: this.base[0].y
		}]
	}, {
		speed: 7.0,//1665.60
		base: 0,
		path: [{
			x: -50,
			y: Render.trueHeight*0.35
		}, {
			x: Render.trueWidth*0.25,
			y: Render.trueHeight*0.45
		}, {
			x: Render.trueWidth*0.5,
			y: Render.trueHeight*0.65
		}, {
			x: this.base[0].x,
			y: this.base[0].y
		}]
	}, {
		speed: 7.0,//1665.60
		base: 0,
		path: [{
			x: -50,
			y: Render.trueHeight*0.65
		}, {
			x: Render.trueWidth*0.25,
			y: Render.trueHeight*0.55
		}, {
			x: Render.trueWidth*0.5,
			y: Render.trueHeight*0.35
		}, {
			x: this.base[0].x,
			y: this.base[0].y
		}]
	}];
	
	//Init
	this.init = function(options)
	{
		if (options == undefined) options = {};
		if (options.mode == undefined) options.mode = Game.mode;
		
		ClickBank.clearAll();
		InputBank.clearAll();
		Render.soundsStopAll();
		
		this.renderBackgroundTV = true;
		this.renderBackgroundGP0 = true;
		this.renderBackgroundGP0Cache = {};
		
		//Base
		this.base[0].life = this.base[0].maxLife;
		this.base[0].shield = 0;
		this.base[0].shieldUse = 0;
		var base;
		for(var key in this.base)
		{
			base = this.base[key];
			base.cache = {};
		}
		
		//Music
		if (Render.sounds["levelbg"].readyState > 0)
			Render.sounds["levelbg"].currentTime = 0;
		Render.sounds["levelbg"].play();
		
		//Game init
		Game.map = this.map;
		Game.mapClass = this;
		Game.mode = options.mode;
		Game.init({money: 300});
		
		//Spots
		var spots = [{
			x: Render.trueWidth*0.65,
			y: Render.trueHeight*0.5
		}, {
			x: Render.trueWidth*0.8-85,
			y: Render.trueHeight*0.5-85
		}, {
			x: Render.trueWidth*0.8-85,
			y: Render.trueHeight*0.5+85
		}, {
			x: Render.trueWidth*0.55,
			y: Render.trueHeight*0.5-200
		}, {
			x: Render.trueWidth*0.55,
			y: Render.trueHeight*0.5+200
		}];
		var spot;
		for(var key in spots)
		{
			spot = spots[key];
			gp0Cord = Game.calculateGPCords(spot.x, spot.y);
			
			Game.spotsAdd({
				x: spot.x, y: spot.y, r: 20,
				x2: gp0Cord.x2, y2: gp0Cord.y2, r2: 20*Render.gp0RenderRatio
			});
		}
		
		Render.renderControl = function(){ MapHyperspace.render(); };
		
		Game.startGame();

		//Game.botsDroneAdd();
		/*Game.botsDroneAdd();
		Game.botsDroneAdd();
		Game.botsDroneAdd();
		Game.botsDroneAdd();*/
		//var ID = Game.botsAdd("sentry", Render.trueWidth/2, Render.trueHeight/2, Render.gp0Width/2, Render.gp0Height/2);
	};
	
	//Map Render
	this.render = function()
	{
		//Clear
		Render.renderClear("all");
		var cxt = Render.tvContext, gxt = Render.gp0Context;
		
		//Gamepad Slice Cache Reset
		var gp0Cord = Game.calculateGPCords(0, 0);
		if (this.renderBackgroundGP0Cache.x0 == undefined || this.renderBackgroundGP0Cache.x0 != gp0Cord.x2
		 || this.renderBackgroundGP0Cache.y0 == undefined || this.renderBackgroundGP0Cache.y0 != gp0Cord.y2
		 || this.renderBackgroundGP0Cache.z0 == undefined || this.renderBackgroundGP0Cache.z0 != Render.gp0RenderRatio)
		{
			this.renderBackgroundGP0 = true;
			Game.resetGP0SliceCache = true;
			
			this.renderBackgroundGP0Cache.x0 = gp0Cord.x2;
			this.renderBackgroundGP0Cache.y0 = gp0Cord.y2;
			this.renderBackgroundGP0Cache.z0 = Render.gp0RenderRatio;
		}
		
		//Gamepad Display Move
		Render.gp0DisplayMoveStart();
		
		//Background
		this.renderBackground();
		
		//Bots
		Game.renderBots();
		
		//Render Bases
		Render.renderBases();
		
		//Call Gamer Render function
		Game.render();
		
		Game.resetGP0SliceCache = false;
		
		/*
		//Show Enemy Paths
		cxt.strokeStyle = "pink"; gxt.strokeStyle = "pink";
		cxt.fillStyle = "maroon"; gxt.fillStyle = "maroon";
		var points, point, point2, d;
		for(var key in this.enemyPaths)
		{
			points = this.enemyPaths[key];
			
			d = 0;
			cxt.beginPath(); gxt.beginPath();
			for(var i=0,n=points.path.length; i<n; i++)
			{
				point = points.path[i];
				gp0Cord = Game.calculateGPCords(point.x, point.y);
				
				if (i == 0)
				{
					cxt.moveTo(point.x, point.y); gxt.moveTo(gp0Cord.x2, gp0Cord.y2);
				} else {
					cxt.lineTo(point.x, point.y); gxt.lineTo(gp0Cord.x2, gp0Cord.y2);
					point2 = points.path[i-1];
					d += Math.sqrt((point.x - point2.x)*(point.x - point2.x) + (point.y - point2.y)*(point.y - point2.y));
				}
				
				cxt.fillRect(point.x-10, point.y-10, 20, 20);
				gxt.fillRect(gp0Cord.x2-5, gp0Cord.y2-5, 10, 10);
			}
			cxt.stroke(); gxt.stroke();
			if (points.distance == undefined)
			{
				console.log(key, d);
				points.distance = d;
			}
		}
		*/
	};

	//Hanldes the render of the Background
	this.renderBackgroundTV = true;
	this.renderBackgroundGP0 = true; this.renderBackgroundGP0Cache = {};
	this.backgroundImages = []; this.backgroundEdgeImages = [];
	this.renderBackground = function()
	{
		//var cxt = Render.tvContext, gxt = Render.gp0Context;
		var cxt = Render.returnTVSliceContext(1), gxt = Render.returnGP0SliceContext(1);
		var speed = Game.isPaused || Game.gamePause ? 0 : (Game.fastEnabled ? Game.fastRate : 1);
		if (speed > 3) speed = 3;
		
		//Setup
		if (this.backgroundImages.length == 0)
		{
			var x=0,y=Render.trueHeight*0.20,w=Render.images["space_long"].width*1.5,h=Render.trueHeight*0.6;
			var h2 = Render.images["space_long"].height;
			
			this.backgroundImages[this.backgroundImages.length] = ({
				x: x, y: y, y2: h2*0.2, w: w, h: h, h2: h2*0.6, d: 1
			});
			this.backgroundImages[this.backgroundImages.length] = ({
				x: x+w, y: y, y2: h2*0.2, w: w, h: h, h2: h2*0.6, d: -1
			});
			
			/*var bDatas = [{
				y: 0.19, h: 0.025, s: 36.5, sd: 1.5, d: -1
			}, {
				y: 0.80, h: 0.025, s: 36.5, sd: 1.5, d: 1
			}], bData;*/
			var bDatas = [{
				y: 0.19, h: 0.01, s: 36.5, sd: 1.5, d: -1
			}, {
				y: 0.80, h: 0.01, s: 36.5, sd: 1.5, d: 1
			}], bData;
			for(var key in bDatas)
			{
				bData = bDatas[key];
				
				while(bData.y >= 0 && bData.y < 1)
				{
					this.backgroundEdgeImages[this.backgroundEdgeImages.length] = ([{
						x: 0, y: Render.trueHeight*bData.y, y2: h2*bData.y, w: w, h: Render.trueHeight*bData.h, h2: h2*bData.h, d: 1, speed: bData.s
					}, {
						x: w, y: Render.trueHeight*bData.y, y2: h2*bData.y, w: w, h: Render.trueHeight*bData.h, h2: h2*bData.h, d: -1, speed: bData.s
					}]);
					
					if (bData.y > 0)
					{
						bData.y += bData.h*bData.d;
						bData.y2 += bData.h2*bData.d;
						if (bData.y < 0) bData.y = 0;
						if (bData.y2 < 0) bData.y2 = 0;
					} else {
						bData.y += bData.h*bData.d;
						bData.y2 += bData.h2*bData.d;
					}
					//bData.y += bData.h*bData.d;
					//bData.y2 += bData.h2*bData.d;
					bData.s += bData.sd;
				}
			}
			
			this._bImgW = Render.images["space_long"].width;
			this._bImgH = Render.images["space_long"].height;
		}
		
		//Display
		var image, gp0Cord, imgW = this._bImgW, imgH = this._bImgH;
		//for(var key in this.backgroundEdgeImages)
		var key = this.backgroundEdgeImages.length-1, key2;
		do
		{
			//for(var key2 in this.backgroundEdgeImages[key])
			key2 = this.backgroundEdgeImages[key].length-1;
			do
			{
				image = this.backgroundEdgeImages[key][key2];
				gp0Cord = Game.calculateGPCords(image.x, image.y);
				
				cxt.drawImage(Render.images["space_long"+(image.d == -1 ? "2" : "")], 0, image.y2*Render.renderTVRatio, imgW, image.h2, image.x*Render.renderTVRatio, image.y*Render.renderTVRatio, image.w*Render.renderTVRatio, image.h*Render.renderTVRatio);
				gxt.drawImage(Render.images["space_long"+(image.d == -1 ? "2" : "")], 0, image.y2, imgW, image.h2, gp0Cord.x2, gp0Cord.y2, image.w*Render.gp0RenderRatio, image.h*Render.gp0RenderRatio);
			} while(key2--);
		} while(key--);
		//for(var key in this.backgroundImages)
		key = this.backgroundImages.length-1;
		do
		{
			image = this.backgroundImages[key];
			gp0Cord = Game.calculateGPCords(image.x, image.y);
			
			//cxt.drawImage(Render.images["space_long"+(image.d == -1 ? "2" : "")], image.x, image.y, image.w, image.h);
			//gxt.drawImage(Render.images["space_long"+(image.d == -1 ? "2" : "")], gp0Cord.x2, gp0Cord.y2, image.w*Render.gp0RenderRatio, image.h*Render.gp0RenderRatio);
			cxt.drawImage(Render.images["space_long"+(image.d == -1 ? "2" : "")], 0, image.y2, imgW, image.h2, image.x*Render.renderTVRatio, image.y*Render.renderTVRatio, image.w*Render.renderTVRatio, image.h*Render.renderTVRatio);
			gxt.drawImage(Render.images["space_long"+(image.d == -1 ? "2" : "")], 0, image.y2, imgW, image.h2, gp0Cord.x2, gp0Cord.y2, image.w*Render.gp0RenderRatio, image.h*Render.gp0RenderRatio);
		} while(key--);
		
		//Move the image
		//for(var key in this.backgroundEdgeImages)
		key = this.backgroundEdgeImages.length-1
		do
		{
			//for(var key2 in this.backgroundEdgeImages[key])
			key2 = this.backgroundEdgeImages[key].length-1;
			do
			{
				this.backgroundEdgeImages[key][key2].x -= this.backgroundEdgeImages[key][key2].speed*speed*0.5;
			} while(key2--);
		} while(key--);
		//for(var key in this.backgroundEdgeImages)
		key = this.backgroundEdgeImages.length-1
		do
		{
			if (this.backgroundEdgeImages[key][0].x + this.backgroundEdgeImages[key][0].w <= 0)
			{
				this.backgroundEdgeImages[key].shift();
				this.backgroundEdgeImages[key][this.backgroundEdgeImages[key].length] = ({
					x: this.backgroundEdgeImages[key][0].x+this.backgroundEdgeImages[key][0].w, y: this.backgroundEdgeImages[key][0].y,
					w: this.backgroundEdgeImages[key][0].w, h: this.backgroundEdgeImages[key][0].h,
					y2: this.backgroundEdgeImages[key][0].y2, h2: this.backgroundEdgeImages[key][0].h2,
					d: -1*this.backgroundEdgeImages[key][0].d, speed: this.backgroundEdgeImages[key][0].speed
				});
			}
		} while(key--);
		//for(var key in this.backgroundImages)
		key = this.backgroundImages.length-1;
		do
		{
			this.backgroundImages[key].x -= 35*speed*0.5;
		} while(key--);
		if (this.backgroundImages[0].x + this.backgroundImages[0].w <= 0)
		{
			var x=0,y=Render.trueHeight*0.20,w=Render.images["space_long"].width*1.5,h=Render.trueHeight*0.6;
			this.backgroundImages.shift();
			this.backgroundImages[this.backgroundImages.length] = ({
				x: x+this.backgroundImages[0].x+this.backgroundImages[0].w, y: y, w: w, h: h, d: -1*this.backgroundImages[0].d,
				y2: this.backgroundImages[0].y2, h2: this.backgroundImages[0].h2
			});
		}
		
		return true;
		
		//Darken
		cxt.globalAlpha = 0.75;
		gxt.globalAlpha = 0.75;
		cxt.fillStyle = "#000";
		gxt.fillStyle = "#000";
		gp0Cord = Game.calculateGPCords(0, Render.trueHeight*0.2);
		cxt.fillRect(0, Render.trueHeight*0.2*Render.renderTVRatio, Render.trueWidth*Render.renderTVRatio, Render.trueHeight*0.6*Render.renderTVRatio);
		gxt.fillRect(gp0Cord.x2, gp0Cord.y2, Render.trueWidth*Render.gp0RenderRatio, Render.trueHeight*0.6*Render.gp0RenderRatio);
		
		/*var bDatas = [{
			y: Render.trueHeight*0.19, h: Render.trueHeight*0.025, a: 0.70, ad: 0.02, d: -1
		}, {
			y: Render.trueHeight*0.8, h: Render.trueHeight*0.025, a: 0.70, ad: 0.02, d: 1
		}], bData;*/
		var bDatas = this._bDatas, bData;
		bDatas[0].y = Render.trueHeight*0.19; bDatas[0].a = 0.7;
		bDatas[1].y = Render.trueHeight*0.8; bDatas[1].a = 0.7;
		//for(var key in bDatas)
		key = bDatas.length-1;
		do
		{
			bData = bDatas[key];
			
			while(bData.y >= 0 && bData.y < Render.trueHeight)
			{
				cxt.globalAlpha = bData.a;
				gxt.globalAlpha = bData.a;
				gp0Cord = Game.calculateGPCords(0, bData.y);
				cxt.fillRect(0, bData.y*Render.renderTVRatio, Render.trueWidth*Render.renderTVRatio, bData.h*Render.renderTVRatio);
				gxt.fillRect(gp0Cord.x2, gp0Cord.y2, Render.trueWidth*Render.gp0RenderRatio, bData.h*Render.gp0RenderRatio);
				
				if (bData.y > 0)
				{
					bData.y += bData.h*bData.d;
					if (bData.y < 0) bData.y = 0;
				} else {
					bData.y += bData.h*bData.d;
				}
				//bData.y += bData.h*bData.d;
				bData.a -= bData.ad;
			}
		} while(key--);
		
		cxt.globalAlpha = 1;
		gxt.globalAlpha = 1;
	};
	this._bDatas = [{
		y: Render.trueHeight*0.19, h: Render.trueHeight*0.01, a: 0.70, ad: 0.02, d: -1
	}, {
		y: Render.trueHeight*0.8, h: Render.trueHeight*0.01, a: 0.70, ad: 0.02, d: 1
	}];
	this._bImgW = 0; this.bImgH = 0;
	
	
	//Map specific spawn enemy function
	//Returns specific data, such as pattern, start position, etc
	this.spawnEnemy = function()
	{
		var data = {};
		data.pattern = Math.floor(Math.random()*(this.enemyPaths.length));
		//if (Math.random() <= 0.05) data.pattern = this.enemyPaths.length-1;
		
		var pathData = this.enemyPaths[data.pattern];
		data.speed = pathData.speed;
		data.point = 0;
		data.startX = pathData.path[0].x;
		data.startY = pathData.path[0].y;
		
		data.destination = {};
		data.destination.x = pathData.path[1].x;
		data.destination.y = pathData.path[1].y;
		
		return data;
	};
	
	//Map specific move enemy function
	this.moveEnemy = function(ID, obj, rate)
	{
		if (rate == undefined) rate = 1;
		var pathData = this.enemyPaths[obj.pattern],
			path = pathData.path,
			pathPoint = obj.data.point,
			speed = obj.speed*rate;
		if (obj.data.point >= pathData.path.length-1) return true;
		
		var newpoint = pathPoint+1;
		var pointMap = path[newpoint];
		var d = Math.sqrt((pointMap.x - obj.x)*(pointMap.x - obj.x) + (pointMap.y - obj.y)*(pointMap.y - obj.y));
		if (d < speed*2)
		{
			obj.data.point = newpoint;
			obj.x = pointMap.x; obj.y = pointMap.y;
			this.moveEnemy(ID, obj);
			return true;
		}
		
		
		if (!pointMap) return false;
		
		//Change Destination Points
		obj.data.destination.x = pointMap.x;
		obj.data.destination.y = pointMap.y;
		
		//Determine x and y increases
		var dX = Math.abs(pointMap.x - obj.x), dY = Math.abs(pointMap.y - obj.y);
		var xSide = 0.0, ySide = 0.0;
		if (dX == 0 && pointMap.y - obj.y < 0) { ySide = -1*speed; }
		else if (dX == 0 && pointMap.y - obj.y > 0) { ySide = speed; }
		else if (dY == 0 && pointMap.x - obj.x < 0) { xSide = -1*speed; }
		else if (dY == 0 && pointMap.x - obj.x > 0) { xSide = speed; }
		else {
			var angleA = Math.atan(dX/dY);// * (180 / Math.PI);
			xSide = Math.abs(speed*Math.sin(angleA));
			ySide = Math.abs(speed*Math.cos(angleA));
			//xSide = (angleA/90)*speed;
			//ySide = ((90-angleA)/90)*speed;
			
			if (pointMap.x - obj.x < 0 && pointMap.y - obj.y < 0) { xSide *= -1; ySide *= -1; }
			else if (pointMap.x - obj.x > 0 && pointMap.y - obj.y < 0) { ySide *= -1; }
			else if (pointMap.x - obj.x > 0 && pointMap.y - obj.y > 0) {  }
			else if (pointMap.x - obj.x < 0 && pointMap.y - obj.y > 0) { xSide *= -1; }
		}
		
		obj.x += xSide; obj.y += ySide;
	};
	
	
	//Map Sepecific spawn drone function
	//Returns spawn data, specifically the x/y
	this.spawnDrone = function()
	{
		return null;
	};
	
	//Map specific move drone function
	this.moveDroneCount = 0
	this.moveDrone = function(ID)
	{
		return null;
	};
};
var MapHyperspace = new MapHyperspace();