function MapKaRaBelt()
{
	this.map = "karabelt";
	this.base = [{
		x: Render.trueWidth*0.3,	x2: Render.gp0Width/2,
		y: Render.trueHeight*0.95,y2: Render.gp0Height*0.55,
		r: 80/2,				r2: (80/2)*Render.gp0RenderRatio,
		life: 50,
		maxLife: 50,
		shield: 0, shieldUse: 0
	}, {
		x: Render.trueWidth*0.7,	x2: Render.gp0Width/2,
		y: Render.trueHeight*0.95,y2: Render.gp0Height*0.55,
		r: 80/2,				r2: (80/2)*Render.gp0RenderRatio,
		life: 50,
		maxLife: 50,
		shield: 0, shieldUse: 0
	}];
	this.gp0ScreenOffset = {x: 0, y: 168};
	this.storeRules = {
		drone: {createData:{movespeed: 3.50}, enabled: false}
	};
	this.walls = [];
	this.dronePathPointsOnReturn = [];
	this.enemyPaths = [{
		speed: 6.5,
		base: 0,
		path: [{
			x: 0,
			y: Render.trueHeight*0.5
		}, {
			x: this.base[0].x,
			y: this.base[0].y
		}]
	}, {
		speed: 6.5,
		base: 0,
		path: [{
			x: Render.trueWidth*0.5,
			y: Render.trueHeight*1
		}, {
			x: this.base[0].x,
			y: this.base[0].y
		}]
	}, {
		speed: 6.5,
		base: 0,
		path: [{
			x: Render.trueWidth,
			y: Render.trueHeight*0.5
		}, {
			x: this.base[0].x,
			y: this.base[0].y
		}]
	}];
	
	
	this.paddle = {};
	this.bricks = [];
	this.balls = [];
	this.lives = 3; this.livesStart = 3;
	this.enemyHitDamage = 0.1;
	
	
	//Init
	this.init = function(options)
	{
		if (options == undefined) options = {};
		if (options.mode == undefined) options.mode = Game.mode;
		
		ClickBank.clearAll();
		InputBank.clearAll();
		Render.soundsStopAll();
		
		this.renderBackgroundTV = true;
		this.renderBackgroundGP0 = true;
		this.renderBackgroundGP0Cache = {};
		this.renderBackgroundTVCover = true;
		this.renderBackgroundGP0Cover = true;
		
		//Base
		this.base[0].life = this.base[0].maxLife;
		this.base[0].shield = 0;
		this.base[0].shieldUse = 0;
		this.base[1].life = this.base[0].maxLife;
		this.base[1].shield = 0;
		this.base[1].shieldUse = 0;
		var base;
		for(var key in this.base)
		{
			base = this.base[key];
			base.cache = {};
		}
		
		//Music
		if (Render.sounds["levelbg"].readyState > 0)
			Render.sounds["levelbg"].currentTime = 0;
		Render.sounds["levelbg"].play();
		
		//Game init
		Game.map = this.map;
		Game.mapClass = this;
		Game.mode = options.mode;
		Game.init({money: 400});
		
		//Spots
		/*Game.spotsAdd({
			x: Render.trueWidth/2, y: Render.trueHeight*0.55, r: 20,
			x2: Render.gp0Width/2, y2: Render.gp0Height*0.55, r2: 20*Render.gp0RenderRatio
		});*/
		/*Game.spotsAdd({
			x: Render.trueWidth/2-this.base[0].r-30, y: Render.trueHeight*0.54, r: 20,
			x2: Render.gp0Width/2-this.base[0].r2, y2: Render.gp0Height*0.55, r2: 20*Render.gp0RenderRatio
		});*/
		/*Game.spotsAdd({
			x: Render.trueWidth/2, y: Render.trueHeight*0.55-this.base[0].r-25, r: 20,
			x2: Render.gp0Width/2, y2: Render.gp0Height*0.55-this.base[0].r2, r2: 20*Render.gp0RenderRatio
		});*/
		/*Game.spotsAdd({
			x: Render.trueWidth/2+this.base[0].r+30, y: Render.trueHeight*0.54, r: 20,
			x2: Render.gp0Width/2+this.base[0].r2, y2: Render.gp0Height*0.55, r2: 20*Render.gp0RenderRatio
		});
		Game.spotsAdd({
			x: Render.trueWidth/2, y: Render.trueHeight*0.55+this.base[0].r+25, r: 20,
			x2: Render.gp0Width/2, y2: Render.gp0Height*0.55+this.base[0].r2, r2: 20*Render.gp0RenderRatio
		});*/
		
		//Add PING entry
		this.setupBrickLevel();
		this.spawnPaddle();
		
		Render.renderControl = function(){ MapKaRaBelt.render(); };
		
		Game.startGame();
		

		
		//Gamepad Extra
		var tab = {tab: "extra", title: "About"}, type = "extra";
		var minbasey = 34;
		var x=315,y=5,w=100,h=minbasey-y-1;
		var div = $(document.createElement("div"));
		div.attr({
			tab: type
		}).addClass("tab_buttons clickevents").css({
			position: "absolute",
			left: x+"px",
			top: y+"px",
			width: w+"px",
			height: h+"px",
			border: "1px solid #AAA",
			//"font-family": "Noto Sans",
			"font-size": "14px",
			color: "#FFF"
		}).html("<img class='img_off' src='media/etc/tab_off.jpg' style='width:"+w+"px;height:"+h+"px;"+(GameGP0Display.tab != type ? "" : "display:none;")+"' />" +
				"<img class='img_on' src='media/etc/tab_on.jpg' style='width:"+w+"px;height:"+h+"px;"+(GameGP0Display.tab != type ? "display:none;" : "")+"' />" +
				"<div class='dark' style='position:absolute;left:0px;top:0px;width:"+w+"px;height:"+h+"px;background:#000;opacity:0.3;display:"+(this.tab != type ? "none" : "block")+";'>&nbsp;</div>" +
				"<div style='position:absolute;left:0px;top:4px;width:"+w+"px;text-align:center;'>"+tab.title+"</div>").click(function()
		{
			GameGP0Display.switchTab($(this).attr("tab"));
		});
		GameGP0Display.container.find(".tab_buttons:last").after(div);
		
		var tab = $(document.createElement("div"));
		GameGP0Display.container.find(".tab:last").after(tab);
		tab.addClass("tab").attr({tab: "extra"}).css({
			position: "absolute",
			left: "0px",
			top: (minbasey+1)+"px",
			width: Render.gp0Width+"px",
			height: (Render.gp0Height-minbasey)+"px",
			display: "none"
		});
		var background = $(document.createElement("div"));
		background.css({
			position: "absolute",
			left: "0px",
			top: "0px",
			width: tab.width()+"px",
			height: tab.height()+"px",
			background: "#000"
		});
		tab.append(background);
		background = $(document.createElement("div"));
		background.css({
			position: "absolute",
			left: "0px",
			top: "0px",
			width: tab.width()+"px",
			height: tab.height()+"px",
			background: "#000",
			opacity: "0.85"
		});
		tab.append(background);
		
		var overflow = $(document.createElement("div"));
		overflow.addClass("overflow").css({
			position: "absolute",
			left: "0px",
			top: "0px",
			width: (tab.width()-30)+"px",
			height: (tab.height()-30)+"px",
			padding: "15px 15px",
			"overflow-x": "hidden",
			"overflow-y": "overflow"
		});
		tab.append(overflow);
		
		var div = $("<div />");
		div.css({
			color: "#CCC"
		}).html("<h2 style='margin-top:0px;color:#FFF;'>About PING 1.5+</h2>"+
			"PING is on a mission to save the world against the Spheres. Will he succeed? Only you can decide the world's fate with your \"ultimate master super gaming\" skills.");
		overflow.append(div);
		
		//Game.botsDroneAdd();
		/*Game.botsDroneAdd();
		Game.botsDroneAdd();
		Game.botsDroneAdd();
		Game.botsDroneAdd();*/
		//Game.botsAdd("sentry", Render.trueWidth/2, Render.trueHeight/2);
	};
	
	//Map Render
	this.counter = 0;
	this.render = function()
	{
		//Clear
		Render.renderClear("all");
		var cxt = Render.tvContext, gxt = Render.gp0Context;
		
		//Gamepad Slice Cache Reset
		var gp0Cord = Game.calculateGPCords(0, 0);
		if (this.renderBackgroundGP0Cache.x0 == undefined || this.renderBackgroundGP0Cache.x0 != gp0Cord.x2
		 || this.renderBackgroundGP0Cache.y0 == undefined || this.renderBackgroundGP0Cache.y0 != gp0Cord.y2
		 || this.renderBackgroundGP0Cache.z0 == undefined || this.renderBackgroundGP0Cache.z0 != Render.gp0RenderRatio)
		{
			this.renderBackgroundGP0 = true;
			this.renderBackgroundGP0Cover = true;
			Game.resetGP0SliceCache = true;
			
			this.renderBackgroundGP0Cache.x0 = gp0Cord.x2;
			this.renderBackgroundGP0Cache.y0 = gp0Cord.y2;
			this.renderBackgroundGP0Cache.z0 = Render.gp0RenderRatio;
		}
		
		//Gamepad Display Move
		Render.gp0DisplayMoveStart();
		
		//Background
		this.renderBackground();
		
		//Bots
		Game.renderBots();
		
		//Render Bases
		Render.renderBases();
		
		//Call Gamer Render function
		Game.render();
		
		Game.resetGP0SliceCache = false;
		
		/*
		//Show drone recorded path
		cxt.fillStyle = "red"; gxt.fillStyle = "red";
		cxt.strokeStyle = "red"; gxt.strokeStyle = "red";
		
		cxt.beginPath(); gxt.beginPath();
		
		var dronePath, gp0Cord;
		for(var i=0; i<this.dronePathPoints.length; i++)
		{
			dronePath = this.dronePathPoints[i];
			gp0Cord = Game.calculateGPCords(dronePath.x, dronePath.y);
			
			if (i == 0)
			{
				cxt.moveTo(dronePath.x, dronePath.y); gxt.moveTo(gp0Cord.x2, gp0Cord.y2);
			} else {
				cxt.lineTo(dronePath.x, dronePath.y); gxt.lineTo(gp0Cord.x2, gp0Cord.y2);
			}
			
			cxt.fillStyle = "#666"; gxt.fillStyle = "#666";
			cxt.fillRect(dronePath.x-10, dronePath.y-10, 20, 20);
			gxt.fillRect(gp0Cord.x2-5, gp0Cord.y2-5, 10, 10);
			cxt.fillStyle = "red"; gxt.fillStyle = "red";
		}
		dronePath = this.dronePathPoints[0];
		gp0Cord = Game.calculateGPCords(dronePath.x, dronePath.y);
		cxt.lineTo(dronePath.x, dronePath.y); gxt.lineTo(gp0Cord.x2, gp0Cord.y2);
		
		cxt.stroke(); gxt.stroke();*/
	};
	
	//Hanldes the render of the Background
	//this.backgroundFade = []; this.lastcalltime = 0;
	this.renderBackgroundTV = true;
	this.renderBackgroundGP0 = true; this.renderBackgroundGP0Cache = {};
	this.renderBackground = function()
	{
		var x=0,y=0,x2,y2,
			_w = Render.tvWidth, _h = Render.tvHeight,
			_w2 = Render.trueWidth*Render.gp0RenderRatio, _h2 = Render.trueHeight*Render.gp0RenderRatio;
		var gp0Cord = Game.calculateGPCords(x, y);
		if (this.renderBackgroundTV)
		{
			var cxt = Render.returnTVSliceContext(1);
			cxt.clearRect(0, 0, Render.tvWidth, Render.tvHeight);
			cxt.drawImage(Render.images["space1_60d"], x, y, _w, _h);
			this.renderBackgroundTV = false;
		}
		if (this.renderBackgroundGP0)
		{
			var gxt = Render.returnGP0SliceContext(1);
			gxt.clearRect(0, 0, Render.gp0Width, Render.gp0Height);
			gxt.drawImage(Render.images["space1_60d"], gp0Cord.x2, gp0Cord.y2, _w2, _h2);
			this.renderBackgroundGP0 = false;
		}
		
		//Bricks
		var cxt = Render.returnTVSliceContext(2), gxt = Render.returnGP0SliceContext(2);
		cxt.clearRect(0, 0, Render.tvWidth, Render.tvHeight);
		gxt.clearRect(0, 0, Render.gp0Width, Render.gp0Height);
		
		var brick;
		for(var key in this.bricks)
		{
			brick = this.bricks[key];

			cxt.fillStyle = "blue";
			cxt.strokeStyle = "#111";
			cxt.fillRect(brick.x*Render.renderTVRatio, brick.y*Render.renderTVRatio, brick.w*Render.renderTVRatio, brick.h*Render.renderTVRatio);
			cxt.strokeRect(brick.x*Render.renderTVRatio, brick.y*Render.renderTVRatio, brick.w*Render.renderTVRatio, brick.h*Render.renderTVRatio);
			
			gp0Cord = Game.calculateGPCords(brick.x, brick.y);
			gxt.fillStyle = "blue";
			gxt.strokeStyle = "#111";
			gxt.fillRect(gp0Cord.x2, gp0Cord.y2, brick.w*Render.gp0RenderRatio, brick.h*Render.gp0RenderRatio);
			gxt.strokeRect(gp0Cord.x2, gp0Cord.y2, brick.w*Render.gp0RenderRatio, brick.h*Render.gp0RenderRatio);
		}
		
		//Paddle
		cxt.fillStyle = "red";
		cxt.strokeStyle = "#111";
		cxt.fillRect(this.paddle.x*Render.renderTVRatio, this.paddle.y*Render.renderTVRatio, this.paddle.w*Render.renderTVRatio, this.paddle.h*Render.renderTVRatio);
		cxt.strokeRect(this.paddle.x*Render.renderTVRatio, this.paddle.y*Render.renderTVRatio, this.paddle.w*Render.renderTVRatio, this.paddle.h*Render.renderTVRatio);
		
		gp0Cord = Game.calculateGPCords(this.paddle.x, this.paddle.y);
		gxt.fillStyle = "red";
		gxt.strokeStyle = "#111";
		gxt.fillRect(gp0Cord.x2, gp0Cord.y2, this.paddle.w*Render.gp0RenderRatio, this.paddle.h*Render.gp0RenderRatio);
		gxt.strokeRect(gp0Cord.x2, gp0Cord.y2, this.paddle.w*Render.gp0RenderRatio, this.paddle.h*Render.gp0RenderRatio);
	};
	
	//Render the background cover
	this.renderBackgroundTVCover = true; this.renderBackgroundGP0Cover = true;
	this.renderBackgroundCover = function()
	{
		
	};
	
	//Start Level Call
	this.startLevel = function()
	{
		//if (Game.level % 5 == 0 && Game.level <= 20)
			//this.spawnPingBot();
	};
	
	//Endless Mode Increase Call
	this.endlessModeIncrease = function()
	{
		//if (Game.enemies.total % 25 == 0 && Game.enemies.total <= 100)
			//this.spawnPingBot();
	};
	
	this.setupBrickLevel = function()
	{
		this.bricks = [];
		
		var w = (Render.trueWidth/15), h = 25;
		for(var i=0; i<15; i++)
		{
			for(var j=0; j<15; j++)
			{
				this.bricks.push({
					x: j*w, y: i*h,
					w: w, h: h
				});
			}
		}
	};
	
	this.spawnPaddle = function()
	{
		this.paddle = {
			x: Render.trueWidth/2-50, y: Render.trueHeight*0.85-25/2,
			w: 100, h: 25
		};
	};
	
	
	//Spawns a Ping Bot
	this.spawnPingBot = function()
	{
		var pingID = Game.botsAdd("ping", Render.trueWidth*0.5, Render.trueHeight-10, 0, 0, "spotbot", {playBuildSound: false});
		var botPing = Game.bots[pingID];
		botPing.ping.dir.x = Math.floor(Math.random()*2) == 1 ? -1 : 1;
		botPing.ping.dir.y = -1;
		
		var xDiff = 0.4-(Math.floor(Math.random()*20)/100);
		var yDiff = 0.4-(Math.floor(Math.random()*20)/100);
		botPing.ping.dir.x += xDiff;
		botPing.ping.dir.y += yDiff;
	};
	
	
	//Map specific spawn enemy function
	//Returns specific data, such as pattern, start position, etc
	this.spawnEnemy = function()
	{
		var data = {};
		data.pattern = Math.floor(Math.random()*(this.enemyPaths.length));
		
		var pathData = this.enemyPaths[data.pattern];
		data.speed = pathData.speed;
		data.point = 0;
		data.startX = pathData.path[0].x;
		data.startY = pathData.path[0].y;
		
		data.destination = {};
		data.destination.x = pathData.path[1].x;
		data.destination.y = pathData.path[1].y;
		
		return data;
	};
	
	//Map specific move enemy function
	this.moveEnemy = function(ID, obj, rate)
	{
		if (rate == undefined) rate = 1;
		var pathData = this.enemyPaths[obj.pattern],
			path = pathData.path,
			pathPoint = obj.data.point,
			speed = obj.speed*rate;
		if (obj.data.point >= pathData.path.length-1) return true;
		
		var newpoint = pathPoint+1;
		var pointMap = path[newpoint];
		var d = Math.sqrt((pointMap.x - obj.x)*(pointMap.x - obj.x) + (pointMap.y - obj.y)*(pointMap.y - obj.y));
		if (d < speed*2)
		{
			obj.data.point = newpoint;
			this.moveEnemy(ID, obj);
			return true;
		}
		
		//On final point?
		if (newpoint == path.length-1)
		{
			if (this.base[pathData.base].life <= 0)
			{
				if (obj.data.newbaseroute == undefined)
				{
					var base, newBase = null;
					for(var key in this.base)
					{
						if (newBase != null) continue;
						
						base = this.base[key];
						if (base.life > 0) newBase = key;
					}
					obj.data.newbaseroute = parseInt(newBase);
				}
				
				pointMap = this.base[obj.data.newbaseroute];
			}
		}
		
		
		if (!pointMap) return false;
		
		//Change Destination Points
		obj.data.destination.x = pointMap.x;
		obj.data.destination.y = pointMap.y;
		
		//Determine x and y increases
		var dX = Math.abs(pointMap.x - obj.x), dY = Math.abs(pointMap.y - obj.y);
		var xSide = 0, ySide = 0;
		if (dX == 0 && pointMap.y - obj.y < 0) { ySide = -1*speed; }
		else if (dX == 0 && pointMap.y - obj.y > 0) { ySide = speed; }
		else if (dY == 0 && pointMap.x - obj.x < 0) { xSide = -1*speed; }
		else if (dY == 0 && pointMap.x - obj.x > 0) { xSide = speed; }
		else {
			var angleA = Math.atan(dX/dY);// * (180 / Math.PI);
			xSide = Math.abs(speed*Math.sin(angleA));
			ySide = Math.abs(speed*Math.cos(angleA));
			//xSide = (angleA/90)*speed*1.3;
			//ySide = ((90-angleA)/90)*speed*1.3;
			
			if (pointMap.x - obj.x < 0 && pointMap.y - obj.y < 0) { xSide *= -1; ySide *= -1; }
			else if (pointMap.x - obj.x > 0 && pointMap.y - obj.y < 0) { ySide *= -1; }
			else if (pointMap.x - obj.x > 0 && pointMap.y - obj.y > 0) {  }
			else if (pointMap.x - obj.x < 0 && pointMap.y - obj.y > 0) { xSide *= -1; }

			//console.log(dX, dY, angleA, speed, xSide, ySide);
		}
		
		obj.x += xSide; obj.y += ySide;
		//this.enemyMovements.push({x: obj.x, y: obj.y});
		
		
		/*
		var x = obj.data.startX - this.base[0].x,
			y = obj.data.startY - this.base[0].y,
			s = obj.speed;
		
		//x: 1010 @ 580 ~17500 | 1.7414 | -1.74137
		//y: 590  @ 600 ~17500 | 0.9833
		var xs = x/s, ys = y/s;
		if (x != 0) xs = x/(s*Math.abs(580/s));
		//if (y != 0) ys = y/(s*Math.abs(600/s));
		
		obj.x -= xs;// * Math.abs(x/590));
		obj.y -= ys;// * Math.abs(y/590));*/
	};
	
	
	//Map Sepecific spawn drone function
	//Returns spawn data, specifically the x/y
	this.spawnDrone = function()
	{
		var data = {x: 0, y: 0, direction: Math.floor(Math.random()*2) == 0 ? -1 : 1};
		var pointindex = Math.floor(Math.random()*this.dronePathPoints.length);
		data.point = pointindex;
		
		//Choose point at random
		var point = this.dronePathPoints[pointindex];
		data.x = point.x;
		data.y = point.y;
		
		//Destination
		var newpoint = data.point + data.direction;
		if (newpoint < 0) newpoint = this.dronePathPoints.length - 1;
		else if (newpoint > this.dronePathPoints.length-1) newpoint = 0;
		var pointMap = this.dronePathPoints[newpoint];
		data.destination = {};
		data.destination.x = pointMap.x;
		data.destination.y = pointMap.y;
		
		return data;
	};
	
	//Map specific move drone function
	this.moveDroneCount = 0;
	this.moveDrone = function(ID, rate, fastRate)
	{
		if (rate == undefined) rate = 1;
		if (fastRate == undefined) fastRate = parseInt(Game.fastRate);
		
		var bot = Game.bots[ID];
		var speed = bot.data.movespeed*rate*fastRate;
		
		//Special check to make sure we did not enter infiniti loop
		this.moveDroneCount++;
		if (this.moveDroneCount >= 10)
		{
			this.moveDroneCount = 0;
			bot.pointAccess = "direct";
			bot.point = Math.floor(Math.random()*this.dronePathPoints.length);
			return false;
		}
		
		//Direction?
		var newpoint = bot.point + bot.direction;
		if (newpoint < 0) newpoint = this.dronePathPoints.length - 1;
		else if (newpoint > this.dronePathPoints.length-1) newpoint = 0;
		var pointMap = this.dronePathPoints[newpoint];
		var d = Math.sqrt((pointMap.x - bot.x)*(pointMap.x - bot.x) + (pointMap.y - bot.y)*(pointMap.y - bot.y));
		if (d < speed*2)
		{
			bot.point = newpoint;
			this.moveDrone(ID);
			return true;
		}
		
		//var cxt = Render.tvContext, gxt = Render.gp0Context;
		//cxt.fillStyle = "red"; gxt.fillStyle = "red";
		
		//Determine where to go
		var pois = [bot.point-1, bot.point, bot.point+1, -2], poi, poiEntry, dcheck = 200, eObj, _d;
		var enemies = Game.enemiesList, eIDtoUse = null, eDtoUse = null;
		if (bot.enemyLockOn && enemies[bot.enemyLockOn] != undefined)
		{
			eIDtoUse = bot.enemyLockOn;
		} else delete bot.enemyLockOn;
		if (eIDtoUse == null)
		{
			for(var key in pois)
			{
				poi = pois[key];
				if (poi != -2)
				{
					if (poi < 0) poi = this.dronePathPoints.length - 1;
					else if (poi > this.dronePathPoints.length-1) poi = 0;
					poiEntry = this.dronePathPoints[poi];
				} else poiEntry = {x: bot.x, y: bot.y};
				
				//Check for enemies close by
				for(var eID in enemies)
				{
					eObj = enemies[eID];
					_d = Math.sqrt((eObj.x - poiEntry.x)*(eObj.x - poiEntry.x) + (eObj.y - poiEntry.y)*(eObj.y - poiEntry.y));
					if (_d <= dcheck)
					{
						_d = Math.sqrt((eObj.x - bot.x)*(eObj.x - bot.x) + (eObj.y - bot.y)*(eObj.y - bot.y));
						if (eIDtoUse == null || _d > eDtoUse)
						{
							eIDtoUse = eID;
							eDtoUse = _d;
						}
					}
				}
				
				//cxt.beginPath();
				//cxt.arc(poiEntry.x, poiEntry.y, dcheck, 0, 2*Math.PI, false);
				//cxt.fill();
			}
		}
		if (eIDtoUse)
		{
			pointMap = enemies[eIDtoUse];
			bot.enemyLockOn = eIDtoUse;
			
			/*cxt.strokeStyle = "yellow";
			cxt.beginPath();
			cxt.moveTo(bot.x, bot.y);
			cxt.lineTo(pointMap.x, pointMap.y);
			cxt.stroke();*/
		} else {
			//Advance smoothly to next point
			if (bot.fireduponenemy != undefined && bot.fireduponenemy)
			{
				var poiToUse = null, poiToUseD = null;
				pois = [bot.point, bot.point+bot.direction, bot.point+bot.direction*2]; _d;
				for(var key in pois)
				{
					poi = pois[key];
					if (poi < 0) poi = this.dronePathPoints.length - 1;
					else if (poi > this.dronePathPoints.length-1) poi = 0;
					poiEntry = this.dronePathPoints[poi];
					_d = Math.sqrt((bot.x - poiEntry.x)*(bot.x - poiEntry.x) + (bot.y - poiEntry.y)*(bot.y - poiEntry.y));
					
					if (poiToUseD == null || poiToUseD > _d)
					{
						poiToUse = poi;
						poiToUseD = _d;
					}
				}
				
				bot.fireduponenemy = false;
				
				if (poiToUse !== null)
				{
					poi = poiToUse+bot.direction;
					if (poi < 0) poi = this.dronePathPoints.length - 1;
					else if (poi > this.dronePathPoints.length-1) poi = 0;
					
					bot.point = poiToUse;
					pointMap = this.dronePathPoints[poi];
				}
			}
		}
		
		//Change Destination Points
		bot.destination.x = pointMap.x;
		bot.destination.y = pointMap.y;
		
		/*var cxt = Render.tvContext, gxt = Render.gp0Context;
		cxt.fillStyle = "red"; gxt.fillStyle = "red";
		cxt.strokeStyle = "red"; gxt.strokeStyle = "red";
		cxt.fillRect(pointMap.x-10, pointMap.y-10, 20, 20);*/
		
		//Determine if point is less then speed
		_d = Math.sqrt((bot.x - pointMap.x)*(bot.x - pointMap.x) + (bot.y - pointMap.y)*(bot.y - pointMap.y));
		if (_d < speed) speed = _d;
		if (Math.abs(speed) < 0.01) return true;
		
		//Determine x and y increases
		var dX = Math.abs(pointMap.x - bot.x), dY = Math.abs(pointMap.y - bot.y);
		var xSide = 0, ySide = 0;
		if (dX == 0 && pointMap.y - bot.y < 0) { ySide = -1*speed; }
		else if (dX == 0 && pointMap.y - bot.y > 0) { ySide = speed; }
		else if (dY == 0 && pointMap.x - bot.x < 0) { xSide = -1*speed; }
		else if (dY == 0 && pointMap.x - bot.x > 0) { xSide = speed; }
		else {
			var angleA = Math.atan(dX/dY);// * (180 / Math.PI);
			xSide = Math.abs(speed*Math.sin(angleA));
			ySide = Math.abs(speed*Math.cos(angleA));
			//xSide = (angleA/90)*speed;
			//ySide = ((90-angleA)/90)*speed;
			
			if (pointMap.x - bot.x < 0 && pointMap.y - bot.y < 0) { xSide *= -1; ySide *= -1; }
			else if (pointMap.x - bot.x > 0 && pointMap.y - bot.y < 0) { ySide *= -1; }
			else if (pointMap.x - bot.x > 0 && pointMap.y - bot.y > 0) {  }
			else if (pointMap.x - bot.x < 0 && pointMap.y - bot.y > 0) { xSide *= -1; }
		}
		
		bot.x += xSide; bot.y += ySide;
		var gp0Cord = Game.calculateGPCords(bot.x, bot.y);
		bot.x2 = gp0Cord.x2; bot.y2 = gp0Cord.y2;
		this.moveDroneCount = 0;
		
		/*
		var gxt = Render.gp0Context;
		gxt.fillStyle = "#FFF";
		gxt.fillRect(0, 0, 400, 200);
		gxt.font = "14px Noto Sans";
		gxt.fillStyle = "#000";
		gxt.fillText(dX, 15, 15);
		gxt.fillText(dY, 15, 35);
		gxt.fillText(xSide, 15, 55);
		gxt.fillText(ySide, 15, 75);
		gxt.fillText(bot.x, 15, 95);
		gxt.fillText(bot.y, 15, 115);*/
	};
};
var MapKaRaBelt = new MapKaRaBelt();