function MapNebula()
{
	this.map = "nebula";
	this.base = [{
		x: Render.trueWidth*0.6,	x2: Render.gp0Width/2,
		y: Render.trueHeight*0.4,	y2: Render.gp0Height/2,
		r: 100/2,				r2: (100/2)*Render.gp0RenderRatio,
		life: 100,
		maxLife: 100,
		shield: 0, shieldUse: 0
	}];
	this.storeRules = {};
	
	this.animateBackground = true;
	this.mapOptions = [{
		type: "options_slider",
		value: "Animate Map",
		options: [{
			value: "No",
			iftrue: function()
			{
				return !Game.mapClass.animateBackground;
			},
			action: function()
			{
				Game.mapClass.animateBackground = false;
			}
		}, {
			value: "Yes",
			iftrue: function()
			{
				return Game.mapClass.animateBackground;
			},
			action: function()
			{
				Game.mapClass.animateBackground = true;
			}
		}],
		action: function()
		{
			Game.mapClass.animateBackground = !Game.mapClass.animateBackground;
		}
	}];
	
	this.walls = [];
	this.dronePathPoints = [{
		x: Render.trueWidth*0.285, y: Render.trueHeight*0.175
	}, {
		x: Render.trueWidth*0.29, y: Render.trueHeight*0.49
	}, {
		x: Render.trueWidth*0.325, y: Render.trueHeight*0.69
	}, {
		x: Render.trueWidth*0.58, y: Render.trueHeight*0.71
	}, {
		x: Render.trueWidth*0.77, y: Render.trueHeight*0.75
	}, {
		x: Render.trueWidth*0.95, y: Render.trueHeight*0.45
	}, {
		x: Render.trueWidth*0.8, y: Render.trueHeight*0.2
	}, {
		x: Render.trueWidth*0.61, y: Render.trueHeight*0.3
	}];
	this.dronePathPointsOnReturn = [];
	this.enemyPaths = [{
		speed: 2.75,
		base: 0,
		path: [{
			x: 0,
			y: 150
		}, {
			x: 550,
			y: 175
		}, {
			x: this.base[0].x,
			y: this.base[0].y
		}]
	}, {
		speed: 2.75,
		base: 0,
		path: [{
			x: 0,
			y: 400
		}, {
			x: 550,
			y: 800
		}, {
			x: this.base[0].x,
			y: this.base[0].y
		}]
	}, {
		speed: 2.75,
		base: 0,
		path: [{
			x: 1350,
			y: Render.trueHeight
		}, {
			x: 1450,
			y: 800
		}, {
			x: this.base[0].x,
			y: this.base[0].y
		}]
	}, {
		speed: 2.75,
		base: 0,
		path: [{
			x: Render.trueWidth,
			y: 750
		}, {
			x: this.base[0].x,
			y: this.base[0].y
		}]
	}, {
		speed: 2.75,
		base: 0,
		path: [{
			x: Render.trueWidth,
			y: 0
		}, {
			x: this.base[0].x,
			y: this.base[0].y
		}]
	}];
	
	//Init
	this.init = function(options)
	{
		if (options == undefined) options = {};
		if (options.mode == undefined) options.mode = Game.mode;
		
		ClickBank.clearAll();
		InputBank.clearAll();
		Render.soundsStopAll();
		
		this.renderBackgroundTV = true;
		this.renderBackgroundGP0 = true;
		this.renderBackgroundGP0Cache = {};
		this.renderBackgroundTVCover = true;
		this.renderBackgroundGP0Cover = true;
		this.backgroundCoverIndexCache = null;
		
		//Base
		this.base[0].life = this.base[0].maxLife;
		this.base[0].shield = 0;
		this.base[0].shieldUse = 0;
		var base;
		for(var key in this.base)
		{
			base = this.base[key];
			base.cache = {};
		}
		
		//Music
		if (Render.sounds["levelbg"].readyState > 0)
			Render.sounds["levelbg"].currentTime = 0;
		Render.sounds["levelbg"].play();
		
		//Game init
		Game.map = this.map;
		Game.mapClass = this;
		Game.mode = options.mode;
		Game.init({money: 400});
		
		//Spots
		Game.spotsAdd({
			x: Render.trueWidth*0.67, y: Render.trueHeight*0.32, r: 20,
			x2: 0, y2: 0, r2: 20*Render.gp0RenderRatio
		});
		Game.spotsAdd({
			x: Render.trueWidth*0.53, y: Render.trueHeight*0.38, r: 20,
			x2: 0, y2: 0, r2: 20*Render.gp0RenderRatio
		});
		Game.spotsAdd({
			x: Render.trueWidth*0.69, y: Render.trueHeight*0.46, r: 20,
			x2: 0, y2: 0, r2: 20*Render.gp0RenderRatio
		});
		Game.spotsAdd({
			x: Render.trueWidth*0.285, y: Render.trueHeight*0.175, r: 20,
			x2: 0, y2: 0, r2: 20*Render.gp0RenderRatio
		});
		Game.spotsAdd({
			x: Render.trueWidth*0.285, y: Render.trueHeight*0.75, r: 20,
			x2: 0, y2: 0, r2: 20*Render.gp0RenderRatio
		});
		Game.spotsAdd({
			x: Render.trueWidth*0.75, y: Render.trueHeight*0.735, r: 20,
			x2: 0, y2: 0, r2: 20*Render.gp0RenderRatio
		});
		
		Render.renderControl = function(){ MapNebula.render(); };
		
		Game.startGame();

		//Game.botsDroneAdd();
		/*Game.botsDroneAdd();
		Game.botsDroneAdd();
		Game.botsDroneAdd();
		Game.botsDroneAdd();*/
		//Game.botsAdd("sentry", Render.trueWidth/2, Render.trueHeight/2);
	};
	
	//Map Render
	this.render = function()
	{
		//Clear
		Render.renderClear("all");
		var cxt = Render.tvContext, gxt = Render.gp0Context;
		
		//Gamepad Slice Cache Reset
		var gp0Cord = Game.calculateGPCords(0, 0);
		if (this.renderBackgroundGP0Cache.x0 == undefined || this.renderBackgroundGP0Cache.x0 != gp0Cord.x2
		 || this.renderBackgroundGP0Cache.y0 == undefined || this.renderBackgroundGP0Cache.y0 != gp0Cord.y2
		 || this.renderBackgroundGP0Cache.z0 == undefined || this.renderBackgroundGP0Cache.z0 != Render.gp0RenderRatio)
		{
			this.renderBackgroundGP0 = true;
			this.renderBackgroundGP0Cover = true;
			Game.resetGP0SliceCache = true;
			
			this.renderBackgroundGP0Cache.x0 = gp0Cord.x2;
			this.renderBackgroundGP0Cache.y0 = gp0Cord.y2;
			this.renderBackgroundGP0Cache.z0 = Render.gp0RenderRatio;
		}
		
		//Gamepad Display Move
		Render.gp0DisplayMoveStart();
		
		//Background
		this.renderBackground();
		
		//Bots
		Game.renderBots();
		
		//Render Bases
		Render.renderBases();
		
		//Call Gamer Render function
		Game.render();
		
		Game.resetGP0SliceCache = false;
		
		//Show drone recorded path
		/*
		cxt.fillStyle = "red"; gxt.fillStyle = "red";
		cxt.strokeStyle = "red"; gxt.strokeStyle = "red";
		
		cxt.beginPath(); gxt.beginPath();
		
		var dronePath, gp0Cord;
		for(var i=0; i<this.dronePathPoints.length; i++)
		{
			dronePath = this.dronePathPoints[i];
			gp0Cord = Game.calculateGPCords(dronePath.x, dronePath.y);
			
			if (i == 0)
			{
				cxt.moveTo(dronePath.x, dronePath.y); gxt.moveTo(gp0Cord.x2, gp0Cord.y2);
			} else {
				cxt.lineTo(dronePath.x, dronePath.y); gxt.lineTo(gp0Cord.x2, gp0Cord.y2);
			}
			
			cxt.fillStyle = "#666"; gxt.fillStyle = "#666";
			cxt.fillRect(dronePath.x-10, dronePath.y-10, 20, 20);
			gxt.fillRect(gp0Cord.x2-5, gp0Cord.y2-5, 10, 10);
			cxt.fillStyle = "red"; gxt.fillStyle = "red";
		}
		dronePath = this.dronePathPoints[0];
		gp0Cord = Game.calculateGPCords(dronePath.x, dronePath.y);
		cxt.lineTo(dronePath.x, dronePath.y); gxt.lineTo(gp0Cord.x2, gp0Cord.y2);
		
		cxt.stroke(); gxt.stroke();*/
		
		//Show Enemy Paths
		/*
		cxt.strokeStyle = "pink"; gxt.strokeStyle = "pink";
		cxt.fillStyle = "maroon"; gxt.fillStyle = "maroon";
		var points, point, point2, d;
		for(var key in this.enemyPaths)
		{
			points = this.enemyPaths[key];
			
			d = 0;
			cxt.beginPath(); gxt.beginPath();
			for(var i=0,n=points.path.length; i<n; i++)
			{
				point = points.path[i];
				gp0Cord = Game.calculateGPCords(point.x, point.y);
				
				if (i == 0)
				{
					cxt.moveTo(point.x, point.y); gxt.moveTo(gp0Cord.x2, gp0Cord.y2);
				} else {
					cxt.lineTo(point.x, point.y); gxt.lineTo(gp0Cord.x2, gp0Cord.y2);
					point2 = points.path[i-1];
					d += Math.sqrt((point.x - point2.x)*(point.x - point2.x) + (point.y - point2.y)*(point.y - point2.y));
				}
				
				cxt.fillRect(point.x-10, point.y-10, 20, 20);
				gxt.fillRect(gp0Cord.x2-5, gp0Cord.y2-5, 10, 10);
			}
			cxt.stroke(); gxt.stroke();
			if (points.distance == undefined)
			{
				console.log(key, d);
				points.distance = d;
			}
		}
		*/
	};
	
	//Hanldes the render of the Background
	this.renderBackgroundTV = true;
	this.renderBackgroundGP0 = true; this.renderBackgroundGP0Cache = {};
	this.backgroundFade = []; this.lastcalltime = 0;
	this.renderBackground = function()
	{
		//var cxt = Render.tvContext, gxt = Render.gp0Context;
		
		var x=0,y=0,x2,y2,
			_w = Render.tvWidth, _h = Render.tvHeight,
			_w2 = Render.trueWidth*Render.gp0RenderRatio, _h2 = Render.trueHeight*Render.gp0RenderRatio;
		var gp0Cord = Game.calculateGPCords(x, y);
		if (this.renderBackgroundTV)
		{
			var cxt = Render.returnTVSliceContext(1);
			cxt.clearRect(0, 0, Render.tvWidth, Render.tvHeight);
			cxt.drawImage(Render.images["space1_60d"], x, y, _w, _h);
			this.renderBackgroundTV = false;
		}
		if (this.renderBackgroundGP0)
		{
			var gxt = Render.returnGP0SliceContext(1);
			gxt.clearRect(0, 0, Render.gp0Width, Render.gp0Height);
			gxt.drawImage(Render.images["space1_60d"], gp0Cord.x2, gp0Cord.y2, _w2, _h2);
			this.renderBackgroundGP0 = false;
		}
	};
	
	//Render the background cover
	this.renderBackgroundTVCover = true; this.renderBackgroundGP0Cover = true;
	this.backgroundCoverTTL = 5; this.backgroundCoverTTL0 = 5; this.backgroundCoverDirection = 1;
	this.backgroundCoverIndex = 1; this.backgroundCoverIndexMax = 3; 
	this.backgroundCoverX = {offset: 0, min: -3, max: 3, dir: 1, ttl: 10, ttl0: 10};
	this.backgroundCoverY = {offset: 0, min: -3, max: 3, dir: -1, ttl: 15, ttl0: 15};
	this.backgroundCoverIndexCache = null;
	this.renderBackgroundCover = function()
	{
		//var cxt = Render.tvContext, gxt = Render.gp0Context;
		
		var x=0,y=0,x2,y2,
			_w = Render.tvWidth+0, _h = Render.tvHeight+0,
			_w2 = Render.trueWidth*Render.gp0RenderRatio, _h2 = Render.trueHeight*Render.gp0RenderRatio;
		var gp0Cord = Game.calculateGPCords(x, y);
		//var gp0Cord2 = Game.calculateGPCords(this.backgroundCoverX.offset, this.backgroundCoverY.offset, true);

		if (this.renderBackgroundTVCover || this.backgroundCoverIndexCache != this.backgroundCoverIndex)
		{
			var cxt = Render.returnTVSliceContext(8);
			cxt.clearRect(0, 0, Render.tvWidth, Render.tvHeight);
			cxt.globalAlpha = 0.75;
			cxt.drawImage(Render.images["nebula_background"+this.backgroundCoverIndex], x+this.backgroundCoverX.offset, y+this.backgroundCoverY.offset, _w, _h);
			cxt.globalAlpha = 1;
			this.renderBackgroundTVCover = false;
		}
		if (this.renderBackgroundGP0Cover || this.backgroundCoverIndexCache != this.backgroundCoverIndex)
		{
			var gxt = Render.returnGP0SliceContext(8);
			gxt.globalAlpha = 0.75;
			gxt.clearRect(0, 0, Render.gp0Width, Render.gp0Height);
			gxt.drawImage(Render.images["nebula_background"+this.backgroundCoverIndex], gp0Cord.x2, gp0Cord.y2, _w2, _h2);
			gxt.globalAlpha = 1;
			this.renderBackgroundGP0Cover = false;
		}
		this.backgroundCoverIndexCache = this.backgroundCoverIndex;
		
		//Background Map
		/*cxt.globalAlpha = 0.75; gxt.globalAlpha = 0.75;
		cxt.drawImage(Render.images["nebula_background"+this.backgroundCoverIndex], x+this.backgroundCoverX.offset, y+this.backgroundCoverY.offset, _w, _h);
		gxt.drawImage(Render.images["nebula_background"+this.backgroundCoverIndex], gp0Cord.x2, gp0Cord.y2, _w2, _h2);
		cxt.globalAlpha = 1; gxt.globalAlpha = 1;*/
		
		if (!Game.isPaused && !Game.gamePause && this.animateBackground)
		{
			this.backgroundCoverTTL -= 1*0.5;
			
			if (this.backgroundCoverTTL <= 0)
			{
				this.backgroundCoverTTL = this.backgroundCoverTTL0;
				this.backgroundCoverIndex += this.backgroundCoverDirection;
				if (this.backgroundCoverIndex > this.backgroundCoverIndexMax || this.backgroundCoverIndex < 1)
				{
					this.backgroundCoverDirection *= -1;
					this.backgroundCoverIndex += this.backgroundCoverDirection*2;
				}
			}
		}
	};
	
	
	//Map specific spawn enemy function
	//Returns specific data, such as pattern, start position, etc
	this.spawnEnemy = function()
	{
		var data = {};
		data.pattern = Math.floor(Math.random()*this.enemyPaths.length);
		
		var pathData = this.enemyPaths[data.pattern];
		data.speed = pathData.speed;
		data.point = 0;
		data.startX = pathData.path[0].x;
		data.startY = pathData.path[0].y;
		
		data.destination = {};
		data.destination.x = pathData.path[1].x;
		data.destination.y = pathData.path[1].y;
		
		return data;
	};
	
	//Map specific move enemy function
	this.moveEnemy = function(ID, obj, rate)
	{
		if (rate == undefined) rate = 1;
		var pathData = this.enemyPaths[obj.pattern],
			path = pathData.path,
			pathPoint = obj.data.point,
			speed = obj.speed*rate;
		if (obj.data.point >= pathData.path.length-1) return true;
		
		var newpoint = pathPoint+1;
		var pointMap = path[newpoint];
		var d = Math.sqrt((pointMap.x - obj.x)*(pointMap.x - obj.x) + (pointMap.y - obj.y)*(pointMap.y - obj.y));
		if (d < speed*2)
		{
			obj.data.point = newpoint;
			obj.x = pointMap.x; obj.y = pointMap.y;
			this.moveEnemy(ID, obj);
			return true;
		}
		
		//On final point?
		if (newpoint == path.length-1)
		{
			if (this.base[pathData.base].life <= 0)
			{
				if (obj.data.newbaseroute == undefined)
				{
					var base, newBase = null;
					for(var key in this.base)
					{
						if (newBase != null) continue;
						
						base = this.base[key];
						if (base.life > 0) newBase = key;
					}
					obj.data.newbaseroute = parseInt(newBase);
				}
				
				pointMap = this.base[obj.data.newbaseroute];
			}
		}
		
		
		if (!pointMap) return false;
		
		//Change Destination Points
		obj.data.destination.x = pointMap.x;
		obj.data.destination.y = pointMap.y;
		
		//Determine x and y increases
		var dX = Math.abs(pointMap.x - obj.x), dY = Math.abs(pointMap.y - obj.y);
		var xSide = 0, ySide = 0;
		if (dX == 0 && pointMap.y - obj.y < 0) { ySide = -1*speed; }
		else if (dX == 0 && pointMap.y - obj.y > 0) { ySide = speed; }
		else if (dY == 0 && pointMap.x - obj.x < 0) { xSide = -1*speed; }
		else if (dY == 0 && pointMap.x - obj.x > 0) { xSide = speed; }
		else {
			var angleA = Math.atan(dX/dY);// * (180 / Math.PI);
			xSide = Math.abs(speed*Math.sin(angleA));
			ySide = Math.abs(speed*Math.cos(angleA));
			//xSide = (angleA/90)*speed*1.3;
			//ySide = ((90-angleA)/90)*speed*1.3;
			
			if (pointMap.x - obj.x < 0 && pointMap.y - obj.y < 0) { xSide *= -1; ySide *= -1; }
			else if (pointMap.x - obj.x > 0 && pointMap.y - obj.y < 0) { ySide *= -1; }
			else if (pointMap.x - obj.x > 0 && pointMap.y - obj.y > 0) {  }
			else if (pointMap.x - obj.x < 0 && pointMap.y - obj.y > 0) { xSide *= -1; }

			//console.log(dX, dY, angleA, speed, xSide, ySide);
		}
		
		obj.x += xSide; obj.y += ySide;
	};
	
	
	//Map Sepecific spawn drone function
	//Returns spawn data, specifically the x/y
	this.spawnDrone = function()
	{
		var data = {x: 0, y: 0, direction: Math.floor(Math.random()*2) == 0 ? -1 : 1};
		var pointindex = Math.floor(Math.random()*this.dronePathPoints.length);
		data.point = pointindex;
		
		//Choose point at random
		var point = this.dronePathPoints[pointindex];
		data.x = point.x;
		data.y = point.y;
		
		//Destination
		var newpoint = data.point + data.direction;
		if (newpoint < 0) newpoint = this.dronePathPoints.length - 1;
		else if (newpoint > this.dronePathPoints.length-1) newpoint = 0;
		var pointMap = this.dronePathPoints[newpoint];
		data.destination = {};
		data.destination.x = pointMap.x;
		data.destination.y = pointMap.y;
		
		return data;
	};
	
	//Map specific move drone function
	this.moveDroneCount = 0;
	this.moveDrone = function(ID, rate, fastRate)
	{
		if (rate == undefined) rate = 1;
		if (fastRate == undefined) fastRate = parseInt(Game.fastRate);
		
		var bot = Game.bots[ID];
		var speed = bot.data.movespeed*rate*fastRate;
		
		//Special check to make sure we did not enter infiniti loop
		this.moveDroneCount++;
		if (this.moveDroneCount >= 10)
		{
			this.moveDroneCount = 0;
			bot.pointAccess = "direct";
			bot.point = Math.floor(Math.random()*this.dronePathPoints.length);
			return false;
		}
		
		//Direction?
		var newpoint = bot.point + bot.direction;
		if (newpoint < 0) newpoint = this.dronePathPoints.length - 1;
		else if (newpoint > this.dronePathPoints.length-1) newpoint = 0;
		var pointMap = this.dronePathPoints[newpoint];
		var d = Math.sqrt((pointMap.x - bot.x)*(pointMap.x - bot.x) + (pointMap.y - bot.y)*(pointMap.y - bot.y));
		if (d < speed*2)
		{
			bot.point = newpoint;
			this.moveDrone(ID);
			return true;
		}
		
		//var cxt = Render.tvContext, gxt = Render.gp0Context;
		//cxt.fillStyle = "red"; gxt.fillStyle = "red";
		
		//Determine where to go
		var pois = [bot.point-1, bot.point, bot.point+1, -2], poi, poiEntry, dcheck = 200, eObj, _d;
		var enemies = Game.enemiesList, eIDtoUse = null, eDtoUse = null;
		if (bot.enemyLockOn && enemies[bot.enemyLockOn] != undefined)
		{
			eIDtoUse = bot.enemyLockOn;
		} else delete bot.enemyLockOn;
		if (eIDtoUse == null)
		{
			for(var key in pois)
			{
				poi = pois[key];
				if (poi != -2)
				{
					if (poi < 0) poi = this.dronePathPoints.length - 1;
					else if (poi > this.dronePathPoints.length-1) poi = 0;
					poiEntry = this.dronePathPoints[poi];
				} else poiEntry = {x: bot.x, y: bot.y};
				
				//Check for enemies close by
				for(var eID in enemies)
				{
					eObj = enemies[eID];
					_d = Math.sqrt((eObj.x - poiEntry.x)*(eObj.x - poiEntry.x) + (eObj.y - poiEntry.y)*(eObj.y - poiEntry.y));
					if (_d <= dcheck)
					{
						_d = Math.sqrt((eObj.x - bot.x)*(eObj.x - bot.x) + (eObj.y - bot.y)*(eObj.y - bot.y));
						if (eIDtoUse == null || _d > eDtoUse)
						{
							eIDtoUse = eID;
							eDtoUse = _d;
						}
					}
				}
				
				//cxt.beginPath();
				//cxt.arc(poiEntry.x, poiEntry.y, dcheck, 0, 2*Math.PI, false);
				//cxt.fill();
			}
		}
		if (eIDtoUse)
		{
			pointMap = enemies[eIDtoUse];
			bot.enemyLockOn = eIDtoUse;
			
			/*cxt.strokeStyle = "yellow";
			cxt.beginPath();
			cxt.moveTo(bot.x, bot.y);
			cxt.lineTo(pointMap.x, pointMap.y);
			cxt.stroke();*/
		} else {
			//Advance smoothly to next point
			if (bot.fireduponenemy != undefined && bot.fireduponenemy)
			{
				var poiToUse = null, poiToUseD = null;
				pois = [bot.point, bot.point+bot.direction, bot.point+bot.direction*2]; _d;
				for(var key in pois)
				{
					poi = pois[key];
					if (poi < 0) poi = this.dronePathPoints.length - 1;
					else if (poi > this.dronePathPoints.length-1) poi = 0;
					poiEntry = this.dronePathPoints[poi];
					_d = Math.sqrt((bot.x - poiEntry.x)*(bot.x - poiEntry.x) + (bot.y - poiEntry.y)*(bot.y - poiEntry.y));
					
					if (poiToUseD == null || poiToUseD > _d)
					{
						poiToUse = poi;
						poiToUseD = _d;
					}
				}
				
				bot.fireduponenemy = false;
				
				if (poiToUse !== null)
				{
					poi = poiToUse+bot.direction;
					if (poi < 0) poi = this.dronePathPoints.length - 1;
					else if (poi > this.dronePathPoints.length-1) poi = 0;
					
					bot.point = poiToUse;
					pointMap = this.dronePathPoints[poi];
				}
			}
		}
		
		//Change Destination Points
		bot.destination.x = pointMap.x;
		bot.destination.y = pointMap.y;
		
		/*var cxt = Render.tvContext, gxt = Render.gp0Context;
		cxt.fillStyle = "red"; gxt.fillStyle = "red";
		cxt.strokeStyle = "red"; gxt.strokeStyle = "red";
		cxt.fillRect(pointMap.x-10, pointMap.y-10, 20, 20);*/
		
		//Determine if point is less then speed
		_d = Math.sqrt((bot.x - pointMap.x)*(bot.x - pointMap.x) + (bot.y - pointMap.y)*(bot.y - pointMap.y));
		if (_d < speed) speed = _d;
		if (Math.abs(speed) < 0.01) return true;
		
		//Determine x and y increases
		var dX = Math.abs(pointMap.x - bot.x), dY = Math.abs(pointMap.y - bot.y);
		var xSide = 0, ySide = 0;
		if (dX == 0 && pointMap.y - bot.y < 0) { ySide = -1*speed; }
		else if (dX == 0 && pointMap.y - bot.y > 0) { ySide = speed; }
		else if (dY == 0 && pointMap.x - bot.x < 0) { xSide = -1*speed; }
		else if (dY == 0 && pointMap.x - bot.x > 0) { xSide = speed; }
		else {
			var angleA = Math.atan(dX/dY);// * (180 / Math.PI);
			xSide = Math.abs(speed*Math.sin(angleA));
			ySide = Math.abs(speed*Math.cos(angleA));
			//xSide = (angleA/90)*speed;
			//ySide = ((90-angleA)/90)*speed;
			
			if (pointMap.x - bot.x < 0 && pointMap.y - bot.y < 0) { xSide *= -1; ySide *= -1; }
			else if (pointMap.x - bot.x > 0 && pointMap.y - bot.y < 0) { ySide *= -1; }
			else if (pointMap.x - bot.x > 0 && pointMap.y - bot.y > 0) {  }
			else if (pointMap.x - bot.x < 0 && pointMap.y - bot.y > 0) { xSide *= -1; }
		}
		
		bot.x += xSide; bot.y += ySide;
		var gp0Cord = Game.calculateGPCords(bot.x, bot.y);
		bot.x2 = gp0Cord.x2; bot.y2 = gp0Cord.y2;
		this.moveDroneCount = 0;
		
		/*
		var gxt = Render.gp0Context;
		gxt.fillStyle = "#FFF";
		gxt.fillRect(0, 0, 400, 200);
		gxt.font = "14px Noto Sans";
		gxt.fillStyle = "#000";
		gxt.fillText(dX, 15, 15);
		gxt.fillText(dY, 15, 35);
		gxt.fillText(xSide, 15, 55);
		gxt.fillText(ySide, 15, 75);
		gxt.fillText(bot.x, 15, 95);
		gxt.fillText(bot.y, 15, 115);*/
	};
};
var MapNebula = new MapNebula();