function MapPING15Plus()
{
	this.map = "ping15plus";
	this.base = [{
		x: Render.trueWidth/2,	x2: Render.gp0Width/2,
		y: Render.trueHeight*0.55,y2: Render.gp0Height*0.55,
		r: 100/2,				r2: (100/2)*Render.gp0RenderRatio,
		life: 100,
		maxLife: 100,
		shield: 0, shieldUse: 0
	}];
	this.storeRules = {
		drone: {createData:{movespeed: 3.50}}
	};
	this.walls = [];
	this.walls2 = [];
	this.walls2.push([{
		x: Render.trueWidth*0, y: Render.trueHeight*0.2
	}, {
		x: Render.trueWidth*0.2, y: Render.trueHeight*0.2
	}, {
		x: Render.trueWidth*0.2, y: Render.trueHeight*0.1
	}, {
		x: Render.trueWidth*0.4, y: Render.trueHeight*0.1
	}, {
		x: Render.trueWidth*0.4, y: Render.trueHeight*0.3
	}, {
		x: Render.trueWidth*0.6, y: Render.trueHeight*0.3
	}, {
		x: Render.trueWidth*0.6, y: Render.trueHeight*0.1
	}, {
		x: Render.trueWidth*0.8, y: Render.trueHeight*0.1
	}, {
		x: Render.trueWidth*0.8, y: Render.trueHeight*0.2
	}, {
		x: Render.trueWidth*1, y: Render.trueHeight*0.2
	}, {
		x: Render.trueWidth*1, y: Render.trueHeight*0
	}, {
		x: Render.trueWidth*0, y: Render.trueHeight*0
	}, {
		x: Render.trueWidth*0, y: Render.trueHeight*0.2
	}]);
	this.walls2.push([{
		x: Render.trueWidth*0, y: Render.trueHeight*0.8
	}, {
		x: Render.trueWidth*0.2, y: Render.trueHeight*0.8
	}, {
		x: Render.trueWidth*0.2, y: Render.trueHeight*0.9
	}, {
		x: Render.trueWidth*0.4, y: Render.trueHeight*0.9
	}, {
		x: Render.trueWidth*0.4, y: Render.trueHeight*1
	}, {
		x: Render.trueWidth*0, y: Render.trueHeight*1
	}, {
		x: Render.trueWidth*0, y: Render.trueHeight*0.8
	}]);
	this.walls2.push([{
		x: Render.trueWidth*0.6, y: Render.trueHeight*1
	}, {
		x: Render.trueWidth*0.6, y: Render.trueHeight*0.9
	}, {
		x: Render.trueWidth*0.8, y: Render.trueHeight*0.9
	}, {
		x: Render.trueWidth*0.8, y: Render.trueHeight*0.8
	}, {
		x: Render.trueWidth*1, y: Render.trueHeight*0.8
	}, {
		x: Render.trueWidth*1, y: Render.trueHeight*1
	}, {
		x: Render.trueWidth*0.6, y: Render.trueHeight*1
	}]);
	
	this.dronePathPoints = [{
		x: Render.trueWidth*0.3, y: Render.trueHeight*0.3
	}, {
		x: Render.trueWidth*0.4, y: Render.trueHeight*0.4
	}, {
		x: Render.trueWidth*0.5, y: Render.trueHeight*0.45
	}, {
		x: Render.trueWidth*0.6, y: Render.trueHeight*0.4
	}, {
		x: Render.trueWidth*0.7, y: Render.trueHeight*0.3

	}, {
		x: Render.trueWidth*0.85, y: Render.trueHeight*0.4
	}, {
		x: Render.trueWidth*0.9, y: Render.trueHeight*0.6
	}, {
		x: Render.trueWidth*0.85, y: Render.trueHeight*0.7
	
	}, {
		x: Render.trueWidth*0.7, y: Render.trueHeight*0.8
	}, {
		x: Render.trueWidth*0.6, y: Render.trueHeight*0.75
	}, {
		x: Render.trueWidth*0.5, y: Render.trueHeight*0.85
	}, {
		x: Render.trueWidth*0.4, y: Render.trueHeight*0.75
	}, {
		x: Render.trueWidth*0.3, y: Render.trueHeight*0.8

	}, {
		x: Render.trueWidth*0.15, y: Render.trueHeight*0.7
	}, {
		x: Render.trueWidth*0.1, y: Render.trueHeight*0.6
	}, {
		x: Render.trueWidth*0.15, y: Render.trueHeight*0.4
	}];
	this.dronePathPointsOnReturn = [];
	this.enemyPaths = [{
		speed: 6.5,
		base: 0,
		path: [{
			x: 0,
			y: Render.trueHeight*0.5
		}, {
			x: this.base[0].x,
			y: this.base[0].y
		}]
	}, {
		speed: 6.5,
		base: 0,
		path: [{
			x: Render.trueWidth*0.5,
			y: Render.trueHeight*1
		}, {
			x: this.base[0].x,
			y: this.base[0].y
		}]
	}, {
		speed: 6.5,
		base: 0,
		path: [{
			x: Render.trueWidth,
			y: Render.trueHeight*0.5
		}, {
			x: this.base[0].x,
			y: this.base[0].y
		}]
	}];
	
	this.pingWalls = [];
	this.pingWalls.push({
		color: "#39FF14", //Green
		d: 30,
		walls: [{
			x: Render.trueWidth*0, y: Render.trueHeight*0.2
		}, {
			x: Render.trueWidth*0.2, y: Render.trueHeight*0.2
		}, {
			x: Render.trueWidth*0.2, y: Render.trueHeight*0.102
		}, {
			x: Render.trueWidth*0.4, y: Render.trueHeight*0.102
		}, {
			x: Render.trueWidth*0.4, y: Render.trueHeight*0.297
		}, {
			x: Render.trueWidth*0.6, y: Render.trueHeight*0.297
		}, {
			x: Render.trueWidth*0.6, y: Render.trueHeight*0.102
		}, {
			x: Render.trueWidth*0.8, y: Render.trueHeight*0.102
		}, {
			x: Render.trueWidth*0.8, y: Render.trueHeight*0.2
		}, {
			x: Render.trueWidth*1.1, y: Render.trueHeight*0.2
		}],
		walls2: [{
			x: Render.trueWidth*1, y: Render.trueHeight*0
		}, {
			x: Render.trueWidth*0, y: Render.trueHeight*0
		}, {
			x: Render.trueWidth*0, y: Render.trueHeight*0.2
		}]
	});
	this.pingWalls.push({
		color: "#67C8FF", //Blue
		d: 30,
		walls: [{
			x: Render.trueWidth*0, y: Render.trueHeight*0.804
		}, {
			x: Render.trueWidth*0.2, y: Render.trueHeight*0.804
		}, {
			x: Render.trueWidth*0.2, y: Render.trueHeight*0.9
		}, {
			x: Render.trueWidth*0.4, y: Render.trueHeight*0.9
		}, {
			x: Render.trueWidth*0.4, y: Render.trueHeight*1
		}],
		walls2: [{
			x: Render.trueWidth*0, y: Render.trueHeight*1
		}, {
			x: Render.trueWidth*0, y: Render.trueHeight*0.8
		}]
	});
	this.pingWalls.push({
		color: "#F3F315", //Yellow
		d: 30,
		walls: [{
			x: Render.trueWidth*0.6, y: Render.trueHeight*1
		}, {
			x: Render.trueWidth*0.6, y: Render.trueHeight*0.9
		}, {
			x: Render.trueWidth*0.8, y: Render.trueHeight*0.9
		}, {
			x: Render.trueWidth*0.8, y: Render.trueHeight*0.8025
		}, {
			x: Render.trueWidth*1.1, y: Render.trueHeight*0.8025
		}],
		walls2: [{
			x: Render.trueWidth*1, y: Render.trueHeight*1
		}, {
			x: Render.trueWidth*0.6, y: Render.trueHeight*1
		}]
	});
	this.pingTeleports = [];
	this.pingTeleports.push({
		walls: [{
			x: Render.trueWidth*0.01, y: Render.trueHeight*0.2
		}, {
			x: Render.trueWidth*0.01, y: Render.trueHeight*0.8
		}],
		teleport: {
			x: Render.trueWidth*0.99, y: Render.trueHeight*0.5
		}
	});
	this.pingTeleports.push({
		walls: [{
			x: Render.trueWidth*0.99, y: Render.trueHeight*0.2
		}, {
			x: Render.trueWidth*0.99, y: Render.trueHeight*0.8
		}],
		teleport: {
			x: Render.trueWidth*0.01, y: Render.trueHeight*0.5
		}
	});
	
	
	//Init
	this.init = function(options)
	{
		if (options == undefined) options = {};
		if (options.mode == undefined) options.mode = Game.mode;
		
		ClickBank.clearAll();
		InputBank.clearAll();
		Render.soundsStopAll();
		
		this.renderBackgroundTV = true;
		this.renderBackgroundGP0 = true;
		this.renderBackgroundGP0Cache = {};
		this.renderBackgroundTVCover = true;
		this.renderBackgroundGP0Cover = true;
		
		//Base
		this.base[0].life = this.base[0].maxLife;
		this.base[0].shield = 0;
		this.base[0].shieldUse = 0;
		var base;
		for(var key in this.base)
		{
			base = this.base[key];
			base.cache = {};
		}
		
		//Music
		if (Render.sounds["levelbg"].readyState > 0)
			Render.sounds["levelbg"].currentTime = 0;
		Render.sounds["levelbg"].play();
		
		//Game init
		Game.map = this.map;
		Game.mapClass = this;
		Game.mode = options.mode;
		Game.init({money: 750});
		
		//Spots
		/*Game.spotsAdd({
			x: Render.trueWidth/2, y: Render.trueHeight*0.55, r: 20,
			x2: Render.gp0Width/2, y2: Render.gp0Height*0.55, r2: 20*Render.gp0RenderRatio
		});*/
		Game.spotsAdd({
			x: Render.trueWidth/2-this.base[0].r-30, y: Render.trueHeight*0.54, r: 20,
			x2: Render.gp0Width/2-this.base[0].r2, y2: Render.gp0Height*0.55, r2: 20*Render.gp0RenderRatio
		});
		/*Game.spotsAdd({
			x: Render.trueWidth/2, y: Render.trueHeight*0.55-this.base[0].r-25, r: 20,
			x2: Render.gp0Width/2, y2: Render.gp0Height*0.55-this.base[0].r2, r2: 20*Render.gp0RenderRatio
		});*/
		Game.spotsAdd({
			x: Render.trueWidth/2+this.base[0].r+30, y: Render.trueHeight*0.54, r: 20,
			x2: Render.gp0Width/2+this.base[0].r2, y2: Render.gp0Height*0.55, r2: 20*Render.gp0RenderRatio
		});
		Game.spotsAdd({
			x: Render.trueWidth/2, y: Render.trueHeight*0.55+this.base[0].r+25, r: 20,
			x2: Render.gp0Width/2, y2: Render.gp0Height*0.55+this.base[0].r2, r2: 20*Render.gp0RenderRatio
		});
		
		//Add PING entry
		this.spawnPingBot();
		
		Render.renderControl = function(){ MapPING15Plus.render(); };
		
		Game.startGame();
		

		
		//Gamepad Extra
		var tab = {tab: "extra", title: _t("About")}, type = "extra";
		var minbasey = 34;
		var x=315,y=5,w=100,h=minbasey-y-1;
		var div = $(document.createElement("div"));
		div.attr({
			tab: type
		}).addClass("tab_buttons clickevents").css({
			position: "absolute",
			left: x+"px",
			top: y+"px",
			width: w+"px",
			height: h+"px",
			border: "1px solid #AAA",
			//"font-family": "Noto Sans",
			"font-size": "14px",
			color: "#FFF"
		}).html("<img class='img_off' src='media/etc/tab_off.jpg' style='width:"+w+"px;height:"+h+"px;"+(GameGP0Display.tab != type ? "" : "display:none;")+"' />" +
				"<img class='img_on' src='media/etc/tab_on.jpg' style='width:"+w+"px;height:"+h+"px;"+(GameGP0Display.tab != type ? "display:none;" : "")+"' />" +
				"<div class='dark' style='position:absolute;left:0px;top:0px;width:"+w+"px;height:"+h+"px;background:#000;opacity:0.3;display:"+(this.tab != type ? "none" : "block")+";'>&nbsp;</div>" +
				"<div style='position:absolute;left:0px;top:4px;width:"+w+"px;text-align:center;'>"+tab.title+"</div>").click(function()
		{
			GameGP0Display.switchTab($(this).attr("tab"));
		});
		GameGP0Display.container.find(".tab_buttons:last").after(div);
		
		var tab = $(document.createElement("div"));
		GameGP0Display.container.find(".tab:last").after(tab);
		tab.addClass("tab").attr({tab: "extra"}).css({
			position: "absolute",
			left: "0px",
			top: (minbasey+1)+"px",
			width: Render.gp0Width+"px",
			height: (Render.gp0Height-minbasey)+"px",
			display: "none"
		});
		var background = $(document.createElement("div"));
		background.css({
			position: "absolute",
			left: "0px",
			top: "0px",
			width: tab.width()+"px",
			height: tab.height()+"px",
			background: "#000"
		});
		tab.append(background);
		background = $(document.createElement("div"));
		background.css({
			position: "absolute",
			left: "0px",
			top: "0px",
			width: tab.width()+"px",
			height: tab.height()+"px",
			background: "#000",
			opacity: "0.85"
		});
		tab.append(background);
		
		var overflow = $(document.createElement("div"));
		overflow.addClass("overflow").css({
			position: "absolute",
			left: "0px",
			top: "0px",
			width: (tab.width()-30)+"px",
			height: (tab.height()-30)+"px",
			padding: "15px 15px",
			"overflow-x": "hidden",
			"overflow-y": "overflow"
		});
		tab.append(overflow);
		
		var div = $("<div />");
		div.css({
			color: "#CCC"
		}).html("<h2 style='margin-top:0px;color:#FFF;'>"+_t("ping15plus_about_title")+"</h2>"+
			""+_t("ping15plus_about_desc")+"");
		overflow.append(div);
		
		//Game.botsDroneAdd();
		/*Game.botsDroneAdd();
		Game.botsDroneAdd();
		Game.botsDroneAdd();
		Game.botsDroneAdd();*/
		//Game.botsAdd("sentry", Render.trueWidth/2, Render.trueHeight/2);
	};
	
	//Map Render
	this.counter = 0;
	this.render = function()
	{
		//Clear
		Render.renderClear("all");
		var cxt = Render.tvContext, gxt = Render.gp0Context;
		
		//Gamepad Slice Cache Reset
		var gp0Cord = Game.calculateGPCords(0, 0);
		if (this.renderBackgroundGP0Cache.x0 == undefined || this.renderBackgroundGP0Cache.x0 != gp0Cord.x2
		 || this.renderBackgroundGP0Cache.y0 == undefined || this.renderBackgroundGP0Cache.y0 != gp0Cord.y2
		 || this.renderBackgroundGP0Cache.z0 == undefined || this.renderBackgroundGP0Cache.z0 != Render.gp0RenderRatio)
		{
			this.renderBackgroundGP0 = true;
			this.renderBackgroundGP0Cover = true;
			Game.resetGP0SliceCache = true;
			
			this.renderBackgroundGP0Cache.x0 = gp0Cord.x2;
			this.renderBackgroundGP0Cache.y0 = gp0Cord.y2;
			this.renderBackgroundGP0Cache.z0 = Render.gp0RenderRatio;
		}
		
		//Gamepad Display Move
		Render.gp0DisplayMoveStart();
		
		//Background
		this.renderBackground();
		
		//Bots
		Game.renderBots();
		
		//Render Bases
		Render.renderBases();
		
		//Call Gamer Render function
		Game.render();
		
		Game.resetGP0SliceCache = false;
		
		/*
		//Show drone recorded path
		cxt.fillStyle = "red"; gxt.fillStyle = "red";
		cxt.strokeStyle = "red"; gxt.strokeStyle = "red";
		
		cxt.beginPath(); gxt.beginPath();
		
		var dronePath, gp0Cord;
		for(var i=0; i<this.dronePathPoints.length; i++)
		{
			dronePath = this.dronePathPoints[i];
			gp0Cord = Game.calculateGPCords(dronePath.x, dronePath.y);
			
			if (i == 0)
			{
				cxt.moveTo(dronePath.x, dronePath.y); gxt.moveTo(gp0Cord.x2, gp0Cord.y2);
			} else {
				cxt.lineTo(dronePath.x, dronePath.y); gxt.lineTo(gp0Cord.x2, gp0Cord.y2);
			}
			
			cxt.fillStyle = "#666"; gxt.fillStyle = "#666";
			cxt.fillRect(dronePath.x-10, dronePath.y-10, 20, 20);
			gxt.fillRect(gp0Cord.x2-5, gp0Cord.y2-5, 10, 10);
			cxt.fillStyle = "red"; gxt.fillStyle = "red";
		}
		dronePath = this.dronePathPoints[0];
		gp0Cord = Game.calculateGPCords(dronePath.x, dronePath.y);
		cxt.lineTo(dronePath.x, dronePath.y); gxt.lineTo(gp0Cord.x2, gp0Cord.y2);
		
		cxt.stroke(); gxt.stroke();*/
	};
	
	//Hanldes the render of the Background
	//this.backgroundFade = []; this.lastcalltime = 0;
	this.renderBackgroundTV = true;
	this.renderBackgroundGP0 = true; this.renderBackgroundGP0Cache = {};
	this.renderBackground = function()
	{
		var x=0,y=0,x2,y2,
			_w = Render.tvWidth, _h = Render.tvHeight,
			_w2 = Render.trueWidth*Render.gp0RenderRatio, _h2 = Render.trueHeight*Render.gp0RenderRatio;
		var gp0Cord = Game.calculateGPCords(x, y);
		if (this.renderBackgroundTV)
		{
			var cxt = Render.returnTVSliceContext(1);
			cxt.clearRect(0, 0, Render.tvWidth, Render.tvHeight);
			cxt.drawImage(Render.images["space1_60d"], x, y, _w, _h);
			this.renderBackgroundTV = false;
		}
		if (this.renderBackgroundGP0)
		{
			var gxt = Render.returnGP0SliceContext(1);
			gxt.clearRect(0, 0, Render.gp0Width, Render.gp0Height);
			gxt.drawImage(Render.images["space1_60d"], gp0Cord.x2, gp0Cord.y2, _w2, _h2);
			this.renderBackgroundGP0 = false;
		}
	};
	
	//Render the background cover
	this.renderBackgroundTVCover = true; this.renderBackgroundGP0Cover = true;
	this.renderBackgroundCover = function()
	{
		var x=0,y=0,x2,y2,
			_w = Render.tvWidth, _h = Render.tvHeight,
			_w2 = Render.trueWidth*Render.gp0RenderRatio, _h2 = Render.trueHeight*Render.gp0RenderRatio;
		var gp0Cord = Game.calculateGPCords(x, y);
		if (this.renderBackgroundTVCover)
		{
			var cxt = Render.returnTVSliceContext(8);
			cxt.clearRect(0, 0, Render.tvWidth, Render.tvHeight);
			cxt.drawImage(Render.images["ping_bg"], x, y, _w, _h);
			this.renderBackgroundTVCover = false;
		}
		if (this.renderBackgroundGP0Cover)
		{
			var gxt = Render.returnGP0SliceContext(8);
			gxt.clearRect(0, 0, Render.gp0Width, Render.gp0Height);
			gxt.drawImage(Render.images["ping_bg"], gp0Cord.x2, gp0Cord.y2, _w2, _h2);
			this.renderBackgroundGP0Cover = false;
		}
		return false;
		
		//var cxt = Render.tvContext, gxt = Render.gp0Context;
		if (this.renderBackgroundTVCover || this.renderBackgroundGP0Cover)
		{
			if (this.renderBackgroundTVCover)
			{
				var cxt = Render.returnTVSliceContext(8);
				cxt.clearRect(0, 0, Render.tvWidth, Render.tvHeight);
			}
			if (this.renderBackgroundGP0Cover)
			{
				var gxt = Render.returnGP0SliceContext(8);
				gxt.clearRect(0, 0, Render.gp0Width, Render.gp0Height);
			}
			
			//Ping Background
			if (this.renderBackgroundTVCover) cxt.fillStyle = "#000";
			if (this.renderBackgroundGP0Cover) gxt.fillStyle = "#000";
			var walls, wall;
			for(var key in this.pingWalls)
			{
				walls = this.pingWalls[key];
				
				if (this.renderBackgroundTVCover) cxt.beginPath();
				if (this.renderBackgroundGP0Cover) gxt.beginPath();
				
				for(var key in walls.walls)
				{
					wall = walls.walls[key];
					if (this.renderBackgroundGP0Cover) gp0Cord = Game.calculateGPCords(wall.x, wall.y);
					
					if (key == 0)
					{
						if (this.renderBackgroundTVCover) cxt.moveTo(wall.x*Render.renderTVRatio, wall.y*Render.renderTVRatio);
						if (this.renderBackgroundGP0Cover) gxt.moveTo(gp0Cord.x2, gp0Cord.y2);
					} else {
						if (this.renderBackgroundTVCover) cxt.lineTo(wall.x*Render.renderTVRatio, wall.y*Render.renderTVRatio);
						if (this.renderBackgroundGP0Cover) gxt.lineTo(gp0Cord.x2, gp0Cord.y2);
					}
				}
				for(var key in walls.walls2)
				{
					wall = walls.walls2[key];
					if (this.renderBackgroundGP0Cover) gp0Cord = Game.calculateGPCords(wall.x, wall.y);
					
					if (this.renderBackgroundTVCover) cxt.lineTo(wall.x*Render.renderTVRatio, wall.y*Render.renderTVRatio);
					if (this.renderBackgroundGP0Cover) gxt.lineTo(gp0Cord.x2, gp0Cord.y2);
				}
				
				if (this.renderBackgroundTVCover) cxt.fill();
				if (this.renderBackgroundGP0Cover) gxt.fill();
			}
			
			
			//Ping Walls - Neon
			var canvas = document.createElement("canvas");
			var context = canvas.getContext("2d");
			canvas.width = Render.tvWidth;
			canvas.height = Render.tvHeight;
			
			var walls, wall, d, d2, wall1, wall2;
			var x1, y1, x2, y2, dStart, dEnd, dAddTo;
			for(var key in this.pingWalls)
			{
				walls = this.pingWalls[key];
				context.fillStyle = walls.color;
				d = walls.d;
				
				wall1 = walls.walls[0];
				for(var wI=1; wI<walls.walls.length; wI++)
				{
					wall2 = walls.walls[wI];
					
					x1 = wall1.x; y1 = wall1.y;
					x2 = wall2.x; y2 = wall2.y;
					if (x1 > x2)
					{
						var x3 = x1;
						x1 = x2;
						x2 = x3;
					}
					if (y1 > y2)
					{
						var y3 = y1;
						y1 = y2;
						y2 = y3;
					}
					
					context.fillRect((x1-d/2-6)*Render.renderTVRatio, (y1-d/2-6)*Render.renderTVRatio, ((x2-x1)+d+12)*Render.renderTVRatio, ((y2-y1)+d+12)*Render.renderTVRatio);
					
					wall1 = wall2;
				}
			}
			
			if (this.renderBackgroundTVCover) cxt.globalAlpha = 0.1;
			if (this.renderBackgroundGP0Cover) gxt.globalAlpha = 0.1;
			if (this.renderBackgroundTVCover) 	cxt.drawImage(canvas, 0, 0, Render.tvWidth, Render.tvHeight);
			if (this.renderBackgroundGP0Cover) var gp0Cord = Game.calculateGPCords(0, 0);
			if (this.renderBackgroundGP0Cover) gxt.drawImage(canvas, gp0Cord.x2, gp0Cord.y2, Render.trueWidth*Render.gp0RenderRatio, Render.trueHeight*Render.gp0RenderRatio);
			if (this.renderBackgroundTVCover) cxt.globalAlpha = 1;
			if (this.renderBackgroundGP0Cover) gxt.globalAlpha = 1;
			
			
			//Ping Walls
			if (this.renderBackgroundTVCover) cxt.lineWidth = 1;
			if (this.renderBackgroundGP0Cover) gxt.lineWidth = 1*Render.gp0RenderRatio;
			for(var key in this.pingWalls)
			{
				walls = this.pingWalls[key];
				if (this.renderBackgroundTVCover) cxt.fillStyle = walls.color;
				if (this.renderBackgroundGP0Cover) gxt.fillStyle = walls.color;
				d = walls.d; d2 = d*Render.gp0RenderRatio;
				
				wall1 = walls.walls[0];
				for(var wI=1; wI<walls.walls.length; wI++)
				{
					wall2 = walls.walls[wI];
					
					x1 = wall1.x; y1 = wall1.y;
					x2 = wall2.x; y2 = wall2.y;
	
					if (x1 != x2)
					{
						dAddTo = "x";
						dStart = x1; dEnd = x2;
						if (x1 > x2)
						{
							x2 = x1;
							x1 = dEnd;
							dStart = x1; dEnd = x2;
						}
					} else if (y1 != y2) {
						dAddTo = "y";
						dStart = y1; dEnd = y2;
						if (y1 > y2)
						{
							y2 = y1;
							y1 = dEnd;
							dStart = y1; dEnd = y2;
						}
					} else {
						dStart = 0;
						dEnd = 0;
					}
					//console.log(x1, y1, x2, y2, dStart, dEnd, d, d2);
					//1152 972 1536 972 1152 1536 5 3
					//1536 864 1536 972 864  972  5 3 
					var canContiue = 0;
					while(dStart < dEnd && canContiue < 100)
					{
						canContiue++;
						if (this.renderBackgroundGP0Cover)
						{
							gp0Cord = Game.calculateGPCords(x1, y1);
							gp0Cord.x2 = Math.floor(gp0Cord.x2); gp0Cord.y2 = Math.floor(gp0Cord.y2);
						}
						
						if (this.renderBackgroundTVCover) cxt.fillRect((x1-d/2)*Render.renderTVRatio, (y1-d/2)*Render.renderTVRatio, d*Render.renderTVRatio, d*Render.renderTVRatio);
						if (this.renderBackgroundGP0Cover) gxt.fillRect(gp0Cord.x2-d2/2, gp0Cord.y2-d2/2, d2, d2);
						
						dStart += d+5;
						if (dAddTo == "x") x1 += d+5;
						else y1 += d+5;
					}
					
					wall1 = wall2;
				}
				/*
				cxt.beginPath();
				gxt.beginPath();
				
				for(var key in walls.walls)
				{
					wall = walls.walls[key];
					gp0Cord = Game.calculateGPCords(wall.x, wall.y);
					
					if (key == 0)
					{
						cxt.moveTo(wall.x, wall.y);
						gxt.moveTo(gp0Cord.x2, gp0Cord.y2);
					} else {
						cxt.lineTo(wall.x, wall.y);
						gxt.lineTo(gp0Cord.x2, gp0Cord.y2);
					}
				}
				
				cxt.stroke();
				gxt.stroke();*/
			}
			
			if (this.renderBackgroundTVCover) this.renderBackgroundTVCover = false;
			if (this.renderBackgroundGP0Cover) this.renderBackgroundGP0Cover = false;
		}
	};
	
	//Start Level Call
	this.startLevel = function()
	{
		//if (Game.level % 5 == 0 && Game.level <= 20)
			//this.spawnPingBot();
	};
	
	//Endless Mode Increase Call
	this.endlessModeIncrease = function()
	{
		//if (Game.enemies.total % 25 == 0 && Game.enemies.total <= 100)
			//this.spawnPingBot();
	};
	
	//Spawns a Ping Bot
	this.spawnPingBot = function()
	{
		var pingID = Game.botsAdd("ping", Render.trueWidth*0.5, Render.trueHeight-10, 0, 0, "spotbot", {playBuildSound: false});
		var botPing = Game.bots[pingID];
		botPing.ping.dir.x = Math.floor(Math.random()*2) == 1 ? -1 : 1;
		botPing.ping.dir.y = -1;
		
		var xDiff = 0.4-(Math.floor(Math.random()*20)/100);
		var yDiff = 0.4-(Math.floor(Math.random()*20)/100);
		botPing.ping.dir.x += xDiff;
		botPing.ping.dir.y += yDiff;
	};
	
	
	//Map specific spawn enemy function
	//Returns specific data, such as pattern, start position, etc
	this.spawnEnemy = function()
	{
		var data = {};
		data.pattern = Math.floor(Math.random()*(this.enemyPaths.length));
		
		var pathData = this.enemyPaths[data.pattern];
		data.speed = pathData.speed;
		data.point = 0;
		data.startX = pathData.path[0].x;
		data.startY = pathData.path[0].y;
		
		data.destination = {};
		data.destination.x = pathData.path[1].x;
		data.destination.y = pathData.path[1].y;
		
		return data;
	};
	
	//Map specific move enemy function
	this.moveEnemy = function(ID, obj, rate)
	{
		if (rate == undefined) rate = 1;
		var pathData = this.enemyPaths[obj.pattern],
			path = pathData.path,
			pathPoint = obj.data.point,
			speed = obj.speed*rate;
		if (obj.data.point >= pathData.path.length-1) return true;
		
		var newpoint = pathPoint+1;
		var pointMap = path[newpoint];
		var d = Math.sqrt((pointMap.x - obj.x)*(pointMap.x - obj.x) + (pointMap.y - obj.y)*(pointMap.y - obj.y));
		if (d < speed*2)
		{
			obj.data.point = newpoint;
			obj.x = pointMap.x; obj.y = pointMap.y;
			this.moveEnemy(ID, obj);
			return true;
		}
		
		//On final point?
		if (newpoint == path.length-1)
		{
			if (this.base[pathData.base].life <= 0)
			{
				if (obj.data.newbaseroute == undefined)
				{
					var base, newBase = null;
					for(var key in this.base)
					{
						if (newBase != null) continue;
						
						base = this.base[key];
						if (base.life > 0) newBase = key;
					}
					obj.data.newbaseroute = parseInt(newBase);
				}
				
				pointMap = this.base[obj.data.newbaseroute];
			}
		}
		
		
		if (!pointMap) return false;
		
		//Change Destination Points
		obj.data.destination.x = pointMap.x;
		obj.data.destination.y = pointMap.y;
		
		//Determine x and y increases
		var dX = Math.abs(pointMap.x - obj.x), dY = Math.abs(pointMap.y - obj.y);
		var xSide = 0, ySide = 0;
		if (dX == 0 && pointMap.y - obj.y < 0) { ySide = -1*speed; }
		else if (dX == 0 && pointMap.y - obj.y > 0) { ySide = speed; }
		else if (dY == 0 && pointMap.x - obj.x < 0) { xSide = -1*speed; }
		else if (dY == 0 && pointMap.x - obj.x > 0) { xSide = speed; }
		else {
			var angleA = Math.atan(dX/dY);// * (180 / Math.PI);
			xSide = Math.abs(speed*Math.sin(angleA));
			ySide = Math.abs(speed*Math.cos(angleA));
			//xSide = (angleA/90)*speed*1.3;
			//ySide = ((90-angleA)/90)*speed*1.3;
			
			if (pointMap.x - obj.x < 0 && pointMap.y - obj.y < 0) { xSide *= -1; ySide *= -1; }
			else if (pointMap.x - obj.x > 0 && pointMap.y - obj.y < 0) { ySide *= -1; }
			else if (pointMap.x - obj.x > 0 && pointMap.y - obj.y > 0) {  }
			else if (pointMap.x - obj.x < 0 && pointMap.y - obj.y > 0) { xSide *= -1; }

			//console.log(dX, dY, angleA, speed, xSide, ySide);
		}
		
		obj.x += xSide; obj.y += ySide;
		//this.enemyMovements.push({x: obj.x, y: obj.y});
		
		
		/*
		var x = obj.data.startX - this.base[0].x,
			y = obj.data.startY - this.base[0].y,
			s = obj.speed;
		
		//x: 1010 @ 580 ~17500 | 1.7414 | -1.74137
		//y: 590  @ 600 ~17500 | 0.9833
		var xs = x/s, ys = y/s;
		if (x != 0) xs = x/(s*Math.abs(580/s));
		//if (y != 0) ys = y/(s*Math.abs(600/s));
		
		obj.x -= xs;// * Math.abs(x/590));
		obj.y -= ys;// * Math.abs(y/590));*/
	};
	
	
	//Map Sepecific spawn drone function
	//Returns spawn data, specifically the x/y
	this.spawnDrone = function()
	{
		var data = {x: 0, y: 0, direction: Math.floor(Math.random()*2) == 0 ? -1 : 1};
		var pointindex = Math.floor(Math.random()*this.dronePathPoints.length);
		data.point = pointindex;
		
		//Choose point at random
		var point = this.dronePathPoints[pointindex];
		data.x = point.x;
		data.y = point.y;
		
		//Destination
		var newpoint = data.point + data.direction;
		if (newpoint < 0) newpoint = this.dronePathPoints.length - 1;
		else if (newpoint > this.dronePathPoints.length-1) newpoint = 0;
		var pointMap = this.dronePathPoints[newpoint];
		data.destination = {};
		data.destination.x = pointMap.x;
		data.destination.y = pointMap.y;
		
		return data;
	};
	
	//Map specific move drone function
	this.moveDroneCount = 0;
	this.moveDrone = function(ID, rate, fastRate)
	{
		if (rate == undefined) rate = 1;
		if (fastRate == undefined) fastRate = parseInt(Game.fastRate);
		
		var bot = Game.bots[ID];
		var speed = bot.data.movespeed*rate*fastRate;
		
		//Special check to make sure we did not enter infiniti loop
		this.moveDroneCount++;
		if (this.moveDroneCount >= 10)
		{
			this.moveDroneCount = 0;
			bot.pointAccess = "direct";
			bot.point = Math.floor(Math.random()*this.dronePathPoints.length);
			return false;
		}
		
		//Direction?
		var newpoint = bot.point + bot.direction;
		if (newpoint < 0) newpoint = this.dronePathPoints.length - 1;
		else if (newpoint > this.dronePathPoints.length-1) newpoint = 0;
		var pointMap = this.dronePathPoints[newpoint];
		var d = Math.sqrt((pointMap.x - bot.x)*(pointMap.x - bot.x) + (pointMap.y - bot.y)*(pointMap.y - bot.y));
		if (d < speed*2)
		{
			bot.point = newpoint;
			this.moveDrone(ID);
			return true;
		}
		
		//var cxt = Render.tvContext, gxt = Render.gp0Context;
		//cxt.fillStyle = "red"; gxt.fillStyle = "red";
		
		//Determine where to go
		var pois = [bot.point-1, bot.point, bot.point+1, -2], poi, poiEntry, dcheck = 200, eObj, _d;
		var enemies = Game.enemiesList, eIDtoUse = null, eDtoUse = null;
		if (bot.enemyLockOn && enemies[bot.enemyLockOn] != undefined)
		{
			eIDtoUse = bot.enemyLockOn;
		} else delete bot.enemyLockOn;
		if (eIDtoUse == null)
		{
			for(var key in pois)
			{
				poi = pois[key];
				if (poi != -2)
				{
					if (poi < 0) poi = this.dronePathPoints.length - 1;
					else if (poi > this.dronePathPoints.length-1) poi = 0;
					poiEntry = this.dronePathPoints[poi];
				} else poiEntry = {x: bot.x, y: bot.y};
				
				//Check for enemies close by
				for(var eID in enemies)
				{
					eObj = enemies[eID];
					_d = Math.sqrt((eObj.x - poiEntry.x)*(eObj.x - poiEntry.x) + (eObj.y - poiEntry.y)*(eObj.y - poiEntry.y));
					if (_d <= dcheck)
					{
						_d = Math.sqrt((eObj.x - bot.x)*(eObj.x - bot.x) + (eObj.y - bot.y)*(eObj.y - bot.y));
						if (eIDtoUse == null || _d > eDtoUse)
						{
							eIDtoUse = eID;
							eDtoUse = _d;
						}
					}
				}
				
				//cxt.beginPath();
				//cxt.arc(poiEntry.x, poiEntry.y, dcheck, 0, 2*Math.PI, false);
				//cxt.fill();
			}
		}
		if (eIDtoUse)
		{
			pointMap = enemies[eIDtoUse];
			bot.enemyLockOn = eIDtoUse;
			
			/*cxt.strokeStyle = "yellow";
			cxt.beginPath();
			cxt.moveTo(bot.x, bot.y);
			cxt.lineTo(pointMap.x, pointMap.y);
			cxt.stroke();*/
		} else {
			//Advance smoothly to next point
			if (bot.fireduponenemy != undefined && bot.fireduponenemy)
			{
				var poiToUse = null, poiToUseD = null;
				pois = [bot.point, bot.point+bot.direction, bot.point+bot.direction*2]; _d;
				for(var key in pois)
				{
					poi = pois[key];
					if (poi < 0) poi = this.dronePathPoints.length - 1;
					else if (poi > this.dronePathPoints.length-1) poi = 0;
					poiEntry = this.dronePathPoints[poi];
					_d = Math.sqrt((bot.x - poiEntry.x)*(bot.x - poiEntry.x) + (bot.y - poiEntry.y)*(bot.y - poiEntry.y));
					
					if (poiToUseD == null || poiToUseD > _d)
					{
						poiToUse = poi;
						poiToUseD = _d;
					}
				}
				
				bot.fireduponenemy = false;
				
				if (poiToUse !== null)
				{
					poi = poiToUse+bot.direction;
					if (poi < 0) poi = this.dronePathPoints.length - 1;
					else if (poi > this.dronePathPoints.length-1) poi = 0;
					
					bot.point = poiToUse;
					pointMap = this.dronePathPoints[poi];
				}
			}
		}
		
		//Change Destination Points
		bot.destination.x = pointMap.x;
		bot.destination.y = pointMap.y;
		
		/*var cxt = Render.tvContext, gxt = Render.gp0Context;
		cxt.fillStyle = "red"; gxt.fillStyle = "red";
		cxt.strokeStyle = "red"; gxt.strokeStyle = "red";
		cxt.fillRect(pointMap.x-10, pointMap.y-10, 20, 20);*/
		
		//Determine if point is less then speed
		_d = Math.sqrt((bot.x - pointMap.x)*(bot.x - pointMap.x) + (bot.y - pointMap.y)*(bot.y - pointMap.y));
		if (_d < speed) speed = _d;
		if (Math.abs(speed) < 0.01) return true;
		
		//Determine x and y increases
		var dX = Math.abs(pointMap.x - bot.x), dY = Math.abs(pointMap.y - bot.y);
		var xSide = 0, ySide = 0;
		if (dX == 0 && pointMap.y - bot.y < 0) { ySide = -1*speed; }
		else if (dX == 0 && pointMap.y - bot.y > 0) { ySide = speed; }
		else if (dY == 0 && pointMap.x - bot.x < 0) { xSide = -1*speed; }
		else if (dY == 0 && pointMap.x - bot.x > 0) { xSide = speed; }
		else {
			var angleA = Math.atan(dX/dY);// * (180 / Math.PI);
			xSide = Math.abs(speed*Math.sin(angleA));
			ySide = Math.abs(speed*Math.cos(angleA));
			//xSide = (angleA/90)*speed;
			//ySide = ((90-angleA)/90)*speed;
			
			if (pointMap.x - bot.x < 0 && pointMap.y - bot.y < 0) { xSide *= -1; ySide *= -1; }
			else if (pointMap.x - bot.x > 0 && pointMap.y - bot.y < 0) { ySide *= -1; }
			else if (pointMap.x - bot.x > 0 && pointMap.y - bot.y > 0) {  }
			else if (pointMap.x - bot.x < 0 && pointMap.y - bot.y > 0) { xSide *= -1; }
		}
		
		bot.x += xSide; bot.y += ySide;
		var gp0Cord = Game.calculateGPCords(bot.x, bot.y);
		bot.x2 = gp0Cord.x2; bot.y2 = gp0Cord.y2;
		this.moveDroneCount = 0;
		
		/*
		var gxt = Render.gp0Context;
		gxt.fillStyle = "#FFF";
		gxt.fillRect(0, 0, 400, 200);
		gxt.font = "14px Noto Sans";
		gxt.fillStyle = "#000";
		gxt.fillText(dX, 15, 15);
		gxt.fillText(dY, 15, 35);
		gxt.fillText(xSide, 15, 55);
		gxt.fillText(ySide, 15, 75);
		gxt.fillText(bot.x, 15, 95);
		gxt.fillText(bot.y, 15, 115);*/
	};
};
var MapPING15Plus = new MapPING15Plus();