function MapPollux()
{
	this.map = "pollux";
	this.base = [{
		x: Render.trueWidth*0.725,	x2: Render.gp0Width/2,
		y: Render.trueHeight/2,	y2: Render.gp0Height/2,
		r: 100/2,				r2: (100/2)*Render.gp0RenderRatio,
		life: 100,
		maxLife: 100,
		shield: 0, shieldUse: 0
	}];
	this.storeRules = {
		drone: {createData:{movespeed: 4.00}}
	};
	this.gp0ScreenOffset = {x: 374, y: 0};
	this.walls = [];
	this.dronePathPoints = [{
		x: Render.trueWidth*0.6, y: Render.trueHeight*0.2
	}, {
		x: Render.trueWidth*0.675, y: Render.trueHeight*0.5
	}, {
		x: Render.trueWidth*0.6, y: Render.trueHeight*0.8
	}, {
		x: Render.trueWidth*0.45, y: Render.trueHeight*0.65
	}, {
		x: Render.trueWidth*0.375, y: Render.trueHeight*0.5
	}, {
		x: Render.trueWidth*0.45, y: Render.trueHeight*0.35
	}];
	this.dronePathPointsOnReturn = [];
	this.enemyPaths = [{
		speed: 10.0,
		base: 0,
		path: [{
			x: 0,
			y: 0
		}, {
			x: this.base[0].x,
			y: this.base[0].y
		}]
	}];
	this._spotbots = [];
	
	//Init
	this.init = function(options)
	{
		if (options == undefined) options = {};
		if (options.mode == undefined) options.mode = Game.mode;
		
		ClickBank.clearAll();
		InputBank.clearAll();
		Render.soundsStopAll();
		
		this.renderBackgroundTV = true;
		this.renderBackgroundGP0 = true;
		this.renderBackgroundGP0Cache = {};
		this.renderBackgroundTVCover = true;
		this.renderBackgroundGP0Cover = true;
		
		//Base
		this.base[0].life = this.base[0].maxLife;
		this.base[0].shield = options.mode == "Easy" ? 10 : 5;
		this.base[0].shieldUse = 0;
		var base;
		for(var key in this.base)
		{
			base = this.base[key];
			base.cache = {};
		}
		
		//Music
		if (Render.sounds["levelbg"].readyState > 0)
			Render.sounds["levelbg"].currentTime = 0;
		Render.sounds["levelbg"].play();
		
		//Game init
		Game.map = this.map;
		Game.mapClass = this;
		Game.mode = options.mode;
		Game.init({money: 1100/*, reduceImageQuality: true, allowBotSpin: true, enableCacheOpts: false*/});
		
		this._spotbots = [];
		this.twoDegree = 0;
		this.threeDegree = 0;
		this.starCycleTTL = 0;
		this.solarFlareActivated = false;
		this.solarFlareActivateTTL = this.solarFlareActivateTTLBase;
		this.solarFlareCycleTTL = 0;
		this.solarFlareMoveTTL = 0;
		
		//Spots
		var spotID = Game.spotsAdd({
			x: 0, y: 0, r: 20,
			x2: 0, y2: 0, r2: 20*Render.gp0RenderRatio
		});
		this._spotbots.push({
			ID: spotID, type: "spot",
			r: 135, d: 0, dir: (Math.floor(Math.random()*2) == 0 ? 1 : -1), speed: 5
		});

		Game.spotsAdd({
			x: Render.trueWidth*0.45, y: Render.trueHeight*0.4, r: 20,
			x2: 0, y2: 0, r2: 20*Render.gp0RenderRatio
		});
		Game.spotsAdd({
			x: Render.trueWidth*0.45, y: Render.trueHeight*0.6, r: 20,
			x2: 0, y2: 0, r2: 20*Render.gp0RenderRatio
		});
		Game.spotsAdd({
			x: Render.trueWidth*0.56, y: Render.trueHeight*0.35, r: 20,
			x2: 0, y2: 0, r2: 20*Render.gp0RenderRatio
		});
		Game.spotsAdd({
			x: Render.trueWidth*0.56, y: Render.trueHeight*0.65, r: 20,
			x2: 0, y2: 0, r2: 20*Render.gp0RenderRatio
		});
		
		/*
		spotID = Game.spotsAdd({
			x: 0, y: 0, r: 20,
			x2: 0, y2: 0, r2: 20*Render.gp0RenderRatio
		});
		this._spotbots.push({
			ID: spotID, type: "spot",
			r: 200, d: 180, dir: 1, speed: 2
		});
		
		//Large Circle
		spotID = Game.spotsAdd({
			x: 0, y: 0, r: 20,
			x2: 0, y2: 0, r2: 20*Render.gp0RenderRatio
		});
		this._spotbots.push({
			ID: spotID, type: "spot",
			r: 400, d: -90, dir: -1, speed: 1.25
		});
		spotID = Game.spotsAdd({
			x: 0, y: 0, r: 20,
			x2: 0, y2: 0, r2: 20*Render.gp0RenderRatio
		});
		this._spotbots.push({
			ID: spotID, type: "spot",
			r: 400, d: 120-90, dir: -1, speed: 1.25
		});
		spotID = Game.spotsAdd({
			x: 0, y: 0, r: 20,
			x2: 0, y2: 0, r2: 20*Render.gp0RenderRatio
		});
		this._spotbots.push({
			ID: spotID, type: "spot",
			r: 400, d: 240-90, dir: -1, speed: 1.25
		});
		/*spotID = Game.spotsAdd({
			x: 0, y: 0, r: 20,
			x2: 0, y2: 0, r2: 20*Render.gp0RenderRatio
		});*/
		
		this._moveSpotBots(true);
		
		Render.renderControl = function(){ MapPollux.render(); };
		
		Game.startGame();
		Game.basesShield = this.base[0].shield;

		//Game.botsDroneAdd();
		/*Game.botsDroneAdd();
		Game.botsDroneAdd();
		Game.botsDroneAdd();
		Game.botsDroneAdd();*/
		//Game.botsAdd("sentry", Render.trueWidth/2, Render.trueHeight/2);
	};
	
	//Map Render
	this.render = function()
	{
		//Clear
		Render.renderClear("all");
		var cxt = Render.tvContext, gxt = Render.gp0Context;
		
		//Gamepad Slice Cache Reset
		var gp0Cord = Game.calculateGPCords(0, 0);
		if (this.renderBackgroundGP0Cache.x0 == undefined || this.renderBackgroundGP0Cache.x0 != gp0Cord.x2
		 || this.renderBackgroundGP0Cache.y0 == undefined || this.renderBackgroundGP0Cache.y0 != gp0Cord.y2
		 || this.renderBackgroundGP0Cache.z0 == undefined || this.renderBackgroundGP0Cache.z0 != Render.gp0RenderRatio)
		{
			this.renderBackgroundGP0 = true;
			this.renderBackgroundGP0Cover = true;
			Game.resetGP0SliceCache = true;
			
			this.renderBackgroundGP0Cache.x0 = gp0Cord.x2;
			this.renderBackgroundGP0Cache.y0 = gp0Cord.y2;
			this.renderBackgroundGP0Cache.z0 = Render.gp0RenderRatio;
		}
		
		//Gamepad Display Move
		Render.gp0DisplayMoveStart();
		
		//Background
		this.renderBackground();
		
		//Bots
		this._moveSpotBots();
		Game.renderBots();
		
		//Render Bases
		Render.renderBases("7b");
		
		if (1)
		{
			cxt = Render.returnTVSliceContext("7");
			cxt.clearRect(0, 0, Render.tvWidth, Render.tvHeight);
			gxt = Render.returnGP0SliceContext("7");
			gxt.clearRect(0, 0, Render.gp0Width, Render.gp0Height);
			
			Game.renderBotsTV = true;
			Game.renderBotsGP0 = true;
		}
		
		//Call Gamer Render function
		Game.render();
		
		Game.resetGP0SliceCache = false;
		
		//Show drone recorded path
		/*var cxt = Render.tvContext, gxt = Render.gp0Context;
		cxt.fillStyle = "red"; gxt.fillStyle = "red";
		cxt.strokeStyle = "red"; gxt.strokeStyle = "red";
		
		cxt.beginPath(); gxt.beginPath();
		
		var dronePath, gp0Cord;
		for(var i=0; i<this.dronePathPoints.length; i++)
		{
			dronePath = this.dronePathPoints[i];
			gp0Cord = Game.calculateGPCords(dronePath.x, dronePath.y);
			
			if (i == 0)
			{
				cxt.moveTo(dronePath.x*Render.renderTVRatio, dronePath.y*Render.renderTVRatio); gxt.moveTo(gp0Cord.x2, gp0Cord.y2);
			} else {
				cxt.lineTo(dronePath.x*Render.renderTVRatio, dronePath.y*Render.renderTVRatio); gxt.lineTo(gp0Cord.x2, gp0Cord.y2);
			}
			
			cxt.fillStyle = "#666"; gxt.fillStyle = "#666";
			cxt.fillRect(dronePath.x*Render.renderTVRatio-10, dronePath.y*Render.renderTVRatio-10, 20, 20);
			gxt.fillRect(gp0Cord.x2-5, gp0Cord.y2-5, 10, 10);
			cxt.fillStyle = "red"; gxt.fillStyle = "red";
		}
		dronePath = this.dronePathPoints[0];
		gp0Cord = Game.calculateGPCords(dronePath.x, dronePath.y);
		cxt.lineTo(dronePath.x*Render.renderTVRatio, dronePath.y*Render.renderTVRatio); gxt.lineTo(gp0Cord.x2, gp0Cord.y2);
		
		cxt.stroke(); gxt.stroke();*/
	};
	
	//Hanldes the render of the Background
	this.renderBackgroundTV = true;
	this.renderBackgroundGP0 = true; this.renderBackgroundGP0Cache = {};
	this.starCycleIndex = 1; this.starCycleIndexMax = 3;
	this.starCycleTTL = 10; this.starCycleTTLBase = 10;
	this.twoDegree = 0; this.threeDegree = 0;
	this.renderBackground = function()
	{
		var starCycleShow = false;
		if (1)
		{
			this.starCycleTTL -= 1*(Game.gameOver ? 1/3 : 1);
			if (this.starCycleTTL <= 0)
			{
				this.starCycleTTL = this.starCycleTTLBase;
				this.starCycleIndex++;
				if (this.starCycleIndex > this.starCycleIndexMax) this.starCycleIndex = 1;
				starCycleShow = true;
			}
		}
		
		var x=Render.trueWidth-150,y=Render.trueHeight/2,x2,y2,
			_w = 200, _h = 200,
			_w2 = _w*Render.gp0RenderRatio, _h2 = _h*Render.gp0RenderRatio;
		var gp0Cord = Game.calculateGPCords(x, y);
		if (this.renderBackgroundTV || starCycleShow)
		{
			var cxt = Render.returnTVSliceContext(2);
			cxt.clearRect(0, 0, Render.tvWidth, Render.tvHeight);
			cxt.drawImage(Render.images["pollux"+this.starCycleIndex], (x-_w/2)*Render.renderTVRatio, (y-_h/2)*Render.renderTVRatio, _w*Render.renderTVRatio, _h*Render.renderTVRatio);
		}
		if (this.renderBackgroundGP0 || starCycleShow)
		{
			var gxt = Render.returnGP0SliceContext(2);
			gxt.clearRect(0, 0, Render.gp0Width, Render.gp0Height);
			gxt.drawImage(Render.images["pollux"+this.starCycleIndex], gp0Cord.x2-_w2/2, gp0Cord.y2-_h2/2, _w2, _h2);
		}
		
		
		var x=0,y=0,x2,y2,
			_w = Render.tvWidth, _h = Render.tvHeight,
			_w2 = Render.trueWidth*Render.gp0RenderRatio, _h2 = Render.trueHeight*Render.gp0RenderRatio;
		var gp0Cord = Game.calculateGPCords(x, y);
		if (this.renderBackgroundTV)
		{
			var cxt = Render.returnTVSliceContext(1);
			cxt.clearRect(0, 0, Render.tvWidth, Render.tvHeight);
			cxt.drawImage(Render.images["space1_60d"], x, y, _w, _h);
			this.renderBackgroundTV = false;
		}
		if (this.renderBackgroundGP0)
		{
			var gxt = Render.returnGP0SliceContext(1);
			gxt.clearRect(0, 0, Render.gp0Width, Render.gp0Height);
			gxt.drawImage(Render.images["space1_60d"], gp0Cord.x2, gp0Cord.y2, _w2, _h2);
			this.renderBackgroundGP0 = false;
		}
		
		
		return true;
		
		
		var cxt = Render.returnTVSliceContext(2), gxt = Render.returnGP0SliceContext(2);
		cxt.clearRect(0, 0, Render.tvWidth, Render.tvHeight);
		gxt.clearRect(0, 0, Render.gp0Width, Render.gp0Height);
		
		//Two
		x = this.base[0].x; y = this.base[0].y;
		var w = 415, h = 415;
		w2 = w*Render.gp0RenderRatio; h2 = h*Render.gp0RenderRatio;
		gp0Cord = Game.calculateGPCords(x, y);
		
		cxt.save();
		cxt.translate(x*Render.renderTVRatio, y*Render.renderTVRatio);
		cxt.rotate((this.twoDegree+90)*Math.PI/180);
		cxt.drawImage(Render.images["circle_two"], -w/2*Render.renderTVRatio, -h/2*Render.renderTVRatio, w*Render.renderTVRatio, h*Render.renderTVRatio);
		cxt.restore();
		gxt.save();
		gxt.translate(gp0Cord.x2, gp0Cord.y2);
		gxt.rotate((this.twoDegree+90)*Math.PI/180);
		gxt.drawImage(Render.images["circle_two"], -w2/2, -h2/2, w2, h2);
		gxt.restore();
		
		//Three
		var w = 815, h = 815;
		w2 = w*Render.gp0RenderRatio; h2 = h*Render.gp0RenderRatio;
		gp0Cord = Game.calculateGPCords(x, y);
		
		cxt.save();
		cxt.translate(x*Render.renderTVRatio, y*Render.renderTVRatio);
		cxt.rotate((this.threeDegree)*Math.PI/180);
		cxt.drawImage(Render.images["circle_three"], -w/2*Render.renderTVRatio, -h/2*Render.renderTVRatio, w*Render.renderTVRatio, h*Render.renderTVRatio);
		cxt.restore();
		gxt.save();
		gxt.translate(gp0Cord.x2, gp0Cord.y2);
		gxt.rotate((this.threeDegree)*Math.PI/180);
		gxt.drawImage(Render.images["circle_three"], -w2/2, -h2/2, w2, h2);
		gxt.restore();
		
		//Move Two & Three
		if (!Game.isPaused && !Game.gamePause)
		{
			this.twoDegree += 2*(Game.fastEnabled ? Game.fastRate : 1)*0.75;
			if (this.twoDegree >= 360) this.twoDegree -= 360;
			this.threeDegree -= 1.25*(Game.fastEnabled ? Game.fastRate : 1)*0.75;
			if (this.threeDegree < 0) this.threeDegree += 360;
		}
	};
	
	//Render the background cover
	this.renderBackgroundTVCover = true; this.renderBackgroundGP0Cover = true;
	this.solarFlareActivated = false;
	this.solarFlareActivateTTL = 0; this.solarFlareActivateTTLBase = 1.3*60*40;
	this.solarFlareCycleIndex = 1; this.solarFlareCycleIndexMax = 3;
	this.solarFlareCycleTTL = 0; this.solarFlareCycleTTLBase = 5;
	this.solarFlareEdge = 25;
	this.solarFlareMoveRadius = 0; this.solarFlareMoveAmt = 5;
	this.solarFlareMoveTTL = 0; this.solarFlareMoveTTLBase = 1;
	this.solarFlareHits = [];
	this.renderBackgroundCover = function()
	{
		if (!this.solarFlareActivated && (!(Game.gamePause || Game.isPaused || Game.gameOver)))
		{
			this.solarFlareActivateTTL -= (Game.fastEnabled ? Game.fastRate : 1);
			if (this.solarFlareActivateTTL <= 0)
			{
				this.solarFlareActivateTTL = this.solarFlareActivateTTLBase;
				this.solarFlareActivated = true;
				this.solarFlareCycleIndex = 1;
				this.solarFlareCycleTTL = 0;
				this.solarFlareMoveRadius = 75;
				this.solarFlareMoveTTL = 0;
				this.solarFlareHits = [];
			}
		}
		if (this.solarFlareActivated)
		{
			var solarFlareCycleShow = false;
			if (1)
			{
				this.solarFlareCycleTTL -= 1*(Game.gameOver ? 1/3 : 1);
				if (this.solarFlareCycleTTL <= 0)
				{
					this.solarFlareCycleTTL = this.solarFlareCycleTTLBase;
					this.solarFlareCycleIndex++;
					if (this.solarFlareCycleIndex > this.solarFlareCycleIndexMax) this.solarFlareCycleIndex = 1;
					solarFlareCycleShow = true;
				}
			}
			
			
			if (this.renderBackgroundTVCover || this.renderBackgroundGP0Cover || solarFlareCycleShow)
			{
				var bot = {x: Render.trueWidth-150, y: Render.trueHeight/2};
				var r0 = this.solarFlareMoveRadius;
				var r = r0*Render.renderTVRatio, r2 = r0*Render.gp0RenderRatio;
				var rx = bot.x*Render.renderTVRatio-r, ry = bot.y*Render.renderTVRatio-r;
				var d;
				
				var newCanvas3 = document.createElement("canvas"), newCtx3 = newCanvas3.getContext("2d");
				var cD = Render.images["pollux"+this.solarFlareCycleIndex+"_edge"].width < r*2 ? Render.images["pollux"+this.solarFlareCycleIndex+"_edge"].width : r*2,
					cP = cD / (r*2);
				if (cP > 1) cP = 1;
				newCanvas3.width = cD;
				newCanvas3.height = cD;
				
				newCtx3.beginPath();
				var points = Game.getCircleClipPoints(bot.x, bot.y, r0, 10);
				for(var degree in points)
				{
					point = points[degree];
					
					d = r;
					radian = degree * Math.PI / 180;
					dx = bot.x*Render.renderTVRatio + (d * Math.sin(radian));
					dy = bot.y*Render.renderTVRatio + (d * Math.cos(radian));
					
					if (degree == 0)
					{
						newCtx3.moveTo((dx-rx)*cP, (dy-ry)*cP);
					} else {
						newCtx3.lineTo((dx-rx)*cP, (dy-ry)*cP);
					}
				}
				newCtx3.clip();
				newCtx3.closePath();
				
				
				newCtx3.fillStyle = "rgb(0, 0, 0)";
				newCtx3.beginPath();
				for(var degree in points)
				{
					point = points[degree];
	
					d = r - this.solarFlareEdge*Render.renderTVRatio;
					radian = degree * Math.PI / 180;
					dx = bot.x*Render.renderTVRatio + (d * Math.sin(radian));
					dy = bot.y*Render.renderTVRatio + (d * Math.cos(radian));
					
					if (degree == 0)
					{
						newCtx3.moveTo((dx-rx)*cP, (dy-ry)*cP);
					} else {
						newCtx3.lineTo((dx-rx)*cP, (dy-ry)*cP);
					}
				}
				newCtx3.fill();
				newCtx3.closePath();
				
			    newCtx3.globalCompositeOperation = "source-out";
			    
				newCtx3.drawImage(Render.images["pollux"+this.solarFlareCycleIndex+"_edge"], 0, 0, cD, cD);
			}
			
			var x=Render.trueWidth-150,y=Render.trueHeight/2,x2,y2,
				_w = r0*2, _h = r0*2,
				_w2 = _w*Render.gp0RenderRatio, _h2 = _h*Render.gp0RenderRatio;
			var gp0Cord = Game.calculateGPCords(x, y);
			if (this.renderBackgroundTVCover || solarFlareCycleShow)
			{
				var cxt = Render.returnTVSliceContext(8);
				cxt.clearRect(0, 0, Render.tvWidth, Render.tvHeight);
				cxt.drawImage(newCanvas3, (x-_w/2)*Render.renderTVRatio, (y-_h/2)*Render.renderTVRatio, r0*2*Render.renderTVRatio, r0*2*Render.renderTVRatio);
				this.renderBackgroundTVCover = false;
			}
			if (this.renderBackgroundGP0Cover || solarFlareCycleShow)
			{
				var gxt = Render.returnGP0SliceContext(8);
				gxt.clearRect(0, 0, Render.gp0Width, Render.gp0Height);
				gxt.drawImage(newCanvas3, gp0Cord.x2-_w2/2, gp0Cord.y2-_h2/2, r2*2, r2*2);
				this.renderBackgroundGP0Cover = false;
			}
			
			if ((!(Game.gamePause || Game.isPaused)))
			{
				var bot = {x: Render.trueWidth-150, y: Render.trueHeight/2};
				var r0 = this.solarFlareMoveRadius;
				
				this.solarFlareMoveTTL -= (Game.fastEnabled ? Game.fastRate : 1)*(Game.gameOver ? 1/3 : 1);
				if (this.solarFlareMoveTTL <= 0)
				{
					this.solarFlareMoveTTL = this.solarFlareMoveTTLBase;
					this.solarFlareMoveRadius += this.solarFlareMoveAmt*(Game.fastEnabled ? Game.fastRate : 1)*(Game.gameOver ? 1/3 : 1);
					
					//Damage Check
					var d;
					var base;
					for(var key in this.base)
					{
						base = this.base[key];
						if (jQuery.inArray("base"+key, this.solarFlareHits) != -1) continue;
						
						d = Math.sqrt((base.x - bot.x)*(base.x - bot.x) + (base.y - bot.y)*(base.y - bot.y));
						if (d <= r0)
						{
							Game.damageBase(base, 1);
							this.solarFlareHits.push("base"+key);
						}
					}
					var obj;
					for(var ID in Game.enemiesList)
					{
						obj = Game.enemiesList[ID];
						if (jQuery.inArray("e"+ID, this.solarFlareHits) != -1) continue;
						
						d = Math.sqrt((obj.x - bot.x)*(obj.x - bot.x) + (obj.y - bot.y)*(obj.y - bot.y));
						if (d <= r0)
						{
							var dmgAmt = obj.maxLife/5;
							obj.life -= dmgAmt;
							if (obj.life < 0) obj.life = 0;
							Render.sounds["hit"].play();
							Game.botFireUponEnemy(null, ID, 1, {hiteval: false, visual: false, sound: false});
							this.solarFlareHits.push("e"+ID);
						}
					}
					
					//End Check
					if (this.solarFlareMoveRadius > 1920)
					{
						this.solarFlareActivated = false;
						
						var cxt = Render.returnTVSliceContext(8);
						cxt.clearRect(0, 0, Render.tvWidth, Render.tvHeight);
						var gxt = Render.returnGP0SliceContext(8);
						gxt.clearRect(0, 0, Render.gp0Width, Render.gp0Height);
					}
				}
			}
		}
	};
	
	
	//Move the Spot Bots in a circle around the bot
	this._moveSpotBots = function(inititalSet)
	{
		if (inititalSet == undefined) inititalSet = false;
		if ((Game.gamePause) && !inititalSet) return false;
		
		/*this._spotbots.push({
			ID: spotID, type: "spot",
			r: 500, d: 270, dir: -1, speed: 1
		});*/
		var data,obj,x,y,gp0Cord;
		for(var key in this._spotbots)
		{
			data = this._spotbots[key];
			obj = (data.type == "spot" ? Game.spots[data.ID] : Game.bots[data.ID]);
			if (!obj) continue;
			
			x = this.base[0].x+(data.r*Math.cos(data.d*(Math.PI/180)));
			y = this.base[0].y+(data.r*Math.sin(data.d*(Math.PI/180)));
			gp0Cord = Game.calculateGPCords(x, y);
			obj.x = x; obj.y = y;
			obj.x2 = gp0Cord.x2; obj.y2 = gp0Cord.y2;
			
			if (!Game.isPaused && !Game.gamePause && !inititalSet)
			{
				data.d += data.dir*data.speed*(Game.fastEnabled ? Game.fastRate : 1)*0.75;
				if (data.d < 0) data.d += 360;
				else if (data.d >= 360) data.d -= 360;
				
				//Game.renderBotsTV = true;
				//Game.renderBotsGP0 = true;
			}
		}
	};

	//Map specific function to handle the tracking of any spot to bot transitions interally
	this.manageSpotToBotConversion = function(spotID, botID)
	{
		var data;
		for(var key in this._spotbots)
		{
			data = this._spotbots[key];
			
			if (data.ID == spotID)
			{
				data.ID = botID;
				data.type = "bot";
			}
		}
	};

	//Map specific function to handle the tracking of any bot to spot transitions interally
	this.manageBotToSpotConversion = function(botID, spotID)
	{
		var data;
		for(var key in this._spotbots)
		{
			data = this._spotbots[key];
			
			if (data.ID == botID)
			{
				data.ID = spotID;
				data.type = "spot";
			}
		}
	};
	
	
	//Map specific spawn enemy function
	//Returns specific data, such as pattern, start position, etc
	this.spawnEnemy = function()
	{
		var data = {};
		data.pattern = Math.floor(Math.random()*this.enemyPaths.length);
		
		var pathData = this.enemyPaths[data.pattern];
		data.speed = pathData.speed;
		data.point = 0;
		
		var r = 0;//Math.floor(Math.random()*4);
		switch(r)
		{
		case 0:
			var x=this.base[0].x, y=this.base[0].y, r=1165;
			var degree = Math.floor(Math.random()*360),//(this.counter++ % 2 == 0 ? 180 : 180+45),//
				radian = degree * Math.PI / 180;
			data.startX = 0;//x + (r * Math.sin(radian));
			data.startY = Math.floor(Math.random()*Render.trueHeight*1.5 - Render.trueHeight*0.25);//y + (r * Math.cos(radian));
			
			//data.startX = Math.floor(Math.random()*Render.tvWidth);
			//data.startY = -50;
		break;
		
		case 1:
			data.startX = Render.tvWidth+50;
			data.startY = Math.floor(Math.random()*Render.tvHeight);
		break;
		
		case 2:
			data.startX = Math.floor(Math.random()*Render.tvWidth);
			data.startY = Render.tvHeight+50;
		break;
		
		case 3:
			data.startX = -50;
			data.startY = Math.floor(Math.random()*Render.tvHeight);
		break;
		
		//Testing
		case 4:
			//data.startX = Render.tvWidth/2;
			//data.startY = Render.tvHeight/2;
			if (this.counter % 2 == 0 && 0)
			{
				data.startX = -50;
				data.startY = -50;
			} else {
				data.startY = -50;
				data.startX = Render.tvWidth/2;
			}
			this.counter++;
		break;
		}
		
		data.destination = {};
		data.destination.x = this.base[0].x;
		data.destination.y = this.base[0].y;
		
		return data;
	};
	
	//Map specific move enemy function
	this.moveEnemy = function(ID, obj, rate)
	{
		if (rate == undefined) rate = 1;
		var pathData = this.enemyPaths[obj.pattern],
			path = pathData.path,
			pathPoint = obj.data.point,
			speed = obj.speed*rate;
		if (obj.data.point >= pathData.path.length-1) return true;
		
		var newpoint = pathPoint+1;
		var pointMap = path[newpoint];
		var d = Math.sqrt((pointMap.x - obj.x)*(pointMap.x - obj.x) + (pointMap.y - obj.y)*(pointMap.y - obj.y));
		if (d < speed*2)
		{
			obj.data.point = newpoint;
			obj.x = pointMap.x; obj.y = pointMap.y;
			this.moveEnemy(ID, obj);
			return true;
		}
		
		//On final point?
		if (newpoint == path.length-1)
		{
			if (this.base[pathData.base].life <= 0)
			{
				if (obj.data.newbaseroute == undefined)
				{
					var base, newBase = null;
					for(var key in this.base)
					{
						if (newBase != null) continue;
						
						base = this.base[key];
						if (base.life > 0) newBase = key;
					}
					obj.data.newbaseroute = parseInt(newBase);
				}
				
				pointMap = this.base[obj.data.newbaseroute];
			}
		}
		
		
		if (!pointMap) return false;
		
		//Change Destination Points
		obj.data.destination.x = pointMap.x;
		obj.data.destination.y = pointMap.y;
		
		//Determine x and y increases
		var dX = Math.abs(pointMap.x - obj.x), dY = Math.abs(pointMap.y - obj.y);
		var xSide = 0, ySide = 0;
		if (dX == 0 && pointMap.y - obj.y < 0) { ySide = -1*speed; }
		else if (dX == 0 && pointMap.y - obj.y > 0) { ySide = speed; }
		else if (dY == 0 && pointMap.x - obj.x < 0) { xSide = -1*speed; }
		else if (dY == 0 && pointMap.x - obj.x > 0) { xSide = speed; }
		else {
			var angleA = Math.atan(dX/dY);// * (180 / Math.PI);
			xSide = Math.abs(speed*Math.sin(angleA));
			ySide = Math.abs(speed*Math.cos(angleA));
			//xSide = (angleA/90)*speed*1.3;
			//ySide = ((90-angleA)/90)*speed*1.3;
			
			if (pointMap.x - obj.x < 0 && pointMap.y - obj.y < 0) { xSide *= -1; ySide *= -1; }
			else if (pointMap.x - obj.x > 0 && pointMap.y - obj.y < 0) { ySide *= -1; }
			else if (pointMap.x - obj.x > 0 && pointMap.y - obj.y > 0) {  }
			else if (pointMap.x - obj.x < 0 && pointMap.y - obj.y > 0) { xSide *= -1; }

			//console.log(dX, dY, angleA, speed, xSide, ySide);
		}
		
		obj.x += xSide; obj.y += ySide;
		//this.enemyMovements.push({x: obj.x, y: obj.y});
		
		
		/*
		var x = obj.data.startX - this.base[0].x,
			y = obj.data.startY - this.base[0].y,
			s = obj.speed;
		
		//x: 1010 @ 580 ~17500 | 1.7414 | -1.74137
		//y: 590  @ 600 ~17500 | 0.9833
		var xs = x/s, ys = y/s;
		if (x != 0) xs = x/(s*Math.abs(580/s));
		//if (y != 0) ys = y/(s*Math.abs(600/s));
		
		obj.x -= xs;// * Math.abs(x/590));
		obj.y -= ys;// * Math.abs(y/590));*/
	};
	
	
	//Map Sepecific spawn drone function
	//Returns spawn data, specifically the x/y
	this.spawnDrone = function()
	{
		var data = {x: 0, y: 0, direction: Math.floor(Math.random()*2) == 0 ? -1 : 1};
		var pointindex = Math.floor(Math.random()*this.dronePathPoints.length);
		data.point = pointindex;
		
		//Choose point at random
		var point = this.dronePathPoints[pointindex];
		data.x = point.x;
		data.y = point.y;
		
		//Destination
		var newpoint = data.point + data.direction;
		if (newpoint < 0) newpoint = this.dronePathPoints.length - 1;
		else if (newpoint > this.dronePathPoints.length-1) newpoint = 0;
		var pointMap = this.dronePathPoints[newpoint];
		data.destination = {};
		data.destination.x = pointMap.x;
		data.destination.y = pointMap.y;
		
		return data;
	};
	
	//Map specific move drone function
	this.moveDroneCount = 0;
	this.moveDrone = function(ID, rate, fastRate)
	{
		if (rate == undefined) rate = 1;
		if (fastRate == undefined) fastRate = parseInt(Game.fastRate);
		
		var bot = Game.bots[ID];
		var speed = bot.data.movespeed*rate*fastRate;
		
		//Special check to make sure we did not enter infiniti loop
		this.moveDroneCount++;
		if (this.moveDroneCount >= 10)
		{
			this.moveDroneCount = 0;
			bot.pointAccess = "direct";
			bot.point = Math.floor(Math.random()*this.dronePathPoints.length);
			return false;
		}
		
		//Direction?
		var newpoint = bot.point + bot.direction;
		if (newpoint < 0) newpoint = this.dronePathPoints.length - 1;
		else if (newpoint > this.dronePathPoints.length-1) newpoint = 0;
		var pointMap = this.dronePathPoints[newpoint];
		var d = Math.sqrt((pointMap.x - bot.x)*(pointMap.x - bot.x) + (pointMap.y - bot.y)*(pointMap.y - bot.y));
		if (d < speed*2)
		{
			bot.point = newpoint;
			this.moveDrone(ID);
			return true;
		}
		
		//var cxt = Render.tvContext, gxt = Render.gp0Context;
		//cxt.fillStyle = "red"; gxt.fillStyle = "red";
		
		//Determine where to go
		var pois = [bot.point-1, bot.point, bot.point+1, -2], poi, poiEntry, dcheck = 200, eObj, _d;
		var enemies = Game.enemiesList, eIDtoUse = null, eDtoUse = null;
		if (bot.enemyLockOn && enemies[bot.enemyLockOn] != undefined)
		{
			eIDtoUse = bot.enemyLockOn;
		} else delete bot.enemyLockOn;
		if (eIDtoUse == null)
		{
			for(var key in pois)
			{
				poi = pois[key];
				if (poi != -2)
				{
					if (poi < 0) poi = this.dronePathPoints.length - 1;
					else if (poi > this.dronePathPoints.length-1) poi = 0;
					poiEntry = this.dronePathPoints[poi];
				} else poiEntry = {x: bot.x, y: bot.y};
				
				//Check for enemies close by
				for(var eID in enemies)
				{
					eObj = enemies[eID];
					_d = Math.sqrt((eObj.x - poiEntry.x)*(eObj.x - poiEntry.x) + (eObj.y - poiEntry.y)*(eObj.y - poiEntry.y));
					if (_d <= dcheck)
					{
						_d = Math.sqrt((eObj.x - bot.x)*(eObj.x - bot.x) + (eObj.y - bot.y)*(eObj.y - bot.y));
						if (eIDtoUse == null || _d > eDtoUse)
						{
							eIDtoUse = eID;
							eDtoUse = _d;
						}
					}
				}
				
				//cxt.beginPath();
				//cxt.arc(poiEntry.x, poiEntry.y, dcheck, 0, 2*Math.PI, false);
				//cxt.fill();
			}
		}
		if (eIDtoUse)
		{
			pointMap = enemies[eIDtoUse];
			bot.enemyLockOn = eIDtoUse;
			
			/*cxt.strokeStyle = "yellow";
			cxt.beginPath();
			cxt.moveTo(bot.x, bot.y);
			cxt.lineTo(pointMap.x, pointMap.y);
			cxt.stroke();*/
		} else {
			//Advance smoothly to next point
			if (bot.fireduponenemy != undefined && bot.fireduponenemy)
			{
				var poiToUse = null, poiToUseD = null;
				pois = [bot.point, bot.point+bot.direction, bot.point+bot.direction*2]; _d;
				for(var key in pois)
				{
					poi = pois[key];
					if (poi < 0) poi = this.dronePathPoints.length - 1;
					else if (poi > this.dronePathPoints.length-1) poi = 0;
					poiEntry = this.dronePathPoints[poi];
					_d = Math.sqrt((bot.x - poiEntry.x)*(bot.x - poiEntry.x) + (bot.y - poiEntry.y)*(bot.y - poiEntry.y));
					
					if (poiToUseD == null || poiToUseD > _d)
					{
						poiToUse = poi;
						poiToUseD = _d;
					}
				}
				
				bot.fireduponenemy = false;
				
				if (poiToUse !== null)
				{
					poi = poiToUse+bot.direction;
					if (poi < 0) poi = this.dronePathPoints.length - 1;
					else if (poi > this.dronePathPoints.length-1) poi = 0;
					
					bot.point = poiToUse;
					pointMap = this.dronePathPoints[poi];
				}
			}
		}
		
		//Change Destination Points
		bot.destination.x = pointMap.x;
		bot.destination.y = pointMap.y;
		
		/*var cxt = Render.tvContext, gxt = Render.gp0Context;
		cxt.fillStyle = "red"; gxt.fillStyle = "red";
		cxt.strokeStyle = "red"; gxt.strokeStyle = "red";
		cxt.fillRect(pointMap.x-10, pointMap.y-10, 20, 20);*/
		
		//Determine if point is less then speed
		_d = Math.sqrt((bot.x - pointMap.x)*(bot.x - pointMap.x) + (bot.y - pointMap.y)*(bot.y - pointMap.y));
		if (_d < speed) speed = _d;
		if (Math.abs(speed) < 0.01) return true;
		
		//Determine x and y increases
		var dX = Math.abs(pointMap.x - bot.x), dY = Math.abs(pointMap.y - bot.y);
		var xSide = 0, ySide = 0;
		if (dX == 0 && pointMap.y - bot.y < 0) { ySide = -1*speed; }
		else if (dX == 0 && pointMap.y - bot.y > 0) { ySide = speed; }
		else if (dY == 0 && pointMap.x - bot.x < 0) { xSide = -1*speed; }
		else if (dY == 0 && pointMap.x - bot.x > 0) { xSide = speed; }
		else {
			var angleA = Math.atan(dX/dY);// * (180 / Math.PI);
			xSide = Math.abs(speed*Math.sin(angleA));
			ySide = Math.abs(speed*Math.cos(angleA));
			//xSide = (angleA/90)*speed;
			//ySide = ((90-angleA)/90)*speed;
			
			if (pointMap.x - bot.x < 0 && pointMap.y - bot.y < 0) { xSide *= -1; ySide *= -1; }
			else if (pointMap.x - bot.x > 0 && pointMap.y - bot.y < 0) { ySide *= -1; }
			else if (pointMap.x - bot.x > 0 && pointMap.y - bot.y > 0) {  }
			else if (pointMap.x - bot.x < 0 && pointMap.y - bot.y > 0) { xSide *= -1; }
		}
		
		bot.x += xSide; bot.y += ySide;
		var gp0Cord = Game.calculateGPCords(bot.x, bot.y);
		bot.x2 = gp0Cord.x2; bot.y2 = gp0Cord.y2;
		this.moveDroneCount = 0;
		
		/*
		var gxt = Render.gp0Context;
		gxt.fillStyle = "#FFF";
		gxt.fillRect(0, 0, 400, 200);
		gxt.font = "14px Noto Sans";
		gxt.fillStyle = "#000";
		gxt.fillText(dX, 15, 15);
		gxt.fillText(dY, 15, 35);
		gxt.fillText(xSide, 15, 55);
		gxt.fillText(ySide, 15, 75);
		gxt.fillText(bot.x, 15, 95);
		gxt.fillText(bot.y, 15, 115);*/
	};
};
var MapPollux = new MapPollux();