function MapSS001()
{
	this.map = "ss001";
	this.base = [{
		x: Render.trueWidth/2,	x2: Render.gp0Width/2,
		y: Render.trueHeight/2,	y2: Render.gp0Height/2,
		r: 100/2,				r2: (100/2),
		life: 100,
		maxLife: 100,
		shield: 0, shieldUse: 0
	}];
	this.storeRules = {};
	this.walls = [];
	this.dronePathPoints = [{
		x: Render.trueWidth*0.5, y: Render.trueHeight*0.1
	}, {
		x: Render.trueWidth*0.66, y: Render.trueHeight*0.125
	}, {
		x: Render.trueWidth*0.8, y: Render.trueHeight*0.2
	}, {
		x: Render.trueWidth*0.88, y: Render.trueHeight*0.28
	}, {
		x: Render.trueWidth*0.935, y: Render.trueHeight*0.39
	}, {
		
		x: Render.trueWidth*0.95, y: Render.trueHeight*0.5
	}, {
		x: Render.trueWidth*0.935, y: Render.trueHeight*0.61
	}, {
		x: Render.trueWidth*0.88, y: Render.trueHeight*0.72
	}, {
		x: Render.trueWidth*0.8, y: Render.trueHeight*0.8
	}, {
		x: Render.trueWidth*0.66, y: Render.trueHeight*0.875
	}, {
		
		x: Render.trueWidth*0.5, y: Render.trueHeight*0.9
	}, {
		x: Render.trueWidth*0.34, y: Render.trueHeight*0.875
	}, {
		x: Render.trueWidth*0.2, y: Render.trueHeight*0.8
	}, {
		x: Render.trueWidth*0.12, y: Render.trueHeight*0.72
	}, {
		x: Render.trueWidth*0.065, y: Render.trueHeight*0.61
	}, {
		
		x: Render.trueWidth*0.05, y: Render.trueHeight*0.5
	}, {
		x: Render.trueWidth*0.065, y: Render.trueHeight*0.39
	}, {
		x: Render.trueWidth*0.12, y: Render.trueHeight*0.28
	}, {
		x: Render.trueWidth*0.2, y: Render.trueHeight*0.2
	}, {
		x: Render.trueWidth*0.34, y: Render.trueHeight*0.125
	}];
	this.dronePathPointsOnReturn = [];
	this.enemyPaths = [{
		speed: 2.0,
		base: 0,
		path: [{
			x: 0,
			y: 0
		}, {
			x: this.base[0].x,
			y: this.base[0].y
		}]
	}];
	
	//Init
	this.init = function(options)
	{
		if (options == undefined) options = {};
		if (options.mode == undefined) options.mode = Game.mode;
		
		ClickBank.clearAll();
		InputBank.clearAll();
		Render.soundsStopAll();
		
		this.renderBackgroundTV = true;
		this.renderBackgroundGP0 = true;
		this.renderBackgroundGP0Cache = {};
		
		//Base
		this.base[0].life = this.base[0].maxLife;
		this.base[0].shield = 0;
		this.base[0].shieldUse = 0;
		var base;
		for(var key in this.base)
		{
			base = this.base[key];
			base.cache = {};
		}
		
		//Music
		if (Render.sounds["levelbg"].readyState > 0)
			Render.sounds["levelbg"].currentTime = 0;
		Render.sounds["levelbg"].play();
		
		//Game init
		Game.map = this.map;
		Game.mapClass = this;
		Game.mode = options.mode;
		Game.init();
		
		//Spots
		if (1) {
			Game.spotsAdd({
				x: Render.trueWidth/2, y: Render.trueHeight/2, r: 20,
				x2: Render.gp0Width/2, y2: Render.gp0Height/2, r2: 20*Render.gp0RenderRatio
			});
			Game.spotsAdd({
				x: Render.trueWidth/2-this.base[0].r-25, y: Render.trueHeight/2, r: 20,
				x2: Render.gp0Width/2-this.base[0].r2, y2: Render.gp0Height/2, r2: 20*Render.gp0RenderRatio
			});
			Game.spotsAdd({
				x: Render.trueWidth/2, y: Render.trueHeight/2-this.base[0].r-25, r: 20,
				x2: Render.gp0Width/2, y2: Render.gp0Height/2-this.base[0].r2, r2: 20*Render.gp0RenderRatio
			});
			Game.spotsAdd({
				x: Render.trueWidth/2+this.base[0].r+25, y: Render.trueHeight/2, r: 20,
				x2: Render.gp0Width/2+this.base[0].r2, y2: Render.gp0Height/2, r2: 20*Render.gp0RenderRatio
			});
			Game.spotsAdd({
				x: Render.trueWidth/2, y: Render.trueHeight/2+this.base[0].r+25, r: 20,
				x2: Render.gp0Width/2, y2: Render.gp0Height/2+this.base[0].r2, r2: 20*Render.gp0RenderRatio
			});
		}
		
		Render.renderControl = function(){ MapSS001.render(); };
		
		Game.startGame();

		//Game.botsDroneAdd();
		/*Game.botsDroneAdd();
		Game.botsDroneAdd();
		Game.botsDroneAdd();
		Game.botsDroneAdd();*/
		//Game.botsAdd("sentry", Render.trueWidth/2, Render.trueHeight/2);
		/*for(var i=0; i<5; i++)
		{
			var xDiff = (Render.trueWidth/8)-Math.floor(Math.random()*(Render.trueWidth/4));
			var botID = Game.botsAdd("sentry", Render.trueWidth/2+xDiff, Render.trueHeight/2);
			var bot = Game.bots[botID];
			bot.data.range = 500;
		}*/

		/*Game.botsAdd("sentry", Render.trueWidth*0.4, Render.trueHeight*0.325);
		Game.botsAdd("teslacoil", Render.trueWidth*0.6, Render.trueHeight*0.325);
		Game.botsAdd("bomber", Render.trueWidth*0.3, Render.trueHeight*0.65);
		Game.botsAdd("cloud", Render.trueWidth*0.5, Render.trueHeight*0.65);
		Game.botsAdd("helper", Render.trueWidth*0.7, Render.trueHeight*0.65);
		Game.botsDroneAdd();*/
	};
	
	//Map Render
	this.counter = 0;
	this.render = function()
	{
		//Clear
		Render.renderClear("all");
		//var cxt = Render.tvContext, gxt = Render.gp0Context;
		
		//Gamepad Slice Cache Reset
		var gp0Cord = Game.calculateGPCords(0, 0);
		if (this.renderBackgroundGP0Cache.x0 == undefined || this.renderBackgroundGP0Cache.x0 != gp0Cord.x2
		 || this.renderBackgroundGP0Cache.y0 == undefined || this.renderBackgroundGP0Cache.y0 != gp0Cord.y2
		 || this.renderBackgroundGP0Cache.z0 == undefined || this.renderBackgroundGP0Cache.z0 != Render.gp0RenderRatio)
		{
			this.renderBackgroundGP0 = true;
			Game.resetGP0SliceCache = true;
			
			this.renderBackgroundGP0Cache.x0 = gp0Cord.x2;
			this.renderBackgroundGP0Cache.y0 = gp0Cord.y2;
			this.renderBackgroundGP0Cache.z0 = Render.gp0RenderRatio;
		}
		
		//Gamepad Display Move
		Render.gp0DisplayMoveStart();
		
		
		//Background
		this.renderBackground();
		
		//Bots
		Game.renderBots();
		
		//Render Bases
		Render.renderBases();
		
		//Call Gamer Render function
		Game.render();
		
		Game.resetGP0SliceCache = false;
	};
		
		//Show drone recorded path
		/*cxt.fillStyle = "red"; gxt.fillStyle = "red";
		cxt.strokeStyle = "red"; gxt.strokeStyle = "red";
		
		cxt.save();
		cxt.scale(2, 1);
		cxt.beginPath();
		cxt.arc(Render.tvWidth/4, Render.tvHeight/2, Render.tvWidth*0.225, 0, 2*Math.PI, false);
		cxt.stroke();
		cxt.restore();
		
		cxt.beginPath(); gxt.beginPath();
		
		var dronePath, gp0Cord;
		for(var i=0; i<this.dronePathPoints.length; i++)
		{
			dronePath = this.dronePathPoints[i];
			gp0Cord = Game.calculateGPCords(dronePath.x, dronePath.y);
			
			if (i == 0)
			{
				cxt.moveTo(dronePath.x, dronePath.y); gxt.moveTo(gp0Cord.x2, gp0Cord.y2);
			} else {
				cxt.lineTo(dronePath.x, dronePath.y); gxt.lineTo(gp0Cord.x2, gp0Cord.y2);
			}
			
			cxt.fillStyle = "#666"; gxt.fillStyle = "#666";
			cxt.fillRect(dronePath.x-10, dronePath.y-10, 20, 20);
			gxt.fillRect(gp0Cord.x2-5, gp0Cord.y2-5, 10, 10);
			cxt.fillStyle = "red"; gxt.fillStyle = "red";
		}
		dronePath = this.dronePathPoints[0];
		gp0Cord = Game.calculateGPCords(dronePath.x, dronePath.y);
		cxt.lineTo(dronePath.x, dronePath.y); gxt.lineTo(gp0Cord.x2, gp0Cord.y2);
		
		cxt.stroke(); gxt.stroke();*/
	//};
	
	//Hanldes the render of the Background
	//this.backgroundFade = []; this.lastcalltime = 0;
	this.renderBackgroundTV = true;
	this.renderBackgroundGP0 = true; this.renderBackgroundGP0Cache = {};
	this.renderBackground = function()
	{
		//var gxt = Render.gp0Context;
		
		var x=0,y=0,x2,y2,
			_w = Render.tvWidth, _h = Render.tvHeight,
			_w2 = Render.trueWidth*Render.gp0RenderRatio, _h2 = Render.trueHeight*Render.gp0RenderRatio;
		var gp0Cord = Game.calculateGPCords(x, y);
		if (this.renderBackgroundTV)
		{
			var cxt = Render.returnTVSliceContext(1);
			cxt.clearRect(0, 0, Render.tvWidth, Render.tvHeight);
			cxt.drawImage(Render.images["space1_60d"], x, y, _w, _h);
			this.renderBackgroundTV = false;
		}
		if (this.renderBackgroundGP0)
		{
			var gxt = Render.returnGP0SliceContext(1);
			gxt.clearRect(0, 0, Render.gp0Width, Render.gp0Height);
			gxt.drawImage(Render.images["space1_60d"], gp0Cord.x2, gp0Cord.y2, _w2, _h2);
			this.renderBackgroundGP0 = false;
		}
	};
		
		/*if (this.backgroundFade.length == 0)
		{
			this.lastcalltime = Date.now();
			this.backgroundFade.push({
				x: 0, y: 0,
				w: _w, h: _h,
				alpha: 0.7, startfadein: 0, inbetweendelay: 0, inbetweendelayreset: 150,
				alphaLow: 0.5, alphaHigh: 0.7, direction: -1, speed: 0.001});
		}
		
		cxt.fillStyle = "#000"; gxt.fillStyle = "#000";
		var info, mstime = Date.now() - this.lastcalltime;
		for(var key in this.backgroundFade)
		{
			info = this.backgroundFade[key];
			gp0Cord = Game.calculateGPCords(info.x, info.y);
			
			if (info.startfadein > 0)
			{
				info.startfadein -= mstime;
			} else if (info.inbetweendelay > 0) {
				info.inbetweendelay -= mstime;
			} else {
				info.alpha += info.direction*info.speed;
				if (info.alpha <= info.alphaLow || info.alpha >= info.alphaHigh)
				{
					info.direction *= -1;
					info.inbetweendelay = info.inbetweendelayreset;
				}
			}
			
			cxt.globalAlpha = info.alpha;
			gxt.globalAlpha = info.alpha;
			cxt.fillRect(info.x, info.y, info.w, info.h);
			gxt.fillRect(gp0Cord.x2, gp0Cord.y2, info.w*Render.gp0RenderRatio, info.h*Render.gp0RenderRatio);
		}
		cxt.globalAlpha = 1;
		gxt.globalAlpha = 1;
		*/
		
		//this.lastcalltime = Date.now();
	//};
	
	
	//Map specific spawn enemy function
	//Returns specific data, such as pattern, start position, etc
	this.spawnEnemy = function()
	{
		var data = {};
		data.pattern = Math.floor(Math.random()*this.enemyPaths.length);
		
		var pathData = this.enemyPaths[data.pattern];
		data.speed = pathData.speed;
		data.point = 0;
		
		var x=this.base[0].x, y=this.base[0].y, r=1165;
		var degree = Math.floor(Math.random()*360),
			radian = degree * Math.PI / 180;
		data.startX = x + (r * Math.sin(radian));
		data.startY = y + (r * Math.cos(radian));
		
		data.destination = {};
		data.destination.x = this.base[0].x;
		data.destination.y = this.base[0].y;
		
		return data;
	};
	
	//Map specific move enemy function
	this.moveEnemy = function(ID, obj, rate)
	{
		if (rate == undefined) rate = 1;
		var pathData = this.enemyPaths[obj.pattern],
			path = pathData.path,
			pathPoint = obj.data.point,
			speed = obj.speed*rate;
		if (obj.data.point >= pathData.path.length-1) return true;
		
		var newpoint = pathPoint+1;
		var pointMap = path[newpoint];
		var d = Math.sqrt((pointMap.x - obj.x)*(pointMap.x - obj.x) + (pointMap.y - obj.y)*(pointMap.y - obj.y));
		if (d < speed*2)
		{
			obj.data.point = newpoint;
			obj.x = pointMap.x; obj.y = pointMap.y;
			this.moveEnemy(ID, obj);
			return true;
		}
		
		//On final point?
		if (newpoint == path.length-1)
		{
			if (this.base[pathData.base].life <= 0)
			{
				if (obj.data.newbaseroute == undefined)
				{
					var base, newBase = null;
					for(var key in this.base)
					{
						if (newBase != null) continue;
						
						base = this.base[key];
						if (base.life > 0) newBase = key;
					}
					obj.data.newbaseroute = parseInt(newBase);
				}
				
				pointMap = this.base[obj.data.newbaseroute];
			}
		}
		
		
		if (!pointMap) return false;
		
		//Change Destination Points
		obj.data.destination.x = pointMap.x;
		obj.data.destination.y = pointMap.y;
		
		//Determine x and y increases
		var dX = (pointMap.x - obj.x), dY = (pointMap.y - obj.y);
		dX = dX < 0 ? -dX : dX; dY = dY < 0 ? -dY : dY;
		var xSide = 0, ySide = 0;
		if (dX == 0 && pointMap.y - obj.y < 0) { ySide = -1*speed; }
		else if (dX == 0 && pointMap.y - obj.y > 0) { ySide = speed; }
		else if (dY == 0 && pointMap.x - obj.x < 0) { xSide = -1*speed; }
		else if (dY == 0 && pointMap.x - obj.x > 0) { xSide = speed; }
		else {
			var angleA = Math.atan(dX/dY);// * (180 / Math.PI);
			xSide = (speed*Math.sin(angleA)); xSide = xSide < 0 ? -xSide : xSide;
			ySide = (speed*Math.cos(angleA)); ySide = ySide < 0 ? -ySide : ySide;
			//xSide = (angleA/90)*speed*1.3;
			//ySide = ((90-angleA)/90)*speed*1.3;
			
			if (pointMap.x - obj.x < 0 && pointMap.y - obj.y < 0) { xSide *= -1; ySide *= -1; }
			else if (pointMap.x - obj.x > 0 && pointMap.y - obj.y < 0) { ySide *= -1; }
			else if (pointMap.x - obj.x > 0 && pointMap.y - obj.y > 0) {  }
			else if (pointMap.x - obj.x < 0 && pointMap.y - obj.y > 0) { xSide *= -1; }

			//console.log(dX, dY, angleA, speed, xSide, ySide);
		}
		
		obj.x += xSide; obj.y += ySide;
		//this.enemyMovements.push({x: obj.x, y: obj.y});
		
		
		/*
		var x = obj.data.startX - this.base[0].x,
			y = obj.data.startY - this.base[0].y,
			s = obj.speed;
		
		//x: 1010 @ 580 ~17500 | 1.7414 | -1.74137
		//y: 590  @ 600 ~17500 | 0.9833
		var xs = x/s, ys = y/s;
		if (x != 0) xs = x/(s*Math.abs(580/s));
		//if (y != 0) ys = y/(s*Math.abs(600/s));
		
		obj.x -= xs;// * Math.abs(x/590));
		obj.y -= ys;// * Math.abs(y/590));*/
	};
	
	
	//Map Sepecific spawn drone function
	//Returns spawn data, specifically the x/y
	this.spawnDrone = function()
	{
		var data = {x: 0, y: 0, direction: Math.floor(Math.random()*2) == 0 ? -1 : 1};
		var pointindex = Math.floor(Math.random()*this.dronePathPoints.length);
		data.point = pointindex;
		
		//Choose point at random
		var point = this.dronePathPoints[pointindex];
		data.x = point.x;
		data.y = point.y;
		
		//Destination
		var newpoint = data.point + data.direction;
		if (newpoint < 0) newpoint = this.dronePathPoints.length - 1;
		else if (newpoint > this.dronePathPoints.length-1) newpoint = 0;
		var pointMap = this.dronePathPoints[newpoint];
		data.destination = {};
		data.destination.x = pointMap.x;
		data.destination.y = pointMap.y;
		
		return data;
	};
	
	//Map specific move drone function
	this.moveDroneCount = 0;
	this.moveDrone = function(ID, rate, fastRate)
	{
		if (rate == undefined) rate = 1;
		if (fastRate == undefined) fastRate = parseInt(Game.fastRate);
		
		var bot = Game.bots[ID];
		var speed = bot.data.movespeed*rate*fastRate;
		
		//Special check to make sure we did not enter infiniti loop
		this.moveDroneCount++;
		if (this.moveDroneCount >= 10)
		{
			this.moveDroneCount = 0;
			bot.pointAccess = "direct";
			bot.point = Math.floor(Math.random()*this.dronePathPoints.length);
			return false;
		}
		
		//Direction?
		var newpoint = bot.point + bot.direction;
		if (newpoint < 0) newpoint = this.dronePathPoints.length - 1;
		else if (newpoint > this.dronePathPoints.length-1) newpoint = 0;
		var pointMap = this.dronePathPoints[newpoint];
		var d = Math.sqrt((pointMap.x - bot.x)*(pointMap.x - bot.x) + (pointMap.y - bot.y)*(pointMap.y - bot.y));
		if (d < speed*2)
		{
			bot.point = newpoint;
			this.moveDrone(ID);
			return true;
		}
		
		//var cxt = Render.tvContext, gxt = Render.gp0Context;
		//cxt.fillStyle = "red"; gxt.fillStyle = "red";
		
		//Determine where to go
		var pois = [bot.point-1, bot.point, bot.point+1, -2], poi, poiEntry, dcheck = 200, eObj, _d;
		var enemies = Game.enemiesList, eIDtoUse = null, eDtoUse = null;
		if (bot.enemyLockOn && enemies[bot.enemyLockOn] != undefined)
		{
			eIDtoUse = bot.enemyLockOn;
		} else delete bot.enemyLockOn;
		if (eIDtoUse == null)
		{
			for(var key in pois)
			{
				poi = pois[key];
				if (poi != -2)
				{
					if (poi < 0) poi = this.dronePathPoints.length - 1;
					else if (poi > this.dronePathPoints.length-1) poi = 0;
					poiEntry = this.dronePathPoints[poi];
				} else poiEntry = {x: bot.x, y: bot.y};
				
				//Check for enemies close by
				for(var eID in enemies)
				{
					eObj = enemies[eID];
					_d = Math.sqrt((eObj.x - poiEntry.x)*(eObj.x - poiEntry.x) + (eObj.y - poiEntry.y)*(eObj.y - poiEntry.y));
					if (_d <= dcheck)
					{
						_d = Math.sqrt((eObj.x - bot.x)*(eObj.x - bot.x) + (eObj.y - bot.y)*(eObj.y - bot.y));
						if (eIDtoUse == null || _d > eDtoUse)
						{
							eIDtoUse = eID;
							eDtoUse = _d;
						}
					}
				}
				
				//cxt.beginPath();
				//cxt.arc(poiEntry.x, poiEntry.y, dcheck, 0, 2*Math.PI, false);
				//cxt.fill();
			}
		}
		if (eIDtoUse)
		{
			pointMap = enemies[eIDtoUse];
			bot.enemyLockOn = eIDtoUse;
			
			/*cxt.strokeStyle = "yellow";
			cxt.beginPath();
			cxt.moveTo(bot.x, bot.y);
			cxt.lineTo(pointMap.x, pointMap.y);
			cxt.stroke();*/
		} else {
			//Advance smoothly to next point
			if (bot.fireduponenemy != undefined && bot.fireduponenemy)
			{
				var poiToUse = null, poiToUseD = null;
				pois = [bot.point, bot.point+bot.direction, bot.point+bot.direction*2]; _d;
				for(var key in pois)
				{
					poi = pois[key];
					if (poi < 0) poi = this.dronePathPoints.length - 1;
					else if (poi > this.dronePathPoints.length-1) poi = 0;
					poiEntry = this.dronePathPoints[poi];
					_d = Math.sqrt((bot.x - poiEntry.x)*(bot.x - poiEntry.x) + (bot.y - poiEntry.y)*(bot.y - poiEntry.y));
					
					if (poiToUseD == null || poiToUseD > _d)
					{
						poiToUse = poi;
						poiToUseD = _d;
					}
				}
				
				bot.fireduponenemy = false;
				
				if (poiToUse !== null)
				{
					poi = poiToUse+bot.direction;
					if (poi < 0) poi = this.dronePathPoints.length - 1;
					else if (poi > this.dronePathPoints.length-1) poi = 0;
					
					bot.point = poiToUse;
					pointMap = this.dronePathPoints[poi];
				}
			}
		}
		
		//Change Destination Points
		bot.destination.x = pointMap.x;
		bot.destination.y = pointMap.y;
		
		/*var cxt = Render.tvContext, gxt = Render.gp0Context;
		cxt.fillStyle = "red"; gxt.fillStyle = "red";
		cxt.strokeStyle = "red"; gxt.strokeStyle = "red";
		cxt.fillRect(pointMap.x-10, pointMap.y-10, 20, 20);*/
		
		//Determine if point is less then speed
		_d = Math.sqrt((bot.x - pointMap.x)*(bot.x - pointMap.x) + (bot.y - pointMap.y)*(bot.y - pointMap.y));
		if (_d < speed) speed = _d;
		if ((speed < 0 ? -speed : speed) < 0.01) return true;
		
		//Determine x and y increases
		var dX = (pointMap.x - bot.x), dY = (pointMap.y - bot.y);
		dX = dX < 0 ? -dX : dX; dY = dY < 0 ? -dY : dY;
		var xSide = 0, ySide = 0;
		if (dX == 0 && pointMap.y - bot.y < 0) { ySide = -1*speed; }
		else if (dX == 0 && pointMap.y - bot.y > 0) { ySide = speed; }
		else if (dY == 0 && pointMap.x - bot.x < 0) { xSide = -1*speed; }
		else if (dY == 0 && pointMap.x - bot.x > 0) { xSide = speed; }
		else {
			var angleA = Math.atan(dX/dY);// * (180 / Math.PI);
			xSide = (speed*Math.sin(angleA)); xSide = xSide < 0 ? -xSide : xSide;
			ySide = (speed*Math.cos(angleA)); ySide = ySide < 0 ? -ySide : ySide;
			//xSide = (angleA/90)*speed;
			//ySide = ((90-angleA)/90)*speed;
			
			if (pointMap.x - bot.x < 0 && pointMap.y - bot.y < 0) { xSide *= -1; ySide *= -1; }
			else if (pointMap.x - bot.x > 0 && pointMap.y - bot.y < 0) { ySide *= -1; }
			else if (pointMap.x - bot.x > 0 && pointMap.y - bot.y > 0) {  }
			else if (pointMap.x - bot.x < 0 && pointMap.y - bot.y > 0) { xSide *= -1; }
		}
		
		bot.x += xSide; bot.y += ySide;
		var gp0Cord = Game.calculateGPCords(bot.x, bot.y);
		bot.x2 = gp0Cord.x2; bot.y2 = gp0Cord.y2;
		this.moveDroneCount = 0;
		
		/*
		var gxt = Render.gp0Context;
		gxt.fillStyle = "#FFF";
		gxt.fillRect(0, 0, 400, 200);
		gxt.font = "14px Verdana";
		gxt.fillStyle = "#000";
		gxt.fillText(dX, 15, 15);
		gxt.fillText(dY, 15, 35);
		gxt.fillText(xSide, 15, 55);
		gxt.fillText(ySide, 15, 75);
		gxt.fillText(bot.x, 15, 95);
		gxt.fillText(bot.y, 15, 115);*/
	};
};
var MapSS001 = new MapSS001();