function MapTwin()
{
	this.map = "twin";
	this.base = [{
		x: Render.trueWidth/2,	x2: Render.gp0Width/2,
		y: Render.trueHeight*0.25,y2: Render.gp0Height*0.25,
		r: 80/2,				r2: (80/2)*Render.gp0RenderRatio,
		life: 50,
		maxLife: 50,
		shield: 0, shieldUse: 0,
		spin: {r: 160, d: 270, dir: 1, speed: 1}
	}, {
		x: Render.trueWidth/2,	x2: Render.gp0Width/2,
		y: Render.trueHeight*0.75,y2: Render.gp0Height*0.75,
		r: 80/2,				r2: (80/2)*Render.gp0RenderRatio,
		life: 50,
		maxLife: 50,
		shield: 0, shieldUse: 0,
		spin: {r: 160, d: 90, dir: 1, speed: 1}
	}];
	this.storeRules = {
		drone: {createData:{movespeed: 5.50}}
	};
	
	this.allowDeadBaseHit = false;
	
	this.walls = [];
	this.dronePathPoints = [{
		x: Render.trueWidth*0.5, y: Render.trueHeight*0.05
	}, {
		x: Render.trueWidth*0.6, y: Render.trueHeight*0.09
	}, {
		x: Render.trueWidth*0.69, y: Render.trueHeight*0.2
	}, {
		x: Render.trueWidth*0.735, y: Render.trueHeight*0.35
	}, {
		
		x: Render.trueWidth*0.75, y: Render.trueHeight*0.5
	}, {
		x: Render.trueWidth*0.735, y: Render.trueHeight*0.65
	}, {
		x: Render.trueWidth*0.69, y: Render.trueHeight*0.8
	}, {
		x: Render.trueWidth*0.6, y: Render.trueHeight*0.91
	}, {
		
		x: Render.trueWidth*0.5, y: Render.trueHeight*0.95
	}, {
		x: Render.trueWidth*0.4, y: Render.trueHeight*0.91
	}, {
		x: Render.trueWidth*0.31, y: Render.trueHeight*0.8
	}, {
		x: Render.trueWidth*0.265, y: Render.trueHeight*0.65
	}, {
		
		x: Render.trueWidth*0.25, y: Render.trueHeight*0.5
	}, {
		x: Render.trueWidth*0.265, y: Render.trueHeight*0.35
	}, {
		x: Render.trueWidth*0.31, y: Render.trueHeight*0.2
	}, {
		x: Render.trueWidth*0.4, y: Render.trueHeight*0.09
	}];
	this.dronePathPointsOnReturn = [];
	this.enemyPaths = [{
		speed: 5.5,
		base: 0,
		path: [{
			x: 0,
			y: 0
		}, {
			x: this.base[0].x,
			y: this.base[0].y
		}]
	}, {
		speed: 5.5,
		base: 1,
		path: [{
			x: 0,
			y: 0
		}, {
			x: this.base[1].x,
			y: this.base[1].y
		}]
	}];
	this._spotbots = [];
	
	//Init
	this.init = function(options)
	{
		if (options == undefined) options = {};
		if (options.mode == undefined) options.mode = Game.mode;
		
		ClickBank.clearAll();
		InputBank.clearAll();
		Render.soundsStopAll();
		
		this.renderBackgroundTV = true;
		this.renderBackgroundTV2 = true;
		this.renderBackgroundTV = true;
		this.renderBackgroundGP0 = true;
		this.renderBackgroundGP0Cache = {};
		
		//Base
		this.base[0].life = this.base[0].maxLife;
		this.base[0].shield = 0;
		this.base[0].shieldUse = 0;
		this.base[0].spin.d = 270;
		this.base[1].life = this.base[1].maxLife;
		this.base[1].shield = 0;
		this.base[1].shieldUse = 0;
		this.base[1].spin.d = 90;
		var base;
		for(var key in this.base)
		{
			base = this.base[key];
			base.cache = {};
		}
		
		//Music
		if (Render.sounds["levelbg"].readyState > 0)
			Render.sounds["levelbg"].currentTime = 0;
		Render.sounds["levelbg"].play();
		
		//Game init
		Game.map = this.map;
		Game.mapClass = this;
		Game.mode = options.mode;
		Game.init({money: 2000/*, reduceImageQuality: true, allowBotSpin: true, enableCacheOpts: false*/});
		
		this._spotbots = [];
		this.twoDegree = 0; this.twoDegree2 = 0;
		this.threeDegree = 0; this.threeDegreeDir = 1; this.threeDegreeDirAmt = 0;
		this.threeDegree2 = 20; this.threeDegree3 = 20;
		
		//Spots
		//Small Circle
		var spotID = Game.spotsAdd({
			x: 0, y: 0, r: 20,
			x2: 0, y2: 0, r2: 20*Render.gp0RenderRatio
		});
		this._spotbots.push({
			ID: spotID, type: "spot",
			r: 200*0.8, d: 0, dir: 1, speed: 5, base: 0
		});
		spotID = Game.spotsAdd({
			x: 0, y: 0, r: 20,
			x2: 0, y2: 0, r2: 20*Render.gp0RenderRatio
		});
		this._spotbots.push({
			ID: spotID, type: "spot",
			r: 200*0.8, d: 180, dir: 1, speed: 5, base: 0
		});

		var spotID = Game.spotsAdd({
			x: 0, y: 0, r: 20,
			x2: 0, y2: 0, r2: 20*Render.gp0RenderRatio
		});
		this._spotbots.push({
			ID: spotID, type: "spot",
			r: 200*0.8, d: 90, dir: -1, speed: 5, base: 1
		});
		spotID = Game.spotsAdd({
			x: 0, y: 0, r: 20,
			x2: 0, y2: 0, r2: 20*Render.gp0RenderRatio
		});
		this._spotbots.push({
			ID: spotID, type: "spot",
			r: 200*0.8, d: 270, dir: -1, speed: 5, base: 1
		});
		
		//Large Circle
		spotID = Game.spotsAdd({
			x: 0, y: 0, r: 20,
			x2: 0, y2: 0, r2: 20*Render.gp0RenderRatio
		});
		this._spotbots.push({
			ID: spotID, type: "spot",
			r: 400*1.1, d: 45, dir: 1, speed: 2
		});
		spotID = Game.spotsAdd({
			x: 0, y: 0, r: 20,
			x2: 0, y2: 0, r2: 20*Render.gp0RenderRatio
		});
		this._spotbots.push({
			ID: spotID, type: "spot",
			r: 400*1.1, d: 45+90, dir: 1, speed: 2
		});
		spotID = Game.spotsAdd({
			x: 0, y: 0, r: 20,
			x2: 0, y2: 0, r2: 20*Render.gp0RenderRatio
		});
		this._spotbots.push({
			ID: spotID, type: "spot",
			r: 400*1.1, d: 45+90*2, dir: 1, speed: 2
		});
		spotID = Game.spotsAdd({
			x: 0, y: 0, r: 20,
			x2: 0, y2: 0, r2: 20*Render.gp0RenderRatio
		});
		this._spotbots.push({
			ID: spotID, type: "spot",
			r: 400*1.1, d: 45+90*3, dir: 1, speed: 2
		});
		
		this._moveSpotBots(true);
		
		Render.renderControl = function(){ MapTwin.render(); };
		
		Game.startGame();

		//Game.botsDroneAdd();
		/*Game.botsDroneAdd();
		Game.botsDroneAdd();
		Game.botsDroneAdd();
		Game.botsDroneAdd();*/
		//Game.botsAdd("sentry", Render.trueWidth/2, Render.tvHeight/2);
	};
	
	//Map Render
	this.render = function()
	{
		//Clear
		Render.renderClear("all");
		var cxt = Render.tvContext, gxt = Render.gp0Context;
		
		//Gamepad Slice Cache Reset
		var gp0Cord = Game.calculateGPCords(0, 0);
		if (this.renderBackgroundGP0Cache.x0 == undefined || this.renderBackgroundGP0Cache.x0 != gp0Cord.x2
		 || this.renderBackgroundGP0Cache.y0 == undefined || this.renderBackgroundGP0Cache.y0 != gp0Cord.y2
		 || this.renderBackgroundGP0Cache.z0 == undefined || this.renderBackgroundGP0Cache.z0 != Render.gp0RenderRatio)
		{
			this.renderBackgroundGP0 = true;
			Game.resetGP0SliceCache = true;
			
			this.renderBackgroundGP0Cache.x0 = gp0Cord.x2;
			this.renderBackgroundGP0Cache.y0 = gp0Cord.y2;
			this.renderBackgroundGP0Cache.z0 = Render.gp0RenderRatio;
		}
		
		//Gamepad Display Move
		Render.gp0DisplayMoveStart();
		
		//Background
		this.renderBackground();
		
		//Bots
		this._moveSpotBots();
		Game.renderBots();
		
		//Render Bases
		Render.renderBases("7b");
		
		if (1)
		{
			cxt = Render.returnTVSliceContext("7");
			cxt.clearRect(0, 0, Render.tvWidth, Render.tvHeight);
			gxt = Render.returnGP0SliceContext("7");
			gxt.clearRect(0, 0, Render.gp0Width, Render.gp0Height);
			
			Game.renderBotsTV = true;
			Game.renderBotsGP0 = true;
		}
		
		//Show drone recorded path
		/*cxt.fillStyle = "red"; gxt.fillStyle = "red";
		cxt.strokeStyle = "red"; gxt.strokeStyle = "red";

		cxt.save();
		//cxt.scale(2, 1);
		cxt.beginPath();
		cxt.arc(Render.tvWidth/2, Render.tvHeight/2, Render.tvHeight*0.45, 0, 2*Math.PI, false);
		cxt.stroke();
		cxt.restore();

		gp0Cord = Game.calculateGPCords(Render.tvWidth/2, Render.tvHeight/2);
		gxt.save();
		//gxt.scale(2, 1);
		gxt.beginPath();
		gxt.arc(gp0Cord.x2, gp0Cord.y2, Render.tvHeight*0.45*Render.gp0RenderRatio, 0, 2*Math.PI, false);
		gxt.stroke();
		gxt.restore();
		
		cxt.beginPath(); gxt.beginPath();
		
		var dronePath, gp0Cord;
		for(var i=0; i<this.dronePathPoints.length; i++)
		{
			dronePath = this.dronePathPoints[i];
			gp0Cord = Game.calculateGPCords(dronePath.x, dronePath.y);
			
			if (i == 0)
			{
				cxt.moveTo(dronePath.x, dronePath.y); gxt.moveTo(gp0Cord.x2, gp0Cord.y2);
			} else {
				cxt.lineTo(dronePath.x, dronePath.y); gxt.lineTo(gp0Cord.x2, gp0Cord.y2);
			}
			
			cxt.fillStyle = "#666"; gxt.fillStyle = "#666";
			cxt.fillRect(dronePath.x-10, dronePath.y-10, 20, 20);
			gxt.fillRect(gp0Cord.x2-5, gp0Cord.y2-5, 10, 10);
			cxt.fillStyle = "red"; gxt.fillStyle = "red";
		}
		dronePath = this.dronePathPoints[0];
		gp0Cord = Game.calculateGPCords(dronePath.x, dronePath.y);
		cxt.lineTo(dronePath.x, dronePath.y); gxt.lineTo(gp0Cord.x2, gp0Cord.y2);
		
		cxt.stroke(); gxt.stroke();*/
		
		//Call Gamer Render function
		Game.render();
		
		Game.resetGP0SliceCache = false;
	};
	
	//Hanldes the render of the Background
	this.twoDegree = 0; this.twoDegree2 = 0;
	this.threeDegree = 0; this.threeDegreeDir = 1; this.threeDegreeDirAmt = 0;
	this.threeDegree2 = 20; this.threeDegree3 = 20;
	this.renderBackgroundTV = true; this.renderBackgroundTV2 = true;
	this.renderBackgroundGP0 = true; this.renderBackgroundGP0Cache = {};
	this.renderBackground = function()
	{
		var cxt = Render.tvContext, gxt = Render.gp0Context;
		var x=0,y=0,x2,y2,
			_w = Render.tvWidth, _h = Render.tvHeight,
			_w2 = Render.trueWidth*Render.gp0RenderRatio, _h2 = Render.trueHeight*Render.gp0RenderRatio;
		var gp0Cord = Game.calculateGPCords(x, y);
		if (this.renderBackgroundTV)
		{
			var cxt = Render.returnTVSliceContext(1);
			cxt.clearRect(0, 0, Render.tvWidth, Render.tvHeight);
			cxt.drawImage(Render.images["space1_60d"], x, y, _w, _h);
			this.renderBackgroundTV = false;
		}
		if (this.renderBackgroundGP0)
		{
			var gxt = Render.returnGP0SliceContext(1);
			gxt.clearRect(0, 0, Render.gp0Width, Render.gp0Height);
			gxt.drawImage(Render.images["space1_60d"], gp0Cord.x2, gp0Cord.y2, _w2, _h2);
			this.renderBackgroundGP0 = false;
		}
		
		var cxt = Render.returnTVSliceContext(2), gxt = Render.returnGP0SliceContext(2);
		cxt.clearRect(0, 0, Render.tvWidth, Render.tvHeight);
		gxt.clearRect(0, 0, Render.gp0Width, Render.gp0Height);

		var allBasesAlive = true;
		for(var key in this.base)
			if (this.base[key].life <= 0)
				allBasesAlive = false;
		
		//Two
		x = this.base[0].x; y = this.base[0].y;
		var w = 415*0.8, h = 415*0.8;
		w2 = w*Render.gp0RenderRatio; h2 = h*Render.gp0RenderRatio;
		gp0Cord = Game.calculateGPCords(x, y);
		
		gxt.save();
		gxt.translate(gp0Cord.x2, gp0Cord.y2);
		if (this.base[0].life > 0) gxt.rotate((this.twoDegree+90)*Math.PI/180);
		gxt.drawImage(Render.images["circle_two"], -w2/2, -h2/2, w2, h2);
		gxt.restore();
		
		x = this.base[1].x; y = this.base[1].y;
		gp0Cord = Game.calculateGPCords(x, y);
		gxt.save();
		gxt.translate(gp0Cord.x2, gp0Cord.y2);
		if (this.base[1].life > 0) gxt.rotate((this.twoDegree2+90)*Math.PI/180);
		gxt.drawImage(Render.images["circle_two"], -w2/2, -h2/2, w2, h2);
		gxt.restore();
		
		//Three
		x = Render.trueWidth/2; y = Render.trueHeight/2;
		var w = 815*1.1, h = 815*1.1;
		w2 = w*Render.gp0RenderRatio; h2 = h*Render.gp0RenderRatio;
		gp0Cord = Game.calculateGPCords(x, y);
		
		gxt.save();
		gxt.translate(gp0Cord.x2, gp0Cord.y2);
		gxt.rotate((this.threeDegree)*Math.PI/180);
		gxt.drawImage(Render.images["circle_three"], -w2/2, -h2/2, w2, h2);
		gxt.restore();
		

		if (this.renderBackgroundTV2 || 1)
		{
			//var cxt = Render.returnTVSliceContext(2);
			//cxt.clearRect(0, 0, Render.tvWidth, Render.tvHeight);
			
			//Two
			x = this.base[0].x; y = this.base[0].y;
			var w = 415*0.8, h = 415*0.8;
			gp0Cord = Game.calculateGPCords(x, y);
			
			cxt.save();
			cxt.translate(x*Render.renderTVRatio, y*Render.renderTVRatio);
			if (this.base[0].life > 0) cxt.rotate((this.twoDegree+90)*Math.PI/180);
			cxt.drawImage(Render.images["circle_two"], -w/2*Render.renderTVRatio, -h/2*Render.renderTVRatio, w*Render.renderTVRatio, h*Render.renderTVRatio);
			cxt.restore();
			
			x = this.base[1].x; y = this.base[1].y;
			cxt.save();
			cxt.translate(x*Render.renderTVRatio, y*Render.renderTVRatio);
			if (this.base[1].life > 0) cxt.rotate((this.twoDegree2+90)*Math.PI/180);
			cxt.drawImage(Render.images["circle_two"], -w/2*Render.renderTVRatio, -h/2*Render.renderTVRatio, w*Render.renderTVRatio, h*Render.renderTVRatio);
			cxt.restore();
			
			//Three
			x = Render.trueWidth/2; y = Render.trueHeight/2;
			var w = 815*1.1, h = 815*1.1;
			
			cxt.save();
			cxt.translate(x*Render.renderTVRatio, y*Render.renderTVRatio);
			cxt.rotate((this.threeDegree)*Math.PI/180);
			cxt.drawImage(Render.images["circle_three"], -w/2*Render.renderTVRatio, -h/2*Render.renderTVRatio, w*Render.renderTVRatio, h*Render.renderTVRatio);
			cxt.restore();
			
			this.renderBackgroundTV2 = false;
		}
	};
	
	//Move the Spot Bots in a circle around the bot
	this._moveSpotBots = function(inititalSet)
	{
		if (inititalSet == undefined) inititalSet = false;
		if ((Game.gamePause) && !inititalSet) return false;
		
		var allBasesAlive = true;
		for(var key in this.base)
			if (this.base[key].life <= 0)
				allBasesAlive = false;
		
		/*this._spotbots.push({
			ID: spotID, type: "spot",
			r: 500, d: 270, dir: -1, speed: 1
		});*/
		//Bases
		var base,x,y,gp0Cord;
		for(var key in this.base)
		{
			base = this.base[key];
			if (!allBasesAlive) continue;
			
			x = Render.trueWidth/2+(base.spin.r*Math.cos(base.spin.d*(Math.PI/180)));
			y = Render.trueHeight/2+(base.spin.r*Math.sin(base.spin.d*(Math.PI/180)));
			gp0Cord = Game.calculateGPCords(x, y);
			base.x = x; base.y = y;
			base.x2 = gp0Cord.x2; base.y2 = gp0Cord.y2;
			
			if (!Game.isPaused && !Game.gamePause && !inititalSet)
			{
				base.spin.d += base.spin.dir*base.spin.speed*(Game.fastEnabled ? Game.fastRate : 1);
				if (base.spin.d < 0) base.spin.d += 360;
				else if (base.spin.d >= 360) base.spin.d -= 360;
			}
		}
		
		//Bots
		var data,obj,x,y,gp0Cord;
		for(var key in this._spotbots)
		{
			data = this._spotbots[key];
			obj = (data.type == "spot" ? Game.spots[data.ID] : Game.bots[data.ID]);
			if (!obj) continue;
			if (data.base != undefined)
			{
				if (this.base[data.base].life <= 0) continue;
				
				x = this.base[data.base].x+(data.r*Math.cos(data.d*(Math.PI/180)));
				y = this.base[data.base].y+(data.r*Math.sin(data.d*(Math.PI/180)));
				gp0Cord = Game.calculateGPCords(x, y);
				obj.x = x; obj.y = y;
				obj.x2 = gp0Cord.x2; obj.y2 = gp0Cord.y2;
				
				if (!Game.isPaused && !Game.gamePause && !inititalSet)
				{
					data.d += data.dir*data.speed*(allBasesAlive ? 1 : 1/3)*(Game.fastEnabled ? Game.fastRate : 1);
					if (data.d < 0) data.d += 360;
					else if (data.d >= 360) data.d -= 360;
				}
				
			} else {
				x = Render.trueWidth/2+(data.r*Math.cos(data.d*(Math.PI/180)));
				y = Render.trueHeight/2+(data.r*Math.sin(data.d*(Math.PI/180)));
				gp0Cord = Game.calculateGPCords(x, y);
				obj.x = x; obj.y = y;
				obj.x2 = gp0Cord.x2; obj.y2 = gp0Cord.y2;
				
				if (!Game.isPaused && !Game.gamePause && !inititalSet)
				{
					if (allBasesAlive) data.d += data.dir*data.speed*(Game.fastEnabled ? Game.fastRate : 1);
					if (data.d < 0) data.d += 360;
					else if (data.d >= 360) data.d -= 360;
				}
			}
		}
		
		
		//Move Two & Three - Circles
		if (!Game.isPaused && !Game.gamePause)
		{
			this.twoDegree += 5*(allBasesAlive ? 1 : 1/3)*(Game.fastEnabled ? Game.fastRate : 1)*0.75;
			if (this.twoDegree >= 360) this.twoDegree -= 360;
			this.twoDegree2 -= 5*(allBasesAlive ? 1 : 1/3)*(Game.fastEnabled ? Game.fastRate : 1)*0.75;
			if (this.twoDegree2 < 0) this.twoDegree2 += 360;
			
			this.renderBackgroundTV2 = true;
			Game.renderBotsTV = true;
			
			if (allBasesAlive)
			{
				//threeDegreeDirAmt
				var dirAmt = this.threeDegreeDir*2*(Game.fastEnabled ? Game.fastRate : 1);
				this.threeDegree += dirAmt;
				if (this.threeDegree >= 360) this.threeDegree -= 360;
				else if (this.threeDegree < 0) this.threeDegree += 360;
				
				this.threeDegreeDirAmt += Math.abs(dirAmt);
				if (this.threeDegreeDirAmt >= 360*2)
				{
					this.threeDegreeDir *= -1;
					this.threeDegreeDirAmt -= 360*2;
					
					var data,obj,x,y,gp0Cord;
					for(var key in this._spotbots)
					{
						data = this._spotbots[key];
						obj = (data.type == "spot" ? Game.spots[data.ID] : Game.bots[data.ID]);
						if (!obj || data.base != undefined) continue;
						
						data.dir = this.threeDegreeDir;
					}
				}
			} else {
				this.threeDegree += this.threeDegreeDir*0.25*(Game.fastEnabled ? Game.fastRate : 1);
				if (this.threeDegree >= 360) this.threeDegree -= 360;
				this.threeDegree2 -= (Game.fastEnabled ? Game.fastRate : 1);
				
				var data,obj,x,y,gp0Cord;
				for(var key in this._spotbots)
				{
					data = this._spotbots[key];
					obj = (data.type == "spot" ? Game.spots[data.ID] : Game.bots[data.ID]);
					if (!obj || data.base != undefined) continue;
					
					data.d += data.dir*0.25*(Game.fastEnabled ? Game.fastRate : 1);
				}
				
				if (this.threeDegree2 <= 0)
				{
					var amt = Math.abs(this.threeDegree2)+this.threeDegree3;
					this.threeDegree -= this.threeDegreeDir*0.25*amt;
					if (this.threeDegree < 0) this.threeDegree += 360;
					this.threeDegree2 = this.threeDegree3;
					
					for(var key in this._spotbots)
					{
						data = this._spotbots[key];
						obj = (data.type == "spot" ? Game.spots[data.ID] : Game.bots[data.ID]);
						if (!obj || data.base != undefined) continue;
						
						data.d -= data.dir*0.25*amt;
					}
				}
			}
		}
	};

	//Map specific function to handle the tracking of any spot to bot transitions interally
	this.manageSpotToBotConversion = function(spotID, botID)
	{
		var data;
		for(var key in this._spotbots)
		{
			data = this._spotbots[key];
			
			if (data.ID == spotID)
			{
				data.ID = botID;
				data.type = "bot";
			}
		}
	};

	//Map specific function to handle the tracking of any bot to spot transitions interally
	this.manageBotToSpotConversion = function(botID, spotID)
	{
		var data;
		for(var key in this._spotbots)
		{
			data = this._spotbots[key];
			
			if (data.ID == botID)
			{
				data.ID = spotID;
				data.type = "spot";
			}
		}
	};
	
	
	//Map specific spawn enemy function
	//Returns specific data, such as pattern, start position, etc
	this.spawnEnemy = function()
	{
		var data = {};
		data.pattern = Math.floor(Math.random()*this.enemyPaths.length);
		
		var pathData = this.enemyPaths[data.pattern];
		data.speed = pathData.speed;
		data.point = 0;
		
		var r = 0;//Math.floor(Math.random()*4);
		switch(r)
		{
		case 0:
			var x=this.base[0].x, y=this.base[0].y, r=1165;
			var degree = Math.floor(Math.random()*360),//(this.counter++ % 2 == 0 ? 180 : 180+45),//
				radian = degree * Math.PI / 180;
			data.startX = x + (r * Math.sin(radian));
			data.startY = y + (r * Math.cos(radian));
			
			//data.startX = Math.floor(Math.random()*Render.tvWidth);
			//data.startY = -50;
		break;
		
		case 1:
			data.startX = Render.tvWidth+50;
			data.startY = Math.floor(Math.random()*Render.tvHeight);
		break;
		
		case 2:
			data.startX = Math.floor(Math.random()*Render.tvWidth);
			data.startY = Render.tvHeight+50;
		break;
		
		case 3:
			data.startX = -50;
			data.startY = Math.floor(Math.random()*Render.tvHeight);
		break;
		
		//Testing
		case 4:
			//data.startX = Render.tvWidth/2;
			//data.startY = Render.tvHeight/2;
			if (this.counter % 2 == 0 && 0)
			{
				data.startX = -50;
				data.startY = -50;
			} else {
				data.startY = -50;
				data.startX = Render.tvWidth/2;
			}
			this.counter++;
		break;
		}
		
		data.destination = {};
		data.destination.x = this.base[0].x;
		data.destination.y = this.base[0].y;
		
		return data;
	};
	
	//Map specific move enemy function
	this.moveEnemy = function(ID, obj, rate)
	{
		if (rate == undefined) rate = 1;
		var pathData = this.enemyPaths[obj.pattern],
			path = pathData.path,
			pathPoint = obj.data.point,
			speed = obj.speed*rate;
		if (obj.data.point >= pathData.path.length-1) return true;
		
		var newpoint = pathPoint+1;
		var pointMap = path[newpoint];
		pointMap = this.base[pathData.base];
		/*var d = Math.sqrt((pointMap.x - obj.x)*(pointMap.x - obj.x) + (pointMap.y - obj.y)*(pointMap.y - obj.y));
		if (d < speed*2)
		{
			//obj.data.point = newpoint;
			//this.moveEnemy(ID, obj);
			return true;
		}*/
		
		//On final point?
		if (newpoint == path.length-1)
		{
			if (this.base[pathData.base].life <= 0)
			{
				if (obj.data.newbaseroute == undefined)
				{
					var base, newBase = null;
					for(var key in this.base)
					{
						if (newBase != null) continue;
						
						base = this.base[key];
						if (base.life > 0) newBase = key;
					}
					obj.data.newbaseroute = parseInt(newBase);
					if (obj.data.newbaseroute) pathData.base = obj.data.newbaseroute;
				}
				
				pointMap = this.base[obj.data.newbaseroute];
			} else if (this.base[0].life > 0 && this.base[1].life > 0) {
				//Find nearest base
				pointMap = this.base[0];
				var d1 = Math.sqrt((pointMap.x - obj.x)*(pointMap.x - obj.x) + (pointMap.y - obj.y)*(pointMap.y - obj.y));
				pointMap = this.base[1];
				var d2 = Math.sqrt((pointMap.x - obj.x)*(pointMap.x - obj.x) + (pointMap.y - obj.y)*(pointMap.y - obj.y));
				if (d1 < d2) pointMap = this.base[0];
			}
		}
		
		
		if (!pointMap) return false;
		
		//Change Destination Points
		obj.data.destination.x = pointMap.x;
		obj.data.destination.y = pointMap.y;
		
		//Determine x and y increases
		var dX = Math.abs(pointMap.x - obj.x), dY = Math.abs(pointMap.y - obj.y);
		var xSide = 0, ySide = 0;
		if (dX == 0 && pointMap.y - obj.y < 0) { ySide = -1*speed; }
		else if (dX == 0 && pointMap.y - obj.y > 0) { ySide = speed; }
		else if (dY == 0 && pointMap.x - obj.x < 0) { xSide = -1*speed; }
		else if (dY == 0 && pointMap.x - obj.x > 0) { xSide = speed; }
		else {
			var angleA = Math.atan(dX/dY);// * (180 / Math.PI);
			xSide = Math.abs(speed*Math.sin(angleA));
			ySide = Math.abs(speed*Math.cos(angleA));
			//xSide = (angleA/90)*speed*1.3;
			//ySide = ((90-angleA)/90)*speed*1.3;
			
			if (pointMap.x - obj.x < 0 && pointMap.y - obj.y < 0) { xSide *= -1; ySide *= -1; }
			else if (pointMap.x - obj.x > 0 && pointMap.y - obj.y < 0) { ySide *= -1; }
			else if (pointMap.x - obj.x > 0 && pointMap.y - obj.y > 0) {  }
			else if (pointMap.x - obj.x < 0 && pointMap.y - obj.y > 0) { xSide *= -1; }

			//console.log(dX, dY, angleA, speed, xSide, ySide);
		}
		
		obj.x += xSide; obj.y += ySide;
		//this.enemyMovements.push({x: obj.x, y: obj.y});
		
		
		/*
		var x = obj.data.startX - this.base[0].x,
			y = obj.data.startY - this.base[0].y,
			s = obj.speed;
		
		//x: 1010 @ 580 ~17500 | 1.7414 | -1.74137
		//y: 590  @ 600 ~17500 | 0.9833
		var xs = x/s, ys = y/s;
		if (x != 0) xs = x/(s*Math.abs(580/s));
		//if (y != 0) ys = y/(s*Math.abs(600/s));
		
		obj.x -= xs;// * Math.abs(x/590));
		obj.y -= ys;// * Math.abs(y/590));*/
	};
	
	
	//Map Sepecific spawn drone function
	//Returns spawn data, specifically the x/y
	this.spawnDrone = function()
	{
		var data = {x: 0, y: 0, direction: Math.floor(Math.random()*2) == 0 ? -1 : 1};
		var pointindex = Math.floor(Math.random()*this.dronePathPoints.length);
		data.point = pointindex;
		
		//Choose point at random
		var point = this.dronePathPoints[pointindex];
		data.x = point.x;
		data.y = point.y;
		
		//Destination
		var newpoint = data.point + data.direction;
		if (newpoint < 0) newpoint = this.dronePathPoints.length - 1;
		else if (newpoint > this.dronePathPoints.length-1) newpoint = 0;
		var pointMap = this.dronePathPoints[newpoint];
		data.destination = {};
		data.destination.x = pointMap.x;
		data.destination.y = pointMap.y;
		
		return data;
	};
	
	//Map specific move drone function
	this.moveDroneCount = 0;
	this.moveDrone = function(ID, rate, fastRate)
	{
		if (rate == undefined) rate = 1;
		if (fastRate == undefined) fastRate = parseInt(Game.fastRate);
		
		var bot = Game.bots[ID];
		var speed = bot.data.movespeed*rate*fastRate;
		
		//Special check to make sure we did not enter infiniti loop
		this.moveDroneCount++;
		if (this.moveDroneCount >= 10)
		{
			this.moveDroneCount = 0;
			bot.pointAccess = "direct";
			bot.point = Math.floor(Math.random()*this.dronePathPoints.length);
			return false;
		}
		
		//Direction?
		var newpoint = bot.point + bot.direction;
		if (newpoint < 0) newpoint = this.dronePathPoints.length - 1;
		else if (newpoint > this.dronePathPoints.length-1) newpoint = 0;
		var pointMap = this.dronePathPoints[newpoint];
		var d = Math.sqrt((pointMap.x - bot.x)*(pointMap.x - bot.x) + (pointMap.y - bot.y)*(pointMap.y - bot.y));
		if (d < speed*2)
		{
			bot.point = newpoint;
			this.moveDrone(ID);
			return true;
		}
		
		//var cxt = Render.tvContext, gxt = Render.gp0Context;
		//cxt.fillStyle = "red"; gxt.fillStyle = "red";
		
		//Determine where to go
		var pois = [bot.point-1, bot.point, bot.point+1, bot.point+2, -2], poi, poiEntry, dcheck = 200, eObj, _d;
		var enemies = Game.enemiesList, eIDtoUse = null, eDtoUse = null;
		if (bot.enemyLockOn && enemies[bot.enemyLockOn] != undefined)
		{
			eIDtoUse = bot.enemyLockOn;
		} else delete bot.enemyLockOn;
		if (eIDtoUse == null)
		{
			for(var key in pois)
			{
				poi = pois[key];
				if (poi != -2)
				{
					if (poi < 0) poi = this.dronePathPoints.length - 1;
					else if (poi > this.dronePathPoints.length-1) poi = 0;
					poiEntry = this.dronePathPoints[poi];
				} else poiEntry = {x: bot.x, y: bot.y};
				
				//Check for enemies close by
				for(var eID in enemies)
				{
					eObj = enemies[eID];
					_d = Math.sqrt((eObj.x - poiEntry.x)*(eObj.x - poiEntry.x) + (eObj.y - poiEntry.y)*(eObj.y - poiEntry.y));
					if (_d <= dcheck)
					{
						_d = Math.sqrt((eObj.x - bot.x)*(eObj.x - bot.x) + (eObj.y - bot.y)*(eObj.y - bot.y));
						if (eIDtoUse == null || _d > eDtoUse)
						{
							eIDtoUse = eID;
							eDtoUse = _d;
						}
					}
				}
				
				//cxt.beginPath();
				//cxt.arc(poiEntry.x, poiEntry.y, dcheck, 0, 2*Math.PI, false);
				//cxt.fill();
			}
		}
		if (eIDtoUse)
		{
			pointMap = enemies[eIDtoUse];
			bot.enemyLockOn = eIDtoUse;
			
			/*cxt.strokeStyle = "yellow";
			cxt.beginPath();
			cxt.moveTo(bot.x, bot.y);
			cxt.lineTo(pointMap.x, pointMap.y);
			cxt.stroke();*/
		} else {
			//Advance smoothly to next point
			if (bot.fireduponenemy != undefined && bot.fireduponenemy)
			{
				var poiToUse = null, poiToUseD = null;
				pois = [bot.point, bot.point+bot.direction, bot.point+bot.direction*2]; _d;
				for(var key in pois)
				{
					poi = pois[key];
					if (poi < 0) poi = this.dronePathPoints.length - 1;
					else if (poi > this.dronePathPoints.length-1) poi = 0;
					poiEntry = this.dronePathPoints[poi];
					_d = Math.sqrt((bot.x - poiEntry.x)*(bot.x - poiEntry.x) + (bot.y - poiEntry.y)*(bot.y - poiEntry.y));
					
					if (poiToUseD == null || poiToUseD > _d)
					{
						poiToUse = poi;
						poiToUseD = _d;
					}
				}
				
				bot.fireduponenemy = false;
				
				if (poiToUse !== null)
				{
					poi = poiToUse+bot.direction;
					if (poi < 0) poi = this.dronePathPoints.length - 1;
					else if (poi > this.dronePathPoints.length-1) poi = 0;
					
					bot.point = poiToUse;
					pointMap = this.dronePathPoints[poi];
				}
			}
		}
		
		//Change Destination Points
		bot.destination.x = pointMap.x;
		bot.destination.y = pointMap.y;
		
		/*var cxt = Render.tvContext, gxt = Render.gp0Context;
		cxt.fillStyle = "red"; gxt.fillStyle = "red";
		cxt.strokeStyle = "red"; gxt.strokeStyle = "red";
		cxt.fillRect(pointMap.x-10, pointMap.y-10, 20, 20);*/
		
		//Determine if point is less then speed
		_d = Math.sqrt((bot.x - pointMap.x)*(bot.x - pointMap.x) + (bot.y - pointMap.y)*(bot.y - pointMap.y));
		if (_d < speed) speed = _d;
		if (Math.abs(speed) < 0.01) return true;
		
		//Determine x and y increases
		var dX = Math.abs(pointMap.x - bot.x), dY = Math.abs(pointMap.y - bot.y);
		var xSide = 0, ySide = 0;
		if (dX == 0 && pointMap.y - bot.y < 0) { ySide = -1*speed; }
		else if (dX == 0 && pointMap.y - bot.y > 0) { ySide = speed; }
		else if (dY == 0 && pointMap.x - bot.x < 0) { xSide = -1*speed; }
		else if (dY == 0 && pointMap.x - bot.x > 0) { xSide = speed; }
		else {
			var angleA = Math.atan(dX/dY);// * (180 / Math.PI);
			xSide = Math.abs(speed*Math.sin(angleA));
			ySide = Math.abs(speed*Math.cos(angleA));
			//xSide = (angleA/90)*speed;
			//ySide = ((90-angleA)/90)*speed;
			
			if (pointMap.x - bot.x < 0 && pointMap.y - bot.y < 0) { xSide *= -1; ySide *= -1; }
			else if (pointMap.x - bot.x > 0 && pointMap.y - bot.y < 0) { ySide *= -1; }
			else if (pointMap.x - bot.x > 0 && pointMap.y - bot.y > 0) {  }
			else if (pointMap.x - bot.x < 0 && pointMap.y - bot.y > 0) { xSide *= -1; }
		}
		
		bot.x += xSide; bot.y += ySide;
		var gp0Cord = Game.calculateGPCords(bot.x, bot.y);
		bot.x2 = gp0Cord.x2; bot.y2 = gp0Cord.y2;
		this.moveDroneCount = 0;
		
		/*
		var gxt = Render.gp0Context;
		gxt.fillStyle = "#FFF";
		gxt.fillRect(0, 0, 400, 200);
		gxt.font = "14px Noto Sans";
		gxt.fillStyle = "#000";
		gxt.fillText(dX, 15, 15);
		gxt.fillText(dY, 15, 35);
		gxt.fillText(xSide, 15, 55);
		gxt.fillText(ySide, 15, 75);
		gxt.fillText(bot.x, 15, 95);
		gxt.fillText(bot.y, 15, 115);*/
	};
};
var MapTwin = new MapTwin();