function MusicPlayer()
{
	this.audio = null;
	this.music = null;
	this.musicIsPlaying = false;
	this.musicIsPaused = true;
	
	this.overflowYOffset = 0;
	this.overflowYWindow = 0;
	this.overflowYMax = 0;
	
	this.visualizeEnemies = [];
	
	//Init
	this.init = function(area, map)
	{
		ClickBank.clearAll();
		InputBank.clearAll();
		Render.soundsStopAll();
		
		this.overflowYOffset = 0;
		this.exit();

		var img = new Image();
		img.src = "media/enemies/red1.png";
		Render.images["musicplayer_enemy1"] = img;
		var img = new Image();
		img.src = "media/enemies/red2.png";
		Render.images["musicplayer_enemy2"] = img;
		var img = new Image();
		img.src = "media/enemies/x.png";
		Render.images["musicplayer_enemy3"] = img;
		
		Render.renderControl = function(){ MusicPlayer.render(); };
		
		//Buttons
		InputBank.add({
			id: "button",
			type: ["b"],
			action: function(clickID, vaultEntry, type)
			{
				switch(type)
				{
				case "b":
					MusicPlayer.exit();
					
					MainMenu.init();
				break;
				}
			}
		});
		
		//Movements
		/*InputBank.add({
			id: "move_map",
			type: ["down", "up"],
			controller: "gp0",
			held: function(clickID, vaultEntry, type, controller)
			{
				switch(type)
				{
				case "down":
					
				break;
				
				case "up":
					
				break;
				}
			}
		});*/
		/*InputBank.add({
			id: "move_map2",
			type: ["left", "right"],
			stick: function(clickID, vaultEntry, type, controller, x, y)
			{
				MusicPlayer.moveOverflowContainer(y*5*-1);
			}
		});*/
	};
	
	//Exit
	this.exit = function()
	{
		if (this.audio)
		{
			this.audio.pause();
		}
		
		delete this.audio;
		this.audio = null;
		this.music = null;
		this.musicIsPlaying = false;
		this.musicIsPaused = true;
		
		this.visualizeEnemies = [];
		delete Render.images["musicplayer_enemy1"];
		delete Render.images["musicplayer_enemy2"];
		delete Render.images["musicplayer_enemy3"];
		
		nwf.system.Memory.requestGC();
	};
	
	//Render Function
	this.render = function()
	{
		var cxt = Render.renderContext;
		
		//Clear
		Render.renderClear("all");
		var cxt = Render.tvContext, gxt = Render.gp0Context;
		
		//Background
		cxt.fillStyle = "#000"; gxt.fillStyle = "#000";
		cxt.drawImage(Render.images["space1"], 0, 0, Render.tvWidth, Render.tvHeight);
		gxt.drawImage(Render.images["space1"], 0, 0, Render.gp0Width, Render.gp0Height);
		cxt.globalAlpha = 0.7; gxt.globalAlpha = 0.7;
		cxt.fillRect(0, 0, Render.tvWidth, Render.tvHeight);
		gxt.fillRect(0, 0, Render.gp0Width, Render.gp0Height);
		cxt.globalAlpha = 1; gxt.globalAlpha = 1;
		
		
		/* TV Screen */
		if (this.music)
		{
			//Music Box
			cxt.lineWidth = 1;
			cxt.fillStyle = "#000";
			cxt.fillRect(150, 150, Render.tvWidth-300, Render.tvHeight-300);
			cxt.strokeStyle = "#DDD";
			cxt.strokeRect(150, 150, Render.tvWidth-300, Render.tvHeight-300);
			
			//Music Playing
			cxt.font = "32px Verdana";
			cxt.textAlign = "left";
			cxt.textBaseline = "top";
			cxt.fillStyle = "#FFF";
			cxt.fillText(this.music.title, 165, 100);
			
			//Visualizer
			var enemy, isOverLimit = false;
			for(var key in this.visualizeEnemies)
			{
				enemy = this.visualizeEnemies[key];
				
				cxt.save();
				cxt.translate(enemy.x+150, enemy.y+150);
				cxt.rotate(enemy.rotate*Math.PI/180)
				cxt.drawImage(Render.images["musicplayer_"+enemy.type], -enemy.w/2, -enemy.h/2, enemy.w, enemy.h);
				cxt.restore();
				
				enemy.x += enemy.speed;
				if (enemy.type == "enemy3")
				{
					enemy.rotate += 7;
					enemy.rotate = enemy.rotate % 360;
				}
				if (enemy.x > Render.tvWidth-300-10) isOverLimit = true;
			}
			if (isOverLimit)
			{
				var visualizeEnemies = [];
				for(var key in this.visualizeEnemies)
				{
					enemy = this.visualizeEnemies[key];
					
					if (enemy.x <= Render.tvWidth-300-10)
						visualizeEnemies.push(enemy);
				}
				this.visualizeEnemies = visualizeEnemies;
			}
			
			//Add new
			if (this.visualizeEnemies.length == 0 || (this.visualizeEnemies.length < 7 && Math.random() < 0.02))
			{
				var type = "enemy"+(Math.floor(Math.random()*3+1));
				var w = 30, h = 15;
				if (type == "enemy3")
				{
					w = 40;
					h = w;
				}
				
				this.visualizeEnemies.push({
					type: type,
					x: 0, y: (Math.floor(Math.random()*(Render.tvHeight-340)+20)),
					w: w, h: h,
					speed: (Math.floor(Math.random()*4+2)),
					rotate: 90
				});
			}
		}
		
		
		/* GamePad Screen */
		//Music Box
		gxt.lineWidth = 1;
		gxt.fillStyle = "#000";
		gxt.fillRect(50, 50, Render.gp0Width-100, Render.gp0Height-100);
		gxt.strokeStyle = "#DDD";
		gxt.strokeRect(50, 50, Render.gp0Width-100, Render.gp0Height-100);
		gxt.beginPath();
		gxt.moveTo(50, 100);
		gxt.lineTo(Render.gp0Width-50, 100);
		gxt.stroke();
		
		
		//Music Playing
		if (this.music)
		{
			gxt.font = "14px Arial";// Verdana";
			gxt.textAlign = "left";
			gxt.textBaseline = "top";
			gxt.fillStyle = "#FFF";
			
			var x=65,y=65;
			if (!this.musicIsPlaying)
			{
				gxt.beginPath();
				gxt.moveTo(x, y+2);
				gxt.lineTo(x, y+22);
				gxt.lineTo(x+15, y+12);
				gxt.fill();
			} else {
				gxt.fillRect(x, y+3, 20, 5);
				gxt.fillRect(x, y+13, 20, 5);
			}
			gxt.fillText(this.music.title, x+30, y);
			
			ClickBank.add({
				id: "musicplaypause",
				x: x, y: y, w: (Render.gp0Width-122)/2-25, h: 20,
				click: function(clickID, vaultEntry)
				{
					MusicPlayer.pausePlayMusic();
				}
			});
		}
		
		
		//Music
		gxt.save();
		gxt.translate(51, 101);
		gxt.rect(0, 0, Render.gp0Width-122, Render.gp0Height-152);
		gxt.clip();
		this.overflowYWindow = Render.gp0Height-152;
		
		gxt.font = "14px Verdana";
		gxt.textAlign = "left";
		gxt.textBaseline = "top";
		gxt.fillStyle = "#FFF";
		
		var x=15,y=15,map;
		y += this.overflowYOffset;
		
		var extra = {}, ext;
		extra["mainmenu"] = {title: _t("Main Menu")+" (Aethereal)", fileurl: "audio/mainmenu.ogg"};
		for(var _ext in extra)
		{
			ext = extra[_ext];
			
			gxt.beginPath();
			gxt.moveTo(x, y);
			gxt.lineTo(x, y+20);
			gxt.lineTo(x+15, y+10);
			gxt.fill();
			gxt.fillText(ext.title, x+30, y);
			
			ClickBank.add({
				id: "music_"+__mapID,
				x: 51+x, y: 101+y, w: (Render.gp0Width-122)/2-25, h: 20,
				click: function(clickID, vaultEntry)
				{
					var _ext = vaultEntry.data.extID;
					var ext = extra[_ext];
					
					MusicPlayer.loadMusic({
						title: ext.title,
						fileurl: ext.fileurl
					});
				}, data: {
					extID: _ext
				}
			});
			
			y += 32;
		}
		
		for(var __mapID in __Maps)
		{
			map = __Maps[__mapID];
			
			gxt.beginPath();
			gxt.moveTo(x, y);
			gxt.lineTo(x, y+20);
			gxt.lineTo(x+15, y+10);
			gxt.fill();
			gxt.fillText(_t(__mapID+"_title")+(map.backgroundmusic.title ? " ("+map.backgroundmusic.title+")" : ""), x+30, y);
			
			ClickBank.add({
				id: "music_"+__mapID,
				x: 51+x, y: 101+y, w: (Render.gp0Width-122)/2-25, h: 20,
				click: function(clickID, vaultEntry)
				{
					var __mapID = vaultEntry.data.mapID;
					var map = __Maps[__mapID];
					
					MusicPlayer.loadMusic({
						title: map.title+(map.backgroundmusic.title ? " ("+map.backgroundmusic.title+")" : ""),
						fileurl: map.backgroundmusic.file
					});
				}, data: {
					mapID: __mapID
				}
			});
			
			y += 32;
			
			if (Math.round((y-15)/32) == 9)
			{
				x += (Render.gp0Width-122)/2;
				y = 15;
			}
		}
		this.overflowYMax = y - this.overflowYOffset;
		
		gxt.restore();
		
		
		cxt.textAlign = "center"; gxt.textAlign = "center";
		var str = _t("pressbtoreturn_mainmenu");
		cxt.fillStyle = "#FFF";
		cxt.font = "30px Verdana";
		cxt.fillText(str, Render.tvWidth/2, Render.tvHeight-72*Render.renderTVRatio);
		/*cxt.fillText("press", Render.tvWidth/2-320*Render.renderTVRatio, Render.tvHeight-72*Render.renderTVRatio);
		cxt.fillText("to return to Main Menu", Render.tvWidth/2-130*Render.renderTVRatio, Render.tvHeight-72*Render.renderTVRatio);
		cxt.drawImage(fontImages["b"], Render.tvWidth/2-190*Render.renderTVRatio, Render.tvHeight-62*Render.renderTVRatio, 48*Render.renderTVRatio, 48*Render.renderTVRatio);*/
		
		gxt.fillStyle = "#FFF";
		gxt.font = "25px Verdana";
		gxt.fillText(str, Render.gp0Width/2, Render.gp0Height-40);
		/*gxt.fillText("press", Render.gp0Width/2-175, Render.gp0Height-40);
		gxt.fillText("to return to Main Menu", Render.gp0Width/2-60, Render.gp0Height-40);
		gxt.drawImage(fontImages["b"], Render.gp0Width/2-100, Render.gp0Height-35, 28, 28);*/
	};
	
	//Load Music and Play
	this.loadMusic = function(data)
	{
		if (this.audio)
		{
			this.audio.pause();
		}
		delete this.audio;
		
		nwf.system.Memory.requestGC();
		
		this.audio = new Audio();
		this.audio.loop = true;
		this.audio.autoplay = true;
		this.audio.volume = 0.8;
		this.audio.gamepad1Volume = 0.8;
		this.audio.tvVolume = 0.8;
		this.audio.src = data.fileurl;
		this.audio.isReady = false;
		this.audio.addEventListener("canplay", function()
		{
			this.isReady = true;
			
			this.removeEventListener("canplay", this);
		});
		
		this.music = data;
		this.visualizeEnemies = [];
		
		this.musicIsPlaying = true;
		this.musicIsPaused = false;
	};
	
	//Pause and Play the music
	this.pausePlayMusic = function()
	{
		if (!this.audio || !this.audio.isReady) return false;
		
		if (this.musicIsPlaying)
		{
			this.audio.pause();
			
			this.musicIsPlaying = false;
			this.musicIsPaused = true;
		} else {
			this.audio.play();
			
			this.musicIsPlaying = true;
			this.musicIsPaused = false;
		}
	};
	
	//Move Overflow Container
	this.moveOverflowContainer = function(y)
	{
		this.overflowYOffset += y;
		
		if (Math.abs(this.overflowYOffset) >= this.overflowYMax-this.overflowYWindow) this.overflowYOffset = -1*(this.overflowYMax-this.overflowYWindow);
		else if (this.overflowYOffset >= 0) this.overflowYOffset = 0;
	};
};
var MusicPlayer = new MusicPlayer();