var __StoreUpgradeCostBase = 1.50,
	__StoreUpgradeCostMin = 1.3,
	__StoreUpgradeCostLess = 0.05,
	__StoreUpgradeCostHard = 1.4,
	__StoreUpgradeCostHardLv = 7,
	__StoreUpgradeCostMax = 2,
	__StoreUpgradeCostMore = 0.01,
	__StoreResellRate = 0.75;
var __Store = {
	//Sentry
	"sentry": {
		type: "bot",
		name: "sentry_title",
		description: "sentry_desc",//"Simple bot weapon that fires at incoming enemies within it's range.",
		cost: 100,
		color: "#4299EC",
		createData: {
			range: 150,
			number: 1,
			power: 1.5,
			speed: 100,
			whofirst: "lowhealth"
		},
		createUpgrades: {
			range: 1,
			power: 1,
			number: 1,
			speed: 1
		},
		upgrades: {
			power: {
				name: "Power",
				cost: 50,
				maxLv: 0,
				upgrade: function(bot)
				{
					var lv = bot.upgrades.power;
					bot.data.power *= 1.3;
					bot.data.power = Math.round(bot.data.power*100)/100;
				},
				statRender: function(bot)
				{
					var value = typeof bot == "object" ? bot.data.power : bot;
					return Leaderboard.numberFormat(value.toFixed(2), "short")+" "+_t("Attack");
				}
			},
			range: {
				name: "Range",
				cost: 100,
				maxLv: 0,
				upgrade: function(bot)
				{
					bot.data.range += 25;
				},
				statRender: function(bot)
				{
					var value = typeof bot == "object" ? bot.data.range : bot;
					return Leaderboard.numberFormat(value, "short")+" "+_t("Meters");
				}
			},
			number: {
				name: "Target",
				cost: 100,
				maxLv: 0,
				upgrade: function(bot)
				{
					bot.data.number += 1;
				},
				statRender: function(bot)
				{
					var value = typeof bot == "object" ? bot.data.number : bot;
					return value;
				}
			},
			speed: {
				name: "Fire Rate",
				cost: 100,
				maxLv: 6,
				upgrade: function(bot)
				{
					bot.data.speed -= 10;
				},
				statRender: function(bot)
				{
					var value = typeof bot == "object" ? bot.data.speed : bot;
					return (value/1000).toFixed(3)+" "+_t("Seconds");
				}
			}
		}
	},
	
	//Bomber
	"bomber": {
		type: "bot",
		name: "bomber_title",
		description: "bomber_desc",//Powerful bombing bot that has a great long distance range.",
		cost: 150,
		color: "#AF5B5B",
		createData: {
			range: 75,
			rangeInner: 50,
			number: 1,
			power: 25,
			speed: 2000,
			whofirst: "lowhealth"
		},
		createUpgrades: {
			range: 1,
			power: 1,
			number: 1,
			speed: 1
		},
		upgrades: {
			power: {
				name: "Power",
				cost: 100,
				maxLv: 0,
				upgrade: function(bot)
				{
					bot.data.power = Math.floor(bot.data.power * 1.45);
				},
				statRender: function(bot)
				{
					var value = typeof bot == "object" ? bot.data.power : bot;
					return Leaderboard.numberFormat(value.toFixed(2), "short")+" "+_t("Attack");
				}
			},
			range: {
				name: "Range",
				cost: 50,
				maxLv: 0,
				upgrade: function(bot)
				{
					bot.data.range += 25;
				},
				statRender: function(bot)
				{
					var value = typeof bot == "object" ? bot.data.range : bot;
					return Leaderboard.numberFormat(value, "short")+" "+_t("Meters");
				}
			},
			number: {
				name: "Target",
				cost: 100,
				maxLv: 0,
				upgrade: function(bot)
				{
					bot.data.number += 1;
				},
				statRender: function(bot)
				{
					var value = typeof bot == "object" ? bot.data.number : bot;
					return value;
				}
			},
			speed: {
				name: "Fire Rate",
				cost: 50,
				maxLv: 16,
				upgrade: function(bot)
				{
					bot.data.speed -= 100;
				},
				statRender: function(bot)
				{
					var value = typeof bot == "object" ? bot.data.speed : bot;
					return (value/1000).toFixed(3)+" "+_t("Seconds");
				}
			}
		}
	},
	
	//Cloud
	"cloud": {
		type: "bot",
		name: "cloud_title",
		description: "cloud_desc",//A large range attack bot that fires very quickly but has low attack power.",
		cost: 50,
		color: "#5A5A66",
		createData: {
			range: 200,
			number: 1,
			power: 0.23,
			speed: 40,
			whofirst: "lowhealth"
		},
		createUpgrades: {
			range: 1,
			power: 1
		},
		upgrades: {
			power: {
				name: "Power",
				cost: 25,
				maxLv: 0,
				upgrade: function(bot)
				{
					var lv = bot.upgrades.power;
					bot.data.power *= 1.4;
					bot.data.power = Math.round(bot.data.power*100)/100;
				},
				statRender: function(bot)
				{
					var value = typeof bot == "object" ? bot.data.power : bot;
					return Leaderboard.numberFormat(value.toFixed(2), "short")+" "+_t("Attack");
				}
			},
			range: {
				name: "Range",
				cost: 50,
				maxLv: 0,
				upgrade: function(bot)
				{
					bot.data.range += 25;
				},
				statRender: function(bot)
				{
					var value = typeof bot == "object" ? bot.data.range : bot;
					return Leaderboard.numberFormat(value, "short")+" "+_t("Meters");
				}
			}
		}
	},
	
	//Elemental Spin
	/*"elemental": {
		type: "bot",
		name: "Elemental Spin",
		description: "Use a spinning blade of Fire, Ice, & Lightning to deal with enemies.",
		cost: 500,
		showrange: false,
		showattackmode: false,
		createData: {
			range: 150,
			number: 1,
			power: 100,
			speed: 50,
			
			fire: 1,
			ice: 1,
			lightning: 1,
			plasma: 0,
			bladespeed: 500,
			
			whofirst: "lowhealth"
		},
		createUpgrades: {
			power: 1,
			range: 1,
			fire: 1,
			ice: 1,
			lightning: 1,
			plasma: 1,
			bladespeed: 1
		},
		render: function(ID)
		{
			var bot = Game.bots[ID];
			
			return true;
		},
		canhiteval: function(ID, eID)
		{
			var bot = Game.bots[ID], eObj = Game.enemiesList[eID];
			
			return true;
		},
		hiteval: function(ID, eID)
		{
			var bot = Game.bots[ID], eObj = Game.enemiesList[eID];
		},
		upgrades: {
			power: {
				name: "Power",
				cost: 100,
				maxLv: 0,
				upgrade: function(bot)
				{
					var lv = bot.upgrades.power;
					bot.data.power *= 1.5;
					bot.data.power = Math.round(bot.data.power*100)/100;
				},
				statRender: function(bot)
				{
					return Leaderboard.numberFormat(bot.data.power.toFixed(2))+" Attack";
				}
			},
			range: {
				name: "Range",
				cost: 100,
				maxLv: 0,
				upgrade: function(bot)
				{
					bot.data.range += 25;
				},
				statRender: function(bot)
				{
					var value = typeof bot == "object" ? bot.data.range : bot;
					return Leaderboard.numberFormat(value)+" Meters";
				}
			},
			fire: {
				name: "Fire",
				cost: 50,
				maxLv: 4,
				upgrade: function(bot)
				{
					bot.data.fire += 1;
				},
				showeval: function(bot)
				{
					if (bot.data.plasma >= 1) return false;
					return true;
				}
			},
			ice: {
				name: "Ice",
				cost: 50,
				maxLv: 4,
				upgrade: function(bot)
				{
					bot.data.ice += 1;
				},
				showeval: function(bot)
				{
					if (bot.data.plasma >= 1) return false;
					return true;
				}
			},
			lightning: {
				name: "Lighting",
				cost: 50,
				maxLv: 4,
				upgrade: function(bot)
				{
					bot.data.lightning += 1;
				},
				showeval: function(bot)
				{
					if (bot.data.plasma >= 1) return false;
					return true;
				}
			},
			plasma: {
				name: "Plasma",
				cost: 250,
				maxLv: 4,
				upgrade: function(bot)
				{
					bot.data.plasma += 1;
				},
				showeval: function(bot)
				{
					if (bot.data.plasma >= 1
						|| (bot.data.fire >= 5 && bot.data.ice >= 5 && bot.data.lightning >= 5))
						return true;
					
					return false;
				}
			},
			bladespeed: {
				name: "Blade Speed",
				cost: 50,
				maxLv: 4,
				upgrade: function(bot)
				{
					bot.data.bladespeed -= 50;
				}
			},
		}
	},*/
	
	//Tesla Coil
	"teslacoil": {
		type: "bot",
		name: "teslacoil_title",
		description: "teslacoil_desc",//A powerful attack bot that zaps at all enemies in range and spreads to nearby enemies.",
		cost: 500,
		color: "#2C526D",
		colors: ["#2C526D", "#285877", "#144768"],
		createData: {
			range: 150,
			number: 1,
			power: 0.5,
			speed: 50,
			chain: 1,
			chaindistance: 250,
			whofirst: "lowhealth"
		},
		createUpgrades: {
			range: 1,
			power: 1,
			chain: 1,
			chaindistance: 1,
			speed: 1
		},
		upgrades: {
			power: {
				name: "Power",
				cost: 100,
				maxLv: 0,
				upgrade: function(bot)
				{
					var lv = bot.upgrades.power;
					bot.data.power *= 1.5;
					bot.data.power = Math.round(bot.data.power*100)/100;
				},
				statRender: function(bot)
				{
					var value = typeof bot == "object" ? bot.data.power : bot;
					return Leaderboard.numberFormat(value.toFixed(2), "short")+" "+_t("Attack");
				}
			},
			range: {
				name: "Range",
				cost: 50,
				maxLv: 0,
				upgrade: function(bot)
				{
					bot.data.range += 25;
				},
				statRender: function(bot)
				{
					var value = typeof bot == "object" ? bot.data.range : bot;
					return Leaderboard.numberFormat(value, "short")+" "+_t("Meters");
				}
			},
			chain: {
				name: "Chain",
				cost: 100,
				maxLv: 0,
				upgrade: function(bot)
				{
					bot.data.chain += 1;
				},
				statRender: function(bot)
				{
					var value = typeof bot == "object" ? bot.data.chain : bot;
					return value+" "+_t("Linked Chains");
				}
			},
			chaindistance: {
				name: "Chain Gap",
				cost: 250,
				maxLv: 8,
				upgrade: function(bot)
				{
					bot.data.chaindistance += 50;
				},
				statRender: function(bot)
				{
					var value = typeof bot == "object" ? bot.data.chaindistance : bot;
					return Leaderboard.numberFormat(value, "short")+" "+_t("Meters");
				}
			},
			speed: {
				name: "Fire Rate",
				cost: 10000,
				maxLv: 3,
				upgrade: function(bot)
				{
					bot.data.speed -= 10;
				},
				statRender: function(bot)
				{
					var value = typeof bot == "object" ? bot.data.speed : bot;
					return (value/1000).toFixed(3)+" "+_t("Seconds");
				}
			}
		}
	},
	
	//Drone
	"drone": {
		type: "defense",
		name: "drone_title",
		description: "drone_desc",//A fast and powerful mobile bot for the outer edges of the map. Manually take control of a drone anytime with a Wii Remote Controller.",
		cost: 200,
		color: "#3F7477",
		message: "Add a drone to the outer edge?",
		maxAllowed: 15,
		createData: {
			range: 75,
			number: 1,
			power: 1.3,
			speed: 100,
			movespeed: 2.25,
			whofirst: "lowhealth"
		},
		createUpgrades: {
			range: 1,
			power: 1,
			speed: 1,
			movespeed: 1
		},
		action: function()
		{
			var ID = Game.botsDroneAdd();
			var bot = Game.bots[ID];
			
			if (Game.mapClass.storeRules.drone != undefined
			 && Game.mapClass.storeRules.drone.createData != undefined
			 && Game.mapClass.storeRules.drone.createData.movespeed != undefined)
				bot.data.movespeed = Game.mapClass.storeRules.drone.createData.movespeed;
		},
		hiteval: function(ID, eID)
		{
			var obj = Game.bots[ID], eObj = Game.enemiesList[eID];
			obj.fireduponenemy = true;
			
			if (eObj.life <= 0 && (eObj.destroyedBy == undefined || !eObj.destroyedBy))
			{
				eObj.destroyedBy = ID;
				obj.direction *= -1;
			}
		},
		upgrades: {
			power: {
				name: "Power",
				cost: 50,
				maxLv: 0,
				upgrade: function(bot)
				{
					var lv = bot.upgrades.power;
					bot.data.power *= 1.35;
					bot.data.power = Math.round(bot.data.power*100)/100;
				},
				statRender: function(bot)
				{
					var value = typeof bot == "object" ? bot.data.power : bot;
					return Leaderboard.numberFormat(value.toFixed(2), "short")+" "+_t("Attack");
				}
			},
			range: {
				name: "Range",
				cost: 100,
				maxLv: 3,
				upgrade: function(bot)
				{
					bot.data.range += 25;
				},
				statRender: function(bot)
				{
					var value = typeof bot == "object" ? bot.data.range : bot;
					return Leaderboard.numberFormat(value, "short")+" "+_t("Meters");
				}
			},
			speed: {
				name: "Fire Rate",
				cost: 50,
				maxLv: 6,
				upgrade: function(bot)
				{
					bot.data.speed -= 10;
				},
				statRender: function(bot)
				{
					var value = typeof bot == "object" ? bot.data.speed : bot;
					return (value/1000).toFixed(3)+" "+_t("Seconds");
				}
			},
			movespeed: {
				name: "Move Speed",
				cost: 50,
				maxLv: 5,
				upgrade: function(bot)
				{
					bot.data.movespeed += 1;
				},
				statRender: function(bot)
				{
					var value = typeof bot == "object" ? bot.data.movespeed : bot;
					return Leaderboard.numberFormat(value.toFixed(0), "short")+" "+_t("Meters");
				}
			}
		}
	},
	
	//Helper
	"helper": {
		type: "bot",
		name: "helper_title",
		description: "helper_desc",//Defense bot to help slow down oncoming enemies.",
		cost: 50,
		color: "#DE91E2",
		createData: {
			range: 125,
			number: 1,
			power: 0,
			speed: 1000,
			freeze: 1.0,
			slow: 150,
			maxhit: 2,
			whofirst: "closest"
		},
		createUpgrades: {
			slow: 1,
			freeze: 1,
			number: 1,
			range: 1,
			maxhit: 1
		},
		canhiteval: function(ID, eID)
		{
			var obj = Game.bots[ID], eObj = Game.enemiesList[eID];
			if (!obj || !eObj) return false;
			
			//Make sure we can hit this enemy
			if (eObj.data.hitbyhelpers == undefined) eObj.data.hitbyhelpers = {};
			if (eObj.data.hitbyhelpers[ID] == undefined) eObj.data.hitbyhelpers[ID] = 0;
			if (obj.data.maxhit <= eObj.data.hitbyhelpers[ID]) return false;
			
			return true;
		},
		hiteval: function(ID, eID)
		{
			var obj = Game.bots[ID], eObj = Game.enemiesList[eID];
			
			//Make sure we can hit this enemy
			if (eObj.data.hitbyhelpers == undefined) eObj.data.hitbyhelpers = {};
			if (eObj.data.hitbyhelpers[ID] == undefined) eObj.data.hitbyhelpers[ID] = 0;
			if (obj.data.maxhit <= eObj.data.hitbyhelpers[ID]) return false;
			
			if (eObj.speed != undefined)
			{
				if (eObj.data.speed0 == undefined) eObj.data.speed0 = eObj.speed;
				if (Game.map == "ss001" && 0) eObj.speed += obj.data.slow;
				else {
					eObj.speed -= eObj.data.speed0 * ((2*obj.upgrades["slow"])/100);
					if (eObj.speed < eObj.data.speed0/2) eObj.speed = eObj.data.speed0/2;
				}
			}
			if (eObj.data.freeze == undefined || eObj.data.freeze <= 0) eObj.data.freeze = obj.data.freeze;
			else if (eObj.data.freeze > 0) eObj.data.freeze += obj.data.freeze;
			eObj.data.hitbyhelpers[ID]++;
		},
		upgrades: {
			slow: {
				name: "Slow",
				cost: 25,
				maxLv: 10,
				upgrade: function(bot)
				{
					bot.data.slow += 50;
				},
				statRender: function(bot)
				{
					var value = typeof bot == "object" ? bot.data.slow : bot;
					return (value/100).toFixed(1)+" "+_t("Slow");
				}
			},
			freeze: {
				name: "Freeze",
				cost: 25,
				maxLv: 10,
				upgrade: function(bot)
				{
					bot.data.freeze += 0.5;
				},
				statRender: function(bot)
				{
					var value = typeof bot == "object" ? bot.data.freeze : bot;
					return value.toFixed(1)+" "+_t("Freeze");
				}
			},
			number: {
				name: "Target",
				cost: 100,
				maxLv: 0,
				upgrade: function(bot)
				{
					bot.data.number += 1;
				},
				statRender: function(bot)
				{
					var value = typeof bot == "object" ? bot.data.number : bot;
					return value;
				}
			},
			range: {
				name: "Range",
				cost: 100,
				maxLv: 0,
				upgrade: function(bot)
				{
					bot.data.range += 25;
				},
				statRender: function(bot)
				{
					var value = typeof bot == "object" ? bot.data.range : bot;
					return Leaderboard.numberFormat(value, "short")+" "+_t("Meters");
				}
			},
			maxhit: {
				name: "Max Hits",
				cost: 500,
				maxLv: 5,
				upgrade: function(bot)
				{
					bot.data.maxhit += 1;
				},
				statRender: function(bot)
				{
					var value = typeof bot == "object" ? bot.data.maxhit : bot;
					return Leaderboard.numberFormat(value.toFixed(0), "short")+" "+_t("Hits");
				}
			}
		}
	},
	
	//Missile Silo
	/*"missilesilo": {
		type: "bot",
		name: "Missile Silo",
		description: "A stationary bot that takes aim and fires rockets at enemies. Manually take control of the aiming anytime with a Wii Remote Controller.",
		cost: 200,
		message: "Launch rockets at your enemies?",
		displayForPurchase: false, //Hides from Resources Tab & Spot Selection normally
		showAttackMode: false,
		createData: {
			range: 150,
			power: 25,
			scanspeed: 5
		},
		createUpgrades: {
			range: 1,
			power: 1,
			scanspeed: 1
		},
		createAction: function(ID)
		{
			var bot = Game.bots[ID];
			
			bot.crosshair = {x: 0, y: 0};
			bot.crosshairAutoIndex = 0;
			bot.crosshairAutoRange = [{x: 0, y: 0}, {x: 100, y: 100}];
			bot.crosshairAutoDirection = (Math.floor(Math.random()*2)+1 == 1 ? 1 : -1);
			bot.crosshairAutoSpeed = 2.5; bot.crosshairAutoSpeedZoneIn = 4.0;
			bot.crosshairAuteRangeSearch = 250;
			bot.crosshairAutoAdjustDistance = 125;
			bot.waitperiod = 2.0;
			bot.missileFire = {x: 0, y: 0, isActive: false, origin: {x: 0, y: 0}, destination: {x: 0, y: 0}, speed: 15};
			bot.missileExplosion = {x: 0, y: 0, r: 0, isActive: false, expandRate: 3.0, enemieHits: [], cooldown: 0, ttl: 15, time: 0};
			
			bot.destination = {x: 0, y: 0};
			
			Game.mapClass.missilesilo_createAction(ID);
		},
		renderEdge: function(ID)
		{
			return true;
		},
		render: function(ID)
		{
			var bot = Game.bots[ID];
			var cxt = Render.tvContext, gxt = Render.gp0Context;
			var vi, vi2;
			
			cxt.lineWidth = 1; gxt.lineWidth = 1;
			cxt.strokeStyle = "#BBB"; gxt.strokeStyle = "#BBB";
			
			if (!bot.missileFire.isActive && !bot.missileExplosion.isActive)
			{
				//Line
				cxt.beginPath();
				cxt.moveTo(bot.x, bot.y);
				cxt.lineTo(bot.crosshair.x, bot.crosshair.y);
				cxt.stroke();
				
				gxt.beginPath();
				vi2 = Game.enemyCalculateGPCords(bot.x, bot.y);
				gxt.lineTo(vi2.x2, vi2.y2);
				vi2 = Game.enemyCalculateGPCords(bot.crosshair.x, bot.crosshair.y);
				gxt.lineTo(vi2.x2, vi2.y2);
				gxt.stroke();
				
				//Crosshair
				var d = 15;
				cxt.save();
				cxt.translate(bot.crosshair.x, bot.crosshair.y);
				cxt.rotate(45*Math.PI/180);
				cxt.beginPath();
				cxt.moveTo(-d, 0);
				cxt.lineTo(d, 0);
				cxt.moveTo(0, -d);
				cxt.lineTo(0, d);
				cxt.stroke();
				cxt.restore();
	
				vi2 = Game.enemyCalculateGPCords(bot.crosshair.x, bot.crosshair.y);
				gxt.save();
				gxt.translate(vi2.x2, vi2.y2);
				gxt.rotate(45*Math.PI/180);
				d = Game.enemyCalculateGPCords(d, d, true);
				gxt.beginPath();
				gxt.moveTo(-d.x2, 0);
				gxt.lineTo(d.x2, 0);
				gxt.moveTo(0, -d.x2);
				gxt.lineTo(0, d.x2);
				gxt.stroke();
				gxt.restore();
			}
			
			//Range
			/*cxt.globalAlpha = 0.25; gxt.globalAlpha = 0.25;
			cxt.fillStyle="#FFF";
			cxt.beginPath();
			cxt.arc(bot.crosshair.x, bot.crosshair.y, bot.crosshairAuteRangeSearch/2, 0, 2*Math.PI);
			cxt.fill();
			
			gxt.fillStyle="#FFF";
			gxt.beginPath();
			vi = Game.enemyCalculateGPCords(bot.crosshair.x, bot.crosshair.y);
			gxt.arc(vi.x2, vi.y2, bot.crosshairAuteRangeSearch*Render.gp0RenderRatio/2, 0, 2*Math.PI);
			gxt.fill();
			cxt.globalAlpha = 1; gxt.globalAlpha = 1;
			*
			
			//Fire Rocket Animation
			//bot.missileFire = {x: 0, y: 0, isActive: false, origin: {x: 0, y: 0}, destination: {x: 0, y: 0}, speed: 25};
			if (bot.missileFire.isActive)
			{
				var d = 10;
				vi2 = Game.enemyCalculateGPCords(d, 0, true);
				var d2 = vi2.x2;
				cxt.fillStyle = "#DDD"; gxt.fillStyle = "#DDD";
				cxt.fillRect(bot.missileFire.x-d/2, bot.missileFire.y-d/2, d, d);
				vi2 = Game.enemyCalculateGPCords(bot.missileFire.x, bot.missileFire.y);
				gxt.fillRect(vi2.x2-d2/2, vi2.y2-d2/2, d2, d2);
			}
			
			//Rocket Explosion
			//bot.missileExplosion = {x: 0, y: 0, r: 0, isActive: false, expandRate: 3, enemieHits: []};
			if (bot.missileExplosion.isActive || bot.missileExplosion.cooldown > 0)
			{
				cxt.globalAlpha = 0.3; gxt.globalAlpha = 0.3;
				cxt.fillStyle="#FFF";
				cxt.beginPath();
				cxt.arc(bot.missileExplosion.x, bot.missileExplosion.y, bot.missileExplosion.r, 0, 2*Math.PI);
				cxt.fill();
				
				gxt.fillStyle="#FFF";
				gxt.beginPath();
				vi = Game.enemyCalculateGPCords(bot.missileExplosion.x, bot.missileExplosion.y);
				gxt.arc(vi.x2, vi.y2, bot.missileExplosion.r*Render.gp0RenderRatio, 0, 2*Math.PI);
				gxt.fill();
				cxt.globalAlpha = 1; gxt.globalAlpha = 1;
				
				if (!bot.missileExplosion.isActive)
				{
					var cdown = 1*(Game.fastEnabled ? Game.fastRate : 1);
					if (Game.isPaused || Game.gamePause) cdown = 0;
					bot.missileExplosion.cooldown -= cdown;
				}
			}
			
			//Extra Stuff
			if (Game.isPaused || Game.gamePause)
			{
				if (bot.missileExplosion.time+bot.waitperiod > Date.now())
					bot.missileExplosion.time = Date.now()-bot.waitperiod;
			}
			
			return true;
		},
		moveBot: function(ID, rate, fastRate)
		{
			if (rate == undefined) rate = 1;
			if (fastRate == undefined) fastRate = parseInt(Game.fastRate);
			
			var bot = Game.bots[ID];
			__Store["missilesilo"].fireRocketAnimate(ID);
			__Store["missilesilo"].explodeRocketAnimate(ID);
			if (bot.missileFire.isActive || bot.missileExplosion.isActive) return false;
			if (bot.missileExplosion.time+(bot.waitperiod/(Game.fastEnabled ? Game.fastRate : 1)) > Date.now()) return false;
			var speed = bot.crosshairAutoSpeed*rate*fastRate;
			
			var newpoint = bot.crosshairAutoIndex + bot.crosshairAutoDirection;
			if (newpoint < 0 || newpoint > bot.crosshairAutoRange.length-1)
			{
				bot.crosshairAutoDirection *= -1;
				newpoint += bot.crosshairAutoDirection*2;
			}
			var pointMap = bot.crosshairAutoRange[newpoint];
			var d = Math.sqrt(Math.pow(pointMap.x - bot.crosshair.x, 2) + Math.pow(pointMap.y - bot.crosshair.y, 2));
			if (d < speed*2)
			{
				bot.crosshairAutoIndex = newpoint;
				return true;
			}
			
			//Does this new point not have access?
			if (Game.doesInterceptWall(bot.crosshair.x, bot.crosshair.y, pointMap.x, pointMap.y))
			{
				pointMap = bot.crosshairAutoRange[bot.crosshairAutoIndex];
			}
			
			//Enemy in range?
			var eObj, _d, poiEntry, dcheck = bot.crosshairAuteRangeSearch;
			var enemies = Game.enemiesList, eIDtoUse = null, eDtoUse = null;
			if (bot.enemyLockOn && enemies[bot.enemyLockOn] != undefined)
			{
				var eTempObj = enemies[bot.enemyLockOn];
				//Make sure still have direct access
				if (eTempObj && !Game.doesInterceptWall(bot.crosshair.x, bot.crosshair.y, eTempObj.x, eTempObj.y))
					eIDtoUse = bot.enemyLockOn;
				else delete bot.enemyLockOn;
			} else delete bot.enemyLockOn;
			if (eIDtoUse == null)
			{
				poiEntry = {x: bot.crosshair.x, y: bot.crosshair.y};
				
				//Check for enemies close by
				for(var eID in enemies)
				{
					eObj = enemies[eID];
					_d = Math.sqrt(Math.pow(eObj.x - poiEntry.x, 2) + Math.pow(eObj.y - poiEntry.y, 2));
					if (_d <= dcheck)
					{
						_d = Math.sqrt(Math.pow(eObj.x - bot.crosshair.x, 2) + Math.pow(eObj.y - bot.crosshair.y, 2));
						if (eIDtoUse == null || _d > eDtoUse)
						{
							wallCheck = Game.doesInterceptWall(bot.crosshair.x, bot.crosshair.y, eObj.x, eObj.y);
							if (!wallCheck)
							{
								eIDtoUse = eID;
								eDtoUse = _d;
							}
						}
					}
				}
			}
			if (eIDtoUse)
			{
				pointMap = jQuery.extend(true, {}, enemies[eIDtoUse]);
				//pointMap.y += bot.crosshairAutoAdjustDistance*(Game.fastEnabled ? Game.fastRate : 1);
				pointMap.y += bot.crosshairAutoAdjustDistance;
				bot.enemyLockOn = eIDtoUse;
				speed = bot.crosshairAutoSpeedZoneIn*(Game.fastEnabled ? Game.fastRate : 1);
				
				d = Math.sqrt(Math.pow(bot.crosshair.x - pointMap.x, 2) + Math.pow(bot.crosshair.y - pointMap.y, 2));
				if (Math.abs(d) <= 5.00)
					__Store["missilesilo"].fireRocket(ID, bot.crosshair.x, bot.crosshair.y);
				
				/*cxt.strokeStyle = "yellow";
				cxt.beginPath();
				cxt.moveTo(bot.x, bot.y);
				cxt.lineTo(pointMap.x, pointMap.y);
				cxt.stroke();*
			} else {
				//Advance smoothly to next point
				//XXX?
			}
			
			//Change Destination Points
			bot.destination.x = pointMap.x;
			bot.destination.y = pointMap.y;
			
			//Determine if point is less then speed
			_d = Math.sqrt(Math.pow(bot.crosshair.x - pointMap.x, 2) + Math.pow(bot.crosshair.y - pointMap.y, 2));
			if (_d < speed) speed = _d;
			if (Math.abs(speed) < 0.01) return false;

			//Determine x and y increases
			var dX = Math.abs(pointMap.x - bot.crosshair.x), dY = Math.abs(pointMap.y - bot.crosshair.y);
			var xSide = 0, ySide = 0;
			if (dX == 0 && pointMap.y - bot.crosshair.y < 0) { ySide = -1*speed; }
			else if (dX == 0 && pointMap.y - bot.crosshair.y > 0) { ySide = speed; }
			else if (dY == 0 && pointMap.x - bot.crosshair.x < 0) { xSide = -1*speed; }
			else if (dY == 0 && pointMap.x - bot.crosshair.x > 0) { xSide = speed; }
			else {
				var angleA = Math.atan(dX/dY);// * (180 / Math.PI);
				xSide = Math.abs(speed*Math.sin(angleA));
				ySide = Math.abs(speed*Math.cos(angleA));
				//xSide = (angleA/90)*speed;
				//ySide = ((90-angleA)/90)*speed;
				
				if (pointMap.x - bot.crosshair.x < 0 && pointMap.y - bot.crosshair.y < 0) { xSide *= -1; ySide *= -1; }
				else if (pointMap.x - bot.crosshair.x > 0 && pointMap.y - bot.crosshair.y < 0) { ySide *= -1; }
				else if (pointMap.x - bot.crosshair.x > 0 && pointMap.y - bot.crosshair.y > 0) {  }
				else if (pointMap.x - bot.crosshair.x < 0 && pointMap.y - bot.crosshair.y > 0) { xSide *= -1; }
			}
			
			bot.crosshair.x += xSide; bot.crosshair.y += ySide;
			
			return false;
		},
		hiteval: function(ID, eID)
		{
			var bot = Game.bots[ID], eObj = Game.enemiesList[eID];
			
			
		},
		fireRocket: function(ID, x, y)
		{
			var bot = Game.bots[ID];
			//bot.missileFire = {x: 0, y: 0, isActive: false, origin: {x: 0, y: 0}, destination: {x: 0, y: 0}, speed: 25};

			bot.missileFire.isActive = true;
			bot.missileFire.x = bot.x;
			bot.missileFire.y = bot.y;
			bot.missileFire.origin.x = bot.x;
			bot.missileFire.origin.y = bot.y;
			bot.missileFire.destination.x = x;
			bot.missileFire.destination.y = y;
		},
		fireRocketAnimate: function(ID)
		{
			var bot = Game.bots[ID];
			if (!bot.missileFire.isActive) return false;
			var speed = bot.missileFire.speed*(Game.fastEnabled ? Game.fastRate : 1);
			
			var pointMap = bot.missileFire.destination;
			
			_d = Math.sqrt(Math.pow(bot.missileFire.x - pointMap.x, 2) + Math.pow(bot.missileFire.y - pointMap.y, 2));
			if (_d < speed) speed = _d;
			if (Math.abs(speed) < 0.02)
			{
				__Store["missilesilo"].explodeRocket(ID);
				return false;
			}

			//Determine x and y increases
			var dX = Math.abs(pointMap.x - bot.missileFire.x), dY = Math.abs(pointMap.y - bot.missileFire.y);
			var xSide = 0, ySide = 0;
			if (dX == 0 && pointMap.y - bot.missileFire.y < 0) { ySide = -1*speed; }
			else if (dX == 0 && pointMap.y - bot.missileFire.y > 0) { ySide = speed; }
			else if (dY == 0 && pointMap.x - bot.missileFire.x < 0) { xSide = -1*speed; }
			else if (dY == 0 && pointMap.x - bot.missileFire.x > 0) { xSide = speed; }
			else {
				var angleA = Math.atan(dX/dY);// * (180 / Math.PI);
				xSide = Math.abs(speed*Math.sin(angleA));
				ySide = Math.abs(speed*Math.cos(angleA));
				//xSide = (angleA/90)*speed;
				//ySide = ((90-angleA)/90)*speed;
				
				if (pointMap.x - bot.missileFire.x < 0 && pointMap.y - bot.missileFire.y < 0) { xSide *= -1; ySide *= -1; }
				else if (pointMap.x - bot.missileFire.x > 0 && pointMap.y - bot.missileFire.y < 0) { ySide *= -1; }
				else if (pointMap.x - bot.missileFire.x > 0 && pointMap.y - bot.missileFire.y > 0) {  }
				else if (pointMap.x - bot.missileFire.x < 0 && pointMap.y - bot.missileFire.y > 0) { xSide *= -1; }
			}
			
			bot.missileFire.x += xSide; bot.missileFire.y += ySide;
		},
		explodeRocket: function(ID)
		{
			var bot = Game.bots[ID];
			//bot.missileExplosion = {x: 0, y: 0, r: 0, isActive: false, expandRate: 3, enemieHits: []};

			bot.missileFire.isActive = false;
			bot.missileExplosion.isActive = true;
			bot.missileExplosion.x = bot.missileFire.destination.x;
			bot.missileExplosion.y = bot.missileFire.destination.y;
			bot.missileExplosion.r = 0;
			bot.missileExplosion.enemieHits = [];
		},
		explodeRocketAnimate: function(ID)
		{
			var bot = Game.bots[ID];
			if (!bot.missileExplosion.isActive) return false;
			
			bot.missileExplosion.r += bot.missileExplosion.expandRate;
			if (bot.missileExplosion.r > bot.data.range)
				bot.missileExplosion.r = bot.data.range;
			
			//Check for Enemies within range
			var enemies = Game.enemiesList, eID, eObj, d;
			for(var eID in enemies)
			{
				eObj = enemies[eID];
				
				d = Math.sqrt(Math.pow(bot.missileExplosion.x - eObj.x, 2) + Math.pow(bot.missileExplosion.y - eObj.y, 2));
				if (d < bot.missileExplosion.r && jQuery.inArray(eID, bot.missileExplosion.enemieHits) == -1)
				{
					Game.botFireUponEnemy(ID, eID, 1, {
						visual: false
					});
					
					bot.missileExplosion.enemieHits.push(eID);
				}
			}
			
			if (bot.missileExplosion.r >= bot.data.range-0.01)
			{
				bot.missileExplosion.isActive = false;
				bot.missileExplosion.cooldown = bot.missileExplosion.ttl;
				bot.missileExplosion.time = Date.now();
			}
		},
		upgrades: {}
	},*/
	
	//Shield
	"shield": {
		type: "defense",
		name: "shield_title",
		description: "shield_desc",//Enhances all base shields.",
		cost: 250,
		message: "Enhance your shield by 25 points?",
		costupgrade: function()
		{
			var cost = this.cost;
			for(var i=0; i<Game.mapClass.base[0].shieldUse; i++)
			{
				cost += cost*(1/2);
				cost = Math.round(cost);
			}
			
			return cost;
		},
		action: function()
		{
			for(var key in Game.mapClass.base)
			{
				Game.mapClass.base[key].shield += 25;
				Game.mapClass.base[key].shieldUse += 1;
				Game.basesShield += 25;
			}
		}
	},
	
	
	
	/* Hidden Bots */
	//Ping
	"ping": {
		type: "bot",
		name: "PING",
		description: "",
		cost: 0,
		displayForPurchase: false, //Hides from Resources Tab & Spot Selection normally
		displayOnActiveBotsTab: false, //Hides from Active Bots Tab
		showrange: false,
		showbot: false,
		createData: {
			range: 50,
			number: 1,
			power: 0,
			speed: 40,
			movespeed: 2.5, movespeedinc: 0.01,
			whofirst: "lowhealth"
		},
		createAction: function(ID)
		{
			var bot = Game.bots[ID];
			
			bot.ping = {};
			bot.ping.dir = {x: 1, y: 1};
			bot.ping.hits = 0;
			bot.ping.maxHits = 100;
			bot.ping.recentChanges = {hitsArray: []};
			bot.ping.hitBotsTime = {};
		},
		render: function(ID)
		{
			var bot = Game.bots[ID];
			var cxt = Render.tvContext, gxt = Render.gp0Context;
			
			var _w = bot.data.range/2, _h = bot.data.range/2,
			_w2 = _w*Render.gp0RenderRatio, _h2 = _h*Render.gp0RenderRatio;
			
			var gp0Cord = Game.calculateGPCords(bot.x, bot.y);
			cxt.drawImage(Render.images["bottype_ping"], (bot.x-_w/2)*Render.renderTVRatio, (bot.y-_h/2)*Render.renderTVRatio, _w*Render.renderTVRatio, _h*Render.renderTVRatio);
			gxt.drawImage(Render.images["bottype_ping"], gp0Cord.x2-_w2/2, gp0Cord.y2-_h2/2, _w2, _h2);
		},
		renderCover: function(ID)
		{
			var bot = Game.bots[ID];
			var cxt = Render.tvContext, gxt = Render.gp0Context;
			
			var _w = bot.data.range, _h = bot.data.range,
			_w2 = _w*Render.gp0RenderRatio, _h2 = _h*Render.gp0RenderRatio;
			
			if (bot.ping.hits > 0)
			{
				if (bot.ping.recentChanges.hits == undefined || bot.ping.recentChanges.hits != bot.ping.hits)
				{
					bot.ping.recentChanges.hits = bot.ping.hits;
					bot.ping.recentChanges.hitsArray.push({
						hits: bot.ping.hits,
						hitsTimer0: Date.now(),
						hitsTimer: 2500,
						hitsPos: {x: bot.x, y: bot.y-_h*2}
					});
				}
				
				var hitsArray;
				for(var key in bot.ping.recentChanges.hitsArray)
				{
					hitsArray = bot.ping.recentChanges.hitsArray[key];
					
					if (hitsArray.hitsTimer > 0)
					{
						cxt.fillStyle = "#EEE"; gxt.fillStyle = "#EEE";
						cxt.font = "16px Verdana"; gxt.font = "12px Verdana";
						cxt.textAlign = "center"; gxt.textAlign = "center";
	
						var gp0Cord = Game.calculateGPCords(hitsArray.hitsPos.x, hitsArray.hitsPos.y);
						cxt.fillText(hitsArray.hits, hitsArray.hitsPos.x*Render.renderTVRatio, hitsArray.hitsPos.y*Render.renderTVRatio);
						gxt.fillText(hitsArray.hits, gp0Cord.x2, gp0Cord.y2);
						
						cxt.textAlign = "left"; gxt.textAlign = "left";
						
						var msTimer = Date.now() - hitsArray.hitsTimer0;
						hitsArray.hitsTimer0 = Date.now();
						if (!Game.gamePause && !Game.isPaused)
						{
							hitsArray.hitsTimer -= msTimer*(Game.fastEnabled ? Game.fastRate : 1);
							hitsArray.hitsPos.y -= 1*(Game.fastEnabled ? Game.fastRate : 1);
						}
					}
				}
			}
			
			if (0)
			if (Game.map && Game.mapClass.pingWalls != undefined)
			{
				var walls, wall, wall0, rtrX, rtrY, d;
				for(var key in Game.mapClass.pingWalls)
				{
					walls = Game.mapClass.pingWalls[key];
					d = walls.d;
					
					for(var i=1; i<walls.walls.length; i++)
					{
						wall0 = walls.walls[i-1];
						wall = walls.walls[i];
						
						if (wall.x < wall0.x || wall.y < wall0.y)
						{
							var wall2 = wall0;
							wall0 = wall;
							wall = wall2;
						}
						
						pingLinePreview(wall0, wall, d);
					}
				}
			}
		},
		moveBot: function(ID, rate, fastRate)
		{
			if (rate == undefined) rate = 1;
			if (fastRate == undefined) fastRate = parseInt(Game.fastRate);
			
			var bot = Game.bots[ID];
			var hits = bot.ping.hits;
			
			var xSpeed = bot.data.movespeed*rate*fastRate;
			var ySpeed = bot.data.movespeed*rate*fastRate;
			
			var newX = bot.x+bot.ping.dir.x*xSpeed;
			var newY = bot.y+bot.ping.dir.y*ySpeed;
			//bot.x += bot.ping.dir.x*xSpeed;
			//bot.y += bot.ping.dir.y*ySpeed;
			
			//Ping Teleports?
			var didTeleport = false;
			if (Game.map && Game.mapClass.pingTeleports != undefined)
			{
				var walls, wall, wall0, rtr, rtrX, rtrY;
				for(var key in Game.mapClass.pingTeleports)
				{
					walls = Game.mapClass.pingTeleports[key];
					
					for(var i=1; i<walls.walls.length; i++)
					{
						wall0 = walls.walls[i-1];
						wall = walls.walls[i];
						
						rtr = Game.doesInterceptLine(bot.x, bot.y, newX, newY, wall0.x, wall0.y, wall.x, wall.y);
						//rtrX = Game.doesInterceptLine(bot.x-xSpeed, bot.y, bot.x+xSpeed, bot.y, wall0.x, wall0.y, wall.x, wall.y);
						//rtrY = Game.doesInterceptLine(bot.x, bot.y-ySpeed, bot.x, bot.y+ySpeed, wall0.x, wall0.y, wall.x, wall.y);
						if (rtr)
						{
							//Vertical
							if (wall0.x == wall.x)
							{
								newX = walls.teleport.x+xSpeed*bot.ping.dir.x*2;
							} else {
								newY = walls.teleport.y+ySpeed*bot.ping.dir.y*2;
							}
							didTeleport = true;
						}
						if (rtrX)
						{
							newX = walls.teleport.x+xSpeed*bot.ping.dir.x;
						} else if (rtrY) {
							newY = walls.teleport.y+ySpeed*bot.ping.dir.y;
						}
					}
				}
			}
			if (didTeleport)
			{
				bot.x = newX;
				bot.y = newY;
				
				return true;
			}
			
			//Map Boundaries
			if (newX <= 0)
			{
				newX = 0;
				bot.ping.dir.x *= -1;
				bot.ping.hits++;
			} else if (newX >= Render.trueWidth) {
				newX = Render.trueWidth;
				bot.ping.dir.x *= -1;
				bot.ping.hits++;
			}
			if (newY <= 0)
			{
				newY = 0;
				bot.ping.dir.y *= -1;
				bot.ping.hits++;
			} else if (newY >= Render.trueHeight) {
				newY = Render.trueHeight;
				bot.ping.dir.y *= -1;
				bot.ping.hits++;
			}
			
			//Ping Walls?
			if (Game.map && Game.mapClass.pingWalls != undefined)
			{
				var walls, wall, wall0, rtr, rtrX, rtrX2, rtrY, rtrY2, d;
				for(var key in Game.mapClass.pingWalls)
				{
					walls = Game.mapClass.pingWalls[key];
					d = walls.d;
					
					for(var i=1; i<walls.walls.length; i++)
					{
						wall0 = walls.walls[i-1];
						wall = walls.walls[i];
						
						if (wall.x < wall0.x || wall.y < wall0.y)
						{
							var wall2 = wall0;
							wall0 = wall;
							wall = wall2;
						}
						
						rtr = null;
						rtrX = null; rtrX2 = null;
						rtrY = null; rtrY2 = null;
						
						var _ds = [[0, -d*0.8], [d*0.8, 0], [0, d*0.8], [-d*0.8, 0]];
						for(var key in _ds)
						{
							if (rtr) continue;
							var _d = _ds[key];
							
							rtr = Game.doesInterceptLine(bot.x, bot.y, newX+_d[0], newY+_d[1], wall0.x, wall0.y, wall.x, wall.y);
							
							if (wall0.x != wall.x)
							{
								//rtrY = Game.doesInterceptLine(bot.x, bot.y-d/2-xSpeed*1.2, bot.x, bot.y+d/2+xSpeed*1.2, wall0.x-d/2, wall0.y-d/2, wall.x-d/2, wall.y+d/2);
								//rtrY2 = Game.doesInterceptLine(bot.x, bot.y-d/2-xSpeed*1.2, bot.x, bot.y+d/2+xSpeed*1.2, wall0.x+d/2, wall0.y-d/2, wall.x+d/2, wall.y+d/2);
								
								/*pingLinePreview({
									x: bot.x-d-xSpeed*1.2, y: bot.y
								}, {
									x: bot.x+d+xSpeed*1.2, y: bot.y
								}, 0);*/
							}
							
							if (wall0.y != wall.y)
							{
								//rtrX = Game.doesInterceptLine(bot.x-d/2-ySpeed*1.2, bot.y, bot.x+d/2+ySpeed*1.2, bot.y, wall0.x-d/2, wall0.y-d/2, wall.x+d/2, wall.y-d/2);
								//rtrX2 = Game.doesInterceptLine(bot.x-d/2-ySpeed*1.2, bot.y, bot.x+d/2+ySpeed*1.2, bot.y, wall0.x-d/2, wall0.y+d/2, wall.x+d/2, wall.y+d/2);
	
								/*pingLinePreview({
									x: bot.x, y: bot.y-d-xSpeed*1.2
								}, {
									x: bot.x, y: bot.y+d+xSpeed*1.2
								}, 0);*/
							}
							
							if (rtr)
							{
								newX = bot.x;
								newY = bot.y;
								
								//Vertical
								if (wall0.x == wall.x)
								{
									bot.ping.dir.x *= -1;
								} else {
									bot.ping.dir.y *= -1;
								}
								
								bot.ping.hits++;
							}
							if (rtrX || rtrX2)
							{
								//rtrX.x+
								bot.ping.dir.x *= -1;
								bot.x += (xSpeed)*bot.ping.dir.x;
								bot.ping.hits++;
							} else if (rtrY || rtrY2) {
								//rtrY.y+
								bot.ping.dir.y *= -1;
								bot.y += (ySpeed)*bot.ping.dir.y;
								bot.ping.hits++;
							}
						}
					}
				}
			}
			
			bot.x = newX;
			bot.y = newY;
			
			if (hits != bot.ping.hits)
				__Store["ping"].bounceEffect(ID);
			
			return false;
		},
		hiteval: function(ID, eID)
		{
			var obj = Game.bots[ID], eObj = Game.enemiesList[eID];
			var hits = obj.ping.hits;
			if (obj.ping.hitBotsTime[eID] && obj.ping.hitBotsTime[eID] > Date.now()-750) return true;
			
			var xSpeed = obj.data.movespeed*(Game.fastEnabled ? Game.fastRate : 1);
			var ySpeed = obj.data.movespeed*(Game.fastEnabled ? Game.fastRate : 1);
			
			var dmgAmt = eObj.maxLife/10;
			eObj.life -= dmgAmt;
			if (eObj.life < 0) eObj.life = 0;
			obj.ping.hitBotsTime[eID] = Date.now();
			
			Game.botFireUponEnemy(ID, eID, 1, {hiteval: false});

			var dX = Math.abs(obj.x - eObj.x);
			var dY = Math.abs(obj.y - eObj.y);
			if (dX >= dY)
			{
				obj.x += obj.ping.dir.x*xSpeed;
				obj.ping.dir.x *= -1;
				var xDiff = 0.4-(Math.floor(Math.random()*20)/100);
				obj.ping.dir.x = Math.round(obj.ping.dir.x)+xDiff;
				obj.ping.hits++;
			} else {
				obj.y += obj.ping.dir.y*ySpeed;
				obj.ping.dir.y *= -1;
				var yDiff = 0.4-(Math.floor(Math.random()*20)/100);
				obj.ping.dir.y = Math.round(obj.ping.dir.y)+yDiff;
				obj.ping.hits++;
			}
			
			obj.data.movespeed += obj.data.movespeedinc;
			
			if (hits != obj.ping.hits)
				__Store["ping"].bounceEffect(ID);
		},
		bounceEffect: function(ID)
		{
			var bot = Game.bots[ID];
			
			//Quick check to see if we are out of bounds
			if (bot.ping.hits < bot.ping.maxHits && 0)
			{
				if (Game.map && Game.mapClass.pingWalls != undefined)
				{
					var walls, wallsToUse;
					for(var key in Game.mapClass.pingWalls)
					{
						if (bot.ping.hits >= bot.ping.maxHits) continue;
						walls = Game.mapClass.pingWalls[key];
						
						wallsToUse = [];
						for(var i=1; i<walls.walls.length; i++)
							wallsToUse.push(walls.walls[i]);
						for(var i=1; i<walls.walls2.length; i++)
							wallsToUse.push(walls.walls2[i]);
						
						if (Game.pointInPolygon(bot.x, bot.y, wallsToUse))
							bot.ping.hits = bot.ping.maxHits;
					}
				}
			}
			
			
			//Respawn?
			if (bot.ping.hits >= bot.ping.maxHits)
			{
				if (Render.sounds["ping_break"])
					Render.sounds["ping_break"].play();
				
				Game.botsDelete(ID);
				Particles.addEmitter(bot.x, bot.y, 2, Math.PI, 250, 500, {
					image: "particle_white",
					w: 4, h: 4
				});
				
				if (Game.mapClass && Game.mapClass.spawnPingBot != undefined)
					Game.mapClass.spawnPingBot();
			} else {
				if (Render.sounds["ping_bounce"])
				{
					Render.sounds["ping_bounce"].currentTime = 0;
					Render.sounds["ping_bounce"].play();
				}
			}
		},
		createUpgrades: {
		},
		upgrades: {
		}
	}
};

//Calculates the cost for the upgrade
function whatIsUpgradeCost(baseCost, level)
{
	var cost = baseCost, inc = __StoreUpgradeCostBase;
	for(var _i=1; _i<level; _i++)
	{
		cost *= inc;
		
		if (_i < __StoreUpgradeCostHardLv)
		{
			if (inc > __StoreUpgradeCostMin)
				inc -= __StoreUpgradeCostLess;
		} else if (_i == __StoreUpgradeCostHardLv) {
			inc = __StoreUpgradeCostHard;
		} else {
			if (inc < __StoreUpgradeCostMax)
				inc += __StoreUpgradeCostMore;
		}
	}
	cost = Math.round(cost);
	
	return cost;
};

function pingLinePreview(wall0, wall, d)
{
	var cxt = Render.tvContext;
	cxt.lineWidth=1; cxt.strokeStyle = "red";
	
	if (wall0.x != wall.x)
	{
		cxt.beginPath();
		cxt.moveTo(wall0.x-d/2, wall0.y-d/2);
		cxt.lineTo(wall.x+d/2, wall.y-d/2);
		cxt.stroke();
		cxt.beginPath();
		cxt.moveTo(wall0.x-d/2, wall0.y+d/2);
		cxt.lineTo(wall.x+d/2, wall.y+d/2);
		cxt.stroke();
	}
	
	if (wall0.y != wall.y)
	{
		cxt.beginPath();
		cxt.moveTo(wall0.x-d/2, wall0.y-d/2);
		cxt.lineTo(wall.x-d/2, wall.y+d/2);
		cxt.stroke();
		cxt.beginPath();
		cxt.moveTo(wall0.x+d/2, wall0.y-d/2);
		cxt.lineTo(wall.x+d/2, wall.y+d/2);
		cxt.stroke();
	}
}

//Calculates the resell amount for the bot
function whatIsResellAmount(bot)
{
	var amt = __Store[bot.type].cost;
	
	for(var upgrade in bot.upgrades)
	{
		if (bot.upgrades[upgrade] > 1)
		{
			amt += whatIsUpgradeCost(__Store[bot.type].upgrades[upgrade].cost, bot.upgrades[upgrade]-1);
		}
	}
	
	return Math.round(amt*__StoreResellRate);
};